﻿-- Configure 配置页面
local _, ns = ...
local _, R = unpack(ns)

-- BUFF/DEBUFF相关
R.Auras = {
	IconSize		= 32,											-- BUFF图标大小
	IconsPerRow		= 16,											-- BUFF每行个数
	Spacing			= 6,											-- BUFF图标间距
	BHPos			= {"CENTER", UIParent, "CENTER", 0, -200},		-- 血DK助手默认位置
	StaggerPos		= {"CENTER", UIParent, "CENTER", 0, -290},		-- 坦僧工具默认位置
	TotemsPos		= {"CENTER", UIParent, "CENTER", 0, -260},		-- 图腾助手默认位置
	MarksmanPos		= {"CENTER", UIParent, "CENTER", 0, -310},		-- 射击猎助手默认位置
	StatuePos		= {"BOTTOMLEFT", UIParent, 520, 260},			-- 武僧雕像默认位置
	EnergyBarPos	= {"CENTER", UIParent, "CENTER", 0, -195},		-- 职业能量条默认位置
	
  -- 技能监控各组初始位置
	DrogPos	      = {"CENTER", UIParent, "TOP", -380, -43},	        -- 药水分组
	ClassBarPos	  = {"CENTER", UIParent, "CENTER", -105, -260},	    -- 药水分组
	AbsorbPos	    = {"CENTER", UIParent, "CENTER",-145, -80},	      -- 药水分组
	ShieldPos	    = {"CENTER", UIParent, "CENTER",45, -80},	        -- 药水分组
	EnchantPos		= {"RIGHT", UIParent, "CENTER", -190, -150},	    -- 附魔及饰品分组
	SpecialPos		= {"RIGHT", UIParent, "CENTER", -240, -155},	    -- 玩家重要光环分组
	WarningPos		= {"LEFT", UIParent, "CENTER", 190, -150},		    -- 目标重要光环分组
	PlayerAuraPos	= {"RIGHT", UIParent, "CENTER", -360, -160},	    -- 玩家光环分组
	TargetAuraPos = {"LEFT", UIParent, "CENTER", 240, -155},		    -- 目标光环分组
	FocusPos		  = {"LEFT", UIParent, "CENTER", 360, -160},		    -- 焦点光环分组
	RaidBuffPos		= {"CENTER", UIParent, "CENTER", -160, 200},		  -- 团队增益分组
	RaidDebuffPos	= {"CENTER", UIParent, "CENTER", 160, 200},			  -- 团队减益分组
	CDPos			    = {"RIGHT", UIParent, "CENTER", -430, -220},	    -- 冷却计时分组
	InternalPos		= {"TOP", UIParent, "CENTER", -480, -250},	      -- 法术内置冷却分组
}

-- 小地图
R.Minimap = {
	Pos				= {"TOPRIGHT", UIParent, "TOPRIGHT", 0, 0},	-- 小地图位置
}

-- 鼠标提示框
R.Tooltips = {
	TipPos 	= {"BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -55, 210},		-- 鼠标提示框默认位置
}

-- 信息条
R.Infobar = {
	Spec			= true,												-- 天赋专精
	SpecPos			= {"topleft", UIParent,"topleft",0, 0},				-- 天赋专精位置
	Time			= true,												-- 时间信息
	TimePos			= {"topleft", UIParent, "topleft", 25, 2},			-- 时间信息位置	
	Guild	 		= true,												-- 公会信息
	GuildPos 		= {"topleft", UIParent, "topleft", 100, -3},			-- 公会信息位置
	Friends 		= true,												-- 好友模块
	FriendsPos 		= {"topleft", UIParent, "topleft", 135, -3},		-- 好友模块位置
	Durability		= true,												-- 耐久度
	DurabilityPos	= {"topleft", UIParent, "topleft", 185, -3},		-- 耐久度位置
	System			= true,												-- 帧数/延迟
	SystemPos		= {"topleft", UIParent, "topleft", 225, -3},		-- 帧数/延迟位置
	Memory			= true,												-- 内存占用
	MemoryPos		= {"topleft", UIParent, "topleft", 320, -3},		-- 内存占用位置
	MaxAddOns		= 21,												-- 插件信息显示数量
  Bags            = true,
  BagsPos         = {"topleft", UIParent, "topleft", 375, -4},
	Gold			= true,												-- 金币信息
	GoldPos			= {"bottomleft", Minimap, "bottomleft", 1, 3}, 	    -- 金币信息位置
	Location		= true,												-- 区域信息
	LocationPos		= {"top", UIParent,"top", 0, -3},					-- 区域信息位置
	
	Fonts			= {STANDARD_TEXT_FONT, 12, "OUTLINE"},				-- 字体
	TimeFonts       = {"Interface\\Addons\\_ShiGuang\\Media\\Fonts\\Pixel.ttf", 24, "outline"},
	TTFonts         = {STANDARD_TEXT_FONT, 18, "outline"},
}

ShiGuangDB = {
	DisplayInfo = 54860,		--74504   --71057 	--68323   --35908   --65636
  ["FamilyFamiliarHelper_JustOnce"] = true,
	["FamilyFamiliarHelper_AutoShow"] = true,
	["FamilyFamiliarHelper_ActiveTab"] = 1,
	["QuestNotifier_Switch"]		= true,  --通告功能 打开/关闭
	["QuestNotifier_Instance"]	= true,	 --在副本中时通报				
	["QuestNotifier_Raid"]		= false,    --在团队中时通报
	["QuestNotifier_Party"]		= true,    --在小队中时通报
	["QuestNotifier_Solo"]		= false,   --单人时候通报
	["QuestNotifier_Sound"]		= true,    --完成时播放提示音
	["QuestNotifier_Color"]		= true,   --任务进度彩色提示
	["QuestNotifier_NoDetail"]	= true,  --不通报详细进度
	["QuestNotifier_CompleteX"]	= false, --自动移除追踪面板中已完成的任务
	["ACPAddonSet"] = {
		{ "_ShiGuang","Combuctor","MaxDps",
			["name"] = "极简", }, -- [1]
		{ "_ShiGuang","Combuctor","Gladius","MaxDps","PVPMaster","Skada","WhisperMaster",
			["name"] = "PVP", }, -- [2]
		{ "AngryKeystones","AngryWorldQuests","Combuctor","GarrisonMaster","MaxDps","Skada","WhisperMaster","DBM-Core","DBM-TrialofValor","DBM-Nighthold","DBM-BrokenIsles","DBM-EmeraldNightmare","DBM-Party-Legion","DBM-StatusBarTimers","DBM-DefaultSkin","DBM-Archaeology","DBM-GUI","DBM-PvP","DBM-WorldEvents","DBM-VPYike","DBM-Brawlers","DBM-DMF","DBM-ProvingGrounds","DBM-GarrisonInvasions","DBM-Party-Cataclysm","DBM-Party-MoP","DBM-SiegeOfOrgrimmarV2","DBM-Scenario-MoP","DBM-HeartofFear","DBM-TerraceofEndlessSpring","DBM-Pandaria","DBM-ThroneofThunder","DBM-MogushanVaults","DBM-HellfireCitadel","DBM-Party-BC","DBM-Party-WoD","DBM-Draenor","DBM-Highmaul","DBM-BlackrockFoundry","DBM-Party-WotLK",
			["name"] = "初始", }, -- [3]
	},
}