--- ɫ ---
hooksecurefunc('PaperDollFrame_SetItemLevel', function(self, unit)
	if (unit ~= 'player') then return end
	local total, equip = GetAverageItemLevel()
	if (total > 0) then total = string.format('%.1f', total) end
	if (equip > 0) then equip = string.format('%.1f', equip) end
	local ilvl = equip
	if (equip < total) then ilvl = equip .. ' / ' .. total end
	CharacterStatsPane.ItemLevelFrame.Value:SetText(ilvl)
end)



local SimpleItemLevel = {}
-- events
local f = CreateFrame("Frame")
f:SetScript("OnEvent", function(self, event, ...) if SimpleItemLevel[event] then return SimpleItemLevel[event](SimpleItemLevel, event, ...) end end)
function SimpleItemLevel:RegisterEvent(...) for i=1,select("#", ...) do f:RegisterEvent((select(i, ...))) end end
function SimpleItemLevel:UnregisterEvent(...) for i=1,select("#", ...) do f:UnregisterEvent((select(i, ...))) end end

local LIL = LibStub("LibItemLevel-1.0")
local function GetItemQualityAndLevel(unit, slotID)
    local itemID = GetInventoryItemID(unit, slotID)

    if itemID ~= nil then
        local quality = GetInventoryItemQuality(unit, slotID)
        local level = LIL.GetItemLevel(slotID, unit)

        return quality, level
    end
end
local function UpdateItemSlotButton(button, unit)
    local slotID = button:GetID()

    if (slotID >= INVSLOT_FIRST_EQUIPPED and slotID <= INVSLOT_LAST_EQUIPPED) then
        local itemQuality, itemLevel = GetItemQualityAndLevel(unit, slotID)

        if not button.simpleilvl then
            button.simpleilvl = button:CreateFontString('$parentItemLevel', 'ARTWORK')
            if (slotID <= 5 or slotID == 9 or slotID == 15 or slotID == 19) then
                button.simpleilvl:SetPoint("TOPLEFT", button, "TOPRIGHT", 6, -6)
            elseif (slotID == 17) then
                button.simpleilvl:SetPoint("TOPLEFT", button, "TOPRIGHT", 6, -3)
            elseif (slotID == 16) then
                button.simpleilvl:SetPoint("TOPRIGHT", button, "TOPLEFT", -6, -3)
            else
                button.simpleilvl:SetPoint("TOPRIGHT", button, "TOPLEFT", -6, -6)
            end
            --button.simpleilvl:SetPoint('TOPRIGHT', -2, -2)
            button.simpleilvl:SetFontObject(NumberFontNormal)
            button.simpleilvl:SetJustifyH('RIGHT')
        end

        if not itemLevel then
            return button.simpleilvl:Hide()
        end

        local r, g, b, hex = GetItemQualityColor(itemQuality)
        button.simpleilvl:SetFormattedText('|c%s%s|r', hex, itemLevel or '?')
        button.simpleilvl:Show()
    end
end
hooksecurefunc("PaperDollItemSlotButton_Update", function(button)
    UpdateItemSlotButton(button, "player")
end)

function SimpleItemLevel:GET_ITEM_INFO_RECEIVED()
    if InspectFrame and InspectFrame:IsShown() then
        -- TODO: I think I need to schedule a flushed-cache a little while after the inspect happens. Artifact weapons are reliably not-quite-loaded.
        InspectPaperDollFrame_OnShow()
    end
end
SimpleItemLevel:RegisterEvent("GET_ITEM_INFO_RECEIVED")

function SimpleItemLevel:ADDON_LOADED(event, addon)
    if addon == "Blizzard_InspectUI" then
        self:ModInspectUI()
    end
    if addon == "_ShiGuang" then
        if IsAddOnLoaded("Blizzard_InspectUI") then
            self:ModInspectUI()
        end
    end
end
SimpleItemLevel:RegisterEvent("ADDON_LOADED")

function SimpleItemLevel:ModInspectUI()
    hooksecurefunc("InspectPaperDollItemSlotButton_Update", function(button)
        UpdateItemSlotButton(button, "target")
    end)
end
