﻿--[[----------------------------------------------------------ImprovedLootFrame
   LOOTFRAME_AUTOLOOT_DELAY = 0.5; 
   LOOTFRAME_AUTOLOOT_RATE = 0.1; 

   -- Woah, nice coding, blizz. 
   -- Anchor something positioned at the top of the frame to the center of the frame instead, 
   -- and make it an anonymous font string so I have to work to find it 
   local i, t = 1, "Interface\\LootFrame\\UI-LootPanel" 

   while true do 
      local r = select(i, LootFrame:GetRegions()) 
      if not r then break end 
      if r.GetText and r:GetText() == ITEMS then 
         r:ClearAllPoints() 
         r:SetPoint("TOP", -12, -19.5) 
      elseif r.GetTexture and r:GetTexture() == t then 
         r:Hide() 
      end 
      i = i + 1 
   end 

-- Calculate base height of the loot frame 
local p, r, x, y = "TOP", "BOTTOM", 0, -4 
local buttonHeight = LootButton1:GetHeight() + abs(y) 
local baseHeight = LootFrame:GetHeight() - (buttonHeight * LOOTFRAME_NUMBUTTONS) - 5 

local OverflowText = LootFrame:CreateFontString(nil, "OVERLAY", "GameFontRedSmall") 
OverflowText:SetPoint("TOP", LootFrame, "TOP", 0, -26) 
OverflowText:SetPoint("LEFT", LootFrame, "LEFT", 60, 0) 
OverflowText:SetPoint("RIGHT", LootFrame, "RIGHT", -8, 0) 
OverflowText:SetPoint("BOTTOM", LootFrame, "TOP", 0, -65) 
OverflowText:SetPoint("LEFT", LootFrame, "RIGHT", 10, 0) 
OverflowText:SetPoint("RIGHT", LootFrame, "RIGHT", -10 + LootFrame:GetWidth(), 0)  
OverflowText:SetSize(1, 1) 
OverflowText:SetJustifyH("LEFT") 
OverflowText:SetJustifyV("TOP") 
OverflowText:SetText("Hit 50-mob limit! Take some, then re-loot for more.") 
OverflowText:Hide() 

local t = {} 
local function CalculateNumMobsLooted() 
   wipe(t) 

   for i = 1, GetNumLootItems() do 
      for n = 1, select("#", GetLootSourceInfo(i)), 2 do 
         local GUID, num = select(n, GetLootSourceInfo(i)) 
         t[GUID] = true 
      end 
   end 

   local n = 0 
   for k, v in pairs(t) do 
      n = n + 1 
   end 

   return n 
end 


local old_LootFrame_Show = LootFrame_Show 
function LootFrame_Show(self, ...) 
   local maxButtons = floor(UIParent:GetHeight()/LootButton1:GetHeight() * 0.7) 
   
   local num = GetNumLootItems() 
 
      if self.AutoLootTable then 
         num = #self.AutoLootTable 
      end 

      self.AutoLootDelay = 0.4 + (num * 0.05) 

   num = min(num, maxButtons) 

   LootFrame:SetHeight(baseHeight + (num * buttonHeight)) 
   for i = 1, num do 
      if i > LOOTFRAME_NUMBUTTONS then 
         local button = _G["LootButton"..i] 
         if not button then 
            button = CreateFrame("Button", "LootButton"..i, LootFrame, "LootButtonTemplate", i) 
         end 
         LOOTFRAME_NUMBUTTONS = i 
      end 
      if i > 1 then 
         local button = _G["LootButton"..i] 
         button:ClearAllPoints() 
         button:SetPoint(p, "LootButton"..(i-1), r, x, y) 
      end 
   end 

   if CalculateNumMobsLooted() >= 50 then 
      OverflowText:Show() 
   else 
      OverflowText:Hide() 
   end 

   
   return old_LootFrame_Show(self, ...) 
end]]

local _, ns = ...
local M, R, U, I = unpack(ns)

local iconSize = 33

local fontSizeItem = math.floor(select(2, GameFontWhite:GetFont()) + .5)

local point = {"CENTER", 300, 0}
local slots = {}

local LightLoot = CreateFrame("Button", "LightLoot")
M.CreateBD(LightLoot, .5, 1, true)
M.CreateSD(LightLoot, 2, 3)
M.CreateTex(LightLoot)
LightLoot:RegisterForClicks("AnyUp")
LightLoot:SetClampedToScreen(true)
LightLoot:SetClampRectInsets(0, 0, 14, 0)
LightLoot:SetFrameStrata("TOOLTIP")
LightLoot:SetHitRectInsets(0, 0, -14, 0)
LightLoot:SetMovable(true)
LightLoot:SetParent(UIParent)
LightLoot:SetToplevel(true)

LightLoot:SetScript("OnEvent", function(self, event, ...)
	self[event](self, event, ...)
end)

LightLoot:SetScript("OnHide", function(self) StaticPopup_Hide("CONFIRM_LOOT_DISTRIBUTION") CloseLoot()
end)

local Title = M.CreateFS(LightLoot, 18, "", false, "TOPLEFT", 4, 20)
LightLoot.Title = Title

local function OnEnter(self)
	local slot = self:GetID()
	if GetLootSlotType(slot) == LOOT_SLOT_ITEM then
		GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
		GameTooltip:SetLootItem(slot)
		CursorUpdate(self)
	end
	self.glow:Show()
end

local function OnLeave(self)
	self.glow:Hide()
	GameTooltip:Hide()
	ResetCursor()
end

local function OnClick(self)
	if IsModifiedClick() then
		HandleModifiedItemClick(GetLootSlotLink(self:GetID()))
	else
		StaticPopup_Hide("CONFIRM_LOOT_DISTRIBUTION")

		LootFrame.selectedLootButton = self
		LootFrame.selectedSlot = self:GetID()
		LootFrame.selectedQuality = self.lootQuality
		LootFrame.selectedItemName = self.name:GetText()

		LootSlot(self:GetID())
	end
end

local function OnUpdate(self)
	if GameTooltip:IsOwned(self) then
		GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
		GameTooltip:SetLootItem(self:GetID())
		CursorOnUpdate(self)
	end
end

local function CreateSlot(id)
	local cr, cg, cb = I.ClassColor.r, I.ClassColor.g, I.ClassColor.b

	local button = CreateFrame("Button", "LightLootSlot"..id, LightLoot)
	button:SetHeight(math.max(fontSizeItem, iconSize))
	button:SetPoint("LEFT", 5, 0)
	button:SetPoint("RIGHT", -5, 0)
	button:SetID(id)

	button:RegisterForClicks("LeftButtonUp", "RightButtonUp")
	button:SetScript("OnEnter", OnEnter)
	button:SetScript("OnLeave", OnLeave)
	button:SetScript("OnClick", OnClick)
	button:SetScript("OnUpdate", OnUpdate)

	local icBD = CreateFrame("Frame", nil, button)
	icBD:SetSize(iconSize, iconSize)
	icBD:SetPoint("LEFT", button)
	M.CreateBD(icBD, 1, 1, true)
	button.icBD = icBD

	local icon = icBD:CreateTexture(nil, "ARTWORK")
	icon:SetAlpha(.8)
	icon:SetTexCoord(.08, .92, .08, .92)
	icon:SetPoint("TOPLEFT", 1, -1)
	icon:SetPoint("BOTTOMRIGHT", -1, 1)
	button.icon = icon

	local glow = button:CreateTexture(nil, "ARTWORK")
	glow:SetAlpha(.5)
	glow:SetPoint("TOPLEFT", icon, "TOPRIGHT", 3, 0)
	glow:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT")
	glow:SetTexture(I.bdTex)
	glow:SetVertexColor(cr, cg, cb)
	glow:Hide()
	button.glow = glow

	local count = M.CreateFS(icBD, 14, "", false, "BOTTOMRIGHT", -1, 1)
	count:SetJustifyH("RIGHT")
	button.count = count

	local name = M.CreateFS(icBD, 14, "")
	name:SetJustifyH("LEFT")
	name:SetPoint("LEFT", icon, "RIGHT", 5, 0)
	name:SetNonSpaceWrap(true)
	button.name = name

	slots[id] = button
	return button
end

function LightLoot:UpdateWidth()
	local maxWidth = 0
	for _, slot in next, slots do
		if slot:IsShown() then
			local width = slot.name:GetStringWidth()
			if width > maxWidth then
				maxWidth = width
			end
		end
	end

	self:SetWidth(math.max(maxWidth + 16 + iconSize, self.Title:GetStringWidth() + 5))
end

function LightLoot:AnchorSlots()
	local buttonSize = math.max(iconSize, fontSizeItem)
	local shownSlots = 0

	for i = 1, #slots do
		local button = slots[i]
		if button:IsShown() then
			shownSlots = shownSlots + 1
			button:SetPoint("TOP", LightLoot, 0, (-5 + iconSize) - (shownSlots * iconSize) - (shownSlots - 1) * 5)
		end
	end

	self:SetHeight(math.max(shownSlots * iconSize + 10 + (shownSlots - 1) * 5 , iconSize))
end

function LightLoot:LOOT_OPENED(event, autoloot)
	self:Show()

	if not self:IsShown() then
		CloseLoot(not autoLoot)
	end

	if IsFishingLoot() then
		self.Title:SetText(PROFESSIONS_FISHING)
	elseif UnitIsDead("target") then
		self.Title:SetText(UnitName("target"))
	else
		self.Title:SetText(LOOT)
	end

	if GetCVar("lootUnderMouse") == "1" then
		local x, y = GetCursorPosition()
		x = x / self:GetEffectiveScale()
		y = y / self:GetEffectiveScale()

		self:ClearAllPoints()
		self:SetPoint("TOPLEFT", nil, "BOTTOMLEFT", x - 40, y + 20)
		self:GetCenter()
		self:Raise()
	else
		self:ClearAllPoints()
		self:SetUserPlaced(false)
		self:SetPoint(unpack(point))
	end

	local maxQuality = 0
	local items = GetNumLootItems()
	if items > 0 then
		for i = 1, items do
			local slot = slots[i] or CreateSlot(i)
			local lootIcon, lootName, lootQuantity, lootQuality, isLocked, isQuestItem, questID, isActive = GetLootSlotInfo(i)
			if lootIcon then
				local color = ITEM_QUALITY_COLORS[lootQuality]
				local r, g, b = color.r, color.g, color.b
				local slotType = GetLootSlotType(i)

				if slotType == LOOT_SLOT_MONEY then
					lootName = lootName:gsub("\n", "，")
				end

				if lootQuantity and lootQuantity > 1 then
					slot.count:SetText(M.Numb(lootQuantity))
					slot.count:Show()
				else
					slot.count:Hide()
				end

				if (lootQuality and lootQuality >= 0) or questId or isQuestItem then
					if questId or isQuestItem then
						r, g, b = .8, .8, 0
					end
					slot.name:SetTextColor(r, g, b)
					slot.icBD:SetBackdropBorderColor(r, g, b)
				else
					slot.name:SetTextColor(.5, .5, .5)
					slot.icBD:SetBackdropBorderColor(.5, .5, .5)
				end

				slot.lootQuality = lootQuality
				slot.isQuestItem = isQuestItem

				slot.name:SetText(lootName)
				slot.icon:SetTexture(lootIcon)

				maxQuality = math.max(maxQuality, lootQuality)

				slot:Enable()
				slot:Show()
			end
		end
	else
		local slot = slots[1] or CreateSlot(1)

		slot.name:SetText(NONE)
		slot.name:SetTextColor(.5, .5, .5)
		slot.icon:SetTexture(nil)

		slot.count:Hide()
		slot.glow:Hide()
		slot:Disable()
		slot:Show()
	end

	local color = ITEM_QUALITY_COLORS[maxQuality]
	local r, g, b = color.r, color.g, color.b
	self:SetBackdropBorderColor(r, g, b)
	self.Shadow:SetBackdropBorderColor(r, g, b)
	self.Title:SetTextColor(r, g, b)

	self:AnchorSlots()
	self:UpdateWidth()
end
LightLoot:RegisterEvent("LOOT_OPENED")

function LightLoot:LOOT_SLOT_CLEARED(event, slot)
	if not self:IsShown() then return end

	slots[slot]:Hide()
	self:AnchorSlots()
end
LightLoot:RegisterEvent("LOOT_SLOT_CLEARED")

function LightLoot:LOOT_CLOSED()
	StaticPopup_Hide("LOOT_BIND")
	self:Hide()

	for _, v in pairs(slots) do
		v:Hide()
	end
end
LightLoot:RegisterEvent("LOOT_CLOSED")

function LightLoot:OPEN_MASTER_LOOT_LIST()
	ToggleDropDownMenu(1, nil, GroupLootDropDown, LootFrame.selectedLootButton, 0, 0)
end
LightLoot:RegisterEvent("OPEN_MASTER_LOOT_LIST")

function LightLoot:UPDATE_MASTER_LOOT_LIST()
	UIDropDownMenu_Refresh(GroupLootDropDown)
end
LightLoot:RegisterEvent("UPDATE_MASTER_LOOT_LIST")

LootFrame:UnregisterAllEvents()
table.insert(UISpecialFrames, "LightLoot")







------------------------------------------------------------simplelootannouncer
local t = 1
local loottemp = {}
local sockets = {3, 497, 523, 563, 564, 565, 572} --564 only?
local warforged = {44, 448, 499, 546, 547, 560, 561, 562, 571} -- only 561 and 754-766?
--titanforged 1372-1672

local function Announce()
local masterlooterRaidID = select(3, GetLootMethod())
if (masterlooterRaidID ~= nil and UnitName("raid"..masterlooterRaidID) == UnitName("player")) or IsLeftControlKeyDown() then
local n = 0
local check = false
local loot = GetLootInfo()

for i = 1, GetNumLootItems() do
	if GetLootSlotType(i) == 1 then
		for j = 1, t do
			if GetLootSourceInfo(i) == loottemp[j] then 
				check = true
			break
			end
		end
	end
end


if check == false or IsLeftControlKeyDown() then

t = GetNumLootItems()
for i = 1, t do
	loot[i]["check"] = 0
	if GetLootSlotType(i) == 1 and loot[i]["quality"] >= 4 and not (bit.band(GetItemFamily(loot[i]["item"] or '') or 0, 0x0040) > 0) then
		local link = GetLootSlotLink(i)
		local ilvl = select(4, GetItemInfo(link))
		loot[i]["upgrade"] = ""
		local itemstring = string.match(link, "item[%-?%d:]+")
		local numbonuses = select(14, strsplit(":", itemstring))
		numbonuses = tonumber(numbonuses) or 0
		local bonus = {}
		for j = 1, numbonuses do
			bonus[j] = select(14 + j, strsplit(":", itemstring))
			bonus[j] = tonumber(bonus[j])
			for k = 1, #warforged do														--Warforged
				if bonus[j] == warforged[k] then
					loot[i]["upgrade"] = loot[i]["upgrade"]..":"..ilvl
				end
			end
			if 766 >= bonus[j] and bonus[j] >= 754 then														--Warforged
					loot[i]["upgrade"] = loot[i]["upgrade"]..":"..ilvl
			end												
			if 1672 >= bonus[j] and bonus[j] >= 1372 then													--Titanforged
					loot[i]["upgrade"] = loot[i]["upgrade"]..":"..ilvl
			end
			for k = 1, #sockets do															--Socket
				if bonus[j] == sockets[k] then
					loot[i]["upgrade"] = loot[i]["upgrade"].."<- *** "
				end
			end
			if bonus[j] == 40 then loot[i]["upgrade"] = loot[i]["upgrade"].." +"..STAT_AVOIDANCE end						--Avoidance
			if bonus[j] == 41 then loot[i]["upgrade"] = loot[i]["upgrade"].." +"..STAT_LIFESTEAL end						--Leech
			if bonus[j] == 42 then loot[i]["upgrade"] = loot[i]["upgrade"].." +"..STAT_SPEED end							--Speed
			if bonus[j] == 43 then loot[i]["upgrade"] = loot[i]["upgrade"].." +"..STAT_STURDINESS end						--Indestructible
		end
		loot[i]["check"] = 1
		for k = 1, i-1 do
			if loot[k]["item"] == loot[i]["item"] and loot[k]["upgrade"] == loot[i]["upgrade"] then
				loot[i]["check"] = 0
				loot[k]["quantity"] = loot[i]["quantity"] + loot[k]["quantity"]
			end
		end
	end
end

for i = 1, t do
	loot[i]["item"] = GetLootSlotLink(i)
	if loot[i]["check"] == 1 then
		n = n + 1
		if loot[i]["quantity"] == 1 then
			SendChatMessage(n..". "..loot[i]["item"]..loot[i]["upgrade"], "RAID")
		else
			SendChatMessage(n..". "..loot[i]["item"].."x"..loot[i]["quantity"].."  "..loot[i]["upgrade"], "RAID")
		end
	end
end

end

for i = 1, t do
	loottemp[i] = GetLootSourceInfo(i)
end

end
end

local SimpleLootAnnouncer = CreateFrame("Frame")
SimpleLootAnnouncer:RegisterEvent("LOOT_OPENED")
SimpleLootAnnouncer:SetScript("OnEvent", function(self, event) Announce() end)

-------LootAnnouncerbutton----------------
local LootAnnouncerbutton = CreateFrame("Button","LootAnnouncerbutton",LightLoot,"UIPanelButtonTemplate")
LootAnnouncerbutton:RegisterEvent("LOOT_OPENED")
LootAnnouncerbutton:SetPoint('BOTTOMRIGHT', 0, -18)
LootAnnouncerbutton:SetWidth(110)
LootAnnouncerbutton:SetHeight(21)
LootAnnouncerbutton:SetText(LOOT_ANNOUNCERBUTTON_TITLE)
LootAnnouncerbutton:SetScript("OnClick", function() Announce() end)


-------BGRoll----------------
local NeedList = {
[18231] = true,
[71951] = true,
[71952] = true,
[71953] = true,
}
local BGRoll = CreateFrame("Frame")
BGRoll:RegisterEvent("START_LOOT_ROLL")
BGRoll:RegisterEvent("CONFIRM_LOOT_ROLL")
BGRoll:SetScript("OnEvent", function(self, event, id, rt)
if event == 'START_LOOT_ROLL' then
	local _, Name, _, _, _, Need, Greed, _ = GetLootRollItemInfo(id)
	local Link = GetLootRollItemLink(id)
	local ItemID = tonumber(strmatch(Link, 'item:(%d+)'))
	if NeedList[ItemID] then
		if Need then
			print("→: ", (Name))
			RollOnLoot(id, 1)
		elseif Greed then
			print("→: ", (Name))
			RollOnLoot(id, 2)
		end
	end
end
if event == 'CONFIRM_LOOT_ROLL' then ConfirmLootRoll(id, rt) end
end)