﻿local _, ns = ...
local M, R, U, I = unpack(ns)
local module = M:GetModule("Skins")
local r, g, b = I.ClassColor.r, I.ClassColor.g, I.ClassColor.b

function module:QuestTracker()
	-- Questblock click enhant
	local function QuestHook(id)
		local questLogIndex = GetQuestLogIndexByID(id)
		if IsControlKeyDown() and CanAbandonQuest(id) then QuestMapQuestOptions_AbandonQuest(id)
		elseif IsAltKeyDown() and GetQuestLogPushable(questLogIndex) then QuestMapQuestOptions_ShareQuest(id)
		end
	end
	hooksecurefunc(QUEST_TRACKER_MODULE, "OnBlockHeaderClick", function(_, block) QuestHook(block.id) end)
	hooksecurefunc("QuestMapLogTitleButton_OnClick", function(self) QuestHook(self.questID) end)

	-- Show quest color and level
	local function Showlevel(_, _, _, title, level, _, isHeader, _, isComplete, frequency, questID)
		if ENABLE_COLORBLIND_MODE == "1" then return end

		for button in pairs(QuestScrollFrame.titleFramePool.activeObjects) do
			if title and not isHeader and button.questID == questID then
				local title = "["..level.."] "..title
				if isComplete then
					title = "|cffff78ff"..title
				elseif frequency == LE_QUEST_FREQUENCY_DAILY then
					title = "|cff3399ff"..title
				end
				button.Text:SetText(title)
				button.Text:SetPoint("TOPLEFT", 24, -5)
				button.Text:SetWidth(216)
				button.Text:SetWordWrap(false)
			end
		end
	end
	hooksecurefunc("QuestLogQuests_AddQuestButton", Showlevel)

	-- Reskin Headers
	local function reskinHeader(header)
		header.Text:SetTextColor(r, g, b)
		header.Background:Hide()
		local bg = header:CreateTexture(nil, "ARTWORK")
		bg:SetTexture("Interface\\LFGFrame\\UI-LFG-SEPARATOR")
		bg:SetTexCoord(0, .66, 0, .31)
		bg:SetVertexColor(r, g, b, .8)
		bg:SetPoint("BOTTOMLEFT", -30, -4)
		bg:SetSize(250, 30)
	end
  -- Move Headers 
  local function Moveit(header) 
    header:EnableMouse(true)	
	  header:RegisterForDrag("LeftButton")
    header:SetHitRectInsets(-15, -15, -5, -5)
 	  header:HookScript("OnDragStart", function(s) 
       ObjectiveTrackerFrame:StartMoving() 
    end) 
	  header:HookScript("OnDragStop", function(s)
	  ObjectiveTrackerFrame:StopMovingOrSizing()
	 end)
  end
	local headers = {
		ObjectiveTrackerBlocksFrame.QuestHeader,
		ObjectiveTrackerBlocksFrame.AchievementHeader,
		ObjectiveTrackerBlocksFrame.ScenarioHeader,
		BONUS_OBJECTIVE_TRACKER_MODULE.Header,
		WORLD_QUEST_TRACKER_MODULE.Header,
	}
	for _, header in pairs(headers) do reskinHeader(header) Moveit(header) end
end

-- 任务名称职业着色 -------------------------------------------------------
function module:QuestTrackerSkinTitle()
 if not MaoRUISettingDB["Skins"]["QuestTrackerSkinTitle"] then return end
    hooksecurefunc(QUEST_TRACKER_MODULE, "SetBlockHeader", function(_, block)
        --for i = 1, GetNumQuestWatches() do
		    --local questID = GetQuestWatchInfo(i)
	        --if not questID then break end
            --local block = QUEST_TRACKER_MODULE:GetBlock(questID)
	          block.HeaderText:SetFont(STANDARD_TEXT_FONT, 12, 'nil')
	          block.HeaderText:SetShadowOffset(.7, -.7)
	          block.HeaderText:SetShadowColor(0, 0, 0, 1)
            block.HeaderText:SetTextColor(r, g, b)
            block.HeaderText:SetJustifyH("LEFT")
          --end
     end)
     local function hoverquest(_, block)
     --for i = 1, GetNumQuestWatches() do
		    --local id = GetQuestWatchInfo(i)
	        --if not id then break end
	        --QUEST_TRACKER_MODULE:GetBlock(id).HeaderText:SetTextColor(r, g, b)
	        block.HeaderText:SetTextColor(r, g, b)
        --end
     end
    hooksecurefunc(QUEST_TRACKER_MODULE, "OnBlockHeaderEnter", hoverquest)  
    hooksecurefunc(QUEST_TRACKER_MODULE, "OnBlockHeaderLeave", hoverquest)
 end   
    
 -- numQuests -------------------------------------------------------
local numQuests=CreateFrame('frame')
numQuests:RegisterEvent('PLAYER_LOGIN')
numQuests:RegisterEvent('QUEST_LOG_UPDATE')
numQuests:SetScript('OnEvent',function() 
  if not InCombatLockdown() then  --not InCombat and 
		ObjectiveTrackerBlocksFrame.QuestHeader.Text:SetText(tostring(select(2,GetNumQuestLogEntries())).."/"..MAX_QUESTS.." "..TRACKER_HEADER_QUESTS)
		ObjectiveTrackerFrame.HeaderMenu.Title:SetText(tostring(select(2,GetNumQuestLogEntries())).."/"..MAX_QUESTS.." "..OBJECTIVES_TRACKER_LABEL)
		--WorldMapFrame.BorderFrame.TitleText:SetText(MAP_AND_QUEST_LOG.." ("..tostring(select(2,GetNumQuestLogEntries())).."/"..MAX_QUESTS..")")
	end 
end)