local _, ns = ...
local M, R, U, I = unpack(ns)
local module = M:GetModule("Skins")

local function ReskinWA()
	local function Skin_WeakAuras(f, fType)
		if fType == "icon" then
			if not f.styled then
				f.icon:SetTexCoord(unpack(I.TexCoord))
				f.icon.SetTexCoord = M.Dummy
				M.CreateSD(f, 3, 3)
				f.styled = true
			end
		elseif fType == "aurabar" then
			if not f.styled then
				M.CreateSD(f.bar, 3, 3)
				f.icon:SetTexCoord(unpack(I.TexCoord))
				f.icon.SetTexCoord = M.Dummy
				f.iconFrame:SetAllPoints(f.icon)
				M.CreateSD(f.iconFrame, 3, 3)
				f.styled = true
			end
		end
	end

	local regionTypes = WeakAuras.regionTypes
	local Create_Icon, Modify_Icon = regionTypes.icon.create, regionTypes.icon.modify
	local Create_AuraBar, Modify_AuraBar = regionTypes.aurabar.create, regionTypes.aurabar.modify

	regionTypes.icon.create = function(parent, data)
		local region = Create_Icon(parent, data)
		Skin_WeakAuras(region, "icon")
		return region
	end

	regionTypes.aurabar.create = function(parent)
		local region = Create_AuraBar(parent)
		Skin_WeakAuras(region, "aurabar")
		return region
	end

	regionTypes.icon.modify = function(parent, region, data)
		Modify_Icon(parent, region, data)
		Skin_WeakAuras(region, "icon")
	end

	regionTypes.aurabar.modify = function(parent, region, data)
		Modify_AuraBar(parent, region, data)
		Skin_WeakAuras(region, "aurabar")
	end

	for weakAura, _ in pairs(WeakAuras.regions) do
		local regions = WeakAuras.regions[weakAura]
		if regions.regionType == "icon" or regions.regionType == "aurabar" then
			Skin_WeakAuras(regions.region, regions.regionType)
		end
	end
end

module:LoadWithAddOn("WeakAuras", "WeakAuras", ReskinWA)