--## Version: 1.1  ## Author: Kygo

local function GetAzeritePowerID(spellID)
	powerInfo = C_AzeriteEmpoweredItem.GetPowerInfo(spellID)
  	if (powerInfo) then
    	local azeriteSpellID = powerInfo["spellID"]
    	return azeriteSpellID
  	end
end

local function AzeriteTooltip(self)

  	local itemName, itemLink = self:GetItem()

  	if not itemName then return end

	if C_AzeriteEmpoweredItem.IsAzeriteEmpoweredItemByID(itemLink) then

		local specIndex = GetSpecialization()
		local specID = GetSpecializationInfo(specIndex)

		local azeriteItemLocation = C_AzeriteItem.FindActiveAzeriteItem()
		local currentLevel = C_AzeriteItem.GetPowerLevel(azeriteItemLocation)
		local allTierInfo = C_AzeriteEmpoweredItem.GetAllTierInfoByItemID(itemLink)

		GameTooltip:AddLine(" ")

		for j=1, 3 do
			local tierLevel = allTierInfo[j]["unlockLevel"]
			local azeritePowerID = allTierInfo[j]["azeritePowerIDs"][1]

			if not allTierInfo[j]["azeritePowerIDs"][1] then return end

			if azeritePowerID == 13 then break end

			if tierLevel <= currentLevel then
				GameTooltip:AddLine(" Level "..tierLevel, 1, 0.8, 0)
				GameTooltip:AddLine(" ")
			else
				GameTooltip:AddLine(" Level "..tierLevel, 0.5, 0.5, 0.5)
				GameTooltip:AddLine(" ")
			end

			for i, _ in pairs(allTierInfo[j]["azeritePowerIDs"]) do
				local azeritePowerID = allTierInfo[j]["azeritePowerIDs"][i]
				local azeriteSpellID = GetAzeritePowerID(allTierInfo[j]["azeritePowerIDs"][i])
				local azeritePowerName, _, icon = GetSpellInfo(azeriteSpellID)
				local azeriteIcon = '|T'..icon..':20:20:0:0:64:64:4:60:4:60|t'

				if C_AzeriteEmpoweredItem.IsPowerAvailableForSpec(azeritePowerID, specID) then

					if tierLevel <= currentLevel then
						GameTooltip:AddLine("   "..azeriteIcon.."  "..azeritePowerName, 0, 1, 0)
					else
						GameTooltip:AddLine("   "..azeriteIcon.."  ".. azeritePowerName, 0.5, 0.5, 0.5)
					end

				end
			end
			GameTooltip:AddLine(" ")
		end
	end
end

GameTooltip:HookScript("OnTooltipSetItem", AzeriteTooltip)
