﻿local RelicInspector = {}  -- Author: Thoralie

-- ArtifactData.lua
local RelicInspector_RelicTypes = {
	["Blood"] = RELIC_SLOT_TYPE_BLOOD,
	["Shadow"] = RELIC_SLOT_TYPE_SHADOW,
	["Iron"] = RELIC_SLOT_TYPE_IRON,
	["Frost"] = RELIC_SLOT_TYPE_FROST,
	["Fire"] = RELIC_SLOT_TYPE_FIRE,
	["Fel"] = RELIC_SLOT_TYPE_FEL,
	["Arcane"] = RELIC_SLOT_TYPE_ARCANE,
	["Life"] = RELIC_SLOT_TYPE_LIFE,
	["Wind"] = RELIC_SLOT_TYPE_WIND,
	["Holy"] = RELIC_SLOT_TYPE_HOLY,
}

local RelicInspector_RelicSlots = {
	[127829] = {"Fel","Shadow","Fel"}, -- Havoc DH
	[128832] = {"Iron","Arcane","Fel"}, -- Vengeance DH

	[128402] = {"Blood","Shadow","Iron"}, -- Blood DK
	[128292] = {"Frost","Shadow","Frost"}, -- Frost DK
	[128403] = {"Fire","Shadow","Blood"}, -- Unholy DK

	[128858] = {"Arcane","Life","Arcane"}, -- Balance Druid
	[128860] = {"Frost","Blood","Life"}, -- Feral Druid
	[128821] = {"Fire","Blood","Life"}, -- Guardian Druid
	[128306] = {"Life","Frost","Life"}, -- Restoration Druid

	[128861] = {"Wind","Arcane","Iron"}, -- Beast Mastery Hunter
	[128826] = {"Wind","Blood","Life"}, -- Marksmanship Hunter
	[128808] = {"Wind","Iron","Blood"}, -- Survival Hunter

	[127857] = {"Arcane","Frost","Arcane"}, -- Arcane Mage
	[128820] = {"Fire","Arcane","Fire"}, -- Fire Mage
	[128862] = {"Frost","Arcane","Frost"}, -- Frost Mage

	[128938] = {"Life","Wind","Iron"}, -- Brewmaster Monk
	[128937] = {"Frost","Life","Wind"}, -- Mistweaver Monk
	[128940] = {"Wind","Iron","Wind"}, -- Windwalker Monk

	[128823] = {"Holy","Life","Holy"}, -- Holy Paladin
	[128866] = {"Holy","Iron","Arcane"}, -- Protection Paladin
	[120978] = {"Holy","Fire","Holy"}, -- Retribution Paladin

	[128868] = {"Holy","Shadow","Holy"}, -- Discipline Priest
	[128825] = {"Holy","Life","Holy"}, -- Holy Priest
	[128827] = {"Shadow","Blood","Shadow"}, -- Shadow Priest

	[128870] = {"Shadow","Iron","Blood"}, -- Assassination Rogue
	[128872] = {"Blood","Iron","Wind"}, -- Outlaw Rogue
	[128476] = {"Fel","Shadow","Fel"}, -- Subtlety Rogue

	[128935] = {"Wind","Frost","Wind"}, -- Elemental Shaman
	[128819] = {"Fire","Iron","Wind"}, -- Enhancement Shaman
	[128911] = {"Life","Frost","Life"}, -- Restoration Shaman

	[128942] = {"Shadow","Blood","Shadow"}, -- Affliction Warlock
	[128943] = {"Shadow","Fire","Fel"}, -- Demonology Warlock
	[128941] = {"Fel","Fire","Fel"}, -- Destruction Warlock

	[128910] = {"Iron","Blood","Shadow"}, -- Arms Warrior
	[128908] = {"Fire","Wind","Iron"}, -- Fury Warrior
	[128289] = {"Iron","Blood","Fire"}, -- Protection Warrior
}

local RelicInspector_Artifacts = {
	[127829] = 577, -- Havoc DH
	[128832] = 581, -- Vengeance DH

	[128402] = 250, -- Blood DK
	[128292] = 251, -- Frost DK
	[128403] = 252, -- Unholy DK

	[128858] = 102, -- Balance Druid
	[128860] = 103, -- Feral Druid
	[128821] = 104, -- Guardian Druid
	[128306] = 105, -- Restoration Druid

	[128861] = 253, -- Beast Mastery Hunter
	[128826] = 254, -- Marksmanship Hunter
	[128808] = 255, -- Survival Hunter

	[127857] = 62, -- Arcane Mage
	[128820] = 63, -- Fire Mage
	[128862] = 64, -- Frost Mage

	[128938] = 268, -- Brewmaster Monk
	[128937] = 270, -- Mistweaver Monk
	[128940] = 269, -- Windwalker Monk

	[128823] = 65, -- Holy Paladin
	[128866] = 66, -- Protection Paladin
	[120978] = 70, -- Retribution Paladin

	[128868] = 256, -- Discipline Priest
	[128825] = 257, -- Holy Priest
	[128827] = 258, -- Shadow Priest

	[128870] = 259, -- Assassination Rogue
	[128872] = 260, -- Outlaw Rogue
	[128476] = 261, -- Subtlety Rogue

	[128935] = 262, -- Elemental Shaman
	[128819] = 263, -- Enhancement Shaman
	[128911] = 264, -- Restoration Shaman

	[128942] = 265, -- Affliction Warlock
	[128943] = 266, -- Demonology Warlock
	[128941] = 267, -- Destruction Warlock

	[128910] = 71, -- Arms Warrior
	[128908] = 72, -- Fury Warrior
	[128289] = 73, -- Protection Warrior	
}

local RelicInspector_PowersToScrape = {
	[1770] = 1,
	[1771] = 1,
	[1774] = 1,
	[1775] = 1,
	[1777] = 1,
	[1778] = 1,
	[1779] = 1,
	[1780] = 1,
	[1781] = 1,
	[1782] = 1,
	[1783] = 1,
	[1784] = 1,
}

-- TraitSpellIDs.lua
local RelicInspector_SpellIDByRelic = {
	["128866.152043"] = 209226,
	["128825.152043"] = 196418,
	["120978.152043"] = 186945,
	["128823.152043"] = 200296,
	["128868.152043"] = 197716,

	["128823.152044"] = 200326,
	["128868.152044"] = 197708,
	["120978.152044"] = 186941,
	["128866.152044"] = 209229,
	["128825.152044"] = 196434,

	["128823.152045"] = 200482,
	["128868.152045"] = 197762,
	["128825.152045"] = 196430,
	["128866.152045"] = 209216,
	["120978.152045"] = 186944,

	["128868.152046"] = 238063,
	["128823.152046"] = 238060,
	["120978.152046"] = 238062,
	["128866.152046"] = 238061,
	["128825.152046"] = 238064,

	["128823.152347"] = 200302,
	["128868.152347"] = 216212,
	["120978.152347"] = 184778,
	["128866.152347"] = 209225,
	["128825.152347"] = 196355,

	["128868.155851"] = 197729,
	["128823.155851"] = 200298,
	["128825.155851"] = 196429,
	["128866.155851"] = 209218,
	["120978.155851"] = 185368,

	["128872.152058"] = 202507,
	["128819.152058"] = 198236,
	["128935.152058"] = 191499,
	["128826.152058"] = 190457,
	["128908.152058"] = 216273,
	["128938.152058"] = 213049,
	["128937.152058"] = 199366,
	["128808.152058"] = 203577,
	["128940.152058"] = 195263,
	["128861.152058"] = 197047,

	["128861.152059"] = 197140,
	["128940.152059"] = 195269,
	["128808.152059"] = 203669,
	["128938.152059"] = 213055,
	["128937.152059"] = 199377,
	["128908.152059"] = 200856,
	["128826.152059"] = 190520,
	["128935.152059"] = 191572,
	["128819.152059"] = 198299,
	["128872.152059"] = 202524,

	["128819.152060"] = 215381,
	["128935.152060"] = 191493,
	["128872.152060"] = 216230,
	["128826.152060"] = 190449,
	["128938.152060"] = 213051,
	["128937.152060"] = 199364,
	["128908.152060"] = 200846,
	["128808.152060"] = 203566,
	["128940.152060"] = 195243,
	["128861.152060"] = 197038,

	["128940.152061"] = 195266,
	["128861.152061"] = 197139,
	["128819.152061"] = 198292,
	["128935.152061"] = 191740,
	["128872.152061"] = 202522,
	["128826.152061"] = 190467,
	["128938.152061"] = 213062,
	["128937.152061"] = 199372,
	["128908.152061"] = 200853,
	["128808.152061"] = 203638,

	["128808.152348"] = 224764,
	["128908.152348"] = 200857,
	["128937.152348"] = 199365,
	["128938.152348"] = 213047,
	["128826.152348"] = 190503,
	["128872.152348"] = 202521,
	["128935.152348"] = 191569,
	["128819.152348"] = 198296,
	["128861.152348"] = 197160,
	["128940.152348"] = 195244,

	["128908.155853"] = 200860,
	["128938.155853"] = 213133,
	["128937.155853"] = 199380,
	["128808.155853"] = 203670,
	["128872.155853"] = 202530,
	["128819.155853"] = 198349,
	["128935.155853"] = 191577,
	["128826.155853"] = 190529,
	["128861.155853"] = 197162,
	["128940.155853"] = 195291,

	["128821.152050"] = 208762,
	["128858.152050"] = 202426,
	["128825.152050"] = 196416,
	["128306.152050"] = 189760,
	["128860.152050"] = 210575,
	["128823.152050"] = 200315,
	["128911.152050"] = 207118,
	["128826.152050"] = 190462,
	["128937.152050"] = 199367,
	["128938.152050"] = 213180,

	["128911.152051"] = 207255,
	["128823.152051"] = 200294,
	["128826.152051"] = 190520,
	["128937.152051"] = 199377,
	["128938.152051"] = 213055,
	["128858.152051"] = 202445,
	["128821.152051"] = 200409,
	["128860.152051"] = 210593,
	["128306.152051"] = 189754,
	["128825.152051"] = 196422,

	["128821.152052"] = 200399,
	["128858.152052"] = 202386,
	["128825.152052"] = 196358,
	["128306.152052"] = 189768,
	["128860.152052"] = 210571,
	["128823.152052"] = 200316,
	["128911.152052"] = 207092,
	["128826.152052"] = 190457,
	["128937.152052"] = 199366,
	["128938.152052"] = 213049,

	["128306.152053"] = 186320,
	["128860.152053"] = 210590,
	["128825.152053"] = 196355,
	["128858.152053"] = 203018,
	["128821.152053"] = 200440,
	["128938.152053"] = 213116,
	["128937.152053"] = 199384,
	["128826.152053"] = 190514,
	["128911.152053"] = 207354,
	["128823.152053"] = 200302,

	["128858.152291"] = 238047,
	["128821.152291"] = 238049,
	["128860.152291"] = 238048,
	["128306.152291"] = 238050,
	["128825.152291"] = 238064,
	["128937.152291"] = 238058,
	["128938.152291"] = 238057,
	["128911.152291"] = 238071,
	["128823.152291"] = 238060,
	["128826.152291"] = 238052,

	["128826.155854"] = 190567,
	["128911.155854"] = 207348,
	["128823.155854"] = 200482,
	["128937.155854"] = 199485,
	["128938.155854"] = 213136,
	["128860.155854"] = 210631,
	["128306.155854"] = 189744,
	["128825.155854"] = 196430,
	["128858.155854"] = 202464,
	["128821.155854"] = 200415,

	["128820.152035"] = 194239,
	["128821.152035"] = 200415,
	["128819.152035"] = 198238,
	["128943.152035"] = 211099,
	["128941.152035"] = 196258,
	["120978.152035"] = 186944,
	["128289.152035"] = 188639,
	["128403.152035"] = 208598,
	["128908.152035"] = 200861,

	["128820.152036"] = 194234,
	["128821.152036"] = 200399,
	["128943.152036"] = 211126,
	["128819.152036"] = 198236,
	["128908.152036"] = 216273,
	["128289.152036"] = 216272,
	["128403.152036"] = 191442,
	["120978.152036"] = 184759,
	["128941.152036"] = 196217,

	["128943.152037"] = 211105,
	["128819.152037"] = 198299,
	["128908.152037"] = 200856,
	["128289.152037"] = 203225,
	["128403.152037"] = 191494,
	["120978.152037"] = 186927,
	["128941.152037"] = 196236,
	["128820.152037"] = 194313,
	["128821.152037"] = 200409,

	["128821.152038"] = 200395,
	["128820.152038"] = 194224,
	["128941.152038"] = 196211,
	["128403.152038"] = 191419,
	["128289.152038"] = 188635,
	["120978.152038"] = 186941,
	["128908.152038"] = 200846,
	["128819.152038"] = 215381,
	["128943.152038"] = 211108,

	["128820.152294"] = 194318,
	["128821.152294"] = 200400,
	["128819.152294"] = 198296,
	["128943.152294"] = 211144,
	["128289.152294"] = 188632,
	["128403.152294"] = 191565,
	["120978.152294"] = 186934,
	["128908.152294"] = 200857,
	["128941.152294"] = 196301,

	["128941.155849"] = 196222,
	["120978.155849"] = 184843,
	["128289.155849"] = 188683,
	["128403.155849"] = 191485,
	["128908.155849"] = 200849,
	["128819.155849"] = 198247,
	["128943.155849"] = 211106,
	["128821.155849"] = 208762,
	["128820.155849"] = 194312,

	["128292.152039"] = 189164,
	["128937.152039"] = 199372,
	["128862.152039"] = 195323,
	["128935.152039"] = 191740,
	["128911.152039"] = 207206,
	["128306.152039"] = 189757,
	["128860.152039"] = 210579,
	["127857.152039"] = 187264,

	["128937.152040"] = 199485,
	["128292.152040"] = 189097,
	["128911.152040"] = 207348,
	["128935.152040"] = 191598,
	["128862.152040"] = 195352,
	["127857.152040"] = 187287,
	["128860.152040"] = 210631,
	["128306.152040"] = 189744,

	["128937.152041"] = 199364,
	["128292.152041"] = 189080,
	["128862.152041"] = 195315,
	["128911.152041"] = 207088,
	["128935.152041"] = 191493,
	["127857.152041"] = 187304,
	["128860.152041"] = 210570,
	["128306.152041"] = 189772,

	["128935.152042"] = 191577,
	["128911.152042"] = 207285,
	["128862.152042"] = 195351,
	["128937.152042"] = 199380,
	["128292.152042"] = 189147,
	["127857.152042"] = 187276,
	["128860.152042"] = 210637,
	["128306.152042"] = 189749,

	["128935.152346"] = 191569,
	["128911.152346"] = 207351,
	["128862.152346"] = 195354,
	["128937.152346"] = 199365,
	["128292.152346"] = 189154,
	["127857.152346"] = 187301,
	["128860.152346"] = 210557,
	["128306.152346"] = 186396,

	["128862.155850"] = 195322,
	["128911.155850"] = 207118,
	["128935.155850"] = 191504,
	["128292.155850"] = 189086,
	["128937.155850"] = 199367,
	["128306.155850"] = 189760,
	["128860.155850"] = 210575,
	["127857.155850"] = 187321,

	["128858.152024"] = 202384,
	["127857.152024"] = 187304,
	["128861.152024"] = 197038,
	["128832.152024"] = 207343,
	["128820.152024"] = 194224,
	["128866.152024"] = 209229,
	["128862.152024"] = 195315,

	["128820.152025"] = 238055,
	["127857.152025"] = 238054,
	["128858.152025"] = 238047,
	["128861.152025"] = 238051,
	["128832.152025"] = 238046,
	["128862.152025"] = 238056,
	["128866.152025"] = 238061,

	["128866.152026"] = 209216,
	["128862.152026"] = 195352,
	["127857.152026"] = 187287,
	["128858.152026"] = 202464,
	["128861.152026"] = 206910,
	["128832.152026"] = 212819,
	["128820.152026"] = 194239,

	["128820.152027"] = 194234,
	["127857.152027"] = 187258,
	["128858.152027"] = 202386,
	["128861.152027"] = 197047,
	["128832.152027"] = 207347,
	["128862.152027"] = 195317,
	["128866.152027"] = 209217,

	["128862.152344"] = 214626,
	["128866.152344"] = 209225,
	["128820.152344"] = 194315,
	["128832.152344"] = 212827,
	["128861.152344"] = 197138,
	["128858.152344"] = 203018,
	["127857.152344"] = 210716,

	["128862.155846"] = 195323,
	["128866.155846"] = 209226,
	["128820.155846"] = 210182,
	["128832.155846"] = 207375,
	["128858.155846"] = 202433,
	["127857.155846"] = 187264,
	["128861.155846"] = 197139,

	["128943.152031"] = 211119,
	["128941.152031"] = 196432,
	["128476.152031"] = 197386,
	["128832.152031"] = 212817,
	["127829.152031"] = 201460,

	["128943.152032"] = 211099,
	["128941.152032"] = 196258,
	["128476.152032"] = 197239,
	["127829.152032"] = 201464,
	["128832.152032"] = 212819,

	["128832.152033"] = 212816,
	["127829.152033"] = 201458,
	["128476.152033"] = 197369,
	["128941.152033"] = 196236,
	["128943.152033"] = 211105,

	["127829.152034"] = 201457,
	["128832.152034"] = 207375,
	["128476.152034"] = 197235,
	["128941.152034"] = 196227,
	["128943.152034"] = 211123,

	["128943.152345"] = 211099,
	["128941.152345"] = 196258,
	["127829.152345"] = 201464,
	["128832.152345"] = 212819,
	["128476.152345"] = 197239,

	["128943.155848"] = 238073,
	["128941.155848"] = 238074,
	["128832.155848"] = 238046,
	["127829.155848"] = 238045,
	["128476.155848"] = 238068,

	["128403.152054"] = 191494,
	["128870.152054"] = 192329,
	["128292.152054"] = 189144,
	["128942.152054"] = 199153,
	["128943.152054"] = 211105,
	["128827.152054"] = 194007,
	["128476.152054"] = 197369,
	["127829.152054"] = 201458,
	["128868.152054"] = 197727,
	["128910.152054"] = 209481,
	["128402.152054"] = 192460,

	["128942.152055"] = 199120,
	["128870.152055"] = 192318,
	["128292.152055"] = 189086,
	["128403.152055"] = 191485,
	["128943.152055"] = 211106,
	["128827.152055"] = 193644,
	["127829.152055"] = 201456,
	["128476.152055"] = 197234,
	["128910.152055"] = 209472,
	["128402.152055"] = 192447,
	["128868.152055"] = 197715,

	["128476.152056"] = 197231,
	["127829.152056"] = 201454,
	["128868.152056"] = 197708,
	["128402.152056"] = 192450,
	["128910.152056"] = 209459,
	["128403.152056"] = 191419,
	["128870.152056"] = 192310,
	["128942.152056"] = 199111,
	["128292.152056"] = 189080,
	["128827.152056"] = 194093,
	["128943.152056"] = 211108,

	["128870.152057"] = 238066,
	["128942.152057"] = 238072,
	["128292.152057"] = 238043,
	["128403.152057"] = 238044,
	["128943.152057"] = 238073,
	["128827.152057"] = 238065,
	["127829.152057"] = 238045,
	["128476.152057"] = 238068,
	["128910.152057"] = 238075,
	["128402.152057"] = 238042,
	["128868.152057"] = 238063,

	["127829.152290"] = 201459,
	["128476.152290"] = 197241,
	["128910.152290"] = 209483,
	["128402.152290"] = 192514,
	["128868.152290"] = 197711,
	["128292.152290"] = 189154,
	["128870.152290"] = 192323,
	["128942.152290"] = 199212,
	["128403.152290"] = 191565,
	["128943.152290"] = 211144,
	["128827.152290"] = 193642,

	["128403.155852"] = 191442,
	["128870.155852"] = 192315,
	["128292.155852"] = 189092,
	["128942.155852"] = 199112,
	["128827.155852"] = 193643,
	["128943.155852"] = 211126,
	["128476.155852"] = 197233,
	["127829.155852"] = 201455,
	["128868.155852"] = 197713,
	["128402.155852"] = 192453,
	["128910.155852"] = 209462,

	["128910.152028"] = 209494,
	["128402.152028"] = 192464,
	["128821.152028"] = 200415,
	["128860.152028"] = 210631,
	["128872.152028"] = 202907,
	["128827.152028"] = 194002,
	["128826.152028"] = 190567,
	["128289.152028"] = 188639,
	["128403.152028"] = 208598,
	["128808.152028"] = 203673,
	["128870.152028"] = 192376,
	["128942.152028"] = 199163,

	["128403.152029"] = 191592,
	["128289.152029"] = 203230,
	["128870.152029"] = 192326,
	["128942.152029"] = 199152,
	["128808.152029"] = 203638,
	["128827.152029"] = 193645,
	["128872.152029"] = 202522,
	["128826.152029"] = 190467,
	["128821.152029"] = 200402,
	["128860.152029"] = 210579,
	["128402.152029"] = 192457,
	["128910.152029"] = 216274,

	["128910.152030"] = 209483,
	["128402.152030"] = 192514,
	["128860.152030"] = 210557,
	["128821.152030"] = 200400,
	["128826.152030"] = 190503,
	["128872.152030"] = 202521,
	["128827.152030"] = 193642,
	["128808.152030"] = 224764,
	["128942.152030"] = 199212,
	["128870.152030"] = 192323,
	["128289.152030"] = 188632,
	["128403.152030"] = 191565,

	["128910.152092"] = 248579,
	["128402.152092"] = 192542,
	["128821.152092"] = 200414,
	["128860.152092"] = 210637,
	["128872.152092"] = 202530,
	["128827.152092"] = 194016,
	["128826.152092"] = 190529,
	["128289.152092"] = 203227,
	["128403.152092"] = 191488,
	["128808.152092"] = 203670,
	["128870.152092"] = 192349,
	["128942.152092"] = 199158,

	["128289.152295"] = 188683,
	["128403.152295"] = 191485,
	["128808.152295"] = 203578,
	["128870.152295"] = 192318,
	["128942.152295"] = 199120,
	["128872.152295"] = 202514,
	["128827.152295"] = 193644,
	["128826.152295"] = 190462,
	["128821.152295"] = 208762,
	["128860.152295"] = 210575,
	["128910.152295"] = 209472,
	["128402.152295"] = 192447,

	["128860.155847"] = 210570,
	["128821.155847"] = 200395,
	["128402.155847"] = 192450,
	["128910.155847"] = 209459,
	["128942.155847"] = 199111,
	["128870.155847"] = 192310,
	["128808.155847"] = 203566,
	["128289.155847"] = 188635,
	["128403.155847"] = 191419,
	["128826.155847"] = 190449,
	["128827.155847"] = 194093,
	["128872.155847"] = 216230,

	["128402.152047"] = 192453,
	["128910.152047"] = 209462,
	["128940.152047"] = 195263,
	["128861.152047"] = 197047,
	["128832.152047"] = 207347,
	["128819.152047"] = 198236,
	["128872.152047"] = 202507,
	["128289.152047"] = 216272,
	["128938.152047"] = 213049,
	["128908.152047"] = 216273,
	["128870.152047"] = 192315,
	["128808.152047"] = 203577,
	["128866.152047"] = 209217,

	["128861.152048"] = 238051,
	["128832.152048"] = 238046,
	["128910.152048"] = 238075,
	["128940.152048"] = 238059,
	["128402.152048"] = 238042,
	["128908.152048"] = 238076,
	["128938.152048"] = 238057,
	["128289.152048"] = 238077,
	["128866.152048"] = 238061,
	["128808.152048"] = 238053,
	["128870.152048"] = 238066,
	["128872.152048"] = 238067,
	["128819.152048"] = 238070,

	["128861.152049"] = 197080,
	["128832.152049"] = 207352,
	["128402.152049"] = 192447,
	["128940.152049"] = 218607,
	["128910.152049"] = 209472,
	["128938.152049"] = 213180,
	["128289.152049"] = 188683,
	["128908.152049"] = 200849,
	["128870.152049"] = 192318,
	["128808.152049"] = 203578,
	["128866.152049"] = 209220,
	["128819.152049"] = 198247,
	["128872.152049"] = 202514,

	["128940.152292"] = 195380,
	["128910.152292"] = 209541,
	["128402.152292"] = 192538,
	["128861.152292"] = 197138,
	["128832.152292"] = 212827,
	["128872.152292"] = 202533,
	["128819.152292"] = 198248,
	["128908.152292"] = 200859,
	["128289.152292"] = 188644,
	["128938.152292"] = 213116,
	["128866.152292"] = 209225,
	["128808.152292"] = 203749,
	["128870.152292"] = 192345,

	["128861.152293"] = 197162,
	["128832.152293"] = 212817,
	["128402.152293"] = 192542,
	["128940.152293"] = 195291,
	["128910.152293"] = 248579,
	["128938.152293"] = 213133,
	["128289.152293"] = 203227,
	["128908.152293"] = 200860,
	["128870.152293"] = 192349,
	["128808.152293"] = 203670,
	["128866.152293"] = 209218,
	["128819.152293"] = 198349,
	["128872.152293"] = 202530,

	["128832.155855"] = 212816,
	["128861.155855"] = 197140,
	["128910.155855"] = 209481,
	["128940.155855"] = 195269,
	["128402.155855"] = 192460,
	["128808.155855"] = 203669,
	["128866.155855"] = 209223,
	["128870.155855"] = 192329,
	["128908.155855"] = 200856,
	["128289.155855"] = 203225,
	["128938.155855"] = 213055,
	["128872.155855"] = 202524,
	["128819.155855"] = 198299,

	["128306.144227"] = 189768,
	["128860.144227"] = 210571,
	["127857.144227"] = 187258,
	["128292.144227"] = 189092,
	["128937.144227"] = 199366,
	["128862.144227"] = 195317,
	["128935.144227"] = 191499,
	["128911.144227"] = 207092,

	["128868.147096"] = 197715,
	["128825.147096"] = 196416,
	["128823.147096"] = 200315,
	["120978.147096"] = 184843,
	["128866.147096"] = 209220,

	["128866.147097"] = 209223,
	["120978.147097"] = 186927,
	["128823.147097"] = 200294,
	["128825.147097"] = 196422,
	["128868.147097"] = 197727,

	["128866.147098"] = 238061,
	["120978.147098"] = 238062,
	["128823.147098"] = 238060,
	["128825.147098"] = 238064,
	["128868.147098"] = 238063,

	["128823.147099"] = 200316,
	["120978.147099"] = 184759,
	["128866.147099"] = 209217,
	["128868.147099"] = 197713,
	["128825.147099"] = 196358,

	["128825.147758"] = 196434,
	["128868.147758"] = 197708,
	["120978.147758"] = 186941,
	["128866.147758"] = 209229,
	["128823.147758"] = 200326,

	["128908.147112"] = 238076,
	["128937.147112"] = 238058,
	["128938.147112"] = 238057,
	["128808.147112"] = 238053,
	["128872.147112"] = 238067,
	["128819.147112"] = 238070,
	["128935.147112"] = 238069,
	["128826.147112"] = 238052,
	["128861.147112"] = 238051,
	["128940.147112"] = 238059,

	["128937.147113"] = 199380,
	["128938.147113"] = 213133,
	["128908.147113"] = 200860,
	["128808.147113"] = 203670,
	["128819.147113"] = 198349,
	["128935.147113"] = 191577,
	["128872.147113"] = 202530,
	["128826.147113"] = 190529,
	["128861.147113"] = 197162,
	["128940.147113"] = 195291,

	["128861.147114"] = 206910,
	["128940.147114"] = 195267,
	["128908.147114"] = 200861,
	["128937.147114"] = 199485,
	["128938.147114"] = 213136,
	["128808.147114"] = 203673,
	["128872.147114"] = 202907,
	["128819.147114"] = 198238,
	["128935.147114"] = 191598,
	["128826.147114"] = 190567,

	["128819.147115"] = 198247,
	["128935.147115"] = 191504,
	["128872.147115"] = 202514,
	["128826.147115"] = 190462,
	["128937.147115"] = 199367,
	["128938.147115"] = 213180,
	["128908.147115"] = 200849,
	["128808.147115"] = 203578,
	["128940.147115"] = 218607,
	["128861.147115"] = 197080,

	["128940.147761"] = 195266,
	["128861.147761"] = 197139,
	["128826.147761"] = 190467,
	["128872.147761"] = 202522,
	["128935.147761"] = 191740,
	["128819.147761"] = 198292,
	["128808.147761"] = 203638,
	["128908.147761"] = 200853,
	["128937.147761"] = 199372,
	["128938.147761"] = 213062,

	["128937.147104"] = 199377,
	["128938.147104"] = 213055,
	["128826.147104"] = 190520,
	["128911.147104"] = 207255,
	["128823.147104"] = 200294,
	["128860.147104"] = 210593,
	["128306.147104"] = 189754,
	["128825.147104"] = 196422,
	["128858.147104"] = 202445,
	["128821.147104"] = 200409,

	["128306.147105"] = 189749,
	["128860.147105"] = 210637,
	["128825.147105"] = 196429,
	["128858.147105"] = 202466,
	["128821.147105"] = 200414,
	["128826.147105"] = 190529,
	["128911.147105"] = 207285,
	["128823.147105"] = 200298,
	["128938.147105"] = 213133,
	["128937.147105"] = 199380,

	["128306.147106"] = 189772,
	["128860.147106"] = 210570,
	["128825.147106"] = 196434,
	["128858.147106"] = 202384,
	["128821.147106"] = 200395,
	["128937.147106"] = 199364,
	["128938.147106"] = 213051,
	["128826.147106"] = 190449,
	["128911.147106"] = 207088,
	["128823.147106"] = 200326,

	["128858.147107"] = 202433,
	["128821.147107"] = 200402,
	["128306.147107"] = 189757,
	["128860.147107"] = 210579,
	["128825.147107"] = 196418,
	["128911.147107"] = 207206,
	["128823.147107"] = 200296,
	["128826.147107"] = 190467,
	["128938.147107"] = 213062,
	["128937.147107"] = 199372,

	["128858.147760"] = 202386,
	["128821.147760"] = 200399,
	["128860.147760"] = 210571,
	["128306.147760"] = 189768,
	["128825.147760"] = 196358,
	["128937.147760"] = 199366,
	["128938.147760"] = 213049,
	["128911.147760"] = 207092,
	["128823.147760"] = 200316,
	["128826.147760"] = 190457,

	["128943.147088"] = 211123,
	["128819.147088"] = 198292,
	["128908.147088"] = 200853,
	["128289.147088"] = 203230,
	["128403.147088"] = 191592,
	["120978.147088"] = 186945,
	["128941.147088"] = 196227,
	["128820.147088"] = 210182,
	["128821.147088"] = 200402,

	["128819.147089"] = 198238,
	["128943.147089"] = 211099,
	["128941.147089"] = 196258,
	["128403.147089"] = 208598,
	["128289.147089"] = 188639,
	["120978.147089"] = 186944,
	["128908.147089"] = 200861,
	["128820.147089"] = 194239,
	["128821.147089"] = 200415,

	["128943.147090"] = 211105,
	["128819.147090"] = 198299,
	["128941.147090"] = 196236,
	["128908.147090"] = 200856,
	["128403.147090"] = 191494,
	["128289.147090"] = 203225,
	["120978.147090"] = 186927,
	["128820.147090"] = 194313,
	["128821.147090"] = 200409,

	["128819.147091"] = 198349,
	["128943.147091"] = 211119,
	["128941.147091"] = 196432,
	["128403.147091"] = 191488,
	["128289.147091"] = 203227,
	["120978.147091"] = 185368,
	["128908.147091"] = 200860,
	["128820.147091"] = 194314,
	["128821.147091"] = 200414,

	["128821.147756"] = 200395,
	["128820.147756"] = 194224,
	["128941.147756"] = 196211,
	["120978.147756"] = 186941,
	["128289.147756"] = 188635,
	["128403.147756"] = 191419,
	["128908.147756"] = 200846,
	["128819.147756"] = 215381,
	["128943.147756"] = 211108,

	["127857.147092"] = 187258,
	["128860.147092"] = 210571,
	["128306.147092"] = 189768,
	["128937.147092"] = 199366,
	["128292.147092"] = 189092,
	["128862.147092"] = 195317,
	["128911.147092"] = 207092,
	["128935.147092"] = 191499,

	["128306.147093"] = 189772,
	["128860.147093"] = 210570,
	["127857.147093"] = 187304,
	["128911.147093"] = 207088,
	["128935.147093"] = 191493,
	["128862.147093"] = 195315,
	["128292.147093"] = 189080,
	["128937.147093"] = 199364,

	["128292.147094"] = 189097,
	["128937.147094"] = 199485,
	["128862.147094"] = 195352,
	["128911.147094"] = 207348,
	["128935.147094"] = 191598,
	["128306.147094"] = 189744,
	["128860.147094"] = 210631,
	["127857.147094"] = 187287,

	["128937.147095"] = 199377,
	["128292.147095"] = 189144,
	["128911.147095"] = 207255,
	["128935.147095"] = 191572,
	["128862.147095"] = 195345,
	["127857.147095"] = 187313,
	["128860.147095"] = 210593,
	["128306.147095"] = 189754,

	["128306.147757"] = 189760,
	["128860.147757"] = 210575,
	["127857.147757"] = 187321,
	["128862.147757"] = 195322,
	["128911.147757"] = 207118,
	["128935.147757"] = 191504,
	["128292.147757"] = 189086,
	["128937.147757"] = 199367,

	["128866.147076"] = 209218,
	["128862.147076"] = 195351,
	["128832.147076"] = 212817,
	["128858.147076"] = 202466,
	["127857.147076"] = 187276,
	["128861.147076"] = 197162,
	["128820.147076"] = 194314,

	["128861.147077"] = 197140,
	["128858.147077"] = 202445,
	["127857.147077"] = 187313,
	["128832.147077"] = 212816,
	["128820.147077"] = 194313,
	["128866.147077"] = 209223,
	["128862.147077"] = 195345,

	["128832.147078"] = 207352,
	["127857.147078"] = 187321,
	["128858.147078"] = 202426,
	["128861.147078"] = 197080,
	["128820.147078"] = 194312,
	["128866.147078"] = 209220,
	["128862.147078"] = 195322,

	["128832.147079"] = 238046,
	["128861.147079"] = 238051,
	["127857.147079"] = 238054,
	["128858.147079"] = 238047,
	["128820.147079"] = 238055,
	["128866.147079"] = 238061,
	["128862.147079"] = 238056,

	["128943.147084"] = 211106,
	["128941.147084"] = 196222,
	["128832.147084"] = 207352,
	["127829.147084"] = 201456,
	["128476.147084"] = 197234,

	["127829.147085"] = 238045,
	["128832.147085"] = 238046,
	["128476.147085"] = 238068,
	["128941.147085"] = 238074,
	["128943.147085"] = 238073,

	["128941.147086"] = 196217,
	["128943.147086"] = 211126,
	["127829.147086"] = 201455,
	["128832.147086"] = 207347,
	["128476.147086"] = 197233,

	["128476.147087"] = 197231,
	["127829.147087"] = 201454,
	["128832.147087"] = 207343,
	["128941.147087"] = 196211,
	["128943.147087"] = 211108,

	["127829.147755"] = 201460,
	["128832.147755"] = 212817,
	["128476.147755"] = 197386,
	["128941.147755"] = 196432,
	["128943.147755"] = 211119,

	["128943.147108"] = 211123,
	["128827.147108"] = 193645,
	["128292.147108"] = 189164,
	["128870.147108"] = 192326,
	["128942.147108"] = 199152,
	["128403.147108"] = 191592,
	["128910.147108"] = 216274,
	["128402.147108"] = 192457,
	["128868.147108"] = 197716,
	["127829.147108"] = 201457,
	["128476.147108"] = 197235,

	["128292.147109"] = 189097,
	["128870.147109"] = 192376,
	["128942.147109"] = 199163,
	["128403.147109"] = 208598,
	["128827.147109"] = 194002,
	["128943.147109"] = 211099,
	["127829.147109"] = 201464,
	["128476.147109"] = 197239,
	["128402.147109"] = 192464,
	["128910.147109"] = 209494,
	["128868.147109"] = 197762,

	["128476.147110"] = 197386,
	["127829.147110"] = 201460,
	["128868.147110"] = 197729,
	["128910.147110"] = 248579,
	["128402.147110"] = 192542,
	["128403.147110"] = 191488,
	["128870.147110"] = 192349,
	["128292.147110"] = 189147,
	["128942.147110"] = 199158,
	["128943.147110"] = 211119,
	["128827.147110"] = 194016,

	["127829.147111"] = 201456,
	["128476.147111"] = 197234,
	["128402.147111"] = 192447,
	["128910.147111"] = 209472,
	["128868.147111"] = 197715,
	["128870.147111"] = 192318,
	["128292.147111"] = 189086,
	["128942.147111"] = 199120,
	["128403.147111"] = 191485,
	["128827.147111"] = 193644,
	["128943.147111"] = 211106,

	["128289.147080"] = 216272,
	["128403.147080"] = 191442,
	["128808.147080"] = 203577,
	["128870.147080"] = 192315,
	["128942.147080"] = 199112,
	["128872.147080"] = 202507,
	["128827.147080"] = 193643,
	["128826.147080"] = 190457,
	["128821.147080"] = 200399,
	["128860.147080"] = 210571,
	["128910.147080"] = 209462,
	["128402.147080"] = 192453,

	["128910.147081"] = 209481,
	["128402.147081"] = 192460,
	["128860.147081"] = 210593,
	["128821.147081"] = 200409,
	["128826.147081"] = 190520,
	["128872.147081"] = 202524,
	["128827.147081"] = 194007,
	["128808.147081"] = 203669,
	["128942.147081"] = 199153,
	["128870.147081"] = 192329,
	["128289.147081"] = 203225,
	["128403.147081"] = 191494,

	["128808.147082"] = 238053,
	["128942.147082"] = 238072,
	["128870.147082"] = 238066,
	["128289.147082"] = 238077,
	["128403.147082"] = 238044,
	["128826.147082"] = 238052,
	["128872.147082"] = 238067,
	["128827.147082"] = 238065,
	["128860.147082"] = 238048,
	["128821.147082"] = 238049,
	["128910.147082"] = 238075,
	["128402.147082"] = 238042,

	["128821.147754"] = 200440,
	["128860.147754"] = 210590,
	["128402.147754"] = 192538,
	["128910.147754"] = 209541,
	["128289.147754"] = 188644,
	["128403.147754"] = 191584,
	["128870.147754"] = 192345,
	["128942.147754"] = 199214,
	["128808.147754"] = 203749,
	["128827.147754"] = 193647,
	["128872.147754"] = 202533,
	["128826.147754"] = 190514,

	["128860.151189"] = 210637,
	["128821.151189"] = 200414,
	["128402.151189"] = 192542,
	["128910.151189"] = 248579,
	["128942.151189"] = 199158,
	["128870.151189"] = 192349,
	["128808.151189"] = 203670,
	["128403.151189"] = 191488,
	["128289.151189"] = 203227,
	["128826.151189"] = 190529,
	["128827.151189"] = 194016,
	["128872.151189"] = 202530,

	["128861.147100"] = 197139,
	["128832.147100"] = 207375,
	["128910.147100"] = 216274,
	["128940.147100"] = 195266,
	["128402.147100"] = 192457,
	["128908.147100"] = 200853,
	["128938.147100"] = 213062,
	["128289.147100"] = 203230,
	["128866.147100"] = 209226,
	["128808.147100"] = 203638,
	["128870.147100"] = 192326,
	["128872.147100"] = 202522,
	["128819.147100"] = 198292,

	["128872.147101"] = 202507,
	["128819.147101"] = 198236,
	["128808.147101"] = 203577,
	["128866.147101"] = 209217,
	["128870.147101"] = 192315,
	["128908.147101"] = 216273,
	["128938.147101"] = 213049,
	["128289.147101"] = 216272,
	["128910.147101"] = 209462,
	["128940.147101"] = 195263,
	["128402.147101"] = 192453,
	["128832.147101"] = 207347,
	["128861.147101"] = 197047,

	["128861.147102"] = 197038,
	["128832.147102"] = 207343,
	["128402.147102"] = 192450,
	["128940.147102"] = 195243,
	["128910.147102"] = 209459,
	["128938.147102"] = 213051,
	["128289.147102"] = 188635,
	["128908.147102"] = 200846,
	["128870.147102"] = 192310,
	["128808.147102"] = 203566,
	["128866.147102"] = 209229,
	["128819.147102"] = 215381,
	["128872.147102"] = 216230,

	["128861.147759"] = 197160,
	["128832.147759"] = 212821,
	["128940.147759"] = 195244,
	["128910.147759"] = 209483,
	["128402.147759"] = 192514,
	["128908.147759"] = 200857,
	["128938.147759"] = 213047,
	["128289.147759"] = 188632,
	["128866.147759"] = 209224,
	["128808.147759"] = 224764,
	["128870.147759"] = 192323,
	["128872.147759"] = 202521,
	["128819.147759"] = 198296,

	["128823.150996"] = 200296,
	["128866.150996"] = 209226,
	["120978.150996"] = 186945,
	["128868.150996"] = 197716,
	["128825.150996"] = 196418,

	["128823.152695"] = 200315,
	["128866.152695"] = 209220,
	["120978.152695"] = 184843,
	["128868.152695"] = 197715,
	["128825.152695"] = 196416,

	["128861.151015"] = 197139,
	["128940.151015"] = 195266,
	["128908.151015"] = 200853,
	["128937.151015"] = 199372,
	["128938.151015"] = 213062,
	["128808.151015"] = 203638,
	["128872.151015"] = 202522,
	["128819.151015"] = 198292,
	["128935.151015"] = 191740,
	["128826.151015"] = 190467,

	["128940.152715"] = 195266,
	["128861.152715"] = 197139,
	["128819.152715"] = 198292,
	["128935.152715"] = 191740,
	["128872.152715"] = 202522,
	["128826.152715"] = 190467,
	["128938.152715"] = 213062,
	["128937.152715"] = 199372,
	["128908.152715"] = 200853,
	["128808.152715"] = 203638,

	["128938.151003"] = 213136,
	["128937.151003"] = 199485,
	["128826.151003"] = 190567,
	["128823.151003"] = 200482,
	["128911.151003"] = 207348,
	["128825.151003"] = 196430,
	["128860.151003"] = 210631,
	["128306.151003"] = 189744,
	["128821.151003"] = 200415,
	["128858.151003"] = 202464,

	["128825.152697"] = 196422,
	["128306.152697"] = 189754,
	["128860.152697"] = 210593,
	["128821.152697"] = 200409,
	["128858.152697"] = 202445,
	["128826.152697"] = 190520,
	["128823.152697"] = 200294,
	["128911.152697"] = 207255,
	["128938.152697"] = 213055,
	["128937.152697"] = 199377,

	["128289.151000"] = 188683,
	["120978.151000"] = 184843,
	["128403.151000"] = 191485,
	["128908.151000"] = 200849,
	["128941.151000"] = 196222,
	["128819.151000"] = 198247,
	["128943.151000"] = 211106,
	["128821.151000"] = 208762,
	["128820.151000"] = 194312,

	["128943.152693"] = 238073,
	["128819.152693"] = 238070,
	["128941.152693"] = 238074,
	["128908.152693"] = 238076,
	["120978.152693"] = 238062,
	["128289.152693"] = 238077,
	["128403.152693"] = 238044,
	["128820.152693"] = 238055,
	["128821.152693"] = 238049,

	["128862.151001"] = 195322,
	["128911.151001"] = 207118,
	["128935.151001"] = 191504,
	["128937.151001"] = 199367,
	["128292.151001"] = 189086,
	["127857.151001"] = 187321,
	["128860.151001"] = 210575,
	["128306.151001"] = 189760,

	["128937.152694"] = 199485,
	["128292.152694"] = 189097,
	["128862.152694"] = 195352,
	["128935.152694"] = 191598,
	["128911.152694"] = 207348,
	["127857.152694"] = 187287,
	["128860.152694"] = 210631,
	["128306.152694"] = 189744,

	["128832.150997"] = 207343,
	["128861.150997"] = 197038,
	["127857.150997"] = 187304,
	["128858.150997"] = 202384,
	["128820.150997"] = 194224,
	["128866.150997"] = 209229,
	["128862.150997"] = 195315,

	["128820.152690"] = 194234,
	["128861.152690"] = 197047,
	["127857.152690"] = 187258,
	["128858.152690"] = 202386,
	["128832.152690"] = 207347,
	["128862.152690"] = 195317,
	["128866.152690"] = 209217,

	["128943.150999"] = 211105,
	["128941.150999"] = 196236,
	["128476.150999"] = 197369,
	["127829.150999"] = 201458,
	["128832.150999"] = 212816,

	["128832.152692"] = 212816,
	["127829.152692"] = 201458,
	["128476.152692"] = 197369,
	["128941.152692"] = 196236,
	["128943.152692"] = 211105,

	["128403.151004"] = 191442,
	["128292.151004"] = 189092,
	["128870.151004"] = 192315,
	["128942.151004"] = 199112,
	["128943.151004"] = 211126,
	["128827.151004"] = 193643,
	["128476.151004"] = 197233,
	["127829.151004"] = 201455,
	["128868.151004"] = 197713,
	["128910.151004"] = 209462,
	["128402.151004"] = 192453,

	["128868.153421"] = 197716,
	["128402.153421"] = 192457,
	["128910.153421"] = 216274,
	["128476.153421"] = 197235,
	["127829.153421"] = 201457,
	["128827.153421"] = 193645,
	["128943.153421"] = 211123,
	["128403.153421"] = 191592,
	["128292.153421"] = 189164,
	["128870.153421"] = 192326,
	["128942.153421"] = 199152,

	["128872.150998"] = 202522,
	["128827.150998"] = 193645,
	["128826.150998"] = 190467,
	["128289.150998"] = 203230,
	["128403.150998"] = 191592,
	["128808.150998"] = 203638,
	["128870.150998"] = 192326,
	["128942.150998"] = 199152,
	["128910.150998"] = 216274,
	["128402.150998"] = 192457,
	["128821.150998"] = 200402,
	["128860.150998"] = 210579,

	["128942.152691"] = 199158,
	["128870.152691"] = 192349,
	["128808.152691"] = 203670,
	["128403.152691"] = 191488,
	["128289.152691"] = 203227,
	["128826.152691"] = 190529,
	["128827.152691"] = 194016,
	["128872.152691"] = 202530,
	["128860.152691"] = 210637,
	["128821.152691"] = 200414,
	["128402.152691"] = 192542,
	["128910.152691"] = 248579,

	["128908.151002"] = 200861,
	["128938.151002"] = 213136,
	["128289.151002"] = 188639,
	["128808.151002"] = 203673,
	["128866.151002"] = 209216,
	["128870.151002"] = 192376,
	["128872.151002"] = 202907,
	["128819.151002"] = 198238,
	["128861.151002"] = 206910,
	["128832.151002"] = 212819,
	["128940.151002"] = 195267,
	["128910.151002"] = 209494,
	["128402.151002"] = 192464,

	["128866.152696"] = 209220,
	["128808.152696"] = 203578,
	["128870.152696"] = 192318,
	["128908.152696"] = 200849,
	["128289.152696"] = 188683,
	["128938.152696"] = 213180,
	["128872.152696"] = 202514,
	["128819.152696"] = 198247,
	["128832.152696"] = 207352,
	["128861.152696"] = 197080,
	["128940.152696"] = 218607,
	["128910.152696"] = 209472,
	["128402.152696"] = 192447,

	["128825.140843"] = 196418,
	["128868.140843"] = 197716,
	["120978.140843"] = 186945,
	["128866.140843"] = 209226,
	["128823.140843"] = 200296,

	["128866.140844"] = 209229,
	["120978.140844"] = 186941,
	["128823.140844"] = 200326,
	["128825.140844"] = 196434,
	["128868.140844"] = 197708,

	["128868.140845"] = 197727,
	["128825.140845"] = 196422,
	["128823.140845"] = 200294,
	["128866.140845"] = 209223,
	["120978.140845"] = 186927,

	["128868.143528"] = 197708,
	["128825.143528"] = 196434,
	["128823.143528"] = 200326,
	["128866.143528"] = 209229,
	["120978.143528"] = 186941,

	["128940.140840"] = 195263,
	["128861.140840"] = 197047,
	["128872.140840"] = 202507,
	["128819.140840"] = 198236,
	["128935.140840"] = 191499,
	["128826.140840"] = 190457,
	["128908.140840"] = 216273,
	["128938.140840"] = 213049,
	["128937.140840"] = 199366,
	["128808.140840"] = 203577,

	["128872.140841"] = 202530,
	["128819.140841"] = 198349,
	["128935.140841"] = 191577,
	["128826.140841"] = 190529,
	["128908.140841"] = 200860,
	["128937.140841"] = 199380,
	["128938.140841"] = 213133,
	["128808.140841"] = 203670,
	["128940.140841"] = 195291,
	["128861.140841"] = 197162,

	["128808.140842"] = 203566,
	["128938.140842"] = 213051,
	["128937.140842"] = 199364,
	["128908.140842"] = 200846,
	["128826.140842"] = 190449,
	["128935.140842"] = 191493,
	["128819.140842"] = 215381,
	["128872.140842"] = 216230,
	["128861.140842"] = 197038,
	["128940.140842"] = 195243,

	["128826.143532"] = 190449,
	["128872.143532"] = 216230,
	["128935.143532"] = 191493,
	["128819.143532"] = 215381,
	["128808.143532"] = 203566,
	["128908.143532"] = 200846,
	["128937.143532"] = 199364,
	["128938.143532"] = 213051,
	["128940.143532"] = 195243,
	["128861.143532"] = 197038,

	["128821.140838"] = 208762,
	["128858.140838"] = 202426,
	["128825.140838"] = 196416,
	["128306.140838"] = 189760,
	["128860.140838"] = 210575,
	["128823.140838"] = 200315,
	["128911.140838"] = 207118,
	["128826.140838"] = 190462,
	["128937.140838"] = 199367,
	["128938.140838"] = 213180,

	["128825.140839"] = 196430,
	["128306.140839"] = 189744,
	["128860.140839"] = 210631,
	["128821.140839"] = 200415,
	["128858.140839"] = 202464,
	["128937.140839"] = 199485,
	["128938.140839"] = 213136,
	["128826.140839"] = 190567,
	["128823.140839"] = 200482,
	["128911.140839"] = 207348,

	["128825.143530"] = 196416,
	["128306.143530"] = 189760,
	["128860.143530"] = 210575,
	["128821.143530"] = 208762,
	["128858.143530"] = 202426,
	["128826.143530"] = 190462,
	["128823.143530"] = 200315,
	["128911.143530"] = 207118,
	["128937.143530"] = 199367,
	["128938.143530"] = 213180,

	["128821.140834"] = 200415,
	["128820.140834"] = 194239,
	["128941.140834"] = 196258,
	["128908.140834"] = 200861,
	["128403.140834"] = 208598,
	["128289.140834"] = 188639,
	["120978.140834"] = 186944,
	["128943.140834"] = 211099,
	["128819.140834"] = 198238,

	["128941.140835"] = 196222,
	["128908.140835"] = 200849,
	["128403.140835"] = 191485,
	["128289.140835"] = 188683,
	["120978.140835"] = 184843,
	["128943.140835"] = 211106,
	["128819.140835"] = 198247,
	["128821.140835"] = 208762,
	["128820.140835"] = 194312,

	["128943.140836"] = 211126,
	["128819.140836"] = 198236,
	["128908.140836"] = 216273,
	["128289.140836"] = 216272,
	["120978.140836"] = 184759,
	["128403.140836"] = 191442,
	["128941.140836"] = 196217,
	["128820.140836"] = 194234,
	["128821.140836"] = 200399,

	["128820.140837"] = 194314,
	["128821.140837"] = 200414,
	["128943.140837"] = 211119,
	["128819.140837"] = 198349,
	["128941.140837"] = 196432,
	["128908.140837"] = 200860,
	["120978.140837"] = 185368,
	["128289.140837"] = 203227,
	["128403.140837"] = 191488,

	["128821.143526"] = 200399,
	["128820.143526"] = 194234,
	["128289.143526"] = 216272,
	["120978.143526"] = 184759,
	["128403.143526"] = 191442,
	["128908.143526"] = 216273,
	["128941.143526"] = 196217,
	["128819.143526"] = 198236,
	["128943.143526"] = 211126,

	["127857.140831"] = 187276,
	["128860.140831"] = 210637,
	["128306.140831"] = 189749,
	["128937.140831"] = 199380,
	["128292.140831"] = 189147,
	["128862.140831"] = 195351,
	["128911.140831"] = 207285,
	["128935.140831"] = 191577,

	["128937.140832"] = 199366,
	["128292.140832"] = 189092,
	["128862.140832"] = 195317,
	["128935.140832"] = 191499,
	["128911.140832"] = 207092,
	["127857.140832"] = 187258,
	["128860.140832"] = 210571,
	["128306.140832"] = 189768,

	["128937.140833"] = 199372,
	["128292.140833"] = 189164,
	["128935.140833"] = 191740,
	["128911.140833"] = 207206,
	["128862.140833"] = 195323,
	["127857.140833"] = 187264,
	["128860.140833"] = 210579,
	["128306.140833"] = 189757,

	["128862.143527"] = 195352,
	["128935.143527"] = 191598,
	["128911.143527"] = 207348,
	["128937.143527"] = 199485,
	["128292.143527"] = 189097,
	["127857.143527"] = 187287,
	["128860.143527"] = 210631,
	["128306.143527"] = 189744,

	["128832.140810"] = 212819,
	["128861.140810"] = 206910,
	["127857.140810"] = 187287,
	["128858.140810"] = 202464,
	["128820.140810"] = 194239,
	["128866.140810"] = 209216,
	["128862.140810"] = 195352,

	["128866.140812"] = 209223,
	["128862.140812"] = 195345,
	["128861.140812"] = 197140,
	["127857.140812"] = 187313,
	["128858.140812"] = 202445,
	["128832.140812"] = 212816,
	["128820.140812"] = 194313,

	["128820.140813"] = 194224,
	["127857.140813"] = 187304,
	["128858.140813"] = 202384,
	["128861.140813"] = 197038,
	["128832.140813"] = 207343,
	["128862.140813"] = 195315,
	["128866.140813"] = 209229,

	["128820.140827"] = 194312,
	["128861.140827"] = 197080,
	["127857.140827"] = 187321,
	["128858.140827"] = 202426,
	["128832.140827"] = 207352,
	["128862.140827"] = 195322,
	["128866.140827"] = 209220,

	["128820.143523"] = 210182,
	["127857.143523"] = 187264,
	["128858.143523"] = 202433,
	["128861.143523"] = 197139,
	["128832.143523"] = 207375,
	["128862.143523"] = 195323,
	["128866.143523"] = 209226,

	["128832.140824"] = 207347,
	["127829.140824"] = 201455,
	["128476.140824"] = 197233,
	["128943.140824"] = 211126,
	["128941.140824"] = 196217,

	["128832.140825"] = 212821,
	["127829.140825"] = 201459,
	["128476.140825"] = 197241,
	["128943.140825"] = 211144,
	["128941.140825"] = 196301,

	["128941.140826"] = 196432,
	["128943.140826"] = 211119,
	["128476.140826"] = 197386,
	["128832.140826"] = 212817,
	["127829.140826"] = 201460,

	["127829.143525"] = 201456,
	["128832.143525"] = 207352,
	["128476.143525"] = 197234,
	["128941.143525"] = 196222,
	["128943.143525"] = 211106,

	["127829.140821"] = 201454,
	["128476.140821"] = 197231,
	["128910.140821"] = 209459,
	["128402.140821"] = 192450,
	["128868.140821"] = 197708,
	["128870.140821"] = 192310,
	["128942.140821"] = 199111,
	["128292.140821"] = 189080,
	["128403.140821"] = 191419,
	["128943.140821"] = 211108,
	["128827.140821"] = 194093,

	["128943.140822"] = 211119,
	["128827.140822"] = 194016,
	["128870.140822"] = 192349,
	["128942.140822"] = 199158,
	["128292.140822"] = 189147,
	["128403.140822"] = 191488,
	["128910.140822"] = 248579,
	["128402.140822"] = 192542,
	["128868.140822"] = 197729,
	["127829.140822"] = 201460,
	["128476.140822"] = 197386,

	["128292.140823"] = 189086,
	["128870.140823"] = 192318,
	["128942.140823"] = 199120,
	["128403.140823"] = 191485,
	["128827.140823"] = 193644,
	["128943.140823"] = 211106,
	["127829.140823"] = 201456,
	["128476.140823"] = 197234,
	["128402.140823"] = 192447,
	["128910.140823"] = 209472,
	["128868.140823"] = 197715,

	["128868.143531"] = 197708,
	["128910.143531"] = 209459,
	["128402.143531"] = 192450,
	["128476.143531"] = 197231,
	["127829.143531"] = 201454,
	["128943.143531"] = 211108,
	["128827.143531"] = 194093,
	["128403.143531"] = 191419,
	["128870.143531"] = 192310,
	["128292.143531"] = 189080,
	["128942.143531"] = 199111,

	["128860.140818"] = 210571,
	["128821.140818"] = 200399,
	["128910.140818"] = 209462,
	["128402.140818"] = 192453,
	["128808.140818"] = 203577,
	["128942.140818"] = 199112,
	["128870.140818"] = 192315,
	["128403.140818"] = 191442,
	["128289.140818"] = 216272,
	["128826.140818"] = 190457,
	["128872.140818"] = 202507,
	["128827.140818"] = 193643,

	["128860.140819"] = 210593,
	["128821.140819"] = 200409,
	["128402.140819"] = 192460,
	["128910.140819"] = 209481,
	["128942.140819"] = 199153,
	["128870.140819"] = 192329,
	["128808.140819"] = 203669,
	["128289.140819"] = 203225,
	["128403.140819"] = 191494,
	["128826.140819"] = 190520,
	["128827.140819"] = 194007,
	["128872.140819"] = 202524,

	["128860.140820"] = 210570,
	["128821.140820"] = 200395,
	["128402.140820"] = 192450,
	["128910.140820"] = 209459,
	["128942.140820"] = 199111,
	["128870.140820"] = 192310,
	["128808.140820"] = 203566,
	["128403.140820"] = 191419,
	["128289.140820"] = 188635,
	["128826.140820"] = 190449,
	["128827.140820"] = 194093,
	["128872.140820"] = 216230,

	["128872.143524"] = 202524,
	["128827.143524"] = 194007,
	["128826.143524"] = 190520,
	["128289.143524"] = 203225,
	["128403.143524"] = 191494,
	["128808.143524"] = 203669,
	["128870.143524"] = 192329,
	["128942.143524"] = 199153,
	["128910.143524"] = 209481,
	["128402.143524"] = 192460,
	["128821.143524"] = 200409,
	["128860.143524"] = 210593,

	["128819.140815"] = 198349,
	["128872.140815"] = 202530,
	["128289.140815"] = 203227,
	["128938.140815"] = 213133,
	["128908.140815"] = 200860,
	["128870.140815"] = 192349,
	["128808.140815"] = 203670,
	["128866.140815"] = 209218,
	["128402.140815"] = 192542,
	["128910.140815"] = 248579,
	["128940.140815"] = 195291,
	["128861.140815"] = 197162,
	["128832.140815"] = 212817,

	["128872.140816"] = 202507,
	["128819.140816"] = 198236,
	["128908.140816"] = 216273,
	["128289.140816"] = 216272,
	["128938.140816"] = 213049,
	["128866.140816"] = 209217,
	["128808.140816"] = 203577,
	["128870.140816"] = 192315,
	["128910.140816"] = 209462,
	["128940.140816"] = 195263,
	["128402.140816"] = 192453,
	["128861.140816"] = 197047,
	["128832.140816"] = 207347,

	["128808.140817"] = 203578,
	["128866.140817"] = 209220,
	["128870.140817"] = 192318,
	["128908.140817"] = 200849,
	["128289.140817"] = 188683,
	["128938.140817"] = 213180,
	["128872.140817"] = 202514,
	["128819.140817"] = 198247,
	["128832.140817"] = 207352,
	["128861.140817"] = 197080,
	["128910.140817"] = 209472,
	["128940.140817"] = 218607,
	["128402.140817"] = 192447,

	["128908.143529"] = 200860,
	["128938.143529"] = 213133,
	["128289.143529"] = 203227,
	["128808.143529"] = 203670,
	["128866.143529"] = 209218,
	["128870.143529"] = 192349,
	["128872.143529"] = 202530,
	["128819.143529"] = 198349,
	["128861.143529"] = 197162,
	["128832.143529"] = 212817,
	["128940.143529"] = 195291,
	["128910.143529"] = 248579,
	["128402.143529"] = 192542,

	["128825.141519"] = 196429,
	["128868.141519"] = 197729,
	["120978.141519"] = 185368,
	["128866.141519"] = 209218,
	["128823.141519"] = 200298,

	["128825.146934"] = 196418,
	["128868.146934"] = 197716,
	["120978.146934"] = 186945,
	["128866.146934"] = 209226,
	["128823.146934"] = 200296,

	["128808.141514"] = 203669,
	["128937.141514"] = 199377,
	["128938.141514"] = 213055,
	["128908.141514"] = 200856,
	["128826.141514"] = 190520,
	["128935.141514"] = 191572,
	["128819.141514"] = 198299,
	["128872.141514"] = 202524,
	["128861.141514"] = 197140,
	["128940.141514"] = 195269,

	["128940.146932"] = 195291,
	["128861.146932"] = 197162,
	["128826.146932"] = 190529,
	["128872.146932"] = 202530,
	["128935.146932"] = 191577,
	["128819.146932"] = 198349,
	["128808.146932"] = 203670,
	["128908.146932"] = 200860,
	["128937.146932"] = 199380,
	["128938.146932"] = 213133,

	["128937.141516"] = 199366,
	["128938.141516"] = 213049,
	["128826.141516"] = 190457,
	["128911.141516"] = 207092,
	["128823.141516"] = 200316,
	["128860.141516"] = 210571,
	["128306.141516"] = 189768,
	["128825.141516"] = 196358,
	["128858.141516"] = 202386,
	["128821.141516"] = 200399,

	["128821.142309"] = 200402,
	["128858.142309"] = 202433,
	["128825.142309"] = 196418,
	["128860.142309"] = 210579,
	["128306.142309"] = 189757,
	["128937.142309"] = 199372,
	["128938.142309"] = 213062,
	["128823.142309"] = 200296,
	["128911.142309"] = 207206,
	["128826.142309"] = 190467,

	["128911.146925"] = 207118,
	["128823.146925"] = 200315,
	["128826.146925"] = 190462,
	["128938.146925"] = 213180,
	["128937.146925"] = 199367,
	["128858.146925"] = 202426,
	["128821.146925"] = 208762,
	["128860.146925"] = 210575,
	["128306.146925"] = 189760,
	["128825.146925"] = 196416,

	["128908.141522"] = 200856,
	["128289.141522"] = 203225,
	["128403.141522"] = 191494,
	["120978.141522"] = 186927,
	["128941.141522"] = 196236,
	["128943.141522"] = 211105,
	["128819.141522"] = 198299,
	["128821.141522"] = 200409,
	["128820.141522"] = 194313,

	["128943.142307"] = 211119,
	["128819.142307"] = 198349,
	["128908.142307"] = 200860,
	["128289.142307"] = 203227,
	["128403.142307"] = 191488,
	["120978.142307"] = 185368,
	["128941.142307"] = 196432,
	["128820.142307"] = 194314,
	["128821.142307"] = 200414,

	["128821.146927"] = 208762,
	["128820.146927"] = 194312,
	["128941.146927"] = 196222,
	["128908.146927"] = 200849,
	["120978.146927"] = 184843,
	["128289.146927"] = 188683,
	["128403.146927"] = 191485,
	["128943.146927"] = 211106,
	["128819.146927"] = 198247,

	["128306.141517"] = 189744,
	["128860.141517"] = 210631,
	["127857.141517"] = 187287,
	["128292.141517"] = 189097,
	["128937.141517"] = 199485,
	["128862.141517"] = 195352,
	["128911.141517"] = 207348,
	["128935.141517"] = 191598,

	["127857.142308"] = 187264,
	["128860.142308"] = 210579,
	["128306.142308"] = 189757,
	["128937.142308"] = 199372,
	["128292.142308"] = 189164,
	["128862.142308"] = 195323,
	["128935.142308"] = 191740,
	["128911.142308"] = 207206,

	["127857.146928"] = 187304,
	["128860.146928"] = 210570,
	["128306.146928"] = 189772,
	["128937.146928"] = 199364,
	["128292.146928"] = 189080,
	["128911.146928"] = 207088,
	["128935.146928"] = 191493,
	["128862.146928"] = 195315,

	["128866.141515"] = 209226,
	["128862.141515"] = 195323,
	["128861.141515"] = 197139,
	["127857.141515"] = 187264,
	["128858.141515"] = 202433,
	["128832.141515"] = 207375,
	["128820.141515"] = 210182,

	["128820.142176"] = 194239,
	["128861.142176"] = 206910,
	["127857.142176"] = 187287,
	["128858.142176"] = 202464,
	["128832.142176"] = 212819,
	["128862.142176"] = 195352,
	["128866.142176"] = 209216,

	["128858.142305"] = 202445,
	["127857.142305"] = 187313,
	["128861.142305"] = 197140,
	["128832.142305"] = 212816,
	["128820.142305"] = 194313,
	["128866.142305"] = 209223,
	["128862.142305"] = 195345,

	["128866.146930"] = 209216,
	["128862.146930"] = 195352,
	["128832.146930"] = 212819,
	["128861.146930"] = 206910,
	["128858.146930"] = 202464,
	["127857.146930"] = 187287,
	["128820.146930"] = 194239,

	["128941.141520"] = 196222,
	["128943.141520"] = 211106,
	["128476.141520"] = 197234,
	["127829.141520"] = 201456,
	["128832.141520"] = 207352,

	["128476.142181"] = 197231,
	["128832.142181"] = 207343,
	["127829.142181"] = 201454,
	["128941.142181"] = 196211,
	["128943.142181"] = 211108,

	["128941.142182"] = 196227,
	["128943.142182"] = 211123,
	["128476.142182"] = 197235,
	["128832.142182"] = 207375,
	["127829.142182"] = 201457,

	["128943.146926"] = 211106,
	["128941.146926"] = 196222,
	["128476.146926"] = 197234,
	["127829.146926"] = 201456,
	["128832.146926"] = 207352,

	["128402.141518"] = 192453,
	["128910.141518"] = 209462,
	["128868.141518"] = 197713,
	["127829.141518"] = 201455,
	["128476.141518"] = 197233,
	["128827.141518"] = 193643,
	["128943.141518"] = 211126,
	["128292.141518"] = 189092,
	["128870.141518"] = 192315,
	["128942.141518"] = 199112,
	["128403.141518"] = 191442,

	["128476.142310"] = 197386,
	["127829.142310"] = 201460,
	["128868.142310"] = 197729,
	["128910.142310"] = 248579,
	["128402.142310"] = 192542,
	["128403.142310"] = 191488,
	["128292.142310"] = 189147,
	["128870.142310"] = 192349,
	["128942.142310"] = 199158,
	["128943.142310"] = 211119,
	["128827.142310"] = 194016,

	["128868.146931"] = 197762,
	["128402.146931"] = 192464,
	["128910.146931"] = 209494,
	["128476.146931"] = 197239,
	["127829.146931"] = 201464,
	["128827.146931"] = 194002,
	["128943.146931"] = 211099,
	["128403.146931"] = 208598,
	["128292.146931"] = 189097,
	["128870.146931"] = 192376,
	["128942.146931"] = 199163,

	["128826.141523"] = 190529,
	["128872.141523"] = 202530,
	["128827.141523"] = 194016,
	["128808.141523"] = 203670,
	["128942.141523"] = 199158,
	["128870.141523"] = 192349,
	["128289.141523"] = 203227,
	["128403.141523"] = 191488,
	["128910.141523"] = 248579,
	["128402.141523"] = 192542,
	["128860.141523"] = 210637,
	["128821.141523"] = 200414,

	["128942.142180"] = 199111,
	["128870.142180"] = 192310,
	["128808.142180"] = 203566,
	["128403.142180"] = 191419,
	["128289.142180"] = 188635,
	["128826.142180"] = 190449,
	["128827.142180"] = 194093,
	["128872.142180"] = 216230,
	["128860.142180"] = 210570,
	["128821.142180"] = 200395,
	["128402.142180"] = 192450,
	["128910.142180"] = 209459,

	["128827.146933"] = 194007,
	["128872.146933"] = 202524,
	["128826.146933"] = 190520,
	["128289.146933"] = 203225,
	["128403.146933"] = 191494,
	["128870.146933"] = 192329,
	["128942.146933"] = 199153,
	["128808.146933"] = 203669,
	["128402.146933"] = 192460,
	["128910.146933"] = 209481,
	["128821.146933"] = 200409,
	["128860.146933"] = 210593,

	["128808.141521"] = 203638,
	["128866.141521"] = 209226,
	["128870.141521"] = 192326,
	["128908.141521"] = 200853,
	["128289.141521"] = 203230,
	["128938.141521"] = 213062,
	["128872.141521"] = 202522,
	["128819.141521"] = 198292,
	["128832.141521"] = 207375,
	["128861.141521"] = 197139,
	["128940.141521"] = 195266,
	["128910.141521"] = 216274,
	["128402.141521"] = 192457,

	["128872.142306"] = 216230,
	["128819.142306"] = 215381,
	["128908.142306"] = 200846,
	["128289.142306"] = 188635,
	["128938.142306"] = 213051,
	["128808.142306"] = 203566,
	["128866.142306"] = 209229,
	["128870.142306"] = 192310,
	["128910.142306"] = 209459,
	["128940.142306"] = 195243,
	["128402.142306"] = 192450,
	["128861.142306"] = 197038,
	["128832.142306"] = 207343,

	["128872.146929"] = 202522,
	["128819.146929"] = 198292,
	["128808.146929"] = 203638,
	["128866.146929"] = 209226,
	["128870.146929"] = 192326,
	["128908.146929"] = 200853,
	["128938.146929"] = 213062,
	["128289.146929"] = 203230,
	["128910.146929"] = 216274,
	["128940.146929"] = 195266,
	["128402.146929"] = 192457,
	["128832.146929"] = 207375,
	["128861.146929"] = 197139,

	["128868.140072"] = 197713,
	["128825.140072"] = 196358,
	["128823.140072"] = 200316,
	["120978.140072"] = 184759,
	["128866.140072"] = 209217,

	["128866.142187"] = 209218,
	["120978.142187"] = 185368,
	["128823.142187"] = 200298,
	["128825.142187"] = 196429,
	["128868.142187"] = 197729,

	["128823.142188"] = 200294,
	["120978.142188"] = 186927,
	["128866.142188"] = 209223,
	["128868.142188"] = 197727,
	["128825.142188"] = 196422,

	["128823.142519"] = 200298,
	["128866.142519"] = 209218,
	["120978.142519"] = 185368,
	["128868.142519"] = 197729,
	["128825.142519"] = 196429,

	["128940.140069"] = 195269,
	["128861.140069"] = 197140,
	["128819.140069"] = 198299,
	["128935.140069"] = 191572,
	["128872.140069"] = 202524,
	["128826.140069"] = 190520,
	["128937.140069"] = 199377,
	["128938.140069"] = 213055,
	["128908.140069"] = 200856,
	["128808.140069"] = 203669,

	["128861.142193"] = 197047,
	["128940.142193"] = 195263,
	["128808.142193"] = 203577,
	["128908.142193"] = 216273,
	["128937.142193"] = 199366,
	["128938.142193"] = 213049,
	["128826.142193"] = 190457,
	["128872.142193"] = 202507,
	["128935.142193"] = 191499,
	["128819.142193"] = 198236,

	["128826.142194"] = 190529,
	["128872.142194"] = 202530,
	["128935.142194"] = 191577,
	["128819.142194"] = 198349,
	["128808.142194"] = 203670,
	["128908.142194"] = 200860,
	["128937.142194"] = 199380,
	["128938.142194"] = 213133,
	["128940.142194"] = 195291,
	["128861.142194"] = 197162,

	["128826.142518"] = 190520,
	["128872.142518"] = 202524,
	["128935.142518"] = 191572,
	["128819.142518"] = 198299,
	["128808.142518"] = 203669,
	["128908.142518"] = 200856,
	["128938.142518"] = 213055,
	["128937.142518"] = 199377,
	["128940.142518"] = 195269,
	["128861.142518"] = 197140,

	["128938.140078"] = 213055,
	["128937.140078"] = 199377,
	["128826.140078"] = 190520,
	["128823.140078"] = 200294,
	["128911.140078"] = 207255,
	["128825.140078"] = 196422,
	["128860.140078"] = 210593,
	["128306.140078"] = 189754,
	["128821.140078"] = 200409,
	["128858.140078"] = 202445,

	["128858.142189"] = 202302,
	["128821.142189"] = 200400,
	["128860.142189"] = 210557,
	["128306.142189"] = 186396,
	["128825.142189"] = 196489,
	["128937.142189"] = 199365,
	["128938.142189"] = 213047,
	["128911.142189"] = 207351,
	["128823.142189"] = 200327,
	["128826.142189"] = 190503,

	["128938.142190"] = 213049,
	["128937.142190"] = 199366,
	["128826.142190"] = 190457,
	["128823.142190"] = 200316,
	["128911.142190"] = 207092,
	["128825.142190"] = 196358,
	["128860.142190"] = 210571,
	["128306.142190"] = 189768,
	["128821.142190"] = 200399,
	["128858.142190"] = 202386,

	["128937.142517"] = 199366,
	["128938.142517"] = 213049,
	["128823.142517"] = 200316,
	["128911.142517"] = 207092,
	["128826.142517"] = 190457,
	["128821.142517"] = 200399,
	["128858.142517"] = 202386,
	["128825.142517"] = 196358,
	["128306.142517"] = 189768,
	["128860.142517"] = 210571,

	["128819.140073"] = 215381,
	["128943.140073"] = 211108,
	["128941.140073"] = 196211,
	["120978.140073"] = 186941,
	["128289.140073"] = 188635,
	["128403.140073"] = 191419,
	["128908.140073"] = 200846,
	["128820.140073"] = 194224,
	["128821.140073"] = 200395,

	["128821.142183"] = 200415,
	["128820.142183"] = 194239,
	["128941.142183"] = 196258,
	["128908.142183"] = 200861,
	["120978.142183"] = 186944,
	["128289.142183"] = 188639,
	["128403.142183"] = 208598,
	["128943.142183"] = 211099,
	["128819.142183"] = 198238,

	["128941.142184"] = 196236,
	["128403.142184"] = 191494,
	["128289.142184"] = 203225,
	["120978.142184"] = 186927,
	["128908.142184"] = 200856,
	["128819.142184"] = 198299,
	["128943.142184"] = 211105,
	["128821.142184"] = 200409,
	["128820.142184"] = 194313,

	["128820.142516"] = 194314,
	["128821.142516"] = 200414,
	["128943.142516"] = 211119,
	["128819.142516"] = 198349,
	["128941.142516"] = 196432,
	["128908.142516"] = 200860,
	["120978.142516"] = 185368,
	["128289.142516"] = 203227,
	["128403.142516"] = 191488,

	["128937.140040"] = 199372,
	["128292.140040"] = 189164,
	["128911.140040"] = 207206,
	["128935.140040"] = 191740,
	["128862.140040"] = 195323,
	["127857.140040"] = 187264,
	["128860.140040"] = 210579,
	["128306.140040"] = 189757,

	["127857.142185"] = 187258,
	["128860.142185"] = 210571,
	["128306.142185"] = 189768,
	["128862.142185"] = 195317,
	["128911.142185"] = 207092,
	["128935.142185"] = 191499,
	["128937.142185"] = 199366,
	["128292.142185"] = 189092,

	["128911.142186"] = 207088,
	["128935.142186"] = 191493,
	["128862.142186"] = 195315,
	["128292.142186"] = 189080,
	["128937.142186"] = 199364,
	["128306.142186"] = 189772,
	["128860.142186"] = 210570,
	["127857.142186"] = 187304,

	["128306.142515"] = 189772,
	["128860.142515"] = 210570,
	["127857.142515"] = 187304,
	["128292.142515"] = 189080,
	["128937.142515"] = 199364,
	["128911.142515"] = 207088,
	["128935.142515"] = 191493,
	["128862.142515"] = 195315,

	["127857.140070"] = 187264,
	["128860.140070"] = 210579,
	["128306.140070"] = 189757,
	["128862.140070"] = 195323,
	["128935.140070"] = 191740,
	["128911.140070"] = 207206,
	["128937.140070"] = 199372,
	["128292.140070"] = 189164,

	["128862.140077"] = 195351,
	["128866.140077"] = 209218,
	["128820.140077"] = 194314,
	["128832.140077"] = 212817,
	["128861.140077"] = 197162,
	["128858.140077"] = 202466,
	["127857.140077"] = 187276,

	["128862.142175"] = 195322,
	["128866.142175"] = 209220,
	["128820.142175"] = 194312,
	["128832.142175"] = 207352,
	["128858.142175"] = 202426,
	["127857.142175"] = 187321,
	["128861.142175"] = 197080,

	["128858.142514"] = 202433,
	["127857.142514"] = 187264,
	["128861.142514"] = 197139,
	["128832.142514"] = 207375,
	["128820.142514"] = 210182,
	["128866.142514"] = 209226,
	["128862.142514"] = 195323,

	["128943.140076"] = 211099,
	["128941.140076"] = 196258,
	["128476.140076"] = 197239,
	["127829.140076"] = 201464,
	["128832.140076"] = 212819,

	["128476.142513"] = 197234,
	["127829.142513"] = 201456,
	["128832.142513"] = 207352,
	["128943.142513"] = 211106,
	["128941.142513"] = 196222,

	["128943.140071"] = 211106,
	["128827.140071"] = 193644,
	["128403.140071"] = 191485,
	["128942.140071"] = 199120,
	["128870.140071"] = 192318,
	["128292.140071"] = 189086,
	["128868.140071"] = 197715,
	["128910.140071"] = 209472,
	["128402.140071"] = 192447,
	["128476.140071"] = 197234,
	["127829.140071"] = 201456,

	["128942.142191"] = 199120,
	["128870.142191"] = 192318,
	["128292.142191"] = 189086,
	["128403.142191"] = 191485,
	["128943.142191"] = 211106,
	["128827.142191"] = 193644,
	["127829.142191"] = 201456,
	["128476.142191"] = 197234,
	["128910.142191"] = 209472,
	["128402.142191"] = 192447,
	["128868.142191"] = 197715,

	["128870.142192"] = 192376,
	["128942.142192"] = 199163,
	["128292.142192"] = 189097,
	["128403.142192"] = 208598,
	["128943.142192"] = 211099,
	["128827.142192"] = 194002,
	["127829.142192"] = 201464,
	["128476.142192"] = 197239,
	["128910.142192"] = 209494,
	["128402.142192"] = 192464,
	["128868.142192"] = 197762,

	["128942.142512"] = 199163,
	["128870.142512"] = 192376,
	["128292.142512"] = 189097,
	["128403.142512"] = 208598,
	["128827.142512"] = 194002,
	["128943.142512"] = 211099,
	["127829.142512"] = 201464,
	["128476.142512"] = 197239,
	["128402.142512"] = 192464,
	["128910.142512"] = 209494,
	["128868.142512"] = 197762,

	["128942.140074"] = 199214,
	["128870.140074"] = 192345,
	["128808.140074"] = 203749,
	["128289.140074"] = 188644,
	["128403.140074"] = 191584,
	["128826.140074"] = 190514,
	["128827.140074"] = 193647,
	["128872.140074"] = 202533,
	["128860.140074"] = 210590,
	["128821.140074"] = 200440,
	["128402.140074"] = 192538,
	["128910.140074"] = 209541,

	["128860.142179"] = 210571,
	["128821.142179"] = 200399,
	["128910.142179"] = 209462,
	["128402.142179"] = 192453,
	["128808.142179"] = 203577,
	["128942.142179"] = 199112,
	["128870.142179"] = 192315,
	["128289.142179"] = 216272,
	["128403.142179"] = 191442,
	["128826.142179"] = 190457,
	["128872.142179"] = 202507,
	["128827.142179"] = 193643,

	["128289.142510"] = 203227,
	["128403.142510"] = 191488,
	["128870.142510"] = 192349,
	["128942.142510"] = 199158,
	["128808.142510"] = 203670,
	["128827.142510"] = 194016,
	["128872.142510"] = 202530,
	["128826.142510"] = 190529,
	["128821.142510"] = 200414,
	["128860.142510"] = 210637,
	["128402.142510"] = 192542,
	["128910.142510"] = 248579,

	["128832.140075"] = 212821,
	["128861.140075"] = 197160,
	["128910.140075"] = 209483,
	["128940.140075"] = 195244,
	["128402.140075"] = 192514,
	["128808.140075"] = 224764,
	["128866.140075"] = 209224,
	["128870.140075"] = 192323,
	["128908.140075"] = 200857,
	["128289.140075"] = 188632,
	["128938.140075"] = 213047,
	["128872.140075"] = 202521,
	["128819.140075"] = 198296,

	["128866.142177"] = 209226,
	["128808.142177"] = 203638,
	["128870.142177"] = 192326,
	["128908.142177"] = 200853,
	["128289.142177"] = 203230,
	["128938.142177"] = 213062,
	["128872.142177"] = 202522,
	["128819.142177"] = 198292,
	["128832.142177"] = 207375,
	["128861.142177"] = 197139,
	["128910.142177"] = 216274,
	["128940.142177"] = 195266,
	["128402.142177"] = 192457,

	["128402.142178"] = 192447,
	["128910.142178"] = 209472,
	["128940.142178"] = 218607,
	["128832.142178"] = 207352,
	["128861.142178"] = 197080,
	["128819.142178"] = 198247,
	["128872.142178"] = 202514,
	["128870.142178"] = 192318,
	["128866.142178"] = 209220,
	["128808.142178"] = 203578,
	["128938.142178"] = 213180,
	["128289.142178"] = 188683,
	["128908.142178"] = 200849,

	["128910.142511"] = 216274,
	["128940.142511"] = 195266,
	["128402.142511"] = 192457,
	["128861.142511"] = 197139,
	["128832.142511"] = 207375,
	["128872.142511"] = 202522,
	["128819.142511"] = 198292,
	["128908.142511"] = 200853,
	["128289.142511"] = 203230,
	["128938.142511"] = 213062,
	["128808.142511"] = 203638,
	["128866.142511"] = 209226,
	["128870.142511"] = 192326,

	["128868.139252"] = 197715,
	["128825.139252"] = 196416,
	["128823.139252"] = 200315,
	["120978.139252"] = 184843,
	["128866.139252"] = 209220,

	["128868.139258"] = 197762,
	["128825.139258"] = 196430,
	["128823.139258"] = 200482,
	["128866.139258"] = 209216,
	["120978.139258"] = 186944,

	["128866.139265"] = 209217,
	["120978.139265"] = 184759,
	["128823.139265"] = 200316,
	["128825.139265"] = 196358,
	["128868.139265"] = 197713,

	["128866.143584"] = 209217,
	["120978.143584"] = 184759,
	["128823.143584"] = 200316,
	["128825.143584"] = 196358,
	["128868.143584"] = 197713,

	["128825.143585"] = 196358,
	["128868.143585"] = 197713,
	["120978.143585"] = 184759,
	["128866.143585"] = 209217,
	["128823.143585"] = 200316,

	["128826.137008"] = 190567,
	["128935.137008"] = 191598,
	["128819.137008"] = 198238,
	["128872.137008"] = 202907,
	["128808.137008"] = 203673,
	["128938.137008"] = 213136,
	["128937.137008"] = 199485,
	["128908.137008"] = 200861,
	["128940.137008"] = 195267,
	["128861.137008"] = 206910,

	["128826.138229"] = 190529,
	["128935.138229"] = 191577,
	["128819.138229"] = 198349,
	["128872.138229"] = 202530,
	["128808.138229"] = 203670,
	["128937.138229"] = 199380,
	["128938.138229"] = 213133,
	["128908.138229"] = 200860,
	["128940.138229"] = 195291,
	["128861.138229"] = 197162,

	["128808.139262"] = 203578,
	["128938.139262"] = 213180,
	["128937.139262"] = 199367,
	["128908.139262"] = 200849,
	["128826.139262"] = 190462,
	["128935.139262"] = 191504,
	["128819.139262"] = 198247,
	["128872.139262"] = 202514,
	["128861.139262"] = 197080,
	["128940.139262"] = 218607,

	["128908.139264"] = 200853,
	["128938.139264"] = 213062,
	["128937.139264"] = 199372,
	["128808.139264"] = 203638,
	["128872.139264"] = 202522,
	["128819.139264"] = 198292,
	["128935.139264"] = 191740,
	["128826.139264"] = 190467,
	["128861.139264"] = 197139,
	["128940.139264"] = 195266,

	["128938.138228"] = 213051,
	["128937.138228"] = 199364,
	["128823.138228"] = 200326,
	["128911.138228"] = 207088,
	["128826.138228"] = 190449,
	["128821.138228"] = 200395,
	["128858.138228"] = 202384,
	["128825.138228"] = 196434,
	["128306.138228"] = 189772,
	["128860.138228"] = 210570,

	["128911.139249"] = 207285,
	["128823.139249"] = 200298,
	["128826.139249"] = 190529,
	["128937.139249"] = 199380,
	["128938.139249"] = 213133,
	["128858.139249"] = 202466,
	["128821.139249"] = 200414,
	["128860.139249"] = 210637,
	["128306.139249"] = 189749,
	["128825.139249"] = 196429,

	["128858.139263"] = 202445,
	["128821.139263"] = 200409,
	["128860.139263"] = 210593,
	["128306.139263"] = 189754,
	["128825.139263"] = 196422,
	["128937.139263"] = 199377,
	["128938.139263"] = 213055,
	["128911.139263"] = 207255,
	["128823.139263"] = 200294,
	["128826.139263"] = 190520,

	["128821.139256"] = 200395,
	["128820.139256"] = 194224,
	["128941.139256"] = 196211,
	["120978.139256"] = 186941,
	["128289.139256"] = 188635,
	["128403.139256"] = 191419,
	["128908.139256"] = 200846,
	["128819.139256"] = 215381,
	["128943.139256"] = 211108,

	["128819.139266"] = 198292,
	["128943.139266"] = 211123,
	["128289.139266"] = 203230,
	["120978.139266"] = 186945,
	["128403.139266"] = 191592,
	["128908.139266"] = 200853,
	["128941.139266"] = 196227,
	["128820.139266"] = 210182,
	["128821.139266"] = 200402,

	["128292.139250"] = 189144,
	["128937.139250"] = 199377,
	["128911.139250"] = 207255,
	["128935.139250"] = 191572,
	["128862.139250"] = 195345,
	["128306.139250"] = 189754,
	["128860.139250"] = 210593,
	["127857.139250"] = 187313,

	["128292.139259"] = 189086,
	["128937.139259"] = 199367,
	["128935.139259"] = 191504,
	["128911.139259"] = 207118,
	["128862.139259"] = 195322,
	["128306.139259"] = 189760,
	["128860.139259"] = 210575,
	["127857.139259"] = 187321,

	["128861.138227"] = 197047,
	["128858.138227"] = 202386,
	["127857.138227"] = 187258,
	["128832.138227"] = 207347,
	["128820.138227"] = 194234,
	["128866.138227"] = 209217,
	["128862.138227"] = 195317,

	["128832.139269"] = 212817,
	["128861.139269"] = 197162,
	["127857.139269"] = 187276,
	["128858.139269"] = 202466,
	["128820.139269"] = 194314,
	["128866.139269"] = 209218,
	["128862.139269"] = 195351,

	["128943.139253"] = 211105,
	["128941.139253"] = 196236,
	["128476.139253"] = 197369,
	["128832.139253"] = 212816,
	["127829.139253"] = 201458,

	["128941.139267"] = 196258,
	["128943.139267"] = 211099,
	["127829.139267"] = 201464,
	["128832.139267"] = 212819,
	["128476.139267"] = 197239,

	["128476.138226"] = 197235,
	["127829.138226"] = 201457,
	["128868.138226"] = 197716,
	["128402.138226"] = 192457,
	["128910.138226"] = 216274,
	["128403.138226"] = 191592,
	["128870.138226"] = 192326,
	["128292.138226"] = 189164,
	["128942.138226"] = 199152,
	["128827.138226"] = 193645,
	["128943.138226"] = 211123,

	["128910.139251"] = 209462,
	["128402.139251"] = 192453,
	["128868.139251"] = 197713,
	["127829.139251"] = 201455,
	["128476.139251"] = 197233,
	["128943.139251"] = 211126,
	["128827.139251"] = 193643,
	["128870.139251"] = 192315,
	["128292.139251"] = 189092,
	["128942.139251"] = 199112,
	["128403.139251"] = 191442,

	["128476.139268"] = 197369,
	["127829.139268"] = 201458,
	["128868.139268"] = 197727,
	["128402.139268"] = 192460,
	["128910.139268"] = 209481,
	["128403.139268"] = 191494,
	["128942.139268"] = 199153,
	["128870.139268"] = 192329,
	["128292.139268"] = 189144,
	["128827.139268"] = 194007,
	["128943.139268"] = 211105,

	["128403.139254"] = 191592,
	["128289.139254"] = 203230,
	["128808.139254"] = 203638,
	["128870.139254"] = 192326,
	["128942.139254"] = 199152,
	["128872.139254"] = 202522,
	["128827.139254"] = 193645,
	["128826.139254"] = 190467,
	["128821.139254"] = 200402,
	["128860.139254"] = 210579,
	["128910.139254"] = 216274,
	["128402.139254"] = 192457,

	["128872.139257"] = 202907,
	["128827.139257"] = 194002,
	["128826.139257"] = 190567,
	["128289.139257"] = 188639,
	["128403.139257"] = 208598,
	["128808.139257"] = 203673,
	["128870.139257"] = 192376,
	["128942.139257"] = 199163,
	["128910.139257"] = 209494,
	["128402.139257"] = 192464,
	["128821.139257"] = 200415,
	["128860.139257"] = 210631,

	["128827.139260"] = 193644,
	["128872.139260"] = 202514,
	["128826.139260"] = 190462,
	["128289.139260"] = 188683,
	["128403.139260"] = 191485,
	["128870.139260"] = 192318,
	["128942.139260"] = 199120,
	["128808.139260"] = 203578,
	["128402.139260"] = 192447,
	["128910.139260"] = 209472,
	["128821.139260"] = 208762,
	["128860.139260"] = 210575,

	["128832.139255"] = 207347,
	["128861.139255"] = 197047,
	["128402.139255"] = 192453,
	["128910.139255"] = 209462,
	["128940.139255"] = 195263,
	["128870.139255"] = 192315,
	["128866.139255"] = 209217,
	["128808.139255"] = 203577,
	["128289.139255"] = 216272,
	["128938.139255"] = 213049,
	["128908.139255"] = 216273,
	["128819.139255"] = 198236,
	["128872.139255"] = 202507,

	["128872.139261"] = 202524,
	["128819.139261"] = 198299,
	["128908.139261"] = 200856,
	["128289.139261"] = 203225,
	["128938.139261"] = 213055,
	["128866.139261"] = 209223,
	["128808.139261"] = 203669,
	["128870.139261"] = 192329,
	["128910.139261"] = 209481,
	["128940.139261"] = 195269,
	["128402.139261"] = 192460,
	["128861.139261"] = 197140,
	["128832.139261"] = 212816,

	["128825.134079"] = 196355,
	["128306.134079"] = 186320,
	["128860.134079"] = 210590,
	["128821.134079"] = 200440,
	["128858.134079"] = 203018,
	["128826.134079"] = 190514,
	["128823.134079"] = 200302,
	["128911.134079"] = 207354,
	["128938.134079"] = 213116,
	["128937.134079"] = 199384,

	["128821.134077"] = 200400,
	["128820.134077"] = 194318,
	["128289.134077"] = 188632,
	["120978.134077"] = 186934,
	["128403.134077"] = 191565,
	["128908.134077"] = 200857,
	["128941.134077"] = 196301,
	["128819.134077"] = 198296,
	["128943.134077"] = 211144,

	["127857.134076"] = 187313,
	["128860.134076"] = 210593,
	["128306.134076"] = 189754,
	["128937.134076"] = 199377,
	["128292.134076"] = 189144,
	["128911.134076"] = 207255,
	["128935.134076"] = 191572,
	["128862.134076"] = 195345,

	["128820.131731"] = 210182,
	["127857.131731"] = 187264,
	["128858.131731"] = 202433,
	["128861.131731"] = 197139,
	["128832.131731"] = 207375,
	["128862.131731"] = 195323,
	["128866.131731"] = 209226,

	["128943.134078"] = 211106,
	["128827.134078"] = 193644,
	["128870.134078"] = 192318,
	["128292.134078"] = 189086,
	["128942.134078"] = 199120,
	["128403.134078"] = 191485,
	["128910.134078"] = 209472,
	["128402.134078"] = 192447,
	["128868.134078"] = 197715,
	["127829.134078"] = 201456,
	["128476.134078"] = 197234,

	["128872.134081"] = 202907,
	["128819.134081"] = 198238,
	["128908.134081"] = 200861,
	["128289.134081"] = 188639,
	["128938.134081"] = 213136,
	["128808.134081"] = 203673,
	["128866.134081"] = 209216,
	["128870.134081"] = 192376,
	["128940.134081"] = 195267,
	["128910.134081"] = 209494,
	["128402.134081"] = 192464,
	["128861.134081"] = 206910,
	["128832.134081"] = 212819,

	["128866.140082"] = 209229,
	["120978.140082"] = 186941,
	["128823.140082"] = 200326,
	["128825.140082"] = 196434,
	["128868.140082"] = 197708,

	["128819.140039"] = 198238,
	["128935.140039"] = 191598,
	["128872.140039"] = 202907,
	["128826.140039"] = 190567,
	["128937.140039"] = 199485,
	["128938.140039"] = 213136,
	["128908.140039"] = 200861,
	["128808.140039"] = 203673,
	["128940.140039"] = 195267,
	["128861.140039"] = 206910,

	["128826.140048"] = 190567,
	["128911.140048"] = 207348,
	["128823.140048"] = 200482,
	["128938.140048"] = 213136,
	["128937.140048"] = 199485,
	["128860.140048"] = 210631,
	["128306.140048"] = 189744,
	["128825.140048"] = 196430,
	["128858.140048"] = 202464,
	["128821.140048"] = 200415,

	["128820.140083"] = 194224,
	["128821.140083"] = 200395,
	["128819.140083"] = 215381,
	["128943.140083"] = 211108,
	["128941.140083"] = 196211,
	["128403.140083"] = 191419,
	["128289.140083"] = 188635,
	["120978.140083"] = 186941,
	["128908.140083"] = 200846,

	["128941.140046"] = 196258,
	["128943.140046"] = 211099,
	["128832.140046"] = 212819,
	["127829.140046"] = 201464,
	["128476.140046"] = 197239,

	["128292.140081"] = 189080,
	["128870.140081"] = 192310,
	["128942.140081"] = 199111,
	["128403.140081"] = 191419,
	["128943.140081"] = 211108,
	["128827.140081"] = 194093,
	["127829.140081"] = 201454,
	["128476.140081"] = 197231,
	["128910.140081"] = 209459,
	["128402.140081"] = 192450,
	["128868.140081"] = 197708,

	["128402.140084"] = 192450,
	["128910.140084"] = 209459,
	["128821.140084"] = 200395,
	["128860.140084"] = 210570,
	["128827.140084"] = 194093,
	["128872.140084"] = 216230,
	["128826.140084"] = 190449,
	["128289.140084"] = 188635,
	["128403.140084"] = 191419,
	["128870.140084"] = 192310,
	["128942.140084"] = 199111,
	["128808.140084"] = 203566,

	["128940.140085"] = 195243,
	["128910.140085"] = 209459,
	["128402.140085"] = 192450,
	["128832.140085"] = 207343,
	["128861.140085"] = 197038,
	["128872.140085"] = 216230,
	["128819.140085"] = 215381,
	["128866.140085"] = 209229,
	["128808.140085"] = 203566,
	["128870.140085"] = 192310,
	["128908.140085"] = 200846,
	["128938.140085"] = 213051,
	["128289.140085"] = 188635,

	["128825.142055"] = 196434,
	["128868.142055"] = 197708,
	["120978.142055"] = 186941,
	["128866.142055"] = 209229,
	["128823.142055"] = 200326,

	["128861.142064"] = 197038,
	["128940.142064"] = 195243,
	["128808.142064"] = 203566,
	["128908.142064"] = 200846,
	["128937.142064"] = 199364,
	["128938.142064"] = 213051,
	["128826.142064"] = 190449,
	["128872.142064"] = 216230,
	["128935.142064"] = 191493,
	["128819.142064"] = 215381,

	["128826.142062"] = 190449,
	["128823.142062"] = 200326,
	["128911.142062"] = 207088,
	["128937.142062"] = 199364,
	["128938.142062"] = 213051,
	["128825.142062"] = 196434,
	["128860.142062"] = 210570,
	["128306.142062"] = 189772,
	["128821.142062"] = 200395,
	["128858.142062"] = 202384,

	["128821.142059"] = 200395,
	["128820.142059"] = 194224,
	["128908.142059"] = 200846,
	["128289.142059"] = 188635,
	["120978.142059"] = 186941,
	["128403.142059"] = 191419,
	["128941.142059"] = 196211,
	["128943.142059"] = 211108,
	["128819.142059"] = 215381,

	["127857.142060"] = 187304,
	["128860.142060"] = 210570,
	["128306.142060"] = 189772,
	["128937.142060"] = 199364,
	["128292.142060"] = 189080,
	["128911.142060"] = 207088,
	["128935.142060"] = 191493,
	["128862.142060"] = 195315,

	["128820.142056"] = 194224,
	["128832.142056"] = 207343,
	["128861.142056"] = 197038,
	["127857.142056"] = 187304,
	["128858.142056"] = 202384,
	["128862.142056"] = 195315,
	["128866.142056"] = 209229,

	["128943.142058"] = 211108,
	["128941.142058"] = 196211,
	["128476.142058"] = 197231,
	["128832.142058"] = 207343,
	["127829.142058"] = 201454,

	["128943.142063"] = 211108,
	["128827.142063"] = 194093,
	["128403.142063"] = 191419,
	["128292.142063"] = 189080,
	["128870.142063"] = 192310,
	["128942.142063"] = 199111,
	["128868.142063"] = 197708,
	["128910.142063"] = 209459,
	["128402.142063"] = 192450,
	["128476.142063"] = 197231,
	["127829.142063"] = 201454,

	["128821.142057"] = 200395,
	["128860.142057"] = 210570,
	["128910.142057"] = 209459,
	["128402.142057"] = 192450,
	["128403.142057"] = 191419,
	["128289.142057"] = 188635,
	["128808.142057"] = 203566,
	["128870.142057"] = 192310,
	["128942.142057"] = 199111,
	["128872.142057"] = 216230,
	["128827.142057"] = 194093,
	["128826.142057"] = 190449,

	["128910.142061"] = 209459,
	["128940.142061"] = 195243,
	["128402.142061"] = 192450,
	["128861.142061"] = 197038,
	["128832.142061"] = 207343,
	["128872.142061"] = 216230,
	["128819.142061"] = 215381,
	["128908.142061"] = 200846,
	["128289.142061"] = 188635,
	["128938.142061"] = 213051,
	["128866.142061"] = 209229,
	["128808.142061"] = 203566,
	["128870.142061"] = 192310,

	["128825.133685"] = 196430,
	["128868.133685"] = 197762,
	["128866.133685"] = 209216,
	["120978.133685"] = 186944,
	["128823.133685"] = 200482,

	["128868.136717"] = 197716,
	["128825.136717"] = 196418,
	["128823.136717"] = 200296,
	["128866.136717"] = 209226,
	["120978.136717"] = 186945,

	["120978.136771"] = 184843,
	["128866.136771"] = 209220,
	["128823.136771"] = 200315,
	["128825.136771"] = 196416,
	["128868.136771"] = 197715,

	["128823.137346"] = 200298,
	["120978.137346"] = 185368,
	["128866.137346"] = 209218,
	["128868.137346"] = 197729,
	["128825.137346"] = 196429,

	["128868.137366"] = 197713,
	["128825.137366"] = 196358,
	["128823.137366"] = 200316,
	["128866.137366"] = 209217,
	["120978.137366"] = 184759,

	["128825.137402"] = 196355,
	["128868.137402"] = 216212,
	["120978.137402"] = 184778,
	["128866.137402"] = 209225,
	["128823.137402"] = 200302,

	["128868.137474"] = 197708,
	["128825.137474"] = 196434,
	["128823.137474"] = 200326,
	["120978.137474"] = 186941,
	["128866.137474"] = 209229,

	["128823.137495"] = 200294,
	["120978.137495"] = 186927,
	["128866.137495"] = 209223,
	["128868.137495"] = 197727,
	["128825.137495"] = 196422,

	["128825.137548"] = 196489,
	["128868.137548"] = 197711,
	["120978.137548"] = 186934,
	["128866.137548"] = 209224,
	["128823.137548"] = 200327,

	["128825.144467"] = 196434,
	["128868.144467"] = 197708,
	["128866.144467"] = 209229,
	["120978.144467"] = 186941,
	["128823.144467"] = 200326,

	["128823.151297"] = 200482,
	["120978.151297"] = 186944,
	["128866.151297"] = 209216,
	["128868.151297"] = 197762,
	["128825.151297"] = 196430,

	["128826.133682"] = 190467,
	["128872.133682"] = 202522,
	["128935.133682"] = 191740,
	["128819.133682"] = 198292,
	["128808.133682"] = 203638,
	["128908.133682"] = 200853,
	["128937.133682"] = 199372,
	["128938.133682"] = 213062,
	["128940.133682"] = 195266,
	["128861.133682"] = 197139,

	["128940.136974"] = 195380,
	["128861.136974"] = 197138,
	["128826.136974"] = 190514,
	["128935.136974"] = 191582,
	["128819.136974"] = 198248,
	["128872.136974"] = 202533,
	["128808.136974"] = 203749,
	["128937.136974"] = 199384,
	["128938.136974"] = 213116,
	["128908.136974"] = 200859,

	["128940.137270"] = 195263,
	["128861.137270"] = 197047,
	["128872.137270"] = 202507,
	["128819.137270"] = 198236,
	["128935.137270"] = 191499,
	["128826.137270"] = 190457,
	["128908.137270"] = 216273,
	["128937.137270"] = 199366,
	["128938.137270"] = 213049,
	["128808.137270"] = 203577,

	["128861.137313"] = 197162,
	["128940.137313"] = 195291,
	["128808.137313"] = 203670,
	["128908.137313"] = 200860,
	["128938.137313"] = 213133,
	["128937.137313"] = 199380,
	["128826.137313"] = 190529,
	["128872.137313"] = 202530,
	["128935.137313"] = 191577,
	["128819.137313"] = 198349,

	["128808.137365"] = 203578,
	["128937.137365"] = 199367,
	["128938.137365"] = 213180,
	["128908.137365"] = 200849,
	["128826.137365"] = 190462,
	["128935.137365"] = 191504,
	["128819.137365"] = 198247,
	["128872.137365"] = 202514,
	["128861.137365"] = 197080,
	["128940.137365"] = 218607,

	["128808.137421"] = 203673,
	["128908.137421"] = 200861,
	["128938.137421"] = 213136,
	["128937.137421"] = 199485,
	["128826.137421"] = 190567,
	["128872.137421"] = 202907,
	["128935.137421"] = 191598,
	["128819.137421"] = 198238,
	["128861.137421"] = 206910,
	["128940.137421"] = 195267,

	["128940.137468"] = 195244,
	["128861.137468"] = 197160,
	["128826.137468"] = 190503,
	["128872.137468"] = 202521,
	["128935.137468"] = 191569,
	["128819.137468"] = 198296,
	["128808.137468"] = 224764,
	["128908.137468"] = 200857,
	["128938.137468"] = 213047,
	["128937.137468"] = 199365,

	["128908.137477"] = 200846,
	["128938.137477"] = 213051,
	["128937.137477"] = 199364,
	["128808.137477"] = 203566,
	["128872.137477"] = 216230,
	["128819.137477"] = 215381,
	["128935.137477"] = 191493,
	["128826.137477"] = 190449,
	["128861.137477"] = 197038,
	["128940.137477"] = 195243,

	["128938.137493"] = 213055,
	["128937.137493"] = 199377,
	["128908.137493"] = 200856,
	["128808.137493"] = 203669,
	["128819.137493"] = 198299,
	["128935.137493"] = 191572,
	["128872.137493"] = 202524,
	["128826.137493"] = 190520,
	["128861.137493"] = 197140,
	["128940.137493"] = 195269,

	["128861.137550"] = 197038,
	["128940.137550"] = 195243,
	["128808.137550"] = 203566,
	["128908.137550"] = 200846,
	["128937.137550"] = 199364,
	["128938.137550"] = 213051,
	["128826.137550"] = 190449,
	["128872.137550"] = 216230,
	["128935.137550"] = 191493,
	["128819.137550"] = 215381,

	["128808.144465"] = 224764,
	["128908.144465"] = 200857,
	["128937.144465"] = 199365,
	["128938.144465"] = 213047,
	["128826.144465"] = 190503,
	["128872.144465"] = 202521,
	["128935.144465"] = 191569,
	["128819.144465"] = 198296,
	["128861.144465"] = 197160,
	["128940.144465"] = 195244,

	["128940.151295"] = 195269,
	["128861.151295"] = 197140,
	["128826.151295"] = 190520,
	["128935.151295"] = 191572,
	["128819.151295"] = 198299,
	["128872.151295"] = 202524,
	["128808.151295"] = 203669,
	["128938.151295"] = 213055,
	["128937.151295"] = 199377,
	["128908.151295"] = 200856,

	["128823.136720"] = 200316,
	["128911.136720"] = 207092,
	["128826.136720"] = 190457,
	["128938.136720"] = 213049,
	["128937.136720"] = 199366,
	["128821.136720"] = 200399,
	["128858.136720"] = 202386,
	["128825.136720"] = 196358,
	["128860.136720"] = 210571,
	["128306.136720"] = 189768,

	["128826.136973"] = 190503,
	["128823.136973"] = 200327,
	["128911.136973"] = 207351,
	["128938.136973"] = 213047,
	["128937.136973"] = 199365,
	["128825.136973"] = 196489,
	["128860.136973"] = 210557,
	["128306.136973"] = 186396,
	["128821.136973"] = 200400,
	["128858.136973"] = 202302,

	["128937.137307"] = 199364,
	["128938.137307"] = 213051,
	["128826.137307"] = 190449,
	["128823.137307"] = 200326,
	["128911.137307"] = 207088,
	["128825.137307"] = 196434,
	["128860.137307"] = 210570,
	["128306.137307"] = 189772,
	["128821.137307"] = 200395,
	["128858.137307"] = 202384,

	["128826.137327"] = 190520,
	["128911.137327"] = 207255,
	["128823.137327"] = 200294,
	["128937.137327"] = 199377,
	["128938.137327"] = 213055,
	["128860.137327"] = 210593,
	["128306.137327"] = 189754,
	["128825.137327"] = 196422,
	["128858.137327"] = 202445,
	["128821.137327"] = 200409,

	["128826.137339"] = 190514,
	["128823.137339"] = 200302,
	["128911.137339"] = 207354,
	["128937.137339"] = 199384,
	["128938.137339"] = 213116,
	["128825.137339"] = 196355,
	["128860.137339"] = 210590,
	["128306.137339"] = 186320,
	["128821.137339"] = 200440,
	["128858.137339"] = 203018,

	["128306.137381"] = 189749,
	["128860.137381"] = 210637,
	["128825.137381"] = 196429,
	["128858.137381"] = 202466,
	["128821.137381"] = 200414,
	["128938.137381"] = 213133,
	["128937.137381"] = 199380,
	["128826.137381"] = 190529,
	["128911.137381"] = 207285,
	["128823.137381"] = 200298,

	["128937.137411"] = 199367,
	["128938.137411"] = 213180,
	["128826.137411"] = 190462,
	["128823.137411"] = 200315,
	["128911.137411"] = 207118,
	["128825.137411"] = 196416,
	["128860.137411"] = 210575,
	["128306.137411"] = 189760,
	["128821.137411"] = 208762,
	["128858.137411"] = 202426,

	["128826.137475"] = 190567,
	["128911.137475"] = 207348,
	["128823.137475"] = 200482,
	["128937.137475"] = 199485,
	["128938.137475"] = 213136,
	["128860.137475"] = 210631,
	["128306.137475"] = 189744,
	["128825.137475"] = 196430,
	["128858.137475"] = 202464,
	["128821.137475"] = 200415,

	["128825.137478"] = 196418,
	["128306.137478"] = 189757,
	["128860.137478"] = 210579,
	["128821.137478"] = 200402,
	["128858.137478"] = 202433,
	["128937.137478"] = 199372,
	["128938.137478"] = 213062,
	["128826.137478"] = 190467,
	["128823.137478"] = 200296,
	["128911.137478"] = 207206,

	["128938.144458"] = 213136,
	["128937.144458"] = 199485,
	["128826.144458"] = 190567,
	["128823.144458"] = 200482,
	["128911.144458"] = 207348,
	["128825.144458"] = 196430,
	["128860.144458"] = 210631,
	["128306.144458"] = 189744,
	["128821.144458"] = 200415,
	["128858.144458"] = 202464,

	["128937.151288"] = 199364,
	["128938.151288"] = 213051,
	["128911.151288"] = 207088,
	["128823.151288"] = 200326,
	["128826.151288"] = 190449,
	["128858.151288"] = 202384,
	["128821.151288"] = 200395,
	["128306.151288"] = 189772,
	["128860.151288"] = 210570,
	["128825.151288"] = 196434,

	["128820.133686"] = 194313,
	["128821.133686"] = 200409,
	["128819.133686"] = 198299,
	["128943.133686"] = 211105,
	["128289.133686"] = 203225,
	["120978.133686"] = 186927,
	["128403.133686"] = 191494,
	["128908.133686"] = 200856,
	["128941.133686"] = 196236,

	["128820.136769"] = 194315,
	["128821.136769"] = 200440,
	["128943.136769"] = 211131,
	["128819.136769"] = 198248,
	["128941.136769"] = 196305,
	["128908.136769"] = 200859,
	["128403.136769"] = 191584,
	["128289.136769"] = 188644,
	["120978.136769"] = 184778,

	["128820.137316"] = 210182,
	["128821.137316"] = 200402,
	["128943.137316"] = 211123,
	["128819.137316"] = 198292,
	["128908.137316"] = 200853,
	["128289.137316"] = 203230,
	["120978.137316"] = 186945,
	["128403.137316"] = 191592,
	["128941.137316"] = 196227,

	["128943.137358"] = 211099,
	["128819.137358"] = 198238,
	["128941.137358"] = 196258,
	["128908.137358"] = 200861,
	["128403.137358"] = 208598,
	["128289.137358"] = 188639,
	["120978.137358"] = 186944,
	["128820.137358"] = 194239,
	["128821.137358"] = 200415,

	["128821.137375"] = 200400,
	["128820.137375"] = 194318,
	["128941.137375"] = 196301,
	["120978.137375"] = 186934,
	["128289.137375"] = 188632,
	["128403.137375"] = 191565,
	["128908.137375"] = 200857,
	["128819.137375"] = 198296,
	["128943.137375"] = 211144,

	["128821.137470"] = 200395,
	["128820.137470"] = 194224,
	["128908.137470"] = 200846,
	["128289.137470"] = 188635,
	["120978.137470"] = 186941,
	["128403.137470"] = 191419,
	["128941.137470"] = 196211,
	["128943.137470"] = 211108,
	["128819.137470"] = 215381,

	["128821.137492"] = 200414,
	["128820.137492"] = 194314,
	["128941.137492"] = 196432,
	["120978.137492"] = 185368,
	["128289.137492"] = 203227,
	["128403.137492"] = 191488,
	["128908.137492"] = 200860,
	["128819.137492"] = 198349,
	["128943.137492"] = 211119,

	["128941.137546"] = 196222,
	["120978.137546"] = 184843,
	["128289.137546"] = 188683,
	["128403.137546"] = 191485,
	["128908.137546"] = 200849,
	["128819.137546"] = 198247,
	["128943.137546"] = 211106,
	["128821.137546"] = 208762,
	["128820.137546"] = 194312,

	["128941.144460"] = 196217,
	["120978.144460"] = 184759,
	["128289.144460"] = 216272,
	["128403.144460"] = 191442,
	["128908.144460"] = 216273,
	["128819.144460"] = 198236,
	["128943.144460"] = 211126,
	["128821.144460"] = 200399,
	["128820.144460"] = 194234,

	["128941.151290"] = 196227,
	["128908.151290"] = 200853,
	["120978.151290"] = 186945,
	["128289.151290"] = 203230,
	["128403.151290"] = 191592,
	["128943.151290"] = 211123,
	["128819.151290"] = 198292,
	["128821.151290"] = 200402,
	["128820.151290"] = 210182,

	["128292.133683"] = 189080,
	["128937.133683"] = 199364,
	["128862.133683"] = 195315,
	["128911.133683"] = 207088,
	["128935.133683"] = 191493,
	["128306.133683"] = 189772,
	["128860.133683"] = 210570,
	["127857.133683"] = 187304,

	["127857.137272"] = 187321,
	["128860.137272"] = 210575,
	["128306.137272"] = 189760,
	["128862.137272"] = 195322,
	["128935.137272"] = 191504,
	["128911.137272"] = 207118,
	["128937.137272"] = 199367,
	["128292.137272"] = 189086,

	["128292.137308"] = 189092,
	["128937.137308"] = 199366,
	["128862.137308"] = 195317,
	["128911.137308"] = 207092,
	["128935.137308"] = 191499,
	["128306.137308"] = 189768,
	["128860.137308"] = 210571,
	["127857.137308"] = 187258,

	["128935.137340"] = 191572,
	["128911.137340"] = 207255,
	["128862.137340"] = 195345,
	["128937.137340"] = 199377,
	["128292.137340"] = 189144,
	["127857.137340"] = 187313,
	["128860.137340"] = 210593,
	["128306.137340"] = 189754,

	["128292.137370"] = 189164,
	["128937.137370"] = 199372,
	["128862.137370"] = 195323,
	["128935.137370"] = 191740,
	["128911.137370"] = 207206,
	["128306.137370"] = 189757,
	["128860.137370"] = 210579,
	["127857.137370"] = 187264,

	["128911.137380"] = 207285,
	["128935.137380"] = 191577,
	["128862.137380"] = 195351,
	["128937.137380"] = 199380,
	["128292.137380"] = 189147,
	["127857.137380"] = 187276,
	["128860.137380"] = 210637,
	["128306.137380"] = 189749,

	["128306.137403"] = 186396,
	["128860.137403"] = 210557,
	["127857.137403"] = 187301,
	["128292.137403"] = 189154,
	["128937.137403"] = 199365,
	["128862.137403"] = 195354,
	["128935.137403"] = 191569,
	["128911.137403"] = 207351,

	["127857.137466"] = 187287,
	["128860.137466"] = 210631,
	["128306.137466"] = 189744,
	["128935.137466"] = 191598,
	["128911.137466"] = 207348,
	["128862.137466"] = 195352,
	["128937.137466"] = 199485,
	["128292.137466"] = 189097,

	["127857.137545"] = 210716,
	["128860.137545"] = 210590,
	["128306.137545"] = 186320,
	["128937.137545"] = 199384,
	["128292.137545"] = 204875,
	["128862.137545"] = 214626,
	["128935.137545"] = 191582,
	["128911.137545"] = 207354,

	["128935.144461"] = 191598,
	["128911.144461"] = 207348,
	["128862.144461"] = 195352,
	["128292.144461"] = 189097,
	["128937.144461"] = 199485,
	["128306.144461"] = 189744,
	["128860.144461"] = 210631,
	["127857.144461"] = 187287,

	["127857.151291"] = 187276,
	["128860.151291"] = 210637,
	["128306.151291"] = 189749,
	["128937.151291"] = 199380,
	["128292.151291"] = 189147,
	["128862.151291"] = 195351,
	["128911.151291"] = 207285,
	["128935.151291"] = 191577,

	["128862.133768"] = 195351,
	["128866.133768"] = 209218,
	["128820.133768"] = 194314,
	["128832.133768"] = 212817,
	["128858.133768"] = 202466,
	["127857.133768"] = 187276,
	["128861.133768"] = 197162,

	["128820.137303"] = 194239,
	["128861.137303"] = 206910,
	["127857.137303"] = 187287,
	["128858.137303"] = 202464,
	["128832.137303"] = 212819,
	["128862.137303"] = 195352,
	["128866.137303"] = 209216,

	["128866.137323"] = 209220,
	["128862.137323"] = 195322,
	["128832.137323"] = 207352,
	["128861.137323"] = 197080,
	["128858.137323"] = 202426,
	["127857.137323"] = 187321,
	["128820.137323"] = 194312,

	["128862.137379"] = 195317,
	["128866.137379"] = 209217,
	["128820.137379"] = 194234,
	["128858.137379"] = 202386,
	["127857.137379"] = 187258,
	["128861.137379"] = 197047,
	["128832.137379"] = 207347,

	["128820.137420"] = 194224,
	["128861.137420"] = 197038,
	["127857.137420"] = 187304,
	["128858.137420"] = 202384,
	["128832.137420"] = 207343,
	["128862.137420"] = 195315,
	["128866.137420"] = 209229,

	["128862.137473"] = 195323,
	["128866.137473"] = 209226,
	["128820.137473"] = 210182,
	["128832.137473"] = 207375,
	["128861.137473"] = 197139,
	["128858.137473"] = 202433,
	["127857.137473"] = 187264,

	["128820.137490"] = 194315,
	["128861.137490"] = 197138,
	["127857.137490"] = 210716,
	["128858.137490"] = 203018,
	["128832.137490"] = 212827,
	["128862.137490"] = 214626,
	["128866.137490"] = 209225,

	["128820.137547"] = 194318,
	["127857.137547"] = 187301,
	["128858.137547"] = 202302,
	["128861.137547"] = 197160,
	["128832.137547"] = 212821,
	["128862.137547"] = 195354,
	["128866.137547"] = 209224,

	["128866.144463"] = 209220,
	["128862.144463"] = 195322,
	["128832.144463"] = 207352,
	["128858.144463"] = 202426,
	["127857.144463"] = 187321,
	["128861.144463"] = 197080,
	["128820.144463"] = 194312,

	["128820.151293"] = 194234,
	["127857.151293"] = 187258,
	["128858.151293"] = 202386,
	["128861.151293"] = 197047,
	["128832.151293"] = 207347,
	["128862.151293"] = 195317,
	["128866.151293"] = 209217,

	["128941.133764"] = 196432,
	["128943.133764"] = 211119,
	["127829.133764"] = 201460,
	["128832.133764"] = 212817,
	["128476.133764"] = 197386,

	["128832.136721"] = 212819,
	["127829.136721"] = 201464,
	["128476.136721"] = 197239,
	["128941.136721"] = 196258,
	["128943.136721"] = 211099,

	["128941.137318"] = 196305,
	["128943.137318"] = 211131,
	["128476.137318"] = 197244,
	["128832.137318"] = 212827,
	["127829.137318"] = 201463,

	["128941.137351"] = 196222,
	["128943.137351"] = 211106,
	["128476.137351"] = 197234,
	["127829.137351"] = 201456,
	["128832.137351"] = 207352,

	["128943.137407"] = 211126,
	["128941.137407"] = 196217,
	["127829.137407"] = 201455,
	["128832.137407"] = 207347,
	["128476.137407"] = 197233,

	["128943.137476"] = 211123,
	["128941.137476"] = 196227,
	["128476.137476"] = 197235,
	["128832.137476"] = 207375,
	["127829.137476"] = 201457,

	["128832.137491"] = 212816,
	["127829.137491"] = 201458,
	["128476.137491"] = 197369,
	["128941.137491"] = 196236,
	["128943.137491"] = 211105,

	["128476.137542"] = 197231,
	["127829.137542"] = 201454,
	["128832.137542"] = 207343,
	["128943.137542"] = 211108,
	["128941.137542"] = 196211,

	["128476.144459"] = 197241,
	["127829.144459"] = 201459,
	["128832.144459"] = 212821,
	["128941.144459"] = 196301,
	["128943.144459"] = 211144,

	["128941.151289"] = 196301,
	["128943.151289"] = 211144,
	["128476.151289"] = 197241,
	["127829.151289"] = 201459,
	["128832.151289"] = 212821,

	["128292.133684"] = 189092,
	["128870.133684"] = 192315,
	["128942.133684"] = 199112,
	["128403.133684"] = 191442,
	["128827.133684"] = 193643,
	["128943.133684"] = 211126,
	["127829.133684"] = 201455,
	["128476.133684"] = 197233,
	["128402.133684"] = 192453,
	["128910.133684"] = 209462,
	["128868.133684"] = 197713,

	["128403.136719"] = 191584,
	["128942.136719"] = 199214,
	["128870.136719"] = 192345,
	["128292.136719"] = 204875,
	["128943.136719"] = 211131,
	["128827.136719"] = 193647,
	["128476.136719"] = 197244,
	["127829.136719"] = 201463,
	["128868.136719"] = 216212,
	["128910.136719"] = 209541,
	["128402.136719"] = 192538,

	["128476.137317"] = 197235,
	["127829.137317"] = 201457,
	["128868.137317"] = 197716,
	["128910.137317"] = 216274,
	["128402.137317"] = 192457,
	["128403.137317"] = 191592,
	["128870.137317"] = 192326,
	["128942.137317"] = 199152,
	["128292.137317"] = 189164,
	["128943.137317"] = 211123,
	["128827.137317"] = 193645,

	["128942.137347"] = 199111,
	["128870.137347"] = 192310,
	["128292.137347"] = 189080,
	["128403.137347"] = 191419,
	["128827.137347"] = 194093,
	["128943.137347"] = 211108,
	["127829.137347"] = 201454,
	["128476.137347"] = 197231,
	["128402.137347"] = 192450,
	["128910.137347"] = 209459,
	["128868.137347"] = 197708,

	["128910.137377"] = 209494,
	["128402.137377"] = 192464,
	["128868.137377"] = 197762,
	["127829.137377"] = 201464,
	["128476.137377"] = 197239,
	["128943.137377"] = 211099,
	["128827.137377"] = 194002,
	["128870.137377"] = 192376,
	["128942.137377"] = 199163,
	["128292.137377"] = 189097,
	["128403.137377"] = 208598,

	["128910.137399"] = 209481,
	["128402.137399"] = 192460,
	["128868.137399"] = 197727,
	["127829.137399"] = 201458,
	["128476.137399"] = 197369,
	["128943.137399"] = 211105,
	["128827.137399"] = 194007,
	["128292.137399"] = 189144,
	["128870.137399"] = 192329,
	["128942.137399"] = 199153,
	["128403.137399"] = 191494,

	["127829.137463"] = 201456,
	["128476.137463"] = 197234,
	["128910.137463"] = 209472,
	["128402.137463"] = 192447,
	["128868.137463"] = 197715,
	["128870.137463"] = 192318,
	["128292.137463"] = 189086,
	["128942.137463"] = 199120,
	["128403.137463"] = 191485,
	["128943.137463"] = 211106,
	["128827.137463"] = 193644,

	["128827.137464"] = 193642,
	["128943.137464"] = 211144,
	["128403.137464"] = 191565,
	["128942.137464"] = 199212,
	["128870.137464"] = 192323,
	["128292.137464"] = 189154,
	["128868.137464"] = 197711,
	["128402.137464"] = 192514,
	["128910.137464"] = 209483,
	["128476.137464"] = 197241,
	["127829.137464"] = 201459,

	["128868.137549"] = 197729,
	["128402.137549"] = 192542,
	["128910.137549"] = 248579,
	["128476.137549"] = 197386,
	["127829.137549"] = 201460,
	["128827.137549"] = 194016,
	["128943.137549"] = 211119,
	["128403.137549"] = 191488,
	["128292.137549"] = 189147,
	["128870.137549"] = 192349,
	["128942.137549"] = 199158,

	["127829.144464"] = 201456,
	["128476.144464"] = 197234,
	["128402.144464"] = 192447,
	["128910.144464"] = 209472,
	["128868.144464"] = 197715,
	["128870.144464"] = 192318,
	["128942.144464"] = 199120,
	["128292.144464"] = 189086,
	["128403.144464"] = 191485,
	["128827.144464"] = 193644,
	["128943.144464"] = 211106,

	["128476.151294"] = 197244,
	["127829.151294"] = 201463,
	["128868.151294"] = 216212,
	["128910.151294"] = 209541,
	["128402.151294"] = 192538,
	["128403.151294"] = 191584,
	["128870.151294"] = 192345,
	["128292.151294"] = 204875,
	["128942.151294"] = 199214,
	["128943.151294"] = 211131,
	["128827.151294"] = 193647,

	["128402.133687"] = 192453,
	["128910.133687"] = 209462,
	["128821.133687"] = 200399,
	["128860.133687"] = 210571,
	["128827.133687"] = 193643,
	["128872.133687"] = 202507,
	["128826.133687"] = 190457,
	["128403.133687"] = 191442,
	["128289.133687"] = 216272,
	["128870.133687"] = 192315,
	["128942.133687"] = 199112,
	["128808.133687"] = 203577,

	["128860.136718"] = 210637,
	["128821.136718"] = 200414,
	["128402.136718"] = 192542,
	["128910.136718"] = 248579,
	["128942.136718"] = 199158,
	["128870.136718"] = 192349,
	["128808.136718"] = 203670,
	["128403.136718"] = 191488,
	["128289.136718"] = 203227,
	["128826.136718"] = 190529,
	["128827.136718"] = 194016,
	["128872.136718"] = 202530,

	["128860.137302"] = 210557,
	["128821.137302"] = 200400,
	["128910.137302"] = 209483,
	["128402.137302"] = 192514,
	["128808.137302"] = 224764,
	["128942.137302"] = 199212,
	["128870.137302"] = 192323,
	["128289.137302"] = 188632,
	["128403.137302"] = 191565,
	["128826.137302"] = 190503,
	["128872.137302"] = 202521,
	["128827.137302"] = 193642,

	["128860.137328"] = 210575,
	["128821.137328"] = 208762,
	["128910.137328"] = 209472,
	["128402.137328"] = 192447,
	["128808.137328"] = 203578,
	["128942.137328"] = 199120,
	["128870.137328"] = 192318,
	["128403.137328"] = 191485,
	["128289.137328"] = 188683,
	["128826.137328"] = 190462,
	["128872.137328"] = 202514,
	["128827.137328"] = 193644,

	["128826.137350"] = 190449,
	["128827.137350"] = 194093,
	["128872.137350"] = 216230,
	["128942.137350"] = 199111,
	["128870.137350"] = 192310,
	["128808.137350"] = 203566,
	["128289.137350"] = 188635,
	["128403.137350"] = 191419,
	["128402.137350"] = 192450,
	["128910.137350"] = 209459,
	["128860.137350"] = 210570,
	["128821.137350"] = 200395,

	["128872.137363"] = 202907,
	["128827.137363"] = 194002,
	["128826.137363"] = 190567,
	["128403.137363"] = 208598,
	["128289.137363"] = 188639,
	["128808.137363"] = 203673,
	["128870.137363"] = 192376,
	["128942.137363"] = 199163,
	["128910.137363"] = 209494,
	["128402.137363"] = 192464,
	["128821.137363"] = 200415,
	["128860.137363"] = 210631,

	["128910.137412"] = 209481,
	["128402.137412"] = 192460,
	["128821.137412"] = 200409,
	["128860.137412"] = 210593,
	["128872.137412"] = 202524,
	["128827.137412"] = 194007,
	["128826.137412"] = 190520,
	["128403.137412"] = 191494,
	["128289.137412"] = 203225,
	["128808.137412"] = 203669,
	["128870.137412"] = 192329,
	["128942.137412"] = 199153,

	["128860.137465"] = 210579,
	["128821.137465"] = 200402,
	["128910.137465"] = 216274,
	["128402.137465"] = 192457,
	["128808.137465"] = 203638,
	["128942.137465"] = 199152,
	["128870.137465"] = 192326,
	["128289.137465"] = 203230,
	["128403.137465"] = 191592,
	["128826.137465"] = 190467,
	["128872.137465"] = 202522,
	["128827.137465"] = 193645,

	["128826.137471"] = 190514,
	["128872.137471"] = 202533,
	["128827.137471"] = 193647,
	["128808.137471"] = 203749,
	["128942.137471"] = 199214,
	["128870.137471"] = 192345,
	["128403.137471"] = 191584,
	["128289.137471"] = 188644,
	["128910.137471"] = 209541,
	["128402.137471"] = 192538,
	["128860.137471"] = 210590,
	["128821.137471"] = 200440,

	["128910.137544"] = 209459,
	["128402.137544"] = 192450,
	["128860.137544"] = 210570,
	["128821.137544"] = 200395,
	["128826.137544"] = 190449,
	["128872.137544"] = 216230,
	["128827.137544"] = 194093,
	["128808.137544"] = 203566,
	["128942.137544"] = 199111,
	["128870.137544"] = 192310,
	["128289.137544"] = 188635,
	["128403.137544"] = 191419,

	["128942.144466"] = 199120,
	["128870.144466"] = 192318,
	["128808.144466"] = 203578,
	["128289.144466"] = 188683,
	["128403.144466"] = 191485,
	["128826.144466"] = 190462,
	["128827.144466"] = 193644,
	["128872.144466"] = 202514,
	["128860.144466"] = 210575,
	["128821.144466"] = 208762,
	["128402.144466"] = 192447,
	["128910.144466"] = 209472,

	["128910.151296"] = 209472,
	["128402.151296"] = 192447,
	["128860.151296"] = 210575,
	["128821.151296"] = 208762,
	["128826.151296"] = 190462,
	["128872.151296"] = 202514,
	["128827.151296"] = 193644,
	["128808.151296"] = 203578,
	["128942.151296"] = 199120,
	["128870.151296"] = 192318,
	["128403.151296"] = 191485,
	["128289.151296"] = 188683,

	["128819.133763"] = 198299,
	["128872.133763"] = 202524,
	["128289.133763"] = 203225,
	["128938.133763"] = 213055,
	["128908.133763"] = 200856,
	["128870.133763"] = 192329,
	["128808.133763"] = 203669,
	["128866.133763"] = 209223,
	["128402.133763"] = 192460,
	["128910.133763"] = 209481,
	["128940.133763"] = 195269,
	["128861.133763"] = 197140,
	["128832.133763"] = 212816,

	["128872.136778"] = 202521,
	["128819.136778"] = 198296,
	["128908.136778"] = 200857,
	["128289.136778"] = 188632,
	["128938.136778"] = 213047,
	["128808.136778"] = 224764,
	["128866.136778"] = 209224,
	["128870.136778"] = 192323,
	["128910.136778"] = 209483,
	["128940.136778"] = 195244,
	["128402.136778"] = 192514,
	["128861.136778"] = 197160,
	["128832.136778"] = 212821,

	["128402.137326"] = 192514,
	["128940.137326"] = 195244,
	["128910.137326"] = 209483,
	["128861.137326"] = 197160,
	["128832.137326"] = 212821,
	["128819.137326"] = 198296,
	["128872.137326"] = 202521,
	["128289.137326"] = 188632,
	["128938.137326"] = 213047,
	["128908.137326"] = 200857,
	["128870.137326"] = 192323,
	["128866.137326"] = 209224,
	["128808.137326"] = 224764,

	["128832.137359"] = 207347,
	["128861.137359"] = 197047,
	["128940.137359"] = 195263,
	["128910.137359"] = 209462,
	["128402.137359"] = 192453,
	["128866.137359"] = 209217,
	["128808.137359"] = 203577,
	["128870.137359"] = 192315,
	["128908.137359"] = 216273,
	["128289.137359"] = 216272,
	["128938.137359"] = 213049,
	["128872.137359"] = 202507,
	["128819.137359"] = 198236,

	["128938.137371"] = 213116,
	["128289.137371"] = 188644,
	["128908.137371"] = 200859,
	["128870.137371"] = 192345,
	["128866.137371"] = 209225,
	["128808.137371"] = 203749,
	["128819.137371"] = 198248,
	["128872.137371"] = 202533,
	["128861.137371"] = 197138,
	["128832.137371"] = 212827,
	["128402.137371"] = 192538,
	["128940.137371"] = 195380,
	["128910.137371"] = 209541,

	["128402.137408"] = 192450,
	["128940.137408"] = 195243,
	["128910.137408"] = 209459,
	["128861.137408"] = 197038,
	["128832.137408"] = 207343,
	["128819.137408"] = 215381,
	["128872.137408"] = 216230,
	["128289.137408"] = 188635,
	["128938.137408"] = 213051,
	["128908.137408"] = 200846,
	["128870.137408"] = 192310,
	["128866.137408"] = 209229,
	["128808.137408"] = 203566,

	["128832.137469"] = 212819,
	["128861.137469"] = 206910,
	["128940.137469"] = 195267,
	["128910.137469"] = 209494,
	["128402.137469"] = 192464,
	["128808.137469"] = 203673,
	["128866.137469"] = 209216,
	["128870.137469"] = 192376,
	["128908.137469"] = 200861,
	["128289.137469"] = 188639,
	["128938.137469"] = 213136,
	["128872.137469"] = 202907,
	["128819.137469"] = 198238,

	["128908.137472"] = 200849,
	["128938.137472"] = 213180,
	["128289.137472"] = 188683,
	["128808.137472"] = 203578,
	["128866.137472"] = 209220,
	["128870.137472"] = 192318,
	["128872.137472"] = 202514,
	["128819.137472"] = 198247,
	["128861.137472"] = 197080,
	["128832.137472"] = 207352,
	["128910.137472"] = 209472,
	["128940.137472"] = 218607,
	["128402.137472"] = 192447,

	["128861.137494"] = 197139,
	["128832.137494"] = 207375,
	["128402.137494"] = 192457,
	["128910.137494"] = 216274,
	["128940.137494"] = 195266,
	["128938.137494"] = 213062,
	["128289.137494"] = 203230,
	["128908.137494"] = 200853,
	["128870.137494"] = 192326,
	["128866.137494"] = 209226,
	["128808.137494"] = 203638,
	["128819.137494"] = 198292,
	["128872.137494"] = 202522,

	["128872.137543"] = 202530,
	["128819.137543"] = 198349,
	["128866.137543"] = 209218,
	["128808.137543"] = 203670,
	["128870.137543"] = 192349,
	["128908.137543"] = 200860,
	["128938.137543"] = 213133,
	["128289.137543"] = 203227,
	["128940.137543"] = 195291,
	["128910.137543"] = 248579,
	["128402.137543"] = 192542,
	["128832.137543"] = 212817,
	["128861.137543"] = 197162,

	["128808.144462"] = 203638,
	["128866.144462"] = 209226,
	["128870.144462"] = 192326,
	["128908.144462"] = 200853,
	["128289.144462"] = 203230,
	["128938.144462"] = 213062,
	["128872.144462"] = 202522,
	["128819.144462"] = 198292,
	["128832.144462"] = 207375,
	["128861.144462"] = 197139,
	["128940.144462"] = 195266,
	["128910.144462"] = 216274,
	["128402.144462"] = 192457,

	["128872.151292"] = 202524,
	["128819.151292"] = 198299,
	["128908.151292"] = 200856,
	["128289.151292"] = 203225,
	["128938.151292"] = 213055,
	["128866.151292"] = 209223,
	["128808.151292"] = 203669,
	["128870.151292"] = 192329,
	["128940.151292"] = 195269,
	["128910.151292"] = 209481,
	["128402.151292"] = 192460,
	["128861.151292"] = 197140,
	["128832.151292"] = 212816,

	["128823.140052"] = 200316,
	["128866.140052"] = 209217,
	["120978.140052"] = 184759,
	["128868.140052"] = 197713,
	["128825.140052"] = 196358,

	["128823.140062"] = 200315,
	["128866.140062"] = 209220,
	["120978.140062"] = 184843,
	["128868.140062"] = 197715,
	["128825.140062"] = 196416,

	["128825.140042"] = 196430,
	["128868.140042"] = 197762,
	["120978.140042"] = 186944,
	["128866.140042"] = 209216,
	["128823.140042"] = 200482,

	["120978.141260"] = 186945,
	["128866.141260"] = 209226,
	["128823.141260"] = 200296,
	["128825.141260"] = 196418,
	["128868.141260"] = 197716,

	["128823.141271"] = 200294,
	["128866.141271"] = 209223,
	["120978.141271"] = 186927,
	["128868.141271"] = 197727,
	["128825.141271"] = 196422,

	["128825.141276"] = 196416,
	["128868.141276"] = 197715,
	["128866.141276"] = 209220,
	["120978.141276"] = 184843,
	["128823.141276"] = 200315,

	["128868.141286"] = 216212,
	["128825.141286"] = 196355,
	["128823.141286"] = 200302,
	["120978.141286"] = 184778,
	["128866.141286"] = 209225,

	["128825.143686"] = 196434,
	["128868.143686"] = 197708,
	["120978.143686"] = 186941,
	["128866.143686"] = 209229,
	["128823.143686"] = 200326,

	["128825.143695"] = 196358,
	["128868.143695"] = 197713,
	["120978.143695"] = 184759,
	["128866.143695"] = 209217,
	["128823.143695"] = 200316,

	["128819.140049"] = 198236,
	["128935.140049"] = 191499,
	["128872.140049"] = 202507,
	["128826.140049"] = 190457,
	["128937.140049"] = 199366,
	["128938.140049"] = 213049,
	["128908.140049"] = 216273,
	["128808.140049"] = 203577,
	["128940.140049"] = 195263,
	["128861.140049"] = 197047,

	["128940.140059"] = 218607,
	["128861.140059"] = 197080,
	["128826.140059"] = 190462,
	["128872.140059"] = 202514,
	["128935.140059"] = 191504,
	["128819.140059"] = 198247,
	["128808.140059"] = 203578,
	["128908.140059"] = 200849,
	["128938.140059"] = 213180,
	["128937.140059"] = 199367,

	["128872.140079"] = 216230,
	["128819.140079"] = 215381,
	["128935.140079"] = 191493,
	["128826.140079"] = 190449,
	["128908.140079"] = 200846,
	["128937.140079"] = 199364,
	["128938.140079"] = 213051,
	["128808.140079"] = 203566,
	["128940.140079"] = 195243,
	["128861.140079"] = 197038,

	["128808.141258"] = 203673,
	["128908.141258"] = 200861,
	["128937.141258"] = 199485,
	["128938.141258"] = 213136,
	["128826.141258"] = 190567,
	["128872.141258"] = 202907,
	["128935.141258"] = 191598,
	["128819.141258"] = 198238,
	["128861.141258"] = 206910,
	["128940.141258"] = 195267,

	["128908.141270"] = 200857,
	["128937.141270"] = 199365,
	["128938.141270"] = 213047,
	["128808.141270"] = 224764,
	["128872.141270"] = 202521,
	["128819.141270"] = 198296,
	["128935.141270"] = 191569,
	["128826.141270"] = 190503,
	["128861.141270"] = 197160,
	["128940.141270"] = 195244,

	["128940.141278"] = 218607,
	["128861.141278"] = 197080,
	["128872.141278"] = 202514,
	["128819.141278"] = 198247,
	["128935.141278"] = 191504,
	["128826.141278"] = 190462,
	["128908.141278"] = 200849,
	["128938.141278"] = 213180,
	["128937.141278"] = 199367,
	["128808.141278"] = 203578,

	["128861.141285"] = 197038,
	["128940.141285"] = 195243,
	["128908.141285"] = 200846,
	["128938.141285"] = 213051,
	["128937.141285"] = 199364,
	["128808.141285"] = 203566,
	["128872.141285"] = 216230,
	["128819.141285"] = 215381,
	["128935.141285"] = 191493,
	["128826.141285"] = 190449,

	["128808.143688"] = 203638,
	["128908.143688"] = 200853,
	["128938.143688"] = 213062,
	["128937.143688"] = 199372,
	["128826.143688"] = 190467,
	["128872.143688"] = 202522,
	["128935.143688"] = 191740,
	["128819.143688"] = 198292,
	["128861.143688"] = 197139,
	["128940.143688"] = 195266,

	["128861.143697"] = 197139,
	["128940.143697"] = 195266,
	["128937.143697"] = 199372,
	["128938.143697"] = 213062,
	["128908.143697"] = 200853,
	["128808.143697"] = 203638,
	["128819.143697"] = 198292,
	["128935.143697"] = 191740,
	["128872.143697"] = 202522,
	["128826.143697"] = 190467,

	["128826.143704"] = 190520,
	["128872.143704"] = 202524,
	["128935.143704"] = 191572,
	["128819.143704"] = 198299,
	["128808.143704"] = 203669,
	["128908.143704"] = 200856,
	["128938.143704"] = 213055,
	["128937.143704"] = 199377,
	["128940.143704"] = 195269,
	["128861.143704"] = 197140,

	["128938.140058"] = 213049,
	["128937.140058"] = 199366,
	["128911.140058"] = 207092,
	["128823.140058"] = 200316,
	["128826.140058"] = 190457,
	["128858.140058"] = 202386,
	["128821.140058"] = 200399,
	["128306.140058"] = 189768,
	["128860.140058"] = 210571,
	["128825.140058"] = 196358,

	["128821.140068"] = 208762,
	["128858.140068"] = 202426,
	["128825.140068"] = 196416,
	["128306.140068"] = 189760,
	["128860.140068"] = 210575,
	["128823.140068"] = 200315,
	["128911.140068"] = 207118,
	["128826.140068"] = 190462,
	["128938.140068"] = 213180,
	["128937.140068"] = 199367,

	["128858.140088"] = 202445,
	["128821.140088"] = 200409,
	["128306.140088"] = 189754,
	["128860.140088"] = 210593,
	["128825.140088"] = 196422,
	["128911.140088"] = 207255,
	["128823.140088"] = 200294,
	["128826.140088"] = 190520,
	["128938.140088"] = 213055,
	["128937.140088"] = 199377,

	["128826.141256"] = 190567,
	["128911.141256"] = 207348,
	["128823.141256"] = 200482,
	["128938.141256"] = 213136,
	["128937.141256"] = 199485,
	["128860.141256"] = 210631,
	["128306.141256"] = 189744,
	["128825.141256"] = 196430,
	["128858.141256"] = 202464,
	["128821.141256"] = 200415,

	["128826.141269"] = 190467,
	["128911.141269"] = 207206,
	["128823.141269"] = 200296,
	["128938.141269"] = 213062,
	["128937.141269"] = 199372,
	["128860.141269"] = 210579,
	["128306.141269"] = 189757,
	["128825.141269"] = 196418,
	["128858.141269"] = 202433,
	["128821.141269"] = 200402,

	["128938.141275"] = 213116,
	["128937.141275"] = 199384,
	["128911.141275"] = 207354,
	["128823.141275"] = 200302,
	["128826.141275"] = 190514,
	["128858.141275"] = 203018,
	["128821.141275"] = 200440,
	["128306.141275"] = 186320,
	["128860.141275"] = 210590,
	["128825.141275"] = 196355,

	["128937.141290"] = 199380,
	["128938.141290"] = 213133,
	["128823.141290"] = 200298,
	["128911.141290"] = 207285,
	["128826.141290"] = 190529,
	["128821.141290"] = 200414,
	["128858.141290"] = 202466,
	["128825.141290"] = 196429,
	["128306.141290"] = 189749,
	["128860.141290"] = 210637,

	["128937.143689"] = 199366,
	["128938.143689"] = 213049,
	["128826.143689"] = 190457,
	["128911.143689"] = 207092,
	["128823.143689"] = 200316,
	["128860.143689"] = 210571,
	["128306.143689"] = 189768,
	["128825.143689"] = 196358,
	["128858.143689"] = 202386,
	["128821.143689"] = 200399,

	["128937.143698"] = 199365,
	["128938.143698"] = 213047,
	["128826.143698"] = 190503,
	["128823.143698"] = 200327,
	["128911.143698"] = 207351,
	["128825.143698"] = 196489,
	["128860.143698"] = 210557,
	["128306.143698"] = 186396,
	["128821.143698"] = 200400,
	["128858.143698"] = 202302,

	["128825.143702"] = 196416,
	["128306.143702"] = 189760,
	["128860.143702"] = 210575,
	["128821.143702"] = 208762,
	["128858.143702"] = 202426,
	["128938.143702"] = 213180,
	["128937.143702"] = 199367,
	["128826.143702"] = 190462,
	["128823.143702"] = 200315,
	["128911.143702"] = 207118,

	["128821.140053"] = 200399,
	["128820.140053"] = 194234,
	["128289.140053"] = 216272,
	["120978.140053"] = 184759,
	["128403.140053"] = 191442,
	["128908.140053"] = 216273,
	["128941.140053"] = 196217,
	["128819.140053"] = 198236,
	["128943.140053"] = 211126,

	["128821.140063"] = 208762,
	["128820.140063"] = 194312,
	["128908.140063"] = 200849,
	["128289.140063"] = 188683,
	["128403.140063"] = 191485,
	["120978.140063"] = 184843,
	["128941.140063"] = 196222,
	["128943.140063"] = 211106,
	["128819.140063"] = 198247,

	["128820.140043"] = 194314,
	["128821.140043"] = 200414,
	["128943.140043"] = 211119,
	["128819.140043"] = 198349,
	["128908.140043"] = 200860,
	["128289.140043"] = 203227,
	["128403.140043"] = 191488,
	["120978.140043"] = 185368,
	["128941.140043"] = 196432,

	["128821.141261"] = 200415,
	["128820.141261"] = 194239,
	["128908.141261"] = 200861,
	["128289.141261"] = 188639,
	["128403.141261"] = 208598,
	["120978.141261"] = 186944,
	["128941.141261"] = 196258,
	["128943.141261"] = 211099,
	["128819.141261"] = 198238,

	["128943.141265"] = 211106,
	["128819.141265"] = 198247,
	["128941.141265"] = 196222,
	["128908.141265"] = 200849,
	["120978.141265"] = 184843,
	["128289.141265"] = 188683,
	["128403.141265"] = 191485,
	["128820.141265"] = 194312,
	["128821.141265"] = 208762,

	["128941.141279"] = 196211,
	["128908.141279"] = 200846,
	["128403.141279"] = 191419,
	["128289.141279"] = 188635,
	["120978.141279"] = 186941,
	["128943.141279"] = 211108,
	["128819.141279"] = 215381,
	["128821.141279"] = 200395,
	["128820.141279"] = 194224,

	["128289.141293"] = 203227,
	["128403.141293"] = 191488,
	["120978.141293"] = 185368,
	["128908.141293"] = 200860,
	["128941.141293"] = 196432,
	["128819.141293"] = 198349,
	["128943.141293"] = 211119,
	["128821.141293"] = 200414,
	["128820.141293"] = 194314,

	["128821.143683"] = 200409,
	["128820.143683"] = 194313,
	["128941.143683"] = 196236,
	["128908.143683"] = 200856,
	["120978.143683"] = 186927,
	["128289.143683"] = 203225,
	["128403.143683"] = 191494,
	["128943.143683"] = 211105,
	["128819.143683"] = 198299,

	["128289.143701"] = 188644,
	["120978.143701"] = 184778,
	["128403.143701"] = 191584,
	["128908.143701"] = 200859,
	["128941.143701"] = 196305,
	["128819.143701"] = 198248,
	["128943.143701"] = 211131,
	["128821.143701"] = 200440,
	["128820.143701"] = 194315,

	["128292.140050"] = 189092,
	["128937.140050"] = 199366,
	["128911.140050"] = 207092,
	["128935.140050"] = 191499,
	["128862.140050"] = 195317,
	["128306.140050"] = 189768,
	["128860.140050"] = 210571,
	["127857.140050"] = 187258,

	["128292.140060"] = 189086,
	["128937.140060"] = 199367,
	["128911.140060"] = 207118,
	["128935.140060"] = 191504,
	["128862.140060"] = 195322,
	["128306.140060"] = 189760,
	["128860.140060"] = 210575,
	["127857.140060"] = 187321,

	["127857.140080"] = 187313,
	["128860.140080"] = 210593,
	["128306.140080"] = 189754,
	["128937.140080"] = 199377,
	["128292.140080"] = 189144,
	["128935.140080"] = 191572,
	["128911.140080"] = 207255,
	["128862.140080"] = 195345,

	["128306.141257"] = 189768,
	["128860.141257"] = 210571,
	["127857.141257"] = 187258,
	["128292.141257"] = 189092,
	["128937.141257"] = 199366,
	["128935.141257"] = 191499,
	["128911.141257"] = 207092,
	["128862.141257"] = 195317,

	["127857.141267"] = 187287,
	["128860.141267"] = 210631,
	["128306.141267"] = 189744,
	["128937.141267"] = 199485,
	["128292.141267"] = 189097,
	["128935.141267"] = 191598,
	["128911.141267"] = 207348,
	["128862.141267"] = 195352,

	["128306.141274"] = 189772,
	["128860.141274"] = 210570,
	["127857.141274"] = 187304,
	["128292.141274"] = 189080,
	["128937.141274"] = 199364,
	["128862.141274"] = 195315,
	["128935.141274"] = 191493,
	["128911.141274"] = 207088,

	["128862.141284"] = 195345,
	["128911.141284"] = 207255,
	["128935.141284"] = 191572,
	["128937.141284"] = 199377,
	["128292.141284"] = 189144,
	["127857.141284"] = 187313,
	["128860.141284"] = 210593,
	["128306.141284"] = 189754,

	["128937.143700"] = 199367,
	["128292.143700"] = 189086,
	["128862.143700"] = 195322,
	["128911.143700"] = 207118,
	["128935.143700"] = 191504,
	["127857.143700"] = 187321,
	["128860.143700"] = 210575,
	["128306.143700"] = 189760,

	["128306.143703"] = 189749,
	["128860.143703"] = 210637,
	["127857.143703"] = 187276,
	["128935.143703"] = 191577,
	["128911.143703"] = 207285,
	["128862.143703"] = 195351,
	["128292.143703"] = 189147,
	["128937.143703"] = 199380,

	["128862.140057"] = 195317,
	["128866.140057"] = 209217,
	["128820.140057"] = 194234,
	["128832.140057"] = 207347,
	["128861.140057"] = 197047,
	["128858.140057"] = 202386,
	["127857.140057"] = 187258,

	["128820.140067"] = 194312,
	["128832.140067"] = 207352,
	["128861.140067"] = 197080,
	["127857.140067"] = 187321,
	["128858.140067"] = 202426,
	["128862.140067"] = 195322,
	["128866.140067"] = 209220,

	["128866.140047"] = 209226,
	["128862.140047"] = 195323,
	["127857.140047"] = 187264,
	["128858.140047"] = 202433,
	["128861.140047"] = 197139,
	["128832.140047"] = 207375,
	["128820.140047"] = 210182,

	["128820.141259"] = 194314,
	["128861.141259"] = 197162,
	["127857.141259"] = 187276,
	["128858.141259"] = 202466,
	["128832.141259"] = 212817,
	["128862.141259"] = 195351,
	["128866.141259"] = 209218,

	["128866.141266"] = 209223,
	["128862.141266"] = 195345,
	["128832.141266"] = 212816,
	["128858.141266"] = 202445,
	["127857.141266"] = 187313,
	["128861.141266"] = 197140,
	["128820.141266"] = 194313,

	["128866.141272"] = 209224,
	["128862.141272"] = 195354,
	["128861.141272"] = 197160,
	["127857.141272"] = 187301,
	["128858.141272"] = 202302,
	["128832.141272"] = 212821,
	["128820.141272"] = 194318,

	["128820.141292"] = 210182,
	["128832.141292"] = 207375,
	["127857.141292"] = 187264,
	["128858.141292"] = 202433,
	["128861.141292"] = 197139,
	["128862.141292"] = 195323,
	["128866.141292"] = 209226,

	["128820.143692"] = 194312,
	["128861.143692"] = 197080,
	["127857.143692"] = 187321,
	["128858.143692"] = 202426,
	["128832.143692"] = 207352,
	["128862.143692"] = 195322,
	["128866.143692"] = 209220,

	["128866.143699"] = 209217,
	["128862.143699"] = 195317,
	["128861.143699"] = 197047,
	["127857.143699"] = 187258,
	["128858.143699"] = 202386,
	["128832.143699"] = 207347,
	["128820.143699"] = 194234,

	["127829.140056"] = 201455,
	["128832.140056"] = 207347,
	["128476.140056"] = 197233,
	["128941.140056"] = 196217,
	["128943.140056"] = 211126,

	["128941.140066"] = 196222,
	["128943.140066"] = 211106,
	["128832.140066"] = 207352,
	["127829.140066"] = 201456,
	["128476.140066"] = 197234,

	["128832.140086"] = 207343,
	["127829.140086"] = 201454,
	["128476.140086"] = 197231,
	["128941.140086"] = 196211,
	["128943.140086"] = 211108,

	["128832.141255"] = 212827,
	["127829.141255"] = 201463,
	["128476.141255"] = 197244,
	["128943.141255"] = 211131,
	["128941.141255"] = 196305,

	["128943.141277"] = 211126,
	["128941.141277"] = 196217,
	["128476.141277"] = 197233,
	["127829.141277"] = 201455,
	["128832.141277"] = 207347,

	["128943.141281"] = 211119,
	["128941.141281"] = 196432,
	["128476.141281"] = 197386,
	["128832.141281"] = 212817,
	["127829.141281"] = 201460,

	["128941.141289"] = 196222,
	["128943.141289"] = 211106,
	["128476.141289"] = 197234,
	["127829.141289"] = 201456,
	["128832.141289"] = 207352,

	["128476.143687"] = 197369,
	["127829.143687"] = 201458,
	["128832.143687"] = 212816,
	["128943.143687"] = 211105,
	["128941.143687"] = 196236,

	["128476.143696"] = 197239,
	["128832.143696"] = 212819,
	["127829.143696"] = 201464,
	["128941.143696"] = 196258,
	["128943.143696"] = 211099,

	["128402.140051"] = 192453,
	["128910.140051"] = 209462,
	["128868.140051"] = 197713,
	["127829.140051"] = 201455,
	["128476.140051"] = 197233,
	["128827.140051"] = 193643,
	["128943.140051"] = 211126,
	["128942.140051"] = 199112,
	["128870.140051"] = 192315,
	["128292.140051"] = 189092,
	["128403.140051"] = 191442,

	["128476.140061"] = 197234,
	["127829.140061"] = 201456,
	["128868.140061"] = 197715,
	["128910.140061"] = 209472,
	["128402.140061"] = 192447,
	["128403.140061"] = 191485,
	["128942.140061"] = 199120,
	["128870.140061"] = 192318,
	["128292.140061"] = 189086,
	["128943.140061"] = 211106,
	["128827.140061"] = 193644,

	["128292.140041"] = 189097,
	["128870.140041"] = 192376,
	["128942.140041"] = 199163,
	["128403.140041"] = 208598,
	["128943.140041"] = 211099,
	["128827.140041"] = 194002,
	["127829.140041"] = 201464,
	["128476.140041"] = 197239,
	["128910.140041"] = 209494,
	["128402.140041"] = 192464,
	["128868.140041"] = 197762,

	["128476.141254"] = 197235,
	["127829.141254"] = 201457,
	["128868.141254"] = 197716,
	["128910.141254"] = 216274,
	["128402.141254"] = 192457,
	["128403.141254"] = 191592,
	["128870.141254"] = 192326,
	["128942.141254"] = 199152,
	["128292.141254"] = 189164,
	["128943.141254"] = 211123,
	["128827.141254"] = 193645,

	["128476.141273"] = 197233,
	["127829.141273"] = 201455,
	["128868.141273"] = 197713,
	["128402.141273"] = 192453,
	["128910.141273"] = 209462,
	["128403.141273"] = 191442,
	["128292.141273"] = 189092,
	["128870.141273"] = 192315,
	["128942.141273"] = 199112,
	["128827.141273"] = 193643,
	["128943.141273"] = 211126,

	["128476.141282"] = 197234,
	["127829.141282"] = 201456,
	["128868.141282"] = 197715,
	["128910.141282"] = 209472,
	["128402.141282"] = 192447,
	["128403.141282"] = 191485,
	["128870.141282"] = 192318,
	["128292.141282"] = 189086,
	["128942.141282"] = 199120,
	["128943.141282"] = 211106,
	["128827.141282"] = 193644,

	["127829.141291"] = 201463,
	["128476.141291"] = 197244,
	["128910.141291"] = 209541,
	["128402.141291"] = 192538,
	["128868.141291"] = 216212,
	["128870.141291"] = 192345,
	["128942.141291"] = 199214,
	["128292.141291"] = 204875,
	["128403.141291"] = 191584,
	["128943.141291"] = 211131,
	["128827.141291"] = 193647,

	["128476.143690"] = 197241,
	["127829.143690"] = 201459,
	["128868.143690"] = 197711,
	["128910.143690"] = 209483,
	["128402.143690"] = 192514,
	["128403.143690"] = 191565,
	["128870.143690"] = 192323,
	["128942.143690"] = 199212,
	["128292.143690"] = 189154,
	["128943.143690"] = 211144,
	["128827.143690"] = 193642,

	["127829.143693"] = 201454,
	["128476.143693"] = 197231,
	["128402.143693"] = 192450,
	["128910.143693"] = 209459,
	["128868.143693"] = 197708,
	["128870.143693"] = 192310,
	["128292.143693"] = 189080,
	["128942.143693"] = 199111,
	["128403.143693"] = 191419,
	["128827.143693"] = 194093,
	["128943.143693"] = 211108,

	["128943.143694"] = 211119,
	["128827.143694"] = 194016,
	["128942.143694"] = 199158,
	["128870.143694"] = 192349,
	["128292.143694"] = 189147,
	["128403.143694"] = 191488,
	["128910.143694"] = 248579,
	["128402.143694"] = 192542,
	["128868.143694"] = 197729,
	["127829.143694"] = 201460,
	["128476.143694"] = 197386,

	["128860.140054"] = 210571,
	["128821.140054"] = 200399,
	["128402.140054"] = 192453,
	["128910.140054"] = 209462,
	["128942.140054"] = 199112,
	["128870.140054"] = 192315,
	["128808.140054"] = 203577,
	["128403.140054"] = 191442,
	["128289.140054"] = 216272,
	["128826.140054"] = 190457,
	["128827.140054"] = 193643,
	["128872.140054"] = 202507,

	["128289.140064"] = 188683,
	["128403.140064"] = 191485,
	["128870.140064"] = 192318,
	["128942.140064"] = 199120,
	["128808.140064"] = 203578,
	["128827.140064"] = 193644,
	["128872.140064"] = 202514,
	["128826.140064"] = 190462,
	["128821.140064"] = 208762,
	["128860.140064"] = 210575,
	["128402.140064"] = 192447,
	["128910.140064"] = 209472,

	["128821.140044"] = 200402,
	["128860.140044"] = 210579,
	["128402.140044"] = 192457,
	["128910.140044"] = 216274,
	["128289.140044"] = 203230,
	["128403.140044"] = 191592,
	["128870.140044"] = 192326,
	["128942.140044"] = 199152,
	["128808.140044"] = 203638,
	["128827.140044"] = 193645,
	["128872.140044"] = 202522,
	["128826.140044"] = 190467,

	["128910.141264"] = 209483,
	["128402.141264"] = 192514,
	["128821.141264"] = 200400,
	["128860.141264"] = 210557,
	["128872.141264"] = 202521,
	["128827.141264"] = 193642,
	["128826.141264"] = 190503,
	["128403.141264"] = 191565,
	["128289.141264"] = 188632,
	["128808.141264"] = 224764,
	["128870.141264"] = 192323,
	["128942.141264"] = 199212,

	["128872.141280"] = 202524,
	["128827.141280"] = 194007,
	["128826.141280"] = 190520,
	["128403.141280"] = 191494,
	["128289.141280"] = 203225,
	["128808.141280"] = 203669,
	["128870.141280"] = 192329,
	["128942.141280"] = 199153,
	["128910.141280"] = 209481,
	["128402.141280"] = 192460,
	["128821.141280"] = 200409,
	["128860.141280"] = 210593,

	["128860.141283"] = 210570,
	["128821.141283"] = 200395,
	["128910.141283"] = 209459,
	["128402.141283"] = 192450,
	["128808.141283"] = 203566,
	["128942.141283"] = 199111,
	["128870.141283"] = 192310,
	["128403.141283"] = 191419,
	["128289.141283"] = 188635,
	["128826.141283"] = 190449,
	["128872.141283"] = 216230,
	["128827.141283"] = 194093,

	["128289.141287"] = 203230,
	["128403.141287"] = 191592,
	["128808.141287"] = 203638,
	["128870.141287"] = 192326,
	["128942.141287"] = 199152,
	["128872.141287"] = 202522,
	["128827.141287"] = 193645,
	["128826.141287"] = 190467,
	["128821.141287"] = 200402,
	["128860.141287"] = 210579,
	["128910.141287"] = 216274,
	["128402.141287"] = 192457,

	["128821.143682"] = 200414,
	["128860.143682"] = 210637,
	["128402.143682"] = 192542,
	["128910.143682"] = 248579,
	["128289.143682"] = 203227,
	["128403.143682"] = 191488,
	["128870.143682"] = 192349,
	["128942.143682"] = 199158,
	["128808.143682"] = 203670,
	["128827.143682"] = 194016,
	["128872.143682"] = 202530,
	["128826.143682"] = 190529,

	["128826.143684"] = 190457,
	["128827.143684"] = 193643,
	["128872.143684"] = 202507,
	["128942.143684"] = 199112,
	["128870.143684"] = 192315,
	["128808.143684"] = 203577,
	["128403.143684"] = 191442,
	["128289.143684"] = 216272,
	["128402.143684"] = 192453,
	["128910.143684"] = 209462,
	["128860.143684"] = 210571,
	["128821.143684"] = 200399,

	["128860.143691"] = 210575,
	["128821.143691"] = 208762,
	["128910.143691"] = 209472,
	["128402.143691"] = 192447,
	["128808.143691"] = 203578,
	["128942.143691"] = 199120,
	["128870.143691"] = 192318,
	["128289.143691"] = 188683,
	["128403.143691"] = 191485,
	["128826.143691"] = 190462,
	["128872.143691"] = 202514,
	["128827.143691"] = 193644,

	["128819.140055"] = 198236,
	["128872.140055"] = 202507,
	["128289.140055"] = 216272,
	["128938.140055"] = 213049,
	["128908.140055"] = 216273,
	["128870.140055"] = 192315,
	["128866.140055"] = 209217,
	["128808.140055"] = 203577,
	["128402.140055"] = 192453,
	["128910.140055"] = 209462,
	["128940.140055"] = 195263,
	["128861.140055"] = 197047,
	["128832.140055"] = 207347,

	["128870.140065"] = 192318,
	["128866.140065"] = 209220,
	["128808.140065"] = 203578,
	["128289.140065"] = 188683,
	["128938.140065"] = 213180,
	["128908.140065"] = 200849,
	["128819.140065"] = 198247,
	["128872.140065"] = 202514,
	["128832.140065"] = 207352,
	["128861.140065"] = 197080,
	["128402.140065"] = 192447,
	["128940.140065"] = 218607,
	["128910.140065"] = 209472,

	["128832.140045"] = 207347,
	["128861.140045"] = 197047,
	["128940.140045"] = 195263,
	["128910.140045"] = 209462,
	["128402.140045"] = 192453,
	["128866.140045"] = 209217,
	["128808.140045"] = 203577,
	["128870.140045"] = 192315,
	["128908.140045"] = 216273,
	["128289.140045"] = 216272,
	["128938.140045"] = 213049,
	["128872.140045"] = 202507,
	["128819.140045"] = 198236,

	["128870.141262"] = 192349,
	["128808.141262"] = 203670,
	["128866.141262"] = 209218,
	["128289.141262"] = 203227,
	["128938.141262"] = 213133,
	["128908.141262"] = 200860,
	["128819.141262"] = 198349,
	["128872.141262"] = 202530,
	["128832.141262"] = 212817,
	["128861.141262"] = 197162,
	["128402.141262"] = 192542,
	["128910.141262"] = 248579,
	["128940.141262"] = 195291,

	["128872.141263"] = 202524,
	["128819.141263"] = 198299,
	["128908.141263"] = 200856,
	["128289.141263"] = 203225,
	["128938.141263"] = 213055,
	["128808.141263"] = 203669,
	["128866.141263"] = 209223,
	["128870.141263"] = 192329,
	["128940.141263"] = 195269,
	["128910.141263"] = 209481,
	["128402.141263"] = 192460,
	["128861.141263"] = 197140,
	["128832.141263"] = 212816,

	["128872.141268"] = 216230,
	["128819.141268"] = 215381,
	["128908.141268"] = 200846,
	["128289.141268"] = 188635,
	["128938.141268"] = 213051,
	["128808.141268"] = 203566,
	["128866.141268"] = 209229,
	["128870.141268"] = 192310,
	["128940.141268"] = 195243,
	["128910.141268"] = 209459,
	["128402.141268"] = 192450,
	["128861.141268"] = 197038,
	["128832.141268"] = 207343,

	["128819.141288"] = 198236,
	["128872.141288"] = 202507,
	["128870.141288"] = 192315,
	["128808.141288"] = 203577,
	["128866.141288"] = 209217,
	["128938.141288"] = 213049,
	["128289.141288"] = 216272,
	["128908.141288"] = 216273,
	["128402.141288"] = 192453,
	["128940.141288"] = 195263,
	["128910.141288"] = 209462,
	["128832.141288"] = 207347,
	["128861.141288"] = 197047,

	["128910.143685"] = 209472,
	["128940.143685"] = 218607,
	["128402.143685"] = 192447,
	["128832.143685"] = 207352,
	["128861.143685"] = 197080,
	["128872.143685"] = 202514,
	["128819.143685"] = 198247,
	["128866.143685"] = 209220,
	["128808.143685"] = 203578,
	["128870.143685"] = 192318,
	["128908.143685"] = 200849,
	["128938.143685"] = 213180,
	["128289.143685"] = 188683,

	["128872.143705"] = 202522,
	["128819.143705"] = 198292,
	["128908.143705"] = 200853,
	["128289.143705"] = 203230,
	["128938.143705"] = 213062,
	["128808.143705"] = 203638,
	["128866.143705"] = 209226,
	["128870.143705"] = 192326,
	["128910.143705"] = 216274,
	["128940.143705"] = 195266,
	["128402.143705"] = 192457,
	["128861.143705"] = 197139,
	["128832.143705"] = 207375,

	["128825.136685"] = 196416,
	["128868.136685"] = 197715,
	["120978.136685"] = 184843,
	["128866.136685"] = 209220,
	["128823.136685"] = 200315,

	["128826.136688"] = 190462,
	["128935.136688"] = 191504,
	["128819.136688"] = 198247,
	["128872.136688"] = 202514,
	["128808.136688"] = 203578,
	["128938.136688"] = 213180,
	["128937.136688"] = 199367,
	["128908.136688"] = 200849,
	["128940.136688"] = 218607,
	["128861.136688"] = 197080,

	["128858.136693"] = 202426,
	["128821.136693"] = 208762,
	["128860.136693"] = 210575,
	["128306.136693"] = 189760,
	["128825.136693"] = 196416,
	["128937.136693"] = 199367,
	["128938.136693"] = 213180,
	["128911.136693"] = 207118,
	["128823.136693"] = 200315,
	["128826.136693"] = 190462,

	["128941.136686"] = 196222,
	["120978.136686"] = 184843,
	["128289.136686"] = 188683,
	["128403.136686"] = 191485,
	["128908.136686"] = 200849,
	["128819.136686"] = 198247,
	["128943.136686"] = 211106,
	["128821.136686"] = 208762,
	["128820.136686"] = 194312,

	["128306.136692"] = 189760,
	["128860.136692"] = 210575,
	["127857.136692"] = 187321,
	["128935.136692"] = 191504,
	["128911.136692"] = 207118,
	["128862.136692"] = 195322,
	["128292.136692"] = 189086,
	["128937.136692"] = 199367,

	["128820.136691"] = 194312,
	["127857.136691"] = 187321,
	["128858.136691"] = 202426,
	["128861.136691"] = 197080,
	["128832.136691"] = 207352,
	["128862.136691"] = 195322,
	["128866.136691"] = 209220,

	["128943.136687"] = 211106,
	["128941.136687"] = 196222,
	["128832.136687"] = 207352,
	["127829.136687"] = 201456,
	["128476.136687"] = 197234,

	["128943.136689"] = 211106,
	["128827.136689"] = 193644,
	["128403.136689"] = 191485,
	["128292.136689"] = 189086,
	["128870.136689"] = 192318,
	["128942.136689"] = 199120,
	["128868.136689"] = 197715,
	["128910.136689"] = 209472,
	["128402.136689"] = 192447,
	["128476.136689"] = 197234,
	["127829.136689"] = 201456,

	["128910.136683"] = 209472,
	["128402.136683"] = 192447,
	["128821.136683"] = 208762,
	["128860.136683"] = 210575,
	["128872.136683"] = 202514,
	["128827.136683"] = 193644,
	["128826.136683"] = 190462,
	["128289.136683"] = 188683,
	["128403.136683"] = 191485,
	["128808.136683"] = 203578,
	["128870.136683"] = 192318,
	["128942.136683"] = 199120,

	["128910.136684"] = 209472,
	["128940.136684"] = 218607,
	["128402.136684"] = 192447,
	["128861.136684"] = 197080,
	["128832.136684"] = 207352,
	["128872.136684"] = 202514,
	["128819.136684"] = 198247,
	["128908.136684"] = 200849,
	["128289.136684"] = 188683,
	["128938.136684"] = 213180,
	["128866.136684"] = 209220,
	["128808.136684"] = 203578,
	["128870.136684"] = 192318,

	["128825.151509"] = 196416,
	["128868.151509"] = 197715,
	["120978.151509"] = 184843,
	["128866.151509"] = 209220,
	["128823.151509"] = 200315,

	["128823.151510"] = 200482,
	["128866.151510"] = 209216,
	["120978.151510"] = 186944,
	["128868.151510"] = 197762,
	["128825.151510"] = 196430,

	["128823.151511"] = 200302,
	["120978.151511"] = 184778,
	["128866.151511"] = 209225,
	["128868.151511"] = 216212,
	["128825.151511"] = 196355,

	["128868.154067"] = 197715,
	["128825.154067"] = 196416,
	["128823.154067"] = 200315,
	["120978.154067"] = 184843,
	["128866.154067"] = 209220,

	["128823.154068"] = 200482,
	["120978.154068"] = 186944,
	["128866.154068"] = 209216,
	["128868.154068"] = 197762,
	["128825.154068"] = 196430,

	["128866.154069"] = 209225,
	["120978.154069"] = 184778,
	["128823.154069"] = 200302,
	["128825.154069"] = 196355,
	["128868.154069"] = 216212,

	["120978.154097"] = 184843,
	["128866.154097"] = 209220,
	["128823.154097"] = 200315,
	["128825.154097"] = 196416,
	["128868.154097"] = 197715,

	["128868.154098"] = 197762,
	["128825.154098"] = 196430,
	["128823.154098"] = 200482,
	["120978.154098"] = 186944,
	["128866.154098"] = 209216,

	["128825.154099"] = 196355,
	["128868.154099"] = 216212,
	["120978.154099"] = 184778,
	["128866.154099"] = 209225,
	["128823.154099"] = 200302,

	["128823.155710"] = 200315,
	["120978.155710"] = 184843,
	["128866.155710"] = 209220,
	["128868.155710"] = 197715,
	["128825.155710"] = 196416,

	["128825.155711"] = 196430,
	["128868.155711"] = 197762,
	["128866.155711"] = 209216,
	["120978.155711"] = 186944,
	["128823.155711"] = 200482,

	["128868.155712"] = 216212,
	["128825.155712"] = 196355,
	["128823.155712"] = 200302,
	["120978.155712"] = 184778,
	["128866.155712"] = 209225,

	["128866.155740"] = 209220,
	["120978.155740"] = 184843,
	["128823.155740"] = 200315,
	["128825.155740"] = 196416,
	["128868.155740"] = 197715,

	["128868.155741"] = 197762,
	["128825.155741"] = 196430,
	["128823.155741"] = 200482,
	["128866.155741"] = 209216,
	["120978.155741"] = 186944,

	["128825.155742"] = 196355,
	["128868.155742"] = 216212,
	["120978.155742"] = 184778,
	["128866.155742"] = 209225,
	["128823.155742"] = 200302,

	["128868.140411"] = 197715,
	["128825.140411"] = 196416,
	["128823.140411"] = 200315,
	["128866.140411"] = 209220,
	["120978.140411"] = 184843,

	["128868.140433"] = 197762,
	["128825.140433"] = 196430,
	["128823.140433"] = 200482,
	["128866.140433"] = 209216,
	["120978.140433"] = 186944,

	["128866.140434"] = 209225,
	["120978.140434"] = 184778,
	["128823.140434"] = 200302,
	["128825.140434"] = 196355,
	["128868.140434"] = 216212,

	["128825.143796"] = 196416,
	["128868.143796"] = 197715,
	["128866.143796"] = 209220,
	["120978.143796"] = 184843,
	["128823.143796"] = 200315,

	["128866.143816"] = 209216,
	["120978.143816"] = 186944,
	["128823.143816"] = 200482,
	["128825.143816"] = 196430,
	["128868.143816"] = 197762,

	["128823.143817"] = 200302,
	["128866.143817"] = 209225,
	["120978.143817"] = 184778,
	["128868.143817"] = 216212,
	["128825.143817"] = 196355,

	["128825.144519"] = 196416,
	["128868.144519"] = 197715,
	["120978.144519"] = 184843,
	["128866.144519"] = 209220,
	["128823.144519"] = 200315,

	["128868.144520"] = 197762,
	["128825.144520"] = 196430,
	["128823.144520"] = 200482,
	["120978.144520"] = 186944,
	["128866.144520"] = 209216,

	["128823.144521"] = 200302,
	["128866.144521"] = 209225,
	["120978.144521"] = 184778,
	["128868.144521"] = 216212,
	["128825.144521"] = 196355,

	["128823.145361"] = 200315,
	["120978.145361"] = 184843,
	["128866.145361"] = 209220,
	["128868.145361"] = 197715,
	["128825.145361"] = 196416,

	["128868.145362"] = 197762,
	["128825.145362"] = 196430,
	["128823.145362"] = 200482,
	["120978.145362"] = 186944,
	["128866.145362"] = 209216,

	["128823.145363"] = 200302,
	["128866.145363"] = 209225,
	["120978.145363"] = 184778,
	["128868.145363"] = 216212,
	["128825.145363"] = 196355,

	["128823.150289"] = 200315,
	["120978.150289"] = 184843,
	["128866.150289"] = 209220,
	["128868.150289"] = 197715,
	["128825.150289"] = 196416,

	["128868.150290"] = 197762,
	["128825.150290"] = 196430,
	["128823.150290"] = 200482,
	["128866.150290"] = 209216,
	["120978.150290"] = 186944,

	["128825.150291"] = 196355,
	["128868.150291"] = 216212,
	["120978.150291"] = 184778,
	["128866.150291"] = 209225,
	["128823.150291"] = 200302,

	["120978.150313"] = 184843,
	["128866.150313"] = 209220,
	["128823.150313"] = 200315,
	["128825.150313"] = 196416,
	["128868.150313"] = 197715,

	["128823.150314"] = 200482,
	["120978.150314"] = 186944,
	["128866.150314"] = 209216,
	["128868.150314"] = 197762,
	["128825.150314"] = 196430,

	["128823.150315"] = 200302,
	["120978.150315"] = 184778,
	["128866.150315"] = 209225,
	["128868.150315"] = 216212,
	["128825.150315"] = 196355,

	["128823.150338"] = 200315,
	["120978.150338"] = 184843,
	["128866.150338"] = 209220,
	["128868.150338"] = 197715,
	["128825.150338"] = 196416,

	["120978.150339"] = 186944,
	["128866.150339"] = 209216,
	["128823.150339"] = 200482,
	["128825.150339"] = 196430,
	["128868.150339"] = 197762,

	["128868.150340"] = 216212,
	["128825.150340"] = 196355,
	["128823.150340"] = 200302,
	["128866.150340"] = 209225,
	["120978.150340"] = 184778,

	["128866.153461"] = 209220,
	["120978.153461"] = 184843,
	["128823.153461"] = 200315,
	["128825.153461"] = 196416,
	["128868.153461"] = 197715,

	["128868.153462"] = 197762,
	["128825.153462"] = 196430,
	["128823.153462"] = 200482,
	["128866.153462"] = 209216,
	["120978.153462"] = 186944,

	["128823.153463"] = 200302,
	["120978.153463"] = 184778,
	["128866.153463"] = 209225,
	["128868.153463"] = 216212,
	["128825.153463"] = 196355,

	["128866.135572"] = 209218,
	["120978.135572"] = 185368,
	["128823.135572"] = 200298,
	["128825.135572"] = 196429,
	["128868.135572"] = 197729,

	["128826.151521"] = 190449,
	["128935.151521"] = 191493,
	["128819.151521"] = 215381,
	["128872.151521"] = 216230,
	["128808.151521"] = 203566,
	["128938.151521"] = 213051,
	["128937.151521"] = 199364,
	["128908.151521"] = 200846,
	["128940.151521"] = 195243,
	["128861.151521"] = 197038,

	["128861.151522"] = 197139,
	["128940.151522"] = 195266,
	["128938.151522"] = 213062,
	["128937.151522"] = 199372,
	["128908.151522"] = 200853,
	["128808.151522"] = 203638,
	["128819.151522"] = 198292,
	["128935.151522"] = 191740,
	["128872.151522"] = 202522,
	["128826.151522"] = 190467,

	["128872.151523"] = 202530,
	["128819.151523"] = 198349,
	["128935.151523"] = 191577,
	["128826.151523"] = 190529,
	["128908.151523"] = 200860,
	["128938.151523"] = 213133,
	["128937.151523"] = 199380,
	["128808.151523"] = 203670,
	["128940.151523"] = 195291,
	["128861.151523"] = 197162,

	["128938.154079"] = 213051,
	["128937.154079"] = 199364,
	["128908.154079"] = 200846,
	["128808.154079"] = 203566,
	["128819.154079"] = 215381,
	["128935.154079"] = 191493,
	["128872.154079"] = 216230,
	["128826.154079"] = 190449,
	["128861.154079"] = 197038,
	["128940.154079"] = 195243,

	["128861.154080"] = 197139,
	["128940.154080"] = 195266,
	["128908.154080"] = 200853,
	["128937.154080"] = 199372,
	["128938.154080"] = 213062,
	["128808.154080"] = 203638,
	["128872.154080"] = 202522,
	["128819.154080"] = 198292,
	["128935.154080"] = 191740,
	["128826.154080"] = 190467,

	["128826.154081"] = 190529,
	["128935.154081"] = 191577,
	["128819.154081"] = 198349,
	["128872.154081"] = 202530,
	["128808.154081"] = 203670,
	["128937.154081"] = 199380,
	["128938.154081"] = 213133,
	["128908.154081"] = 200860,
	["128940.154081"] = 195291,
	["128861.154081"] = 197162,

	["128940.154109"] = 195243,
	["128861.154109"] = 197038,
	["128826.154109"] = 190449,
	["128872.154109"] = 216230,
	["128935.154109"] = 191493,
	["128819.154109"] = 215381,
	["128808.154109"] = 203566,
	["128908.154109"] = 200846,
	["128938.154109"] = 213051,
	["128937.154109"] = 199364,

	["128826.154110"] = 190467,
	["128935.154110"] = 191740,
	["128819.154110"] = 198292,
	["128872.154110"] = 202522,
	["128808.154110"] = 203638,
	["128937.154110"] = 199372,
	["128938.154110"] = 213062,
	["128908.154110"] = 200853,
	["128940.154110"] = 195266,
	["128861.154110"] = 197139,

	["128908.154111"] = 200860,
	["128938.154111"] = 213133,
	["128937.154111"] = 199380,
	["128808.154111"] = 203670,
	["128872.154111"] = 202530,
	["128819.154111"] = 198349,
	["128935.154111"] = 191577,
	["128826.154111"] = 190529,
	["128861.154111"] = 197162,
	["128940.154111"] = 195291,

	["128938.155722"] = 213051,
	["128937.155722"] = 199364,
	["128908.155722"] = 200846,
	["128808.155722"] = 203566,
	["128819.155722"] = 215381,
	["128935.155722"] = 191493,
	["128872.155722"] = 216230,
	["128826.155722"] = 190449,
	["128861.155722"] = 197038,
	["128940.155722"] = 195243,

	["128940.155723"] = 195266,
	["128861.155723"] = 197139,
	["128819.155723"] = 198292,
	["128935.155723"] = 191740,
	["128872.155723"] = 202522,
	["128826.155723"] = 190467,
	["128937.155723"] = 199372,
	["128938.155723"] = 213062,
	["128908.155723"] = 200853,
	["128808.155723"] = 203638,

	["128940.155724"] = 195291,
	["128861.155724"] = 197162,
	["128826.155724"] = 190529,
	["128935.155724"] = 191577,
	["128819.155724"] = 198349,
	["128872.155724"] = 202530,
	["128808.155724"] = 203670,
	["128938.155724"] = 213133,
	["128937.155724"] = 199380,
	["128908.155724"] = 200860,

	["128940.155752"] = 195243,
	["128861.155752"] = 197038,
	["128872.155752"] = 216230,
	["128819.155752"] = 215381,
	["128935.155752"] = 191493,
	["128826.155752"] = 190449,
	["128908.155752"] = 200846,
	["128937.155752"] = 199364,
	["128938.155752"] = 213051,
	["128808.155752"] = 203566,

	["128808.155753"] = 203638,
	["128908.155753"] = 200853,
	["128938.155753"] = 213062,
	["128937.155753"] = 199372,
	["128826.155753"] = 190467,
	["128872.155753"] = 202522,
	["128935.155753"] = 191740,
	["128819.155753"] = 198292,
	["128861.155753"] = 197139,
	["128940.155753"] = 195266,

	["128940.155754"] = 195291,
	["128861.155754"] = 197162,
	["128826.155754"] = 190529,
	["128935.155754"] = 191577,
	["128819.155754"] = 198349,
	["128872.155754"] = 202530,
	["128808.155754"] = 203670,
	["128938.155754"] = 213133,
	["128937.155754"] = 199380,
	["128908.155754"] = 200860,

	["128940.140420"] = 195243,
	["128861.140420"] = 197038,
	["128826.140420"] = 190449,
	["128935.140420"] = 191493,
	["128819.140420"] = 215381,
	["128872.140420"] = 216230,
	["128808.140420"] = 203566,
	["128937.140420"] = 199364,
	["128938.140420"] = 213051,
	["128908.140420"] = 200846,

	["128819.140442"] = 198292,
	["128935.140442"] = 191740,
	["128872.140442"] = 202522,
	["128826.140442"] = 190467,
	["128937.140442"] = 199372,
	["128938.140442"] = 213062,
	["128908.140442"] = 200853,
	["128808.140442"] = 203638,
	["128940.140442"] = 195266,
	["128861.140442"] = 197139,

	["128861.140443"] = 197162,
	["128940.140443"] = 195291,
	["128808.140443"] = 203670,
	["128937.140443"] = 199380,
	["128938.140443"] = 213133,
	["128908.140443"] = 200860,
	["128826.140443"] = 190529,
	["128935.140443"] = 191577,
	["128819.140443"] = 198349,
	["128872.140443"] = 202530,

	["128940.143805"] = 195243,
	["128861.143805"] = 197038,
	["128826.143805"] = 190449,
	["128935.143805"] = 191493,
	["128819.143805"] = 215381,
	["128872.143805"] = 216230,
	["128808.143805"] = 203566,
	["128937.143805"] = 199364,
	["128938.143805"] = 213051,
	["128908.143805"] = 200846,

	["128826.143824"] = 190467,
	["128935.143824"] = 191740,
	["128819.143824"] = 198292,
	["128872.143824"] = 202522,
	["128808.143824"] = 203638,
	["128937.143824"] = 199372,
	["128938.143824"] = 213062,
	["128908.143824"] = 200853,
	["128940.143824"] = 195266,
	["128861.143824"] = 197139,

	["128808.143825"] = 203670,
	["128937.143825"] = 199380,
	["128938.143825"] = 213133,
	["128908.143825"] = 200860,
	["128826.143825"] = 190529,
	["128935.143825"] = 191577,
	["128819.143825"] = 198349,
	["128872.143825"] = 202530,
	["128861.143825"] = 197162,
	["128940.143825"] = 195291,

	["128861.144531"] = 197038,
	["128940.144531"] = 195243,
	["128937.144531"] = 199364,
	["128938.144531"] = 213051,
	["128908.144531"] = 200846,
	["128808.144531"] = 203566,
	["128819.144531"] = 215381,
	["128935.144531"] = 191493,
	["128872.144531"] = 216230,
	["128826.144531"] = 190449,

	["128819.144532"] = 198292,
	["128935.144532"] = 191740,
	["128872.144532"] = 202522,
	["128826.144532"] = 190467,
	["128937.144532"] = 199372,
	["128938.144532"] = 213062,
	["128908.144532"] = 200853,
	["128808.144532"] = 203638,
	["128940.144532"] = 195266,
	["128861.144532"] = 197139,

	["128938.144533"] = 213133,
	["128937.144533"] = 199380,
	["128908.144533"] = 200860,
	["128808.144533"] = 203670,
	["128819.144533"] = 198349,
	["128935.144533"] = 191577,
	["128872.144533"] = 202530,
	["128826.144533"] = 190529,
	["128861.144533"] = 197162,
	["128940.144533"] = 195291,

	["128940.145373"] = 195243,
	["128861.145373"] = 197038,
	["128826.145373"] = 190449,
	["128935.145373"] = 191493,
	["128819.145373"] = 215381,
	["128872.145373"] = 216230,
	["128808.145373"] = 203566,
	["128938.145373"] = 213051,
	["128937.145373"] = 199364,
	["128908.145373"] = 200846,

	["128940.145374"] = 195266,
	["128861.145374"] = 197139,
	["128826.145374"] = 190467,
	["128935.145374"] = 191740,
	["128819.145374"] = 198292,
	["128872.145374"] = 202522,
	["128808.145374"] = 203638,
	["128937.145374"] = 199372,
	["128938.145374"] = 213062,
	["128908.145374"] = 200853,

	["128819.145375"] = 198349,
	["128935.145375"] = 191577,
	["128872.145375"] = 202530,
	["128826.145375"] = 190529,
	["128937.145375"] = 199380,
	["128938.145375"] = 213133,
	["128908.145375"] = 200860,
	["128808.145375"] = 203670,
	["128940.145375"] = 195291,
	["128861.145375"] = 197162,

	["128826.150351"] = 190449,
	["128872.150351"] = 216230,
	["128935.150351"] = 191493,
	["128819.150351"] = 215381,
	["128808.150351"] = 203566,
	["128908.150351"] = 200846,
	["128938.150351"] = 213051,
	["128937.150351"] = 199364,
	["128940.150351"] = 195243,
	["128861.150351"] = 197038,

	["128808.150352"] = 203638,
	["128938.150352"] = 213062,
	["128937.150352"] = 199372,
	["128908.150352"] = 200853,
	["128826.150352"] = 190467,
	["128935.150352"] = 191740,
	["128819.150352"] = 198292,
	["128872.150352"] = 202522,
	["128861.150352"] = 197139,
	["128940.150352"] = 195266,

	["128940.150353"] = 195291,
	["128861.150353"] = 197162,
	["128826.150353"] = 190529,
	["128872.150353"] = 202530,
	["128935.150353"] = 191577,
	["128819.150353"] = 198349,
	["128808.150353"] = 203670,
	["128908.150353"] = 200860,
	["128937.150353"] = 199380,
	["128938.150353"] = 213133,

	["128908.150357"] = 200846,
	["128938.150357"] = 213051,
	["128937.150357"] = 199364,
	["128808.150357"] = 203566,
	["128872.150357"] = 216230,
	["128819.150357"] = 215381,
	["128935.150357"] = 191493,
	["128826.150357"] = 190449,
	["128861.150357"] = 197038,
	["128940.150357"] = 195243,

	["128808.150358"] = 203638,
	["128908.150358"] = 200853,
	["128937.150358"] = 199372,
	["128938.150358"] = 213062,
	["128826.150358"] = 190467,
	["128872.150358"] = 202522,
	["128935.150358"] = 191740,
	["128819.150358"] = 198292,
	["128861.150358"] = 197139,
	["128940.150358"] = 195266,

	["128861.150359"] = 197162,
	["128940.150359"] = 195291,
	["128808.150359"] = 203670,
	["128908.150359"] = 200860,
	["128937.150359"] = 199380,
	["128938.150359"] = 213133,
	["128826.150359"] = 190529,
	["128872.150359"] = 202530,
	["128935.150359"] = 191577,
	["128819.150359"] = 198349,

	["128872.150363"] = 216230,
	["128819.150363"] = 215381,
	["128935.150363"] = 191493,
	["128826.150363"] = 190449,
	["128908.150363"] = 200846,
	["128938.150363"] = 213051,
	["128937.150363"] = 199364,
	["128808.150363"] = 203566,
	["128940.150363"] = 195243,
	["128861.150363"] = 197038,

	["128872.150364"] = 202522,
	["128819.150364"] = 198292,
	["128935.150364"] = 191740,
	["128826.150364"] = 190467,
	["128908.150364"] = 200853,
	["128938.150364"] = 213062,
	["128937.150364"] = 199372,
	["128808.150364"] = 203638,
	["128940.150364"] = 195266,
	["128861.150364"] = 197139,

	["128826.150365"] = 190529,
	["128935.150365"] = 191577,
	["128819.150365"] = 198349,
	["128872.150365"] = 202530,
	["128808.150365"] = 203670,
	["128937.150365"] = 199380,
	["128938.150365"] = 213133,
	["128908.150365"] = 200860,
	["128940.150365"] = 195291,
	["128861.150365"] = 197162,

	["128940.153473"] = 195243,
	["128861.153473"] = 197038,
	["128819.153473"] = 215381,
	["128935.153473"] = 191493,
	["128872.153473"] = 216230,
	["128826.153473"] = 190449,
	["128938.153473"] = 213051,
	["128937.153473"] = 199364,
	["128908.153473"] = 200846,
	["128808.153473"] = 203566,

	["128819.153474"] = 198292,
	["128935.153474"] = 191740,
	["128872.153474"] = 202522,
	["128826.153474"] = 190467,
	["128937.153474"] = 199372,
	["128938.153474"] = 213062,
	["128908.153474"] = 200853,
	["128808.153474"] = 203638,
	["128940.153474"] = 195266,
	["128861.153474"] = 197139,

	["128940.153475"] = 195291,
	["128861.153475"] = 197162,
	["128819.153475"] = 198349,
	["128935.153475"] = 191577,
	["128872.153475"] = 202530,
	["128826.153475"] = 190529,
	["128938.153475"] = 213133,
	["128937.153475"] = 199380,
	["128908.153475"] = 200860,
	["128808.153475"] = 203670,

	["128908.135578"] = 200846,
	["128938.135578"] = 213051,
	["128937.135578"] = 199364,
	["128808.135578"] = 203566,
	["128872.135578"] = 216230,
	["128819.135578"] = 215381,
	["128935.135578"] = 191493,
	["128826.135578"] = 190449,
	["128861.135578"] = 197038,
	["128940.135578"] = 195243,

	["128938.151515"] = 213049,
	["128937.151515"] = 199366,
	["128826.151515"] = 190457,
	["128911.151515"] = 207092,
	["128823.151515"] = 200316,
	["128860.151515"] = 210571,
	["128306.151515"] = 189768,
	["128825.151515"] = 196358,
	["128858.151515"] = 202386,
	["128821.151515"] = 200399,

	["128821.151516"] = 200409,
	["128858.151516"] = 202445,
	["128825.151516"] = 196422,
	["128860.151516"] = 210593,
	["128306.151516"] = 189754,
	["128938.151516"] = 213055,
	["128937.151516"] = 199377,
	["128823.151516"] = 200294,
	["128911.151516"] = 207255,
	["128826.151516"] = 190520,

	["128821.151517"] = 200440,
	["128858.151517"] = 203018,
	["128825.151517"] = 196355,
	["128860.151517"] = 210590,
	["128306.151517"] = 186320,
	["128937.151517"] = 199384,
	["128938.151517"] = 213116,
	["128823.151517"] = 200302,
	["128911.151517"] = 207354,
	["128826.151517"] = 190514,

	["128821.154073"] = 200399,
	["128858.154073"] = 202386,
	["128825.154073"] = 196358,
	["128860.154073"] = 210571,
	["128306.154073"] = 189768,
	["128938.154073"] = 213049,
	["128937.154073"] = 199366,
	["128823.154073"] = 200316,
	["128911.154073"] = 207092,
	["128826.154073"] = 190457,

	["128306.154074"] = 189754,
	["128860.154074"] = 210593,
	["128825.154074"] = 196422,
	["128858.154074"] = 202445,
	["128821.154074"] = 200409,
	["128937.154074"] = 199377,
	["128938.154074"] = 213055,
	["128826.154074"] = 190520,
	["128911.154074"] = 207255,
	["128823.154074"] = 200294,

	["128825.154075"] = 196355,
	["128306.154075"] = 186320,
	["128860.154075"] = 210590,
	["128821.154075"] = 200440,
	["128858.154075"] = 203018,
	["128826.154075"] = 190514,
	["128823.154075"] = 200302,
	["128911.154075"] = 207354,
	["128937.154075"] = 199384,
	["128938.154075"] = 213116,

	["128858.154103"] = 202386,
	["128821.154103"] = 200399,
	["128860.154103"] = 210571,
	["128306.154103"] = 189768,
	["128825.154103"] = 196358,
	["128937.154103"] = 199366,
	["128938.154103"] = 213049,
	["128911.154103"] = 207092,
	["128823.154103"] = 200316,
	["128826.154103"] = 190457,

	["128858.154104"] = 202445,
	["128821.154104"] = 200409,
	["128860.154104"] = 210593,
	["128306.154104"] = 189754,
	["128825.154104"] = 196422,
	["128937.154104"] = 199377,
	["128938.154104"] = 213055,
	["128911.154104"] = 207255,
	["128823.154104"] = 200294,
	["128826.154104"] = 190520,

	["128306.154105"] = 186320,
	["128860.154105"] = 210590,
	["128825.154105"] = 196355,
	["128858.154105"] = 203018,
	["128821.154105"] = 200440,
	["128826.154105"] = 190514,
	["128911.154105"] = 207354,
	["128823.154105"] = 200302,
	["128938.154105"] = 213116,
	["128937.154105"] = 199384,

	["128826.155716"] = 190457,
	["128911.155716"] = 207092,
	["128823.155716"] = 200316,
	["128937.155716"] = 199366,
	["128938.155716"] = 213049,
	["128860.155716"] = 210571,
	["128306.155716"] = 189768,
	["128825.155716"] = 196358,
	["128858.155716"] = 202386,
	["128821.155716"] = 200399,

	["128823.155717"] = 200294,
	["128911.155717"] = 207255,
	["128826.155717"] = 190520,
	["128938.155717"] = 213055,
	["128937.155717"] = 199377,
	["128821.155717"] = 200409,
	["128858.155717"] = 202445,
	["128825.155717"] = 196422,
	["128860.155717"] = 210593,
	["128306.155717"] = 189754,

	["128937.155718"] = 199384,
	["128938.155718"] = 213116,
	["128826.155718"] = 190514,
	["128823.155718"] = 200302,
	["128911.155718"] = 207354,
	["128825.155718"] = 196355,
	["128860.155718"] = 210590,
	["128306.155718"] = 186320,
	["128821.155718"] = 200440,
	["128858.155718"] = 203018,

	["128821.155746"] = 200399,
	["128858.155746"] = 202386,
	["128825.155746"] = 196358,
	["128860.155746"] = 210571,
	["128306.155746"] = 189768,
	["128937.155746"] = 199366,
	["128938.155746"] = 213049,
	["128823.155746"] = 200316,
	["128911.155746"] = 207092,
	["128826.155746"] = 190457,

	["128821.155747"] = 200409,
	["128858.155747"] = 202445,
	["128825.155747"] = 196422,
	["128306.155747"] = 189754,
	["128860.155747"] = 210593,
	["128823.155747"] = 200294,
	["128911.155747"] = 207255,
	["128826.155747"] = 190520,
	["128938.155747"] = 213055,
	["128937.155747"] = 199377,

	["128306.155748"] = 186320,
	["128860.155748"] = 210590,
	["128825.155748"] = 196355,
	["128858.155748"] = 203018,
	["128821.155748"] = 200440,
	["128938.155748"] = 213116,
	["128937.155748"] = 199384,
	["128826.155748"] = 190514,
	["128911.155748"] = 207354,
	["128823.155748"] = 200302,

	["128821.140418"] = 200399,
	["128858.140418"] = 202386,
	["128825.140418"] = 196358,
	["128860.140418"] = 210571,
	["128306.140418"] = 189768,
	["128938.140418"] = 213049,
	["128937.140418"] = 199366,
	["128823.140418"] = 200316,
	["128911.140418"] = 207092,
	["128826.140418"] = 190457,

	["128823.140437"] = 200294,
	["128911.140437"] = 207255,
	["128826.140437"] = 190520,
	["128938.140437"] = 213055,
	["128937.140437"] = 199377,
	["128821.140437"] = 200409,
	["128858.140437"] = 202445,
	["128825.140437"] = 196422,
	["128860.140437"] = 210593,
	["128306.140437"] = 189754,

	["128826.140438"] = 190514,
	["128911.140438"] = 207354,
	["128823.140438"] = 200302,
	["128937.140438"] = 199384,
	["128938.140438"] = 213116,
	["128860.140438"] = 210590,
	["128306.140438"] = 186320,
	["128825.140438"] = 196355,
	["128858.140438"] = 203018,
	["128821.140438"] = 200440,

	["128823.143803"] = 200316,
	["128911.143803"] = 207092,
	["128826.143803"] = 190457,
	["128938.143803"] = 213049,
	["128937.143803"] = 199366,
	["128821.143803"] = 200399,
	["128858.143803"] = 202386,
	["128825.143803"] = 196358,
	["128860.143803"] = 210571,
	["128306.143803"] = 189768,

	["128858.143820"] = 202445,
	["128821.143820"] = 200409,
	["128306.143820"] = 189754,
	["128860.143820"] = 210593,
	["128825.143820"] = 196422,
	["128911.143820"] = 207255,
	["128823.143820"] = 200294,
	["128826.143820"] = 190520,
	["128938.143820"] = 213055,
	["128937.143820"] = 199377,

	["128938.143821"] = 213116,
	["128937.143821"] = 199384,
	["128826.143821"] = 190514,
	["128911.143821"] = 207354,
	["128823.143821"] = 200302,
	["128860.143821"] = 210590,
	["128306.143821"] = 186320,
	["128825.143821"] = 196355,
	["128858.143821"] = 203018,
	["128821.143821"] = 200440,

	["128821.144525"] = 200399,
	["128858.144525"] = 202386,
	["128825.144525"] = 196358,
	["128306.144525"] = 189768,
	["128860.144525"] = 210571,
	["128823.144525"] = 200316,
	["128911.144525"] = 207092,
	["128826.144525"] = 190457,
	["128938.144525"] = 213049,
	["128937.144525"] = 199366,

	["128825.144526"] = 196422,
	["128306.144526"] = 189754,
	["128860.144526"] = 210593,
	["128821.144526"] = 200409,
	["128858.144526"] = 202445,
	["128938.144526"] = 213055,
	["128937.144526"] = 199377,
	["128826.144526"] = 190520,
	["128823.144526"] = 200294,
	["128911.144526"] = 207255,

	["128911.144527"] = 207354,
	["128823.144527"] = 200302,
	["128826.144527"] = 190514,
	["128938.144527"] = 213116,
	["128937.144527"] = 199384,
	["128858.144527"] = 203018,
	["128821.144527"] = 200440,
	["128860.144527"] = 210590,
	["128306.144527"] = 186320,
	["128825.144527"] = 196355,

	["128937.145367"] = 199366,
	["128938.145367"] = 213049,
	["128826.145367"] = 190457,
	["128823.145367"] = 200316,
	["128911.145367"] = 207092,
	["128825.145367"] = 196358,
	["128860.145367"] = 210571,
	["128306.145367"] = 189768,
	["128821.145367"] = 200399,
	["128858.145367"] = 202386,

	["128938.145368"] = 213055,
	["128937.145368"] = 199377,
	["128826.145368"] = 190520,
	["128823.145368"] = 200294,
	["128911.145368"] = 207255,
	["128825.145368"] = 196422,
	["128860.145368"] = 210593,
	["128306.145368"] = 189754,
	["128821.145368"] = 200409,
	["128858.145368"] = 202445,

	["128821.145369"] = 200440,
	["128858.145369"] = 203018,
	["128825.145369"] = 196355,
	["128306.145369"] = 186320,
	["128860.145369"] = 210590,
	["128823.145369"] = 200302,
	["128911.145369"] = 207354,
	["128826.145369"] = 190514,
	["128938.145369"] = 213116,
	["128937.145369"] = 199384,

	["128306.150295"] = 189768,
	["128860.150295"] = 210571,
	["128825.150295"] = 196358,
	["128858.150295"] = 202386,
	["128821.150295"] = 200399,
	["128937.150295"] = 199366,
	["128938.150295"] = 213049,
	["128826.150295"] = 190457,
	["128911.150295"] = 207092,
	["128823.150295"] = 200316,

	["128823.150296"] = 200294,
	["128911.150296"] = 207255,
	["128826.150296"] = 190520,
	["128937.150296"] = 199377,
	["128938.150296"] = 213055,
	["128821.150296"] = 200409,
	["128858.150296"] = 202445,
	["128825.150296"] = 196422,
	["128860.150296"] = 210593,
	["128306.150296"] = 189754,

	["128826.150297"] = 190514,
	["128911.150297"] = 207354,
	["128823.150297"] = 200302,
	["128938.150297"] = 213116,
	["128937.150297"] = 199384,
	["128860.150297"] = 210590,
	["128306.150297"] = 186320,
	["128825.150297"] = 196355,
	["128858.150297"] = 203018,
	["128821.150297"] = 200440,

	["128825.150319"] = 196358,
	["128306.150319"] = 189768,
	["128860.150319"] = 210571,
	["128821.150319"] = 200399,
	["128858.150319"] = 202386,
	["128826.150319"] = 190457,
	["128823.150319"] = 200316,
	["128911.150319"] = 207092,
	["128938.150319"] = 213049,
	["128937.150319"] = 199366,

	["128911.150320"] = 207255,
	["128823.150320"] = 200294,
	["128826.150320"] = 190520,
	["128938.150320"] = 213055,
	["128937.150320"] = 199377,
	["128858.150320"] = 202445,
	["128821.150320"] = 200409,
	["128860.150320"] = 210593,
	["128306.150320"] = 189754,
	["128825.150320"] = 196422,

	["128825.150321"] = 196355,
	["128306.150321"] = 186320,
	["128860.150321"] = 210590,
	["128821.150321"] = 200440,
	["128858.150321"] = 203018,
	["128937.150321"] = 199384,
	["128938.150321"] = 213116,
	["128826.150321"] = 190514,
	["128823.150321"] = 200302,
	["128911.150321"] = 207354,

	["128938.150344"] = 213049,
	["128937.150344"] = 199366,
	["128826.150344"] = 190457,
	["128823.150344"] = 200316,
	["128911.150344"] = 207092,
	["128825.150344"] = 196358,
	["128860.150344"] = 210571,
	["128306.150344"] = 189768,
	["128821.150344"] = 200399,
	["128858.150344"] = 202386,

	["128821.150345"] = 200409,
	["128858.150345"] = 202445,
	["128825.150345"] = 196422,
	["128306.150345"] = 189754,
	["128860.150345"] = 210593,
	["128823.150345"] = 200294,
	["128911.150345"] = 207255,
	["128826.150345"] = 190520,
	["128937.150345"] = 199377,
	["128938.150345"] = 213055,

	["128826.150346"] = 190514,
	["128911.150346"] = 207354,
	["128823.150346"] = 200302,
	["128938.150346"] = 213116,
	["128937.150346"] = 199384,
	["128860.150346"] = 210590,
	["128306.150346"] = 186320,
	["128825.150346"] = 196355,
	["128858.150346"] = 203018,
	["128821.150346"] = 200440,

	["128937.153467"] = 199366,
	["128938.153467"] = 213049,
	["128823.153467"] = 200316,
	["128911.153467"] = 207092,
	["128826.153467"] = 190457,
	["128821.153467"] = 200399,
	["128858.153467"] = 202386,
	["128825.153467"] = 196358,
	["128306.153467"] = 189768,
	["128860.153467"] = 210571,

	["128823.153468"] = 200294,
	["128911.153468"] = 207255,
	["128826.153468"] = 190520,
	["128937.153468"] = 199377,
	["128938.153468"] = 213055,
	["128821.153468"] = 200409,
	["128858.153468"] = 202445,
	["128825.153468"] = 196422,
	["128860.153468"] = 210593,
	["128306.153468"] = 189754,

	["128306.153469"] = 186320,
	["128860.153469"] = 210590,
	["128825.153469"] = 196355,
	["128858.153469"] = 203018,
	["128821.153469"] = 200440,
	["128826.153469"] = 190514,
	["128911.153469"] = 207354,
	["128823.153469"] = 200302,
	["128937.153469"] = 199384,
	["128938.153469"] = 213116,

	["128826.135574"] = 190514,
	["128911.135574"] = 207354,
	["128823.135574"] = 200302,
	["128938.135574"] = 213116,
	["128937.135574"] = 199384,
	["128860.135574"] = 210590,
	["128306.135574"] = 186320,
	["128825.135574"] = 196355,
	["128858.135574"] = 203018,
	["128821.135574"] = 200440,

	["128941.151503"] = 196217,
	["120978.151503"] = 184759,
	["128289.151503"] = 216272,
	["128403.151503"] = 191442,
	["128908.151503"] = 216273,
	["128819.151503"] = 198236,
	["128943.151503"] = 211126,
	["128821.151503"] = 200399,
	["128820.151503"] = 194234,

	["128821.151504"] = 200409,
	["128820.151504"] = 194313,
	["128908.151504"] = 200856,
	["128289.151504"] = 203225,
	["120978.151504"] = 186927,
	["128403.151504"] = 191494,
	["128941.151504"] = 196236,
	["128943.151504"] = 211105,
	["128819.151504"] = 198299,

	["128820.151505"] = 194314,
	["128821.151505"] = 200414,
	["128943.151505"] = 211119,
	["128819.151505"] = 198349,
	["128941.151505"] = 196432,
	["128908.151505"] = 200860,
	["128403.151505"] = 191488,
	["128289.151505"] = 203227,
	["120978.151505"] = 185368,

	["128943.154061"] = 211126,
	["128819.154061"] = 198236,
	["128941.154061"] = 196217,
	["128908.154061"] = 216273,
	["128403.154061"] = 191442,
	["128289.154061"] = 216272,
	["120978.154061"] = 184759,
	["128820.154061"] = 194234,
	["128821.154061"] = 200399,

	["128821.154062"] = 200409,
	["128820.154062"] = 194313,
	["128941.154062"] = 196236,
	["120978.154062"] = 186927,
	["128289.154062"] = 203225,
	["128403.154062"] = 191494,
	["128908.154062"] = 200856,
	["128819.154062"] = 198299,
	["128943.154062"] = 211105,

	["128943.154063"] = 211119,
	["128819.154063"] = 198349,
	["128941.154063"] = 196432,
	["128908.154063"] = 200860,
	["120978.154063"] = 185368,
	["128289.154063"] = 203227,
	["128403.154063"] = 191488,
	["128820.154063"] = 194314,
	["128821.154063"] = 200414,

	["128821.154091"] = 200399,
	["128820.154091"] = 194234,
	["128289.154091"] = 216272,
	["128403.154091"] = 191442,
	["120978.154091"] = 184759,
	["128908.154091"] = 216273,
	["128941.154091"] = 196217,
	["128819.154091"] = 198236,
	["128943.154091"] = 211126,

	["128943.154092"] = 211105,
	["128819.154092"] = 198299,
	["128941.154092"] = 196236,
	["128908.154092"] = 200856,
	["128403.154092"] = 191494,
	["128289.154092"] = 203225,
	["120978.154092"] = 186927,
	["128820.154092"] = 194313,
	["128821.154092"] = 200409,

	["128819.154093"] = 198349,
	["128943.154093"] = 211119,
	["128289.154093"] = 203227,
	["120978.154093"] = 185368,
	["128403.154093"] = 191488,
	["128908.154093"] = 200860,
	["128941.154093"] = 196432,
	["128820.154093"] = 194314,
	["128821.154093"] = 200414,

	["128820.155704"] = 194234,
	["128821.155704"] = 200399,
	["128819.155704"] = 198236,
	["128943.155704"] = 211126,
	["128941.155704"] = 196217,
	["120978.155704"] = 184759,
	["128289.155704"] = 216272,
	["128403.155704"] = 191442,
	["128908.155704"] = 216273,

	["128820.155705"] = 194313,
	["128821.155705"] = 200409,
	["128819.155705"] = 198299,
	["128943.155705"] = 211105,
	["128941.155705"] = 196236,
	["128403.155705"] = 191494,
	["128289.155705"] = 203225,
	["120978.155705"] = 186927,
	["128908.155705"] = 200856,

	["128943.155706"] = 211119,
	["128819.155706"] = 198349,
	["128908.155706"] = 200860,
	["128289.155706"] = 203227,
	["120978.155706"] = 185368,
	["128403.155706"] = 191488,
	["128941.155706"] = 196432,
	["128820.155706"] = 194314,
	["128821.155706"] = 200414,

	["128943.155734"] = 211126,
	["128819.155734"] = 198236,
	["128908.155734"] = 216273,
	["128289.155734"] = 216272,
	["128403.155734"] = 191442,
	["120978.155734"] = 184759,
	["128941.155734"] = 196217,
	["128820.155734"] = 194234,
	["128821.155734"] = 200399,

	["128943.155735"] = 211105,
	["128819.155735"] = 198299,
	["128941.155735"] = 196236,
	["128908.155735"] = 200856,
	["120978.155735"] = 186927,
	["128289.155735"] = 203225,
	["128403.155735"] = 191494,
	["128820.155735"] = 194313,
	["128821.155735"] = 200409,

	["128819.155736"] = 198349,
	["128943.155736"] = 211119,
	["128289.155736"] = 203227,
	["120978.155736"] = 185368,
	["128403.155736"] = 191488,
	["128908.155736"] = 200860,
	["128941.155736"] = 196432,
	["128820.155736"] = 194314,
	["128821.155736"] = 200414,

	["128820.140415"] = 194234,
	["128821.140415"] = 200399,
	["128943.140415"] = 211126,
	["128819.140415"] = 198236,
	["128941.140415"] = 196217,
	["128908.140415"] = 216273,
	["120978.140415"] = 184759,
	["128289.140415"] = 216272,
	["128403.140415"] = 191442,

	["128941.140429"] = 196236,
	["128908.140429"] = 200856,
	["128403.140429"] = 191494,
	["128289.140429"] = 203225,
	["120978.140429"] = 186927,
	["128943.140429"] = 211105,
	["128819.140429"] = 198299,
	["128821.140429"] = 200409,
	["128820.140429"] = 194313,

	["128819.140430"] = 198349,
	["128943.140430"] = 211119,
	["128941.140430"] = 196432,
	["120978.140430"] = 185368,
	["128289.140430"] = 203227,
	["128403.140430"] = 191488,
	["128908.140430"] = 200860,
	["128820.140430"] = 194314,
	["128821.140430"] = 200414,

	["128821.143800"] = 200399,
	["128820.143800"] = 194234,
	["128289.143800"] = 216272,
	["128403.143800"] = 191442,
	["120978.143800"] = 184759,
	["128908.143800"] = 216273,
	["128941.143800"] = 196217,
	["128819.143800"] = 198236,
	["128943.143800"] = 211126,

	["128820.143812"] = 194313,
	["128821.143812"] = 200409,
	["128819.143812"] = 198299,
	["128943.143812"] = 211105,
	["128289.143812"] = 203225,
	["128403.143812"] = 191494,
	["120978.143812"] = 186927,
	["128908.143812"] = 200856,
	["128941.143812"] = 196236,

	["128820.143813"] = 194314,
	["128821.143813"] = 200414,
	["128819.143813"] = 198349,
	["128943.143813"] = 211119,
	["128289.143813"] = 203227,
	["120978.143813"] = 185368,
	["128403.143813"] = 191488,
	["128908.143813"] = 200860,
	["128941.143813"] = 196432,

	["128941.144513"] = 196217,
	["128403.144513"] = 191442,
	["128289.144513"] = 216272,
	["120978.144513"] = 184759,
	["128908.144513"] = 216273,
	["128819.144513"] = 198236,
	["128943.144513"] = 211126,
	["128821.144513"] = 200399,
	["128820.144513"] = 194234,

	["128820.144514"] = 194313,
	["128821.144514"] = 200409,
	["128943.144514"] = 211105,
	["128819.144514"] = 198299,
	["128908.144514"] = 200856,
	["128289.144514"] = 203225,
	["120978.144514"] = 186927,
	["128403.144514"] = 191494,
	["128941.144514"] = 196236,

	["128819.144515"] = 198349,
	["128943.144515"] = 211119,
	["128289.144515"] = 203227,
	["128403.144515"] = 191488,
	["120978.144515"] = 185368,
	["128908.144515"] = 200860,
	["128941.144515"] = 196432,
	["128820.144515"] = 194314,
	["128821.144515"] = 200414,

	["128820.145355"] = 194234,
	["128821.145355"] = 200399,
	["128819.145355"] = 198236,
	["128943.145355"] = 211126,
	["128941.145355"] = 196217,
	["120978.145355"] = 184759,
	["128289.145355"] = 216272,
	["128403.145355"] = 191442,
	["128908.145355"] = 216273,

	["128820.145356"] = 194313,
	["128821.145356"] = 200409,
	["128943.145356"] = 211105,
	["128819.145356"] = 198299,
	["128908.145356"] = 200856,
	["128289.145356"] = 203225,
	["128403.145356"] = 191494,
	["120978.145356"] = 186927,
	["128941.145356"] = 196236,

	["128820.145357"] = 194314,
	["128821.145357"] = 200414,
	["128943.145357"] = 211119,
	["128819.145357"] = 198349,
	["128908.145357"] = 200860,
	["128289.145357"] = 203227,
	["120978.145357"] = 185368,
	["128403.145357"] = 191488,
	["128941.145357"] = 196432,

	["128819.150283"] = 198236,
	["128943.150283"] = 211126,
	["128941.150283"] = 196217,
	["128403.150283"] = 191442,
	["128289.150283"] = 216272,
	["120978.150283"] = 184759,
	["128908.150283"] = 216273,
	["128820.150283"] = 194234,
	["128821.150283"] = 200399,

	["128820.150284"] = 194313,
	["128821.150284"] = 200409,
	["128943.150284"] = 211105,
	["128819.150284"] = 198299,
	["128908.150284"] = 200856,
	["128289.150284"] = 203225,
	["128403.150284"] = 191494,
	["120978.150284"] = 186927,
	["128941.150284"] = 196236,

	["128820.150285"] = 194314,
	["128821.150285"] = 200414,
	["128943.150285"] = 211119,
	["128819.150285"] = 198349,
	["128908.150285"] = 200860,
	["128289.150285"] = 203227,
	["120978.150285"] = 185368,
	["128403.150285"] = 191488,
	["128941.150285"] = 196432,

	["128819.150307"] = 198236,
	["128943.150307"] = 211126,
	["128289.150307"] = 216272,
	["120978.150307"] = 184759,
	["128403.150307"] = 191442,
	["128908.150307"] = 216273,
	["128941.150307"] = 196217,
	["128820.150307"] = 194234,
	["128821.150307"] = 200399,

	["128289.150308"] = 203225,
	["128403.150308"] = 191494,
	["120978.150308"] = 186927,
	["128908.150308"] = 200856,
	["128941.150308"] = 196236,
	["128819.150308"] = 198299,
	["128943.150308"] = 211105,
	["128821.150308"] = 200409,
	["128820.150308"] = 194313,

	["128820.150309"] = 194314,
	["128821.150309"] = 200414,
	["128943.150309"] = 211119,
	["128819.150309"] = 198349,
	["128941.150309"] = 196432,
	["128908.150309"] = 200860,
	["120978.150309"] = 185368,
	["128289.150309"] = 203227,
	["128403.150309"] = 191488,

	["128821.150332"] = 200399,
	["128820.150332"] = 194234,
	["128289.150332"] = 216272,
	["128403.150332"] = 191442,
	["120978.150332"] = 184759,
	["128908.150332"] = 216273,
	["128941.150332"] = 196217,
	["128819.150332"] = 198236,
	["128943.150332"] = 211126,

	["128941.150333"] = 196236,
	["128403.150333"] = 191494,
	["128289.150333"] = 203225,
	["120978.150333"] = 186927,
	["128908.150333"] = 200856,
	["128819.150333"] = 198299,
	["128943.150333"] = 211105,
	["128821.150333"] = 200409,
	["128820.150333"] = 194313,

	["128289.150334"] = 203227,
	["128403.150334"] = 191488,
	["120978.150334"] = 185368,
	["128908.150334"] = 200860,
	["128941.150334"] = 196432,
	["128819.150334"] = 198349,
	["128943.150334"] = 211119,
	["128821.150334"] = 200414,
	["128820.150334"] = 194314,

	["128821.153455"] = 200399,
	["128820.153455"] = 194234,
	["128941.153455"] = 196217,
	["120978.153455"] = 184759,
	["128289.153455"] = 216272,
	["128403.153455"] = 191442,
	["128908.153455"] = 216273,
	["128819.153455"] = 198236,
	["128943.153455"] = 211126,

	["128819.153456"] = 198299,
	["128943.153456"] = 211105,
	["128941.153456"] = 196236,
	["120978.153456"] = 186927,
	["128289.153456"] = 203225,
	["128403.153456"] = 191494,
	["128908.153456"] = 200856,
	["128820.153456"] = 194313,
	["128821.153456"] = 200409,

	["128821.153457"] = 200414,
	["128820.153457"] = 194314,
	["128941.153457"] = 196432,
	["128908.153457"] = 200860,
	["128403.153457"] = 191488,
	["128289.153457"] = 203227,
	["120978.153457"] = 185368,
	["128943.153457"] = 211119,
	["128819.153457"] = 198349,

	["128941.135571"] = 196301,
	["128908.135571"] = 200857,
	["120978.135571"] = 186934,
	["128289.135571"] = 188632,
	["128403.135571"] = 191565,
	["128943.135571"] = 211144,
	["128819.135571"] = 198296,
	["128821.135571"] = 200400,
	["128820.135571"] = 194318,

	["128937.151506"] = 199366,
	["128292.151506"] = 189092,
	["128911.151506"] = 207092,
	["128935.151506"] = 191499,
	["128862.151506"] = 195317,
	["127857.151506"] = 187258,
	["128860.151506"] = 210571,
	["128306.151506"] = 189768,

	["128292.151507"] = 189164,
	["128937.151507"] = 199372,
	["128935.151507"] = 191740,
	["128911.151507"] = 207206,
	["128862.151507"] = 195323,
	["128306.151507"] = 189757,
	["128860.151507"] = 210579,
	["127857.151507"] = 187264,

	["127857.151508"] = 187287,
	["128860.151508"] = 210631,
	["128306.151508"] = 189744,
	["128911.151508"] = 207348,
	["128935.151508"] = 191598,
	["128862.151508"] = 195352,
	["128937.151508"] = 199485,
	["128292.151508"] = 189097,

	["128862.154064"] = 195317,
	["128935.154064"] = 191499,
	["128911.154064"] = 207092,
	["128292.154064"] = 189092,
	["128937.154064"] = 199366,
	["128306.154064"] = 189768,
	["128860.154064"] = 210571,
	["127857.154064"] = 187258,

	["128306.154065"] = 189757,
	["128860.154065"] = 210579,
	["127857.154065"] = 187264,
	["128292.154065"] = 189164,
	["128937.154065"] = 199372,
	["128862.154065"] = 195323,
	["128911.154065"] = 207206,
	["128935.154065"] = 191740,

	["128292.154066"] = 189097,
	["128937.154066"] = 199485,
	["128862.154066"] = 195352,
	["128935.154066"] = 191598,
	["128911.154066"] = 207348,
	["128306.154066"] = 189744,
	["128860.154066"] = 210631,
	["127857.154066"] = 187287,

	["127857.154094"] = 187258,
	["128860.154094"] = 210571,
	["128306.154094"] = 189768,
	["128935.154094"] = 191499,
	["128911.154094"] = 207092,
	["128862.154094"] = 195317,
	["128937.154094"] = 199366,
	["128292.154094"] = 189092,

	["127857.154095"] = 187264,
	["128860.154095"] = 210579,
	["128306.154095"] = 189757,
	["128937.154095"] = 199372,
	["128292.154095"] = 189164,
	["128862.154095"] = 195323,
	["128935.154095"] = 191740,
	["128911.154095"] = 207206,

	["128306.154096"] = 189744,
	["128860.154096"] = 210631,
	["127857.154096"] = 187287,
	["128911.154096"] = 207348,
	["128935.154096"] = 191598,
	["128862.154096"] = 195352,
	["128292.154096"] = 189097,
	["128937.154096"] = 199485,

	["127857.155707"] = 187258,
	["128860.155707"] = 210571,
	["128306.155707"] = 189768,
	["128937.155707"] = 199366,
	["128292.155707"] = 189092,
	["128935.155707"] = 191499,
	["128911.155707"] = 207092,
	["128862.155707"] = 195317,

	["128306.155708"] = 189757,
	["128860.155708"] = 210579,
	["127857.155708"] = 187264,
	["128862.155708"] = 195323,
	["128935.155708"] = 191740,
	["128911.155708"] = 207206,
	["128292.155708"] = 189164,
	["128937.155708"] = 199372,

	["128292.155709"] = 189097,
	["128937.155709"] = 199485,
	["128862.155709"] = 195352,
	["128935.155709"] = 191598,
	["128911.155709"] = 207348,
	["128306.155709"] = 189744,
	["128860.155709"] = 210631,
	["127857.155709"] = 187287,

	["128862.155737"] = 195317,
	["128935.155737"] = 191499,
	["128911.155737"] = 207092,
	["128937.155737"] = 199366,
	["128292.155737"] = 189092,
	["127857.155737"] = 187258,
	["128860.155737"] = 210571,
	["128306.155737"] = 189768,

	["128935.155738"] = 191740,
	["128911.155738"] = 207206,
	["128862.155738"] = 195323,
	["128937.155738"] = 199372,
	["128292.155738"] = 189164,
	["127857.155738"] = 187264,
	["128860.155738"] = 210579,
	["128306.155738"] = 189757,

	["128306.155739"] = 189744,
	["128860.155739"] = 210631,
	["127857.155739"] = 187287,
	["128292.155739"] = 189097,
	["128937.155739"] = 199485,
	["128935.155739"] = 191598,
	["128911.155739"] = 207348,
	["128862.155739"] = 195352,

	["128306.140416"] = 189768,
	["128860.140416"] = 210571,
	["127857.140416"] = 187258,
	["128862.140416"] = 195317,
	["128911.140416"] = 207092,
	["128935.140416"] = 191499,
	["128292.140416"] = 189092,
	["128937.140416"] = 199366,

	["128306.140431"] = 189757,
	["128860.140431"] = 210579,
	["127857.140431"] = 187264,
	["128862.140431"] = 195323,
	["128935.140431"] = 191740,
	["128911.140431"] = 207206,
	["128292.140431"] = 189164,
	["128937.140431"] = 199372,

	["127857.140432"] = 187287,
	["128860.140432"] = 210631,
	["128306.140432"] = 189744,
	["128937.140432"] = 199485,
	["128292.140432"] = 189097,
	["128862.140432"] = 195352,
	["128935.140432"] = 191598,
	["128911.140432"] = 207348,

	["128292.143801"] = 189092,
	["128937.143801"] = 199366,
	["128862.143801"] = 195317,
	["128935.143801"] = 191499,
	["128911.143801"] = 207092,
	["128306.143801"] = 189768,
	["128860.143801"] = 210571,
	["127857.143801"] = 187258,

	["127857.143814"] = 187264,
	["128860.143814"] = 210579,
	["128306.143814"] = 189757,
	["128937.143814"] = 199372,
	["128292.143814"] = 189164,
	["128862.143814"] = 195323,
	["128935.143814"] = 191740,
	["128911.143814"] = 207206,

	["128292.143815"] = 189097,
	["128937.143815"] = 199485,
	["128911.143815"] = 207348,
	["128935.143815"] = 191598,
	["128862.143815"] = 195352,
	["128306.143815"] = 189744,
	["128860.143815"] = 210631,
	["127857.143815"] = 187287,

	["128911.144516"] = 207092,
	["128935.144516"] = 191499,
	["128862.144516"] = 195317,
	["128292.144516"] = 189092,
	["128937.144516"] = 199366,
	["128306.144516"] = 189768,
	["128860.144516"] = 210571,
	["127857.144516"] = 187258,

	["128862.144517"] = 195323,
	["128935.144517"] = 191740,
	["128911.144517"] = 207206,
	["128292.144517"] = 189164,
	["128937.144517"] = 199372,
	["128306.144517"] = 189757,
	["128860.144517"] = 210579,
	["127857.144517"] = 187264,

	["128292.144518"] = 189097,
	["128937.144518"] = 199485,
	["128911.144518"] = 207348,
	["128935.144518"] = 191598,
	["128862.144518"] = 195352,
	["128306.144518"] = 189744,
	["128860.144518"] = 210631,
	["127857.144518"] = 187287,

	["128306.145358"] = 189768,
	["128860.145358"] = 210571,
	["127857.145358"] = 187258,
	["128862.145358"] = 195317,
	["128911.145358"] = 207092,
	["128935.145358"] = 191499,
	["128292.145358"] = 189092,
	["128937.145358"] = 199366,

	["128306.145359"] = 189757,
	["128860.145359"] = 210579,
	["127857.145359"] = 187264,
	["128292.145359"] = 189164,
	["128937.145359"] = 199372,
	["128911.145359"] = 207206,
	["128935.145359"] = 191740,
	["128862.145359"] = 195323,

	["127857.145360"] = 187287,
	["128860.145360"] = 210631,
	["128306.145360"] = 189744,
	["128911.145360"] = 207348,
	["128935.145360"] = 191598,
	["128862.145360"] = 195352,
	["128937.145360"] = 199485,
	["128292.145360"] = 189097,

	["128862.150286"] = 195317,
	["128911.150286"] = 207092,
	["128935.150286"] = 191499,
	["128292.150286"] = 189092,
	["128937.150286"] = 199366,
	["128306.150286"] = 189768,
	["128860.150286"] = 210571,
	["127857.150286"] = 187258,

	["128306.150287"] = 189757,
	["128860.150287"] = 210579,
	["127857.150287"] = 187264,
	["128862.150287"] = 195323,
	["128911.150287"] = 207206,
	["128935.150287"] = 191740,
	["128292.150287"] = 189164,
	["128937.150287"] = 199372,

	["128292.150288"] = 189097,
	["128937.150288"] = 199485,
	["128862.150288"] = 195352,
	["128911.150288"] = 207348,
	["128935.150288"] = 191598,
	["128306.150288"] = 189744,
	["128860.150288"] = 210631,
	["127857.150288"] = 187287,

	["128292.150310"] = 189092,
	["128937.150310"] = 199366,
	["128862.150310"] = 195317,
	["128911.150310"] = 207092,
	["128935.150310"] = 191499,
	["128306.150310"] = 189768,
	["128860.150310"] = 210571,
	["127857.150310"] = 187258,

	["127857.150311"] = 187264,
	["128860.150311"] = 210579,
	["128306.150311"] = 189757,
	["128911.150311"] = 207206,
	["128935.150311"] = 191740,
	["128862.150311"] = 195323,
	["128937.150311"] = 199372,
	["128292.150311"] = 189164,

	["128862.150312"] = 195352,
	["128911.150312"] = 207348,
	["128935.150312"] = 191598,
	["128292.150312"] = 189097,
	["128937.150312"] = 199485,
	["128306.150312"] = 189744,
	["128860.150312"] = 210631,
	["127857.150312"] = 187287,

	["128306.150335"] = 189768,
	["128860.150335"] = 210571,
	["127857.150335"] = 187258,
	["128292.150335"] = 189092,
	["128937.150335"] = 199366,
	["128935.150335"] = 191499,
	["128911.150335"] = 207092,
	["128862.150335"] = 195317,

	["128937.150336"] = 199372,
	["128292.150336"] = 189164,
	["128862.150336"] = 195323,
	["128935.150336"] = 191740,
	["128911.150336"] = 207206,
	["127857.150336"] = 187264,
	["128860.150336"] = 210579,
	["128306.150336"] = 189757,

	["128292.150337"] = 189097,
	["128937.150337"] = 199485,
	["128862.150337"] = 195352,
	["128911.150337"] = 207348,
	["128935.150337"] = 191598,
	["128306.150337"] = 189744,
	["128860.150337"] = 210631,
	["127857.150337"] = 187287,

	["128862.153458"] = 195317,
	["128911.153458"] = 207092,
	["128935.153458"] = 191499,
	["128292.153458"] = 189092,
	["128937.153458"] = 199366,
	["128306.153458"] = 189768,
	["128860.153458"] = 210571,
	["127857.153458"] = 187258,

	["128911.153459"] = 207206,
	["128935.153459"] = 191740,
	["128862.153459"] = 195323,
	["128937.153459"] = 199372,
	["128292.153459"] = 189164,
	["127857.153459"] = 187264,
	["128860.153459"] = 210579,
	["128306.153459"] = 189757,

	["127857.153460"] = 187287,
	["128860.153460"] = 210631,
	["128306.153460"] = 189744,
	["128862.153460"] = 195352,
	["128935.153460"] = 191598,
	["128911.153460"] = 207348,
	["128937.153460"] = 199485,
	["128292.153460"] = 189097,

	["128306.135570"] = 189754,
	["128860.135570"] = 210593,
	["127857.135570"] = 187313,
	["128292.135570"] = 189144,
	["128937.135570"] = 199377,
	["128862.135570"] = 195345,
	["128935.135570"] = 191572,
	["128911.135570"] = 207255,

	["128866.151494"] = 209216,
	["128862.151494"] = 195352,
	["128832.151494"] = 212819,
	["128861.151494"] = 206910,
	["128858.151494"] = 202464,
	["127857.151494"] = 187287,
	["128820.151494"] = 194239,

	["128866.151495"] = 209220,
	["128862.151495"] = 195322,
	["128832.151495"] = 207352,
	["128861.151495"] = 197080,
	["128858.151495"] = 202426,
	["127857.151495"] = 187321,
	["128820.151495"] = 194312,

	["128866.151496"] = 209226,
	["128862.151496"] = 195323,
	["127857.151496"] = 187264,
	["128858.151496"] = 202433,
	["128861.151496"] = 197139,
	["128832.151496"] = 207375,
	["128820.151496"] = 210182,

	["128820.154052"] = 194239,
	["128832.154052"] = 212819,
	["128861.154052"] = 206910,
	["127857.154052"] = 187287,
	["128858.154052"] = 202464,
	["128862.154052"] = 195352,
	["128866.154052"] = 209216,

	["128832.154053"] = 207352,
	["128861.154053"] = 197080,
	["127857.154053"] = 187321,
	["128858.154053"] = 202426,
	["128820.154053"] = 194312,
	["128866.154053"] = 209220,
	["128862.154053"] = 195322,

	["128862.154054"] = 195323,
	["128866.154054"] = 209226,
	["128820.154054"] = 210182,
	["128832.154054"] = 207375,
	["128858.154054"] = 202433,
	["127857.154054"] = 187264,
	["128861.154054"] = 197139,

	["128866.154082"] = 209216,
	["128862.154082"] = 195352,
	["128832.154082"] = 212819,
	["128858.154082"] = 202464,
	["127857.154082"] = 187287,
	["128861.154082"] = 206910,
	["128820.154082"] = 194239,

	["128820.154083"] = 194312,
	["128832.154083"] = 207352,
	["127857.154083"] = 187321,
	["128858.154083"] = 202426,
	["128861.154083"] = 197080,
	["128862.154083"] = 195322,
	["128866.154083"] = 209220,

	["128820.154084"] = 210182,
	["128832.154084"] = 207375,
	["128861.154084"] = 197139,
	["127857.154084"] = 187264,
	["128858.154084"] = 202433,
	["128862.154084"] = 195323,
	["128866.154084"] = 209226,

	["128832.155695"] = 212819,
	["128861.155695"] = 206910,
	["127857.155695"] = 187287,
	["128858.155695"] = 202464,
	["128820.155695"] = 194239,
	["128866.155695"] = 209216,
	["128862.155695"] = 195352,

	["128861.155696"] = 197080,
	["128858.155696"] = 202426,
	["127857.155696"] = 187321,
	["128832.155696"] = 207352,
	["128820.155696"] = 194312,
	["128866.155696"] = 209220,
	["128862.155696"] = 195322,

	["128862.155697"] = 195323,
	["128866.155697"] = 209226,
	["128820.155697"] = 210182,
	["128832.155697"] = 207375,
	["128861.155697"] = 197139,
	["128858.155697"] = 202433,
	["127857.155697"] = 187264,

	["128862.155725"] = 195352,
	["128866.155725"] = 209216,
	["128820.155725"] = 194239,
	["128832.155725"] = 212819,
	["128858.155725"] = 202464,
	["127857.155725"] = 187287,
	["128861.155725"] = 206910,

	["128858.155726"] = 202426,
	["127857.155726"] = 187321,
	["128861.155726"] = 197080,
	["128832.155726"] = 207352,
	["128820.155726"] = 194312,
	["128866.155726"] = 209220,
	["128862.155726"] = 195322,

	["128862.155727"] = 195323,
	["128866.155727"] = 209226,
	["128820.155727"] = 210182,
	["128832.155727"] = 207375,
	["128858.155727"] = 202433,
	["127857.155727"] = 187264,
	["128861.155727"] = 197139,

	["128832.140412"] = 212819,
	["128861.140412"] = 206910,
	["127857.140412"] = 187287,
	["128858.140412"] = 202464,
	["128820.140412"] = 194239,
	["128866.140412"] = 209216,
	["128862.140412"] = 195352,

	["128866.140423"] = 209220,
	["128862.140423"] = 195322,
	["128832.140423"] = 207352,
	["128858.140423"] = 202426,
	["127857.140423"] = 187321,
	["128861.140423"] = 197080,
	["128820.140423"] = 194312,

	["128832.140424"] = 207375,
	["127857.140424"] = 187264,
	["128858.140424"] = 202433,
	["128861.140424"] = 197139,
	["128820.140424"] = 210182,
	["128866.140424"] = 209226,
	["128862.140424"] = 195323,

	["128862.143797"] = 195352,
	["128866.143797"] = 209216,
	["128820.143797"] = 194239,
	["128861.143797"] = 206910,
	["128858.143797"] = 202464,
	["127857.143797"] = 187287,
	["128832.143797"] = 212819,

	["128820.143806"] = 194312,
	["128832.143806"] = 207352,
	["128861.143806"] = 197080,
	["127857.143806"] = 187321,
	["128858.143806"] = 202426,
	["128862.143806"] = 195322,
	["128866.143806"] = 209220,

	["128858.143807"] = 202433,
	["127857.143807"] = 187264,
	["128861.143807"] = 197139,
	["128832.143807"] = 207375,
	["128820.143807"] = 210182,
	["128866.143807"] = 209226,
	["128862.143807"] = 195323,

	["128862.144504"] = 195352,
	["128866.144504"] = 209216,
	["128820.144504"] = 194239,
	["128858.144504"] = 202464,
	["127857.144504"] = 187287,
	["128861.144504"] = 206910,
	["128832.144504"] = 212819,

	["128832.144505"] = 207352,
	["128861.144505"] = 197080,
	["127857.144505"] = 187321,
	["128858.144505"] = 202426,
	["128820.144505"] = 194312,
	["128866.144505"] = 209220,
	["128862.144505"] = 195322,

	["128861.144506"] = 197139,
	["128858.144506"] = 202433,
	["127857.144506"] = 187264,
	["128832.144506"] = 207375,
	["128820.144506"] = 210182,
	["128866.144506"] = 209226,
	["128862.144506"] = 195323,

	["128820.145346"] = 194239,
	["128832.145346"] = 212819,
	["128861.145346"] = 206910,
	["127857.145346"] = 187287,
	["128858.145346"] = 202464,
	["128862.145346"] = 195352,
	["128866.145346"] = 209216,

	["128866.145347"] = 209220,
	["128862.145347"] = 195322,
	["128832.145347"] = 207352,
	["128861.145347"] = 197080,
	["128858.145347"] = 202426,
	["127857.145347"] = 187321,
	["128820.145347"] = 194312,

	["128862.145348"] = 195323,
	["128866.145348"] = 209226,
	["128820.145348"] = 210182,
	["128832.145348"] = 207375,
	["128858.145348"] = 202433,
	["127857.145348"] = 187264,
	["128861.145348"] = 197139,

	["128862.150274"] = 195352,
	["128866.150274"] = 209216,
	["128820.150274"] = 194239,
	["128832.150274"] = 212819,
	["128861.150274"] = 206910,
	["128858.150274"] = 202464,
	["127857.150274"] = 187287,

	["128820.150275"] = 194312,
	["128832.150275"] = 207352,
	["127857.150275"] = 187321,
	["128858.150275"] = 202426,
	["128861.150275"] = 197080,
	["128862.150275"] = 195322,
	["128866.150275"] = 209220,

	["128862.150276"] = 195323,
	["128866.150276"] = 209226,
	["128820.150276"] = 210182,
	["128861.150276"] = 197139,
	["128858.150276"] = 202433,
	["127857.150276"] = 187264,
	["128832.150276"] = 207375,

	["128862.150298"] = 195352,
	["128866.150298"] = 209216,
	["128820.150298"] = 194239,
	["128832.150298"] = 212819,
	["128858.150298"] = 202464,
	["127857.150298"] = 187287,
	["128861.150298"] = 206910,

	["128862.150299"] = 195322,
	["128866.150299"] = 209220,
	["128820.150299"] = 194312,
	["128832.150299"] = 207352,
	["128861.150299"] = 197080,
	["128858.150299"] = 202426,
	["127857.150299"] = 187321,

	["128862.150300"] = 195323,
	["128866.150300"] = 209226,
	["128820.150300"] = 210182,
	["128832.150300"] = 207375,
	["128858.150300"] = 202433,
	["127857.150300"] = 187264,
	["128861.150300"] = 197139,

	["128862.150323"] = 195352,
	["128866.150323"] = 209216,
	["128820.150323"] = 194239,
	["128858.150323"] = 202464,
	["127857.150323"] = 187287,
	["128861.150323"] = 206910,
	["128832.150323"] = 212819,

	["128858.150324"] = 202426,
	["127857.150324"] = 187321,
	["128861.150324"] = 197080,
	["128832.150324"] = 207352,
	["128820.150324"] = 194312,
	["128866.150324"] = 209220,
	["128862.150324"] = 195322,

	["128862.150325"] = 195323,
	["128866.150325"] = 209226,
	["128820.150325"] = 210182,
	["128832.150325"] = 207375,
	["128858.150325"] = 202433,
	["127857.150325"] = 187264,
	["128861.150325"] = 197139,

	["128866.153446"] = 209216,
	["128862.153446"] = 195352,
	["128861.153446"] = 206910,
	["127857.153446"] = 187287,
	["128858.153446"] = 202464,
	["128832.153446"] = 212819,
	["128820.153446"] = 194239,

	["128820.153447"] = 194312,
	["128832.153447"] = 207352,
	["127857.153447"] = 187321,
	["128858.153447"] = 202426,
	["128861.153447"] = 197080,
	["128862.153447"] = 195322,
	["128866.153447"] = 209220,

	["128820.153448"] = 210182,
	["128861.153448"] = 197139,
	["127857.153448"] = 187264,
	["128858.153448"] = 202433,
	["128832.153448"] = 207375,
	["128862.153448"] = 195323,
	["128866.153448"] = 209226,

	["128866.135565"] = 209226,
	["128862.135565"] = 195323,
	["128832.135565"] = 207375,
	["128861.135565"] = 197139,
	["128858.135565"] = 202433,
	["127857.135565"] = 187264,
	["128820.135565"] = 210182,

	["128943.151500"] = 211105,
	["128941.151500"] = 196236,
	["128476.151500"] = 197369,
	["127829.151500"] = 201458,
	["128832.151500"] = 212816,

	["128943.151501"] = 211099,
	["128941.151501"] = 196258,
	["128832.151501"] = 212819,
	["127829.151501"] = 201464,
	["128476.151501"] = 197239,

	["128476.151502"] = 197241,
	["128832.151502"] = 212821,
	["127829.151502"] = 201459,
	["128941.151502"] = 196301,
	["128943.151502"] = 211144,

	["127829.154058"] = 201458,
	["128832.154058"] = 212816,
	["128476.154058"] = 197369,
	["128943.154058"] = 211105,
	["128941.154058"] = 196236,

	["128476.154059"] = 197239,
	["127829.154059"] = 201464,
	["128832.154059"] = 212819,
	["128941.154059"] = 196258,
	["128943.154059"] = 211099,

	["128943.154060"] = 211144,
	["128941.154060"] = 196301,
	["128476.154060"] = 197241,
	["128832.154060"] = 212821,
	["127829.154060"] = 201459,

	["127829.154088"] = 201458,
	["128832.154088"] = 212816,
	["128476.154088"] = 197369,
	["128941.154088"] = 196236,
	["128943.154088"] = 211105,

	["128476.154089"] = 197239,
	["128832.154089"] = 212819,
	["127829.154089"] = 201464,
	["128943.154089"] = 211099,
	["128941.154089"] = 196258,

	["128476.154090"] = 197241,
	["127829.154090"] = 201459,
	["128832.154090"] = 212821,
	["128941.154090"] = 196301,
	["128943.154090"] = 211144,

	["128943.155701"] = 211105,
	["128941.155701"] = 196236,
	["127829.155701"] = 201458,
	["128832.155701"] = 212816,
	["128476.155701"] = 197369,

	["128943.155702"] = 211099,
	["128941.155702"] = 196258,
	["128832.155702"] = 212819,
	["127829.155702"] = 201464,
	["128476.155702"] = 197239,

	["128941.155703"] = 196301,
	["128943.155703"] = 211144,
	["128476.155703"] = 197241,
	["128832.155703"] = 212821,
	["127829.155703"] = 201459,

	["128943.155731"] = 211105,
	["128941.155731"] = 196236,
	["128832.155731"] = 212816,
	["127829.155731"] = 201458,
	["128476.155731"] = 197369,

	["128943.155732"] = 211099,
	["128941.155732"] = 196258,
	["128476.155732"] = 197239,
	["128832.155732"] = 212819,
	["127829.155732"] = 201464,

	["128941.155733"] = 196301,
	["128943.155733"] = 211144,
	["128476.155733"] = 197241,
	["127829.155733"] = 201459,
	["128832.155733"] = 212821,

	["128476.140414"] = 197369,
	["128832.140414"] = 212816,
	["127829.140414"] = 201458,
	["128943.140414"] = 211105,
	["128941.140414"] = 196236,

	["127829.140427"] = 201464,
	["128832.140427"] = 212819,
	["128476.140427"] = 197239,
	["128943.140427"] = 211099,
	["128941.140427"] = 196258,

	["128476.140428"] = 197241,
	["128832.140428"] = 212821,
	["127829.140428"] = 201459,
	["128943.140428"] = 211144,
	["128941.140428"] = 196301,

	["127829.143799"] = 201458,
	["128832.143799"] = 212816,
	["128476.143799"] = 197369,
	["128943.143799"] = 211105,
	["128941.143799"] = 196236,

	["128476.143810"] = 197239,
	["128832.143810"] = 212819,
	["127829.143810"] = 201464,
	["128943.143810"] = 211099,
	["128941.143810"] = 196258,

	["128943.143811"] = 211144,
	["128941.143811"] = 196301,
	["128476.143811"] = 197241,
	["127829.143811"] = 201459,
	["128832.143811"] = 212821,

	["128943.144510"] = 211105,
	["128941.144510"] = 196236,
	["127829.144510"] = 201458,
	["128832.144510"] = 212816,
	["128476.144510"] = 197369,

	["128943.144511"] = 211099,
	["128941.144511"] = 196258,
	["127829.144511"] = 201464,
	["128832.144511"] = 212819,
	["128476.144511"] = 197239,

	["128476.144512"] = 197241,
	["128832.144512"] = 212821,
	["127829.144512"] = 201459,
	["128943.144512"] = 211144,
	["128941.144512"] = 196301,

	["128476.145352"] = 197369,
	["128832.145352"] = 212816,
	["127829.145352"] = 201458,
	["128941.145352"] = 196236,
	["128943.145352"] = 211105,

	["128476.145353"] = 197239,
	["127829.145353"] = 201464,
	["128832.145353"] = 212819,
	["128943.145353"] = 211099,
	["128941.145353"] = 196258,

	["127829.145354"] = 201459,
	["128832.145354"] = 212821,
	["128476.145354"] = 197241,
	["128943.145354"] = 211144,
	["128941.145354"] = 196301,

	["127829.150280"] = 201458,
	["128832.150280"] = 212816,
	["128476.150280"] = 197369,
	["128941.150280"] = 196236,
	["128943.150280"] = 211105,

	["128832.150281"] = 212819,
	["127829.150281"] = 201464,
	["128476.150281"] = 197239,
	["128943.150281"] = 211099,
	["128941.150281"] = 196258,

	["128943.150282"] = 211144,
	["128941.150282"] = 196301,
	["128832.150282"] = 212821,
	["127829.150282"] = 201459,
	["128476.150282"] = 197241,

	["128943.150304"] = 211105,
	["128941.150304"] = 196236,
	["128476.150304"] = 197369,
	["128832.150304"] = 212816,
	["127829.150304"] = 201458,

	["128943.150305"] = 211099,
	["128941.150305"] = 196258,
	["128476.150305"] = 197239,
	["128832.150305"] = 212819,
	["127829.150305"] = 201464,

	["128941.150306"] = 196301,
	["128943.150306"] = 211144,
	["128476.150306"] = 197241,
	["127829.150306"] = 201459,
	["128832.150306"] = 212821,

	["128943.150329"] = 211105,
	["128941.150329"] = 196236,
	["128476.150329"] = 197369,
	["127829.150329"] = 201458,
	["128832.150329"] = 212816,

	["128476.150330"] = 197239,
	["128832.150330"] = 212819,
	["127829.150330"] = 201464,
	["128943.150330"] = 211099,
	["128941.150330"] = 196258,

	["128943.150331"] = 211144,
	["128941.150331"] = 196301,
	["127829.150331"] = 201459,
	["128832.150331"] = 212821,
	["128476.150331"] = 197241,

	["128943.153452"] = 211105,
	["128941.153452"] = 196236,
	["127829.153452"] = 201458,
	["128832.153452"] = 212816,
	["128476.153452"] = 197369,

	["128943.153453"] = 211099,
	["128941.153453"] = 196258,
	["128476.153453"] = 197239,
	["128832.153453"] = 212819,
	["127829.153453"] = 201464,

	["128476.153454"] = 197241,
	["127829.153454"] = 201459,
	["128832.153454"] = 212821,
	["128941.153454"] = 196301,
	["128943.153454"] = 211144,

	["128941.135569"] = 196211,
	["128943.135569"] = 211108,
	["128476.135569"] = 197231,
	["127829.135569"] = 201454,
	["128832.135569"] = 207343,

	["128476.151518"] = 197231,
	["127829.151518"] = 201454,
	["128868.151518"] = 197708,
	["128402.151518"] = 192450,
	["128910.151518"] = 209459,
	["128403.151518"] = 191419,
	["128942.151518"] = 199111,
	["128870.151518"] = 192310,
	["128292.151518"] = 189080,
	["128827.151518"] = 194093,
	["128943.151518"] = 211108,

	["128827.151519"] = 193645,
	["128943.151519"] = 211123,
	["128403.151519"] = 191592,
	["128292.151519"] = 189164,
	["128870.151519"] = 192326,
	["128942.151519"] = 199152,
	["128868.151519"] = 197716,
	["128402.151519"] = 192457,
	["128910.151519"] = 216274,
	["128476.151519"] = 197235,
	["127829.151519"] = 201457,

	["128868.151520"] = 197711,
	["128910.151520"] = 209483,
	["128402.151520"] = 192514,
	["128476.151520"] = 197241,
	["127829.151520"] = 201459,
	["128943.151520"] = 211144,
	["128827.151520"] = 193642,
	["128403.151520"] = 191565,
	["128870.151520"] = 192323,
	["128942.151520"] = 199212,
	["128292.151520"] = 189154,

	["128476.154076"] = 197231,
	["127829.154076"] = 201454,
	["128868.154076"] = 197708,
	["128910.154076"] = 209459,
	["128402.154076"] = 192450,
	["128403.154076"] = 191419,
	["128870.154076"] = 192310,
	["128292.154076"] = 189080,
	["128942.154076"] = 199111,
	["128943.154076"] = 211108,
	["128827.154076"] = 194093,

	["128943.154077"] = 211123,
	["128827.154077"] = 193645,
	["128403.154077"] = 191592,
	["128942.154077"] = 199152,
	["128870.154077"] = 192326,
	["128292.154077"] = 189164,
	["128868.154077"] = 197716,
	["128910.154077"] = 216274,
	["128402.154077"] = 192457,
	["128476.154077"] = 197235,
	["127829.154077"] = 201457,

	["128476.154078"] = 197241,
	["127829.154078"] = 201459,
	["128868.154078"] = 197711,
	["128910.154078"] = 209483,
	["128402.154078"] = 192514,
	["128403.154078"] = 191565,
	["128292.154078"] = 189154,
	["128870.154078"] = 192323,
	["128942.154078"] = 199212,
	["128943.154078"] = 211144,
	["128827.154078"] = 193642,

	["128402.154106"] = 192450,
	["128910.154106"] = 209459,
	["128868.154106"] = 197708,
	["127829.154106"] = 201454,
	["128476.154106"] = 197231,
	["128827.154106"] = 194093,
	["128943.154106"] = 211108,
	["128942.154106"] = 199111,
	["128870.154106"] = 192310,
	["128292.154106"] = 189080,
	["128403.154106"] = 191419,

	["127829.154107"] = 201457,
	["128476.154107"] = 197235,
	["128910.154107"] = 216274,
	["128402.154107"] = 192457,
	["128868.154107"] = 197716,
	["128292.154107"] = 189164,
	["128870.154107"] = 192326,
	["128942.154107"] = 199152,
	["128403.154107"] = 191592,
	["128943.154107"] = 211123,
	["128827.154107"] = 193645,

	["128868.154108"] = 197711,
	["128402.154108"] = 192514,
	["128910.154108"] = 209483,
	["128476.154108"] = 197241,
	["127829.154108"] = 201459,
	["128827.154108"] = 193642,
	["128943.154108"] = 211144,
	["128403.154108"] = 191565,
	["128870.154108"] = 192323,
	["128942.154108"] = 199212,
	["128292.154108"] = 189154,

	["128476.155719"] = 197231,
	["127829.155719"] = 201454,
	["128868.155719"] = 197708,
	["128402.155719"] = 192450,
	["128910.155719"] = 209459,
	["128403.155719"] = 191419,
	["128942.155719"] = 199111,
	["128870.155719"] = 192310,
	["128292.155719"] = 189080,
	["128827.155719"] = 194093,
	["128943.155719"] = 211108,

	["128942.155720"] = 199152,
	["128870.155720"] = 192326,
	["128292.155720"] = 189164,
	["128403.155720"] = 191592,
	["128827.155720"] = 193645,
	["128943.155720"] = 211123,
	["127829.155720"] = 201457,
	["128476.155720"] = 197235,
	["128402.155720"] = 192457,
	["128910.155720"] = 216274,
	["128868.155720"] = 197716,

	["128868.155721"] = 197711,
	["128910.155721"] = 209483,
	["128402.155721"] = 192514,
	["128476.155721"] = 197241,
	["127829.155721"] = 201459,
	["128943.155721"] = 211144,
	["128827.155721"] = 193642,
	["128403.155721"] = 191565,
	["128870.155721"] = 192323,
	["128292.155721"] = 189154,
	["128942.155721"] = 199212,

	["128827.155749"] = 194093,
	["128943.155749"] = 211108,
	["128942.155749"] = 199111,
	["128870.155749"] = 192310,
	["128292.155749"] = 189080,
	["128403.155749"] = 191419,
	["128402.155749"] = 192450,
	["128910.155749"] = 209459,
	["128868.155749"] = 197708,
	["127829.155749"] = 201454,
	["128476.155749"] = 197231,

	["128868.155750"] = 197716,
	["128402.155750"] = 192457,
	["128910.155750"] = 216274,
	["128476.155750"] = 197235,
	["127829.155750"] = 201457,
	["128827.155750"] = 193645,
	["128943.155750"] = 211123,
	["128403.155750"] = 191592,
	["128870.155750"] = 192326,
	["128942.155750"] = 199152,
	["128292.155750"] = 189164,

	["128870.155751"] = 192323,
	["128292.155751"] = 189154,
	["128942.155751"] = 199212,
	["128403.155751"] = 191565,
	["128827.155751"] = 193642,
	["128943.155751"] = 211144,
	["127829.155751"] = 201459,
	["128476.155751"] = 197241,
	["128402.155751"] = 192514,
	["128910.155751"] = 209483,
	["128868.155751"] = 197711,

	["128403.140419"] = 191419,
	["128942.140419"] = 199111,
	["128870.140419"] = 192310,
	["128292.140419"] = 189080,
	["128943.140419"] = 211108,
	["128827.140419"] = 194093,
	["128476.140419"] = 197231,
	["127829.140419"] = 201454,
	["128868.140419"] = 197708,
	["128910.140419"] = 209459,
	["128402.140419"] = 192450,

	["128910.140440"] = 216274,
	["128402.140440"] = 192457,
	["128868.140440"] = 197716,
	["127829.140440"] = 201457,
	["128476.140440"] = 197235,
	["128943.140440"] = 211123,
	["128827.140440"] = 193645,
	["128870.140440"] = 192326,
	["128942.140440"] = 199152,
	["128292.140440"] = 189164,
	["128403.140440"] = 191592,

	["128827.140441"] = 193642,
	["128943.140441"] = 211144,
	["128403.140441"] = 191565,
	["128870.140441"] = 192323,
	["128942.140441"] = 199212,
	["128292.140441"] = 189154,
	["128868.140441"] = 197711,
	["128402.140441"] = 192514,
	["128910.140441"] = 209483,
	["128476.140441"] = 197241,
	["127829.140441"] = 201459,

	["128402.143804"] = 192450,
	["128910.143804"] = 209459,
	["128868.143804"] = 197708,
	["127829.143804"] = 201454,
	["128476.143804"] = 197231,
	["128827.143804"] = 194093,
	["128943.143804"] = 211108,
	["128292.143804"] = 189080,
	["128870.143804"] = 192310,
	["128942.143804"] = 199111,
	["128403.143804"] = 191419,

	["127829.143822"] = 201457,
	["128476.143822"] = 197235,
	["128402.143822"] = 192457,
	["128910.143822"] = 216274,
	["128868.143822"] = 197716,
	["128942.143822"] = 199152,
	["128870.143822"] = 192326,
	["128292.143822"] = 189164,
	["128403.143822"] = 191592,
	["128827.143822"] = 193645,
	["128943.143822"] = 211123,

	["128292.143823"] = 189154,
	["128870.143823"] = 192323,
	["128942.143823"] = 199212,
	["128403.143823"] = 191565,
	["128827.143823"] = 193642,
	["128943.143823"] = 211144,
	["127829.143823"] = 201459,
	["128476.143823"] = 197241,
	["128402.143823"] = 192514,
	["128910.143823"] = 209483,
	["128868.143823"] = 197711,

	["128292.144528"] = 189080,
	["128870.144528"] = 192310,
	["128942.144528"] = 199111,
	["128403.144528"] = 191419,
	["128943.144528"] = 211108,
	["128827.144528"] = 194093,
	["127829.144528"] = 201454,
	["128476.144528"] = 197231,
	["128910.144528"] = 209459,
	["128402.144528"] = 192450,
	["128868.144528"] = 197708,

	["128868.144529"] = 197716,
	["128910.144529"] = 216274,
	["128402.144529"] = 192457,
	["128476.144529"] = 197235,
	["127829.144529"] = 201457,
	["128943.144529"] = 211123,
	["128827.144529"] = 193645,
	["128403.144529"] = 191592,
	["128870.144529"] = 192326,
	["128292.144529"] = 189164,
	["128942.144529"] = 199152,

	["128403.144530"] = 191565,
	["128870.144530"] = 192323,
	["128942.144530"] = 199212,
	["128292.144530"] = 189154,
	["128827.144530"] = 193642,
	["128943.144530"] = 211144,
	["128476.144530"] = 197241,
	["127829.144530"] = 201459,
	["128868.144530"] = 197711,
	["128402.144530"] = 192514,
	["128910.144530"] = 209483,

	["128292.145370"] = 189080,
	["128870.145370"] = 192310,
	["128942.145370"] = 199111,
	["128403.145370"] = 191419,
	["128827.145370"] = 194093,
	["128943.145370"] = 211108,
	["127829.145370"] = 201454,
	["128476.145370"] = 197231,
	["128402.145370"] = 192450,
	["128910.145370"] = 209459,
	["128868.145370"] = 197708,

	["127829.145371"] = 201457,
	["128476.145371"] = 197235,
	["128402.145371"] = 192457,
	["128910.145371"] = 216274,
	["128868.145371"] = 197716,
	["128870.145371"] = 192326,
	["128292.145371"] = 189164,
	["128942.145371"] = 199152,
	["128403.145371"] = 191592,
	["128827.145371"] = 193645,
	["128943.145371"] = 211123,

	["128402.145372"] = 192514,
	["128910.145372"] = 209483,
	["128868.145372"] = 197711,
	["127829.145372"] = 201459,
	["128476.145372"] = 197241,
	["128827.145372"] = 193642,
	["128943.145372"] = 211144,
	["128870.145372"] = 192323,
	["128942.145372"] = 199212,
	["128292.145372"] = 189154,
	["128403.145372"] = 191565,

	["128827.150348"] = 194093,
	["128943.150348"] = 211108,
	["128292.150348"] = 189080,
	["128870.150348"] = 192310,
	["128942.150348"] = 199111,
	["128403.150348"] = 191419,
	["128402.150348"] = 192450,
	["128910.150348"] = 209459,
	["128868.150348"] = 197708,
	["127829.150348"] = 201454,
	["128476.150348"] = 197231,

	["128476.150349"] = 197235,
	["127829.150349"] = 201457,
	["128868.150349"] = 197716,
	["128402.150349"] = 192457,
	["128910.150349"] = 216274,
	["128403.150349"] = 191592,
	["128942.150349"] = 199152,
	["128870.150349"] = 192326,
	["128292.150349"] = 189164,
	["128827.150349"] = 193645,
	["128943.150349"] = 211123,

	["128403.150350"] = 191565,
	["128942.150350"] = 199212,
	["128870.150350"] = 192323,
	["128292.150350"] = 189154,
	["128827.150350"] = 193642,
	["128943.150350"] = 211144,
	["128476.150350"] = 197241,
	["127829.150350"] = 201459,
	["128868.150350"] = 197711,
	["128402.150350"] = 192514,
	["128910.150350"] = 209483,

	["127829.150354"] = 201454,
	["128476.150354"] = 197231,
	["128910.150354"] = 209459,
	["128402.150354"] = 192450,
	["128868.150354"] = 197708,
	["128870.150354"] = 192310,
	["128292.150354"] = 189080,
	["128942.150354"] = 199111,
	["128403.150354"] = 191419,
	["128943.150354"] = 211108,
	["128827.150354"] = 194093,

	["128943.150355"] = 211123,
	["128827.150355"] = 193645,
	["128403.150355"] = 191592,
	["128292.150355"] = 189164,
	["128870.150355"] = 192326,
	["128942.150355"] = 199152,
	["128868.150355"] = 197716,
	["128910.150355"] = 216274,
	["128402.150355"] = 192457,
	["128476.150355"] = 197235,
	["127829.150355"] = 201457,

	["128403.150356"] = 191565,
	["128942.150356"] = 199212,
	["128870.150356"] = 192323,
	["128292.150356"] = 189154,
	["128943.150356"] = 211144,
	["128827.150356"] = 193642,
	["128476.150356"] = 197241,
	["127829.150356"] = 201459,
	["128868.150356"] = 197711,
	["128910.150356"] = 209483,
	["128402.150356"] = 192514,

	["128868.150360"] = 197708,
	["128910.150360"] = 209459,
	["128402.150360"] = 192450,
	["128476.150360"] = 197231,
	["127829.150360"] = 201454,
	["128943.150360"] = 211108,
	["128827.150360"] = 194093,
	["128403.150360"] = 191419,
	["128292.150360"] = 189080,
	["128870.150360"] = 192310,
	["128942.150360"] = 199111,

	["128868.150361"] = 197716,
	["128402.150361"] = 192457,
	["128910.150361"] = 216274,
	["128476.150361"] = 197235,
	["127829.150361"] = 201457,
	["128827.150361"] = 193645,
	["128943.150361"] = 211123,
	["128403.150361"] = 191592,
	["128870.150361"] = 192326,
	["128942.150361"] = 199152,
	["128292.150361"] = 189164,

	["128910.150362"] = 209483,
	["128402.150362"] = 192514,
	["128868.150362"] = 197711,
	["127829.150362"] = 201459,
	["128476.150362"] = 197241,
	["128943.150362"] = 211144,
	["128827.150362"] = 193642,
	["128870.150362"] = 192323,
	["128942.150362"] = 199212,
	["128292.150362"] = 189154,
	["128403.150362"] = 191565,

	["128403.153470"] = 191419,
	["128870.153470"] = 192310,
	["128942.153470"] = 199111,
	["128292.153470"] = 189080,
	["128943.153470"] = 211108,
	["128827.153470"] = 194093,
	["128476.153470"] = 197231,
	["127829.153470"] = 201454,
	["128868.153470"] = 197708,
	["128910.153470"] = 209459,
	["128402.153470"] = 192450,

	["128870.153471"] = 192326,
	["128942.153471"] = 199152,
	["128292.153471"] = 189164,
	["128403.153471"] = 191592,
	["128943.153471"] = 211123,
	["128827.153471"] = 193645,
	["127829.153471"] = 201457,
	["128476.153471"] = 197235,
	["128910.153471"] = 216274,
	["128402.153471"] = 192457,
	["128868.153471"] = 197716,

	["128402.153472"] = 192514,
	["128910.153472"] = 209483,
	["128868.153472"] = 197711,
	["127829.153472"] = 201459,
	["128476.153472"] = 197241,
	["128827.153472"] = 193642,
	["128943.153472"] = 211144,
	["128870.153472"] = 192323,
	["128292.153472"] = 189154,
	["128942.153472"] = 199212,
	["128403.153472"] = 191565,

	["128403.135576"] = 191485,
	["128870.135576"] = 192318,
	["128292.135576"] = 189086,
	["128942.135576"] = 199120,
	["128827.135576"] = 193644,
	["128943.135576"] = 211106,
	["128476.135576"] = 197234,
	["127829.135576"] = 201456,
	["128868.135576"] = 197715,
	["128402.135576"] = 192447,
	["128910.135576"] = 209472,

	["128826.151497"] = 190449,
	["128827.151497"] = 194093,
	["128872.151497"] = 216230,
	["128942.151497"] = 199111,
	["128870.151497"] = 192310,
	["128808.151497"] = 203566,
	["128289.151497"] = 188635,
	["128403.151497"] = 191419,
	["128402.151497"] = 192450,
	["128910.151497"] = 209459,
	["128860.151497"] = 210570,
	["128821.151497"] = 200395,

	["128942.151498"] = 199153,
	["128870.151498"] = 192329,
	["128808.151498"] = 203669,
	["128403.151498"] = 191494,
	["128289.151498"] = 203225,
	["128826.151498"] = 190520,
	["128827.151498"] = 194007,
	["128872.151498"] = 202524,
	["128860.151498"] = 210593,
	["128821.151498"] = 200409,
	["128402.151498"] = 192460,
	["128910.151498"] = 209481,

	["128826.151499"] = 190529,
	["128872.151499"] = 202530,
	["128827.151499"] = 194016,
	["128808.151499"] = 203670,
	["128942.151499"] = 199158,
	["128870.151499"] = 192349,
	["128403.151499"] = 191488,
	["128289.151499"] = 203227,
	["128910.151499"] = 248579,
	["128402.151499"] = 192542,
	["128860.151499"] = 210637,
	["128821.151499"] = 200414,

	["128826.154055"] = 190449,
	["128872.154055"] = 216230,
	["128827.154055"] = 194093,
	["128808.154055"] = 203566,
	["128942.154055"] = 199111,
	["128870.154055"] = 192310,
	["128289.154055"] = 188635,
	["128403.154055"] = 191419,
	["128910.154055"] = 209459,
	["128402.154055"] = 192450,
	["128860.154055"] = 210570,
	["128821.154055"] = 200395,

	["128821.154056"] = 200409,
	["128860.154056"] = 210593,
	["128402.154056"] = 192460,
	["128910.154056"] = 209481,
	["128403.154056"] = 191494,
	["128289.154056"] = 203225,
	["128870.154056"] = 192329,
	["128942.154056"] = 199153,
	["128808.154056"] = 203669,
	["128827.154056"] = 194007,
	["128872.154056"] = 202524,
	["128826.154056"] = 190520,

	["128910.154057"] = 248579,
	["128402.154057"] = 192542,
	["128860.154057"] = 210637,
	["128821.154057"] = 200414,
	["128826.154057"] = 190529,
	["128872.154057"] = 202530,
	["128827.154057"] = 194016,
	["128808.154057"] = 203670,
	["128942.154057"] = 199158,
	["128870.154057"] = 192349,
	["128403.154057"] = 191488,
	["128289.154057"] = 203227,

	["128402.154085"] = 192450,
	["128910.154085"] = 209459,
	["128821.154085"] = 200395,
	["128860.154085"] = 210570,
	["128827.154085"] = 194093,
	["128872.154085"] = 216230,
	["128826.154085"] = 190449,
	["128289.154085"] = 188635,
	["128403.154085"] = 191419,
	["128870.154085"] = 192310,
	["128942.154085"] = 199111,
	["128808.154085"] = 203566,

	["128826.154086"] = 190520,
	["128872.154086"] = 202524,
	["128827.154086"] = 194007,
	["128808.154086"] = 203669,
	["128942.154086"] = 199153,
	["128870.154086"] = 192329,
	["128403.154086"] = 191494,
	["128289.154086"] = 203225,
	["128910.154086"] = 209481,
	["128402.154086"] = 192460,
	["128860.154086"] = 210593,
	["128821.154086"] = 200409,

	["128860.154087"] = 210637,
	["128821.154087"] = 200414,
	["128910.154087"] = 248579,
	["128402.154087"] = 192542,
	["128808.154087"] = 203670,
	["128942.154087"] = 199158,
	["128870.154087"] = 192349,
	["128403.154087"] = 191488,
	["128289.154087"] = 203227,
	["128826.154087"] = 190529,
	["128872.154087"] = 202530,
	["128827.154087"] = 194016,

	["128826.155698"] = 190449,
	["128872.155698"] = 216230,
	["128827.155698"] = 194093,
	["128808.155698"] = 203566,
	["128942.155698"] = 199111,
	["128870.155698"] = 192310,
	["128289.155698"] = 188635,
	["128403.155698"] = 191419,
	["128910.155698"] = 209459,
	["128402.155698"] = 192450,
	["128860.155698"] = 210570,
	["128821.155698"] = 200395,

	["128821.155699"] = 200409,
	["128860.155699"] = 210593,
	["128402.155699"] = 192460,
	["128910.155699"] = 209481,
	["128289.155699"] = 203225,
	["128403.155699"] = 191494,
	["128870.155699"] = 192329,
	["128942.155699"] = 199153,
	["128808.155699"] = 203669,
	["128827.155699"] = 194007,
	["128872.155699"] = 202524,
	["128826.155699"] = 190520,

	["128910.155700"] = 248579,
	["128402.155700"] = 192542,
	["128860.155700"] = 210637,
	["128821.155700"] = 200414,
	["128826.155700"] = 190529,
	["128872.155700"] = 202530,
	["128827.155700"] = 194016,
	["128808.155700"] = 203670,
	["128942.155700"] = 199158,
	["128870.155700"] = 192349,
	["128289.155700"] = 203227,
	["128403.155700"] = 191488,

	["128942.155728"] = 199111,
	["128870.155728"] = 192310,
	["128808.155728"] = 203566,
	["128289.155728"] = 188635,
	["128403.155728"] = 191419,
	["128826.155728"] = 190449,
	["128827.155728"] = 194093,
	["128872.155728"] = 216230,
	["128860.155728"] = 210570,
	["128821.155728"] = 200395,
	["128402.155728"] = 192450,
	["128910.155728"] = 209459,

	["128827.155729"] = 194007,
	["128872.155729"] = 202524,
	["128826.155729"] = 190520,
	["128403.155729"] = 191494,
	["128289.155729"] = 203225,
	["128870.155729"] = 192329,
	["128942.155729"] = 199153,
	["128808.155729"] = 203669,
	["128402.155729"] = 192460,
	["128910.155729"] = 209481,
	["128821.155729"] = 200409,
	["128860.155729"] = 210593,

	["128808.155730"] = 203670,
	["128942.155730"] = 199158,
	["128870.155730"] = 192349,
	["128403.155730"] = 191488,
	["128289.155730"] = 203227,
	["128826.155730"] = 190529,
	["128872.155730"] = 202530,
	["128827.155730"] = 194016,
	["128860.155730"] = 210637,
	["128821.155730"] = 200414,
	["128910.155730"] = 248579,
	["128402.155730"] = 192542,

	["128403.140413"] = 191419,
	["128289.140413"] = 188635,
	["128870.140413"] = 192310,
	["128942.140413"] = 199111,
	["128808.140413"] = 203566,
	["128827.140413"] = 194093,
	["128872.140413"] = 216230,
	["128826.140413"] = 190449,
	["128821.140413"] = 200395,
	["128860.140413"] = 210570,
	["128402.140413"] = 192450,
	["128910.140413"] = 209459,

	["128402.140425"] = 192460,
	["128910.140425"] = 209481,
	["128860.140425"] = 210593,
	["128821.140425"] = 200409,
	["128826.140425"] = 190520,
	["128827.140425"] = 194007,
	["128872.140425"] = 202524,
	["128942.140425"] = 199153,
	["128870.140425"] = 192329,
	["128808.140425"] = 203669,
	["128289.140425"] = 203225,
	["128403.140425"] = 191494,

	["128872.140426"] = 202530,
	["128827.140426"] = 194016,
	["128826.140426"] = 190529,
	["128289.140426"] = 203227,
	["128403.140426"] = 191488,
	["128808.140426"] = 203670,
	["128870.140426"] = 192349,
	["128942.140426"] = 199158,
	["128910.140426"] = 248579,
	["128402.140426"] = 192542,
	["128821.140426"] = 200414,
	["128860.140426"] = 210637,

	["128403.143798"] = 191419,
	["128289.143798"] = 188635,
	["128808.143798"] = 203566,
	["128870.143798"] = 192310,
	["128942.143798"] = 199111,
	["128872.143798"] = 216230,
	["128827.143798"] = 194093,
	["128826.143798"] = 190449,
	["128821.143798"] = 200395,
	["128860.143798"] = 210570,
	["128910.143798"] = 209459,
	["128402.143798"] = 192450,

	["128910.143808"] = 209481,
	["128402.143808"] = 192460,
	["128860.143808"] = 210593,
	["128821.143808"] = 200409,
	["128826.143808"] = 190520,
	["128872.143808"] = 202524,
	["128827.143808"] = 194007,
	["128808.143808"] = 203669,
	["128942.143808"] = 199153,
	["128870.143808"] = 192329,
	["128289.143808"] = 203225,
	["128403.143808"] = 191494,

	["128872.143809"] = 202530,
	["128827.143809"] = 194016,
	["128826.143809"] = 190529,
	["128289.143809"] = 203227,
	["128403.143809"] = 191488,
	["128808.143809"] = 203670,
	["128870.143809"] = 192349,
	["128942.143809"] = 199158,
	["128910.143809"] = 248579,
	["128402.143809"] = 192542,
	["128821.143809"] = 200414,
	["128860.143809"] = 210637,

	["128403.144507"] = 191419,
	["128289.144507"] = 188635,
	["128870.144507"] = 192310,
	["128942.144507"] = 199111,
	["128808.144507"] = 203566,
	["128827.144507"] = 194093,
	["128872.144507"] = 216230,
	["128826.144507"] = 190449,
	["128821.144507"] = 200395,
	["128860.144507"] = 210570,
	["128402.144507"] = 192450,
	["128910.144507"] = 209459,

	["128821.144508"] = 200409,
	["128860.144508"] = 210593,
	["128910.144508"] = 209481,
	["128402.144508"] = 192460,
	["128289.144508"] = 203225,
	["128403.144508"] = 191494,
	["128808.144508"] = 203669,
	["128870.144508"] = 192329,
	["128942.144508"] = 199153,
	["128872.144508"] = 202524,
	["128827.144508"] = 194007,
	["128826.144508"] = 190520,

	["128402.144509"] = 192542,
	["128910.144509"] = 248579,
	["128860.144509"] = 210637,
	["128821.144509"] = 200414,
	["128826.144509"] = 190529,
	["128827.144509"] = 194016,
	["128872.144509"] = 202530,
	["128942.144509"] = 199158,
	["128870.144509"] = 192349,
	["128808.144509"] = 203670,
	["128403.144509"] = 191488,
	["128289.144509"] = 203227,

	["128910.145349"] = 209459,
	["128402.145349"] = 192450,
	["128860.145349"] = 210570,
	["128821.145349"] = 200395,
	["128826.145349"] = 190449,
	["128872.145349"] = 216230,
	["128827.145349"] = 194093,
	["128808.145349"] = 203566,
	["128942.145349"] = 199111,
	["128870.145349"] = 192310,
	["128289.145349"] = 188635,
	["128403.145349"] = 191419,

	["128403.145350"] = 191494,
	["128289.145350"] = 203225,
	["128808.145350"] = 203669,
	["128870.145350"] = 192329,
	["128942.145350"] = 199153,
	["128872.145350"] = 202524,
	["128827.145350"] = 194007,
	["128826.145350"] = 190520,
	["128821.145350"] = 200409,
	["128860.145350"] = 210593,
	["128910.145350"] = 209481,
	["128402.145350"] = 192460,

	["128910.145351"] = 248579,
	["128402.145351"] = 192542,
	["128821.145351"] = 200414,
	["128860.145351"] = 210637,
	["128872.145351"] = 202530,
	["128827.145351"] = 194016,
	["128826.145351"] = 190529,
	["128403.145351"] = 191488,
	["128289.145351"] = 203227,
	["128808.145351"] = 203670,
	["128870.145351"] = 192349,
	["128942.145351"] = 199158,

	["128808.150277"] = 203566,
	["128942.150277"] = 199111,
	["128870.150277"] = 192310,
	["128403.150277"] = 191419,
	["128289.150277"] = 188635,
	["128826.150277"] = 190449,
	["128872.150277"] = 216230,
	["128827.150277"] = 194093,
	["128860.150277"] = 210570,
	["128821.150277"] = 200395,
	["128910.150277"] = 209459,
	["128402.150277"] = 192450,

	["128910.150278"] = 209481,
	["128402.150278"] = 192460,
	["128821.150278"] = 200409,
	["128860.150278"] = 210593,
	["128872.150278"] = 202524,
	["128827.150278"] = 194007,
	["128826.150278"] = 190520,
	["128289.150278"] = 203225,
	["128403.150278"] = 191494,
	["128808.150278"] = 203669,
	["128870.150278"] = 192329,
	["128942.150278"] = 199153,

	["128827.150279"] = 194016,
	["128872.150279"] = 202530,
	["128826.150279"] = 190529,
	["128289.150279"] = 203227,
	["128403.150279"] = 191488,
	["128870.150279"] = 192349,
	["128942.150279"] = 199158,
	["128808.150279"] = 203670,
	["128402.150279"] = 192542,
	["128910.150279"] = 248579,
	["128821.150279"] = 200414,
	["128860.150279"] = 210637,

	["128827.150301"] = 194093,
	["128872.150301"] = 216230,
	["128826.150301"] = 190449,
	["128289.150301"] = 188635,
	["128403.150301"] = 191419,
	["128870.150301"] = 192310,
	["128942.150301"] = 199111,
	["128808.150301"] = 203566,
	["128402.150301"] = 192450,
	["128910.150301"] = 209459,
	["128821.150301"] = 200395,
	["128860.150301"] = 210570,

	["128403.150302"] = 191494,
	["128289.150302"] = 203225,
	["128870.150302"] = 192329,
	["128942.150302"] = 199153,
	["128808.150302"] = 203669,
	["128827.150302"] = 194007,
	["128872.150302"] = 202524,
	["128826.150302"] = 190520,
	["128821.150302"] = 200409,
	["128860.150302"] = 210593,
	["128402.150302"] = 192460,
	["128910.150302"] = 209481,

	["128860.150303"] = 210637,
	["128821.150303"] = 200414,
	["128402.150303"] = 192542,
	["128910.150303"] = 248579,
	["128942.150303"] = 199158,
	["128870.150303"] = 192349,
	["128808.150303"] = 203670,
	["128289.150303"] = 203227,
	["128403.150303"] = 191488,
	["128826.150303"] = 190529,
	["128827.150303"] = 194016,
	["128872.150303"] = 202530,

	["128403.150326"] = 191419,
	["128289.150326"] = 188635,
	["128808.150326"] = 203566,
	["128870.150326"] = 192310,
	["128942.150326"] = 199111,
	["128872.150326"] = 216230,
	["128827.150326"] = 194093,
	["128826.150326"] = 190449,
	["128821.150326"] = 200395,
	["128860.150326"] = 210570,
	["128910.150326"] = 209459,
	["128402.150326"] = 192450,

	["128402.150327"] = 192460,
	["128910.150327"] = 209481,
	["128860.150327"] = 210593,
	["128821.150327"] = 200409,
	["128826.150327"] = 190520,
	["128827.150327"] = 194007,
	["128872.150327"] = 202524,
	["128942.150327"] = 199153,
	["128870.150327"] = 192329,
	["128808.150327"] = 203669,
	["128289.150327"] = 203225,
	["128403.150327"] = 191494,

	["128827.150328"] = 194016,
	["128872.150328"] = 202530,
	["128826.150328"] = 190529,
	["128403.150328"] = 191488,
	["128289.150328"] = 203227,
	["128870.150328"] = 192349,
	["128942.150328"] = 199158,
	["128808.150328"] = 203670,
	["128402.150328"] = 192542,
	["128910.150328"] = 248579,
	["128821.150328"] = 200414,
	["128860.150328"] = 210637,

	["128402.153449"] = 192450,
	["128910.153449"] = 209459,
	["128860.153449"] = 210570,
	["128821.153449"] = 200395,
	["128826.153449"] = 190449,
	["128827.153449"] = 194093,
	["128872.153449"] = 216230,
	["128942.153449"] = 199111,
	["128870.153449"] = 192310,
	["128808.153449"] = 203566,
	["128289.153449"] = 188635,
	["128403.153449"] = 191419,

	["128821.153450"] = 200409,
	["128860.153450"] = 210593,
	["128910.153450"] = 209481,
	["128402.153450"] = 192460,
	["128289.153450"] = 203225,
	["128403.153450"] = 191494,
	["128808.153450"] = 203669,
	["128870.153450"] = 192329,
	["128942.153450"] = 199153,
	["128872.153450"] = 202524,
	["128827.153450"] = 194007,
	["128826.153450"] = 190520,

	["128827.153451"] = 194016,
	["128872.153451"] = 202530,
	["128826.153451"] = 190529,
	["128403.153451"] = 191488,
	["128289.153451"] = 203227,
	["128870.153451"] = 192349,
	["128942.153451"] = 199158,
	["128808.153451"] = 203670,
	["128402.153451"] = 192542,
	["128910.153451"] = 248579,
	["128821.153451"] = 200414,
	["128860.153451"] = 210637,

	["128860.135568"] = 210571,
	["128821.135568"] = 200399,
	["128402.135568"] = 192453,
	["128910.135568"] = 209462,
	["128942.135568"] = 199112,
	["128870.135568"] = 192315,
	["128808.135568"] = 203577,
	["128289.135568"] = 216272,
	["128403.135568"] = 191442,
	["128826.135568"] = 190457,
	["128827.135568"] = 193643,
	["128872.135568"] = 202507,

	["128402.151512"] = 192447,
	["128910.151512"] = 209472,
	["128940.151512"] = 218607,
	["128861.151512"] = 197080,
	["128832.151512"] = 207352,
	["128819.151512"] = 198247,
	["128872.151512"] = 202514,
	["128289.151512"] = 188683,
	["128938.151512"] = 213180,
	["128908.151512"] = 200849,
	["128870.151512"] = 192318,
	["128808.151512"] = 203578,
	["128866.151512"] = 209220,

	["128819.151513"] = 198349,
	["128872.151513"] = 202530,
	["128289.151513"] = 203227,
	["128938.151513"] = 213133,
	["128908.151513"] = 200860,
	["128870.151513"] = 192349,
	["128808.151513"] = 203670,
	["128866.151513"] = 209218,
	["128402.151513"] = 192542,
	["128940.151513"] = 195291,
	["128910.151513"] = 248579,
	["128861.151513"] = 197162,
	["128832.151513"] = 212817,

	["128832.151514"] = 212821,
	["128861.151514"] = 197160,
	["128402.151514"] = 192514,
	["128940.151514"] = 195244,
	["128910.151514"] = 209483,
	["128870.151514"] = 192323,
	["128866.151514"] = 209224,
	["128808.151514"] = 224764,
	["128289.151514"] = 188632,
	["128938.151514"] = 213047,
	["128908.151514"] = 200857,
	["128819.151514"] = 198296,
	["128872.151514"] = 202521,

	["128940.154070"] = 218607,
	["128910.154070"] = 209472,
	["128402.154070"] = 192447,
	["128861.154070"] = 197080,
	["128832.154070"] = 207352,
	["128872.154070"] = 202514,
	["128819.154070"] = 198247,
	["128908.154070"] = 200849,
	["128289.154070"] = 188683,
	["128938.154070"] = 213180,
	["128808.154070"] = 203578,
	["128866.154070"] = 209220,
	["128870.154070"] = 192318,

	["128402.154071"] = 192542,
	["128910.154071"] = 248579,
	["128940.154071"] = 195291,
	["128861.154071"] = 197162,
	["128832.154071"] = 212817,
	["128819.154071"] = 198349,
	["128872.154071"] = 202530,
	["128289.154071"] = 203227,
	["128938.154071"] = 213133,
	["128908.154071"] = 200860,
	["128870.154071"] = 192349,
	["128808.154071"] = 203670,
	["128866.154071"] = 209218,

	["128870.154072"] = 192323,
	["128866.154072"] = 209224,
	["128808.154072"] = 224764,
	["128289.154072"] = 188632,
	["128938.154072"] = 213047,
	["128908.154072"] = 200857,
	["128819.154072"] = 198296,
	["128872.154072"] = 202521,
	["128832.154072"] = 212821,
	["128861.154072"] = 197160,
	["128402.154072"] = 192514,
	["128910.154072"] = 209483,
	["128940.154072"] = 195244,

	["128832.154100"] = 207352,
	["128861.154100"] = 197080,
	["128402.154100"] = 192447,
	["128910.154100"] = 209472,
	["128940.154100"] = 218607,
	["128870.154100"] = 192318,
	["128808.154100"] = 203578,
	["128866.154100"] = 209220,
	["128289.154100"] = 188683,
	["128938.154100"] = 213180,
	["128908.154100"] = 200849,
	["128819.154100"] = 198247,
	["128872.154100"] = 202514,

	["128870.154101"] = 192349,
	["128808.154101"] = 203670,
	["128866.154101"] = 209218,
	["128289.154101"] = 203227,
	["128938.154101"] = 213133,
	["128908.154101"] = 200860,
	["128819.154101"] = 198349,
	["128872.154101"] = 202530,
	["128832.154101"] = 212817,
	["128861.154101"] = 197162,
	["128402.154101"] = 192542,
	["128940.154101"] = 195291,
	["128910.154101"] = 248579,

	["128819.154102"] = 198296,
	["128872.154102"] = 202521,
	["128870.154102"] = 192323,
	["128808.154102"] = 224764,
	["128866.154102"] = 209224,
	["128938.154102"] = 213047,
	["128289.154102"] = 188632,
	["128908.154102"] = 200857,
	["128402.154102"] = 192514,
	["128910.154102"] = 209483,
	["128940.154102"] = 195244,
	["128832.154102"] = 212821,
	["128861.154102"] = 197160,

	["128872.155713"] = 202514,
	["128819.155713"] = 198247,
	["128908.155713"] = 200849,
	["128289.155713"] = 188683,
	["128938.155713"] = 213180,
	["128808.155713"] = 203578,
	["128866.155713"] = 209220,
	["128870.155713"] = 192318,
	["128940.155713"] = 218607,
	["128910.155713"] = 209472,
	["128402.155713"] = 192447,
	["128861.155713"] = 197080,
	["128832.155713"] = 207352,

	["128870.155714"] = 192349,
	["128866.155714"] = 209218,
	["128808.155714"] = 203670,
	["128289.155714"] = 203227,
	["128938.155714"] = 213133,
	["128908.155714"] = 200860,
	["128819.155714"] = 198349,
	["128872.155714"] = 202530,
	["128832.155714"] = 212817,
	["128861.155714"] = 197162,
	["128402.155714"] = 192542,
	["128910.155714"] = 248579,
	["128940.155714"] = 195291,

	["128832.155715"] = 212821,
	["128861.155715"] = 197160,
	["128402.155715"] = 192514,
	["128940.155715"] = 195244,
	["128910.155715"] = 209483,
	["128870.155715"] = 192323,
	["128866.155715"] = 209224,
	["128808.155715"] = 224764,
	["128289.155715"] = 188632,
	["128938.155715"] = 213047,
	["128908.155715"] = 200857,
	["128819.155715"] = 198296,
	["128872.155715"] = 202521,

	["128861.155743"] = 197080,
	["128832.155743"] = 207352,
	["128402.155743"] = 192447,
	["128910.155743"] = 209472,
	["128940.155743"] = 218607,
	["128938.155743"] = 213180,
	["128289.155743"] = 188683,
	["128908.155743"] = 200849,
	["128870.155743"] = 192318,
	["128866.155743"] = 209220,
	["128808.155743"] = 203578,
	["128819.155743"] = 198247,
	["128872.155743"] = 202514,

	["128402.155744"] = 192542,
	["128910.155744"] = 248579,
	["128940.155744"] = 195291,
	["128861.155744"] = 197162,
	["128832.155744"] = 212817,
	["128819.155744"] = 198349,
	["128872.155744"] = 202530,
	["128289.155744"] = 203227,
	["128938.155744"] = 213133,
	["128908.155744"] = 200860,
	["128870.155744"] = 192349,
	["128866.155744"] = 209218,
	["128808.155744"] = 203670,

	["128940.155745"] = 195244,
	["128910.155745"] = 209483,
	["128402.155745"] = 192514,
	["128861.155745"] = 197160,
	["128832.155745"] = 212821,
	["128872.155745"] = 202521,
	["128819.155745"] = 198296,
	["128908.155745"] = 200857,
	["128289.155745"] = 188632,
	["128938.155745"] = 213047,
	["128808.155745"] = 224764,
	["128866.155745"] = 209224,
	["128870.155745"] = 192323,

	["128908.140417"] = 200849,
	["128938.140417"] = 213180,
	["128289.140417"] = 188683,
	["128808.140417"] = 203578,
	["128866.140417"] = 209220,
	["128870.140417"] = 192318,
	["128872.140417"] = 202514,
	["128819.140417"] = 198247,
	["128861.140417"] = 197080,
	["128832.140417"] = 207352,
	["128910.140417"] = 209472,
	["128940.140417"] = 218607,
	["128402.140417"] = 192447,

	["128866.140435"] = 209218,
	["128808.140435"] = 203670,
	["128870.140435"] = 192349,
	["128908.140435"] = 200860,
	["128289.140435"] = 203227,
	["128938.140435"] = 213133,
	["128872.140435"] = 202530,
	["128819.140435"] = 198349,
	["128832.140435"] = 212817,
	["128861.140435"] = 197162,
	["128940.140435"] = 195291,
	["128910.140435"] = 248579,
	["128402.140435"] = 192542,

	["128866.140436"] = 209224,
	["128808.140436"] = 224764,
	["128870.140436"] = 192323,
	["128908.140436"] = 200857,
	["128289.140436"] = 188632,
	["128938.140436"] = 213047,
	["128872.140436"] = 202521,
	["128819.140436"] = 198296,
	["128832.140436"] = 212821,
	["128861.140436"] = 197160,
	["128940.140436"] = 195244,
	["128910.140436"] = 209483,
	["128402.140436"] = 192514,

	["128402.143802"] = 192447,
	["128910.143802"] = 209472,
	["128940.143802"] = 218607,
	["128861.143802"] = 197080,
	["128832.143802"] = 207352,
	["128819.143802"] = 198247,
	["128872.143802"] = 202514,
	["128289.143802"] = 188683,
	["128938.143802"] = 213180,
	["128908.143802"] = 200849,
	["128870.143802"] = 192318,
	["128808.143802"] = 203578,
	["128866.143802"] = 209220,

	["128872.143818"] = 202530,
	["128819.143818"] = 198349,
	["128908.143818"] = 200860,
	["128289.143818"] = 203227,
	["128938.143818"] = 213133,
	["128866.143818"] = 209218,
	["128808.143818"] = 203670,
	["128870.143818"] = 192349,
	["128910.143818"] = 248579,
	["128940.143818"] = 195291,
	["128402.143818"] = 192542,
	["128861.143818"] = 197162,
	["128832.143818"] = 212817,

	["128866.143819"] = 209224,
	["128808.143819"] = 224764,
	["128870.143819"] = 192323,
	["128908.143819"] = 200857,
	["128289.143819"] = 188632,
	["128938.143819"] = 213047,
	["128872.143819"] = 202521,
	["128819.143819"] = 198296,
	["128832.143819"] = 212821,
	["128861.143819"] = 197160,
	["128910.143819"] = 209483,
	["128940.143819"] = 195244,
	["128402.143819"] = 192514,

	["128938.144522"] = 213180,
	["128289.144522"] = 188683,
	["128908.144522"] = 200849,
	["128870.144522"] = 192318,
	["128808.144522"] = 203578,
	["128866.144522"] = 209220,
	["128819.144522"] = 198247,
	["128872.144522"] = 202514,
	["128861.144522"] = 197080,
	["128832.144522"] = 207352,
	["128402.144522"] = 192447,
	["128940.144522"] = 218607,
	["128910.144522"] = 209472,

	["128402.144523"] = 192542,
	["128940.144523"] = 195291,
	["128910.144523"] = 248579,
	["128832.144523"] = 212817,
	["128861.144523"] = 197162,
	["128819.144523"] = 198349,
	["128872.144523"] = 202530,
	["128870.144523"] = 192349,
	["128808.144523"] = 203670,
	["128866.144523"] = 209218,
	["128938.144523"] = 213133,
	["128289.144523"] = 203227,
	["128908.144523"] = 200860,

	["128872.144524"] = 202521,
	["128819.144524"] = 198296,
	["128808.144524"] = 224764,
	["128866.144524"] = 209224,
	["128870.144524"] = 192323,
	["128908.144524"] = 200857,
	["128938.144524"] = 213047,
	["128289.144524"] = 188632,
	["128940.144524"] = 195244,
	["128910.144524"] = 209483,
	["128402.144524"] = 192514,
	["128832.144524"] = 212821,
	["128861.144524"] = 197160,

	["128870.145364"] = 192318,
	["128808.145364"] = 203578,
	["128866.145364"] = 209220,
	["128289.145364"] = 188683,
	["128938.145364"] = 213180,
	["128908.145364"] = 200849,
	["128819.145364"] = 198247,
	["128872.145364"] = 202514,
	["128832.145364"] = 207352,
	["128861.145364"] = 197080,
	["128402.145364"] = 192447,
	["128940.145364"] = 218607,
	["128910.145364"] = 209472,

	["128872.145365"] = 202530,
	["128819.145365"] = 198349,
	["128866.145365"] = 209218,
	["128808.145365"] = 203670,
	["128870.145365"] = 192349,
	["128908.145365"] = 200860,
	["128938.145365"] = 213133,
	["128289.145365"] = 203227,
	["128940.145365"] = 195291,
	["128910.145365"] = 248579,
	["128402.145365"] = 192542,
	["128832.145365"] = 212817,
	["128861.145365"] = 197162,

	["128832.145366"] = 212821,
	["128861.145366"] = 197160,
	["128402.145366"] = 192514,
	["128940.145366"] = 195244,
	["128910.145366"] = 209483,
	["128870.145366"] = 192323,
	["128866.145366"] = 209224,
	["128808.145366"] = 224764,
	["128289.145366"] = 188632,
	["128938.145366"] = 213047,
	["128908.145366"] = 200857,
	["128819.145366"] = 198296,
	["128872.145366"] = 202521,

	["128832.150292"] = 207352,
	["128861.150292"] = 197080,
	["128402.150292"] = 192447,
	["128940.150292"] = 218607,
	["128910.150292"] = 209472,
	["128870.150292"] = 192318,
	["128808.150292"] = 203578,
	["128866.150292"] = 209220,
	["128289.150292"] = 188683,
	["128938.150292"] = 213180,
	["128908.150292"] = 200849,
	["128819.150292"] = 198247,
	["128872.150292"] = 202514,

	["128908.150293"] = 200860,
	["128938.150293"] = 213133,
	["128289.150293"] = 203227,
	["128808.150293"] = 203670,
	["128866.150293"] = 209218,
	["128870.150293"] = 192349,
	["128872.150293"] = 202530,
	["128819.150293"] = 198349,
	["128861.150293"] = 197162,
	["128832.150293"] = 212817,
	["128910.150293"] = 248579,
	["128940.150293"] = 195291,
	["128402.150293"] = 192542,

	["128910.150294"] = 209483,
	["128940.150294"] = 195244,
	["128402.150294"] = 192514,
	["128861.150294"] = 197160,
	["128832.150294"] = 212821,
	["128872.150294"] = 202521,
	["128819.150294"] = 198296,
	["128908.150294"] = 200857,
	["128289.150294"] = 188632,
	["128938.150294"] = 213047,
	["128866.150294"] = 209224,
	["128808.150294"] = 224764,
	["128870.150294"] = 192323,

	["128832.150316"] = 207352,
	["128861.150316"] = 197080,
	["128402.150316"] = 192447,
	["128940.150316"] = 218607,
	["128910.150316"] = 209472,
	["128870.150316"] = 192318,
	["128808.150316"] = 203578,
	["128866.150316"] = 209220,
	["128289.150316"] = 188683,
	["128938.150316"] = 213180,
	["128908.150316"] = 200849,
	["128819.150316"] = 198247,
	["128872.150316"] = 202514,

	["128861.150317"] = 197162,
	["128832.150317"] = 212817,
	["128402.150317"] = 192542,
	["128910.150317"] = 248579,
	["128940.150317"] = 195291,
	["128938.150317"] = 213133,
	["128289.150317"] = 203227,
	["128908.150317"] = 200860,
	["128870.150317"] = 192349,
	["128866.150317"] = 209218,
	["128808.150317"] = 203670,
	["128819.150317"] = 198349,
	["128872.150317"] = 202530,

	["128861.150318"] = 197160,
	["128832.150318"] = 212821,
	["128940.150318"] = 195244,
	["128910.150318"] = 209483,
	["128402.150318"] = 192514,
	["128908.150318"] = 200857,
	["128938.150318"] = 213047,
	["128289.150318"] = 188632,
	["128808.150318"] = 224764,
	["128866.150318"] = 209224,
	["128870.150318"] = 192323,
	["128872.150318"] = 202521,
	["128819.150318"] = 198296,

	["128832.150341"] = 207352,
	["128861.150341"] = 197080,
	["128402.150341"] = 192447,
	["128940.150341"] = 218607,
	["128910.150341"] = 209472,
	["128870.150341"] = 192318,
	["128808.150341"] = 203578,
	["128866.150341"] = 209220,
	["128289.150341"] = 188683,
	["128938.150341"] = 213180,
	["128908.150341"] = 200849,
	["128819.150341"] = 198247,
	["128872.150341"] = 202514,

	["128819.150342"] = 198349,
	["128872.150342"] = 202530,
	["128870.150342"] = 192349,
	["128808.150342"] = 203670,
	["128866.150342"] = 209218,
	["128938.150342"] = 213133,
	["128289.150342"] = 203227,
	["128908.150342"] = 200860,
	["128402.150342"] = 192542,
	["128940.150342"] = 195291,
	["128910.150342"] = 248579,
	["128832.150342"] = 212817,
	["128861.150342"] = 197162,

	["128861.150343"] = 197160,
	["128832.150343"] = 212821,
	["128910.150343"] = 209483,
	["128940.150343"] = 195244,
	["128402.150343"] = 192514,
	["128908.150343"] = 200857,
	["128938.150343"] = 213047,
	["128289.150343"] = 188632,
	["128866.150343"] = 209224,
	["128808.150343"] = 224764,
	["128870.150343"] = 192323,
	["128872.150343"] = 202521,
	["128819.150343"] = 198296,

	["128402.153464"] = 192447,
	["128940.153464"] = 218607,
	["128910.153464"] = 209472,
	["128861.153464"] = 197080,
	["128832.153464"] = 207352,
	["128819.153464"] = 198247,
	["128872.153464"] = 202514,
	["128289.153464"] = 188683,
	["128938.153464"] = 213180,
	["128908.153464"] = 200849,
	["128870.153464"] = 192318,
	["128808.153464"] = 203578,
	["128866.153464"] = 209220,

	["128819.153465"] = 198349,
	["128872.153465"] = 202530,
	["128870.153465"] = 192349,
	["128808.153465"] = 203670,
	["128866.153465"] = 209218,
	["128938.153465"] = 213133,
	["128289.153465"] = 203227,
	["128908.153465"] = 200860,
	["128402.153465"] = 192542,
	["128910.153465"] = 248579,
	["128940.153465"] = 195291,
	["128832.153465"] = 212817,
	["128861.153465"] = 197162,

	["128872.153466"] = 202521,
	["128819.153466"] = 198296,
	["128908.153466"] = 200857,
	["128289.153466"] = 188632,
	["128938.153466"] = 213047,
	["128808.153466"] = 224764,
	["128866.153466"] = 209224,
	["128870.153466"] = 192323,
	["128940.153466"] = 195244,
	["128910.153466"] = 209483,
	["128402.153466"] = 192514,
	["128861.153466"] = 197160,
	["128832.153466"] = 212821,

	["128861.135573"] = 206910,
	["128832.135573"] = 212819,
	["128402.135573"] = 192464,
	["128940.135573"] = 195267,
	["128910.135573"] = 209494,
	["128938.135573"] = 213136,
	["128289.135573"] = 188639,
	["128908.135573"] = 200861,
	["128870.135573"] = 192376,
	["128808.135573"] = 203673,
	["128866.135573"] = 209216,
	["128819.135573"] = 198238,
	["128872.135573"] = 202907,

	["128868.132334"] = 197708,
	["128825.132334"] = 196434,
	["128823.132334"] = 200326,
	["128866.132334"] = 209229,
	["120978.132334"] = 186941,

	["128868.132345"] = 197716,
	["128825.132345"] = 196418,
	["128823.132345"] = 200296,
	["120978.132345"] = 186945,
	["128866.132345"] = 209226,

	["128868.132824"] = 197729,
	["128825.132824"] = 196429,
	["128823.132824"] = 200298,
	["120978.132824"] = 185368,
	["128866.132824"] = 209218,

	["128825.132844"] = 196430,
	["128868.132844"] = 197762,
	["120978.132844"] = 186944,
	["128866.132844"] = 209216,
	["128823.132844"] = 200482,

	["120978.133018"] = 186941,
	["128866.133018"] = 209229,
	["128823.133018"] = 200326,
	["128825.133018"] = 196434,
	["128868.133018"] = 197708,

	["120978.133051"] = 184843,
	["128866.133051"] = 209220,
	["128823.133051"] = 200315,
	["128825.133051"] = 196416,
	["128868.133051"] = 197715,

	["128868.133114"] = 197711,
	["128825.133114"] = 196489,
	["128823.133114"] = 200327,
	["120978.133114"] = 186934,
	["128866.133114"] = 209224,

	["120978.133125"] = 186944,
	["128866.133125"] = 209216,
	["128823.133125"] = 200482,
	["128825.133125"] = 196430,
	["128868.133125"] = 197762,

	["128868.133136"] = 216212,
	["128825.133136"] = 196355,
	["128823.133136"] = 200302,
	["128866.133136"] = 209225,
	["120978.133136"] = 184778,

	["120978.132279"] = 184843,
	["128866.132279"] = 209220,
	["128823.132279"] = 200315,
	["128825.132279"] = 196416,
	["128868.132279"] = 197715,

	["120978.132280"] = 185368,
	["128866.132280"] = 209218,
	["128823.132280"] = 200298,
	["128825.132280"] = 196429,
	["128868.132280"] = 197729,

	["120978.132775"] = 186945,
	["128866.132775"] = 209226,
	["128823.132775"] = 200296,
	["128825.132775"] = 196418,
	["128868.132775"] = 197716,

	["128823.132786"] = 200294,
	["120978.132786"] = 186927,
	["128866.132786"] = 209223,
	["128868.132786"] = 197727,
	["128825.132786"] = 196422,

	["128823.132983"] = 200296,
	["128866.132983"] = 209226,
	["120978.132983"] = 186945,
	["128868.132983"] = 197716,
	["128825.132983"] = 196418,

	["128823.132994"] = 200482,
	["128866.132994"] = 209216,
	["120978.132994"] = 186944,
	["128868.132994"] = 197762,
	["128825.132994"] = 196430,

	["128868.133006"] = 197713,
	["128825.133006"] = 196358,
	["128823.133006"] = 200316,
	["128866.133006"] = 209217,
	["120978.133006"] = 184759,

	["128823.133029"] = 200326,
	["128866.133029"] = 209229,
	["120978.133029"] = 186941,
	["128868.133029"] = 197708,
	["128825.133029"] = 196434,

	["128868.133040"] = 197711,
	["128825.133040"] = 196489,
	["128823.133040"] = 200327,
	["120978.133040"] = 186934,
	["128866.133040"] = 209224,

	["128823.133092"] = 200294,
	["120978.133092"] = 186927,
	["128866.133092"] = 209223,
	["128868.133092"] = 197727,
	["128825.133092"] = 196422,

	["128823.133103"] = 200298,
	["120978.133103"] = 185368,
	["128866.133103"] = 209218,
	["128868.133103"] = 197729,
	["128825.133103"] = 196429,

	["128868.151005"] = 197729,
	["128825.151005"] = 196429,
	["128823.151005"] = 200298,
	["120978.151005"] = 185368,
	["128866.151005"] = 209218,

	["128808.132344"] = 203566,
	["128908.132344"] = 200846,
	["128938.132344"] = 213051,
	["128937.132344"] = 199364,
	["128826.132344"] = 190449,
	["128872.132344"] = 216230,
	["128935.132344"] = 191493,
	["128819.132344"] = 215381,
	["128861.132344"] = 197038,
	["128940.132344"] = 195243,

	["128908.132355"] = 200853,
	["128938.132355"] = 213062,
	["128937.132355"] = 199372,
	["128808.132355"] = 203638,
	["128872.132355"] = 202522,
	["128819.132355"] = 198292,
	["128935.132355"] = 191740,
	["128826.132355"] = 190467,
	["128861.132355"] = 197139,
	["128940.132355"] = 195266,

	["128826.132834"] = 190449,
	["128872.132834"] = 216230,
	["128935.132834"] = 191493,
	["128819.132834"] = 215381,
	["128808.132834"] = 203566,
	["128908.132834"] = 200846,
	["128937.132834"] = 199364,
	["128938.132834"] = 213051,
	["128940.132834"] = 195243,
	["128861.132834"] = 197038,

	["128940.132854"] = 195263,
	["128861.132854"] = 197047,
	["128872.132854"] = 202507,
	["128819.132854"] = 198236,
	["128935.132854"] = 191499,
	["128826.132854"] = 190457,
	["128908.132854"] = 216273,
	["128937.132854"] = 199366,
	["128938.132854"] = 213049,
	["128808.132854"] = 203577,

	["128808.133028"] = 203566,
	["128908.133028"] = 200846,
	["128937.133028"] = 199364,
	["128938.133028"] = 213051,
	["128826.133028"] = 190449,
	["128872.133028"] = 216230,
	["128935.133028"] = 191493,
	["128819.133028"] = 215381,
	["128861.133028"] = 197038,
	["128940.133028"] = 195243,

	["128938.133061"] = 213180,
	["128937.133061"] = 199367,
	["128908.133061"] = 200849,
	["128808.133061"] = 203578,
	["128819.133061"] = 198247,
	["128935.133061"] = 191504,
	["128872.133061"] = 202514,
	["128826.133061"] = 190462,
	["128861.133061"] = 197080,
	["128940.133061"] = 218607,

	["128861.133124"] = 197080,
	["128940.133124"] = 218607,
	["128808.133124"] = 203578,
	["128908.133124"] = 200849,
	["128937.133124"] = 199367,
	["128938.133124"] = 213180,
	["128826.133124"] = 190462,
	["128872.133124"] = 202514,
	["128935.133124"] = 191504,
	["128819.133124"] = 198247,

	["128861.133135"] = 206910,
	["128940.133135"] = 195267,
	["128908.133135"] = 200861,
	["128937.133135"] = 199485,
	["128938.133135"] = 213136,
	["128808.133135"] = 203673,
	["128872.133135"] = 202907,
	["128819.133135"] = 198238,
	["128935.133135"] = 191598,
	["128826.133135"] = 190567,

	["128808.133146"] = 203638,
	["128908.133146"] = 200853,
	["128938.133146"] = 213062,
	["128937.133146"] = 199372,
	["128826.133146"] = 190467,
	["128872.133146"] = 202522,
	["128935.133146"] = 191740,
	["128819.133146"] = 198292,
	["128861.133146"] = 197139,
	["128940.133146"] = 195266,

	["128808.132302"] = 203578,
	["128908.132302"] = 200849,
	["128938.132302"] = 213180,
	["128937.132302"] = 199367,
	["128826.132302"] = 190462,
	["128872.132302"] = 202514,
	["128935.132302"] = 191504,
	["128819.132302"] = 198247,
	["128861.132302"] = 197080,
	["128940.132302"] = 218607,

	["128940.132303"] = 195291,
	["128861.132303"] = 197162,
	["128819.132303"] = 198349,
	["128935.132303"] = 191577,
	["128872.132303"] = 202530,
	["128826.132303"] = 190529,
	["128938.132303"] = 213133,
	["128937.132303"] = 199380,
	["128908.132303"] = 200860,
	["128808.132303"] = 203670,

	["128940.132314"] = 195263,
	["128861.132314"] = 197047,
	["128826.132314"] = 190457,
	["128872.132314"] = 202507,
	["128935.132314"] = 191499,
	["128819.132314"] = 198236,
	["128808.132314"] = 203577,
	["128908.132314"] = 216273,
	["128938.132314"] = 213049,
	["128937.132314"] = 199366,

	["128940.132325"] = 195267,
	["128861.132325"] = 206910,
	["128872.132325"] = 202907,
	["128819.132325"] = 198238,
	["128935.132325"] = 191598,
	["128826.132325"] = 190567,
	["128908.132325"] = 200861,
	["128938.132325"] = 213136,
	["128937.132325"] = 199485,
	["128808.132325"] = 203673,

	["128819.132785"] = 198292,
	["128935.132785"] = 191740,
	["128872.132785"] = 202522,
	["128826.132785"] = 190467,
	["128938.132785"] = 213062,
	["128937.132785"] = 199372,
	["128908.132785"] = 200853,
	["128808.132785"] = 203638,
	["128940.132785"] = 195266,
	["128861.132785"] = 197139,

	["128872.132796"] = 202524,
	["128819.132796"] = 198299,
	["128935.132796"] = 191572,
	["128826.132796"] = 190520,
	["128908.132796"] = 200856,
	["128938.132796"] = 213055,
	["128937.132796"] = 199377,
	["128808.132796"] = 203669,
	["128940.132796"] = 195269,
	["128861.132796"] = 197140,

	["128861.132808"] = 197138,
	["128940.132808"] = 195380,
	["128808.132808"] = 203749,
	["128937.132808"] = 199384,
	["128938.132808"] = 213116,
	["128908.132808"] = 200859,
	["128826.132808"] = 190514,
	["128935.132808"] = 191582,
	["128819.132808"] = 198248,
	["128872.132808"] = 202533,

	["128819.132819"] = 198247,
	["128935.132819"] = 191504,
	["128872.132819"] = 202514,
	["128826.132819"] = 190462,
	["128937.132819"] = 199367,
	["128938.132819"] = 213180,
	["128908.132819"] = 200849,
	["128808.132819"] = 203578,
	["128940.132819"] = 218607,
	["128861.132819"] = 197080,

	["128808.132993"] = 203638,
	["128908.132993"] = 200853,
	["128937.132993"] = 199372,
	["128938.132993"] = 213062,
	["128826.132993"] = 190467,
	["128872.132993"] = 202522,
	["128935.132993"] = 191740,
	["128819.132993"] = 198292,
	["128861.132993"] = 197139,
	["128940.132993"] = 195266,

	["128940.133004"] = 195267,
	["128861.133004"] = 206910,
	["128826.133004"] = 190567,
	["128935.133004"] = 191598,
	["128819.133004"] = 198238,
	["128872.133004"] = 202907,
	["128808.133004"] = 203673,
	["128937.133004"] = 199485,
	["128938.133004"] = 213136,
	["128908.133004"] = 200861,

	["128861.133016"] = 197047,
	["128940.133016"] = 195263,
	["128937.133016"] = 199366,
	["128938.133016"] = 213049,
	["128908.133016"] = 216273,
	["128808.133016"] = 203577,
	["128819.133016"] = 198236,
	["128935.133016"] = 191499,
	["128872.133016"] = 202507,
	["128826.133016"] = 190457,

	["128826.133039"] = 190520,
	["128872.133039"] = 202524,
	["128935.133039"] = 191572,
	["128819.133039"] = 198299,
	["128808.133039"] = 203669,
	["128908.133039"] = 200856,
	["128937.133039"] = 199377,
	["128938.133039"] = 213055,
	["128940.133039"] = 195269,
	["128861.133039"] = 197140,

	["128826.133050"] = 190503,
	["128872.133050"] = 202521,
	["128935.133050"] = 191569,
	["128819.133050"] = 198296,
	["128808.133050"] = 224764,
	["128908.133050"] = 200857,
	["128937.133050"] = 199365,
	["128938.133050"] = 213047,
	["128940.133050"] = 195244,
	["128861.133050"] = 197160,

	["128819.133079"] = 215381,
	["128935.133079"] = 191493,
	["128872.133079"] = 216230,
	["128826.133079"] = 190449,
	["128938.133079"] = 213051,
	["128937.133079"] = 199364,
	["128908.133079"] = 200846,
	["128808.133079"] = 203566,
	["128940.133079"] = 195243,
	["128861.133079"] = 197038,

	["128937.133090"] = 199365,
	["128938.133090"] = 213047,
	["128908.133090"] = 200857,
	["128808.133090"] = 224764,
	["128819.133090"] = 198296,
	["128935.133090"] = 191569,
	["128872.133090"] = 202521,
	["128826.133090"] = 190503,
	["128861.133090"] = 197160,
	["128940.133090"] = 195244,

	["128808.133102"] = 203669,
	["128908.133102"] = 200856,
	["128938.133102"] = 213055,
	["128937.133102"] = 199377,
	["128826.133102"] = 190520,
	["128872.133102"] = 202524,
	["128935.133102"] = 191572,
	["128819.133102"] = 198299,
	["128861.133102"] = 197140,
	["128940.133102"] = 195269,

	["128861.133113"] = 197162,
	["128940.133113"] = 195291,
	["128938.133113"] = 213133,
	["128937.133113"] = 199380,
	["128908.133113"] = 200860,
	["128808.133113"] = 203670,
	["128819.133113"] = 198349,
	["128935.133113"] = 191577,
	["128872.133113"] = 202530,
	["128826.133113"] = 190529,

	["128938.151014"] = 213116,
	["128937.151014"] = 199384,
	["128908.151014"] = 200859,
	["128808.151014"] = 203749,
	["128819.151014"] = 198248,
	["128935.151014"] = 191582,
	["128872.151014"] = 202533,
	["128826.151014"] = 190514,
	["128861.151014"] = 197138,
	["128940.151014"] = 195380,

	["128937.132341"] = 199364,
	["128938.132341"] = 213051,
	["128826.132341"] = 190449,
	["128823.132341"] = 200326,
	["128911.132341"] = 207088,
	["128825.132341"] = 196434,
	["128860.132341"] = 210570,
	["128306.132341"] = 189772,
	["128821.132341"] = 200395,
	["128858.132341"] = 202384,

	["128858.132352"] = 202433,
	["128821.132352"] = 200402,
	["128860.132352"] = 210579,
	["128306.132352"] = 189757,
	["128825.132352"] = 196418,
	["128937.132352"] = 199372,
	["128938.132352"] = 213062,
	["128911.132352"] = 207206,
	["128823.132352"] = 200296,
	["128826.132352"] = 190467,

	["128938.132831"] = 213047,
	["128937.132831"] = 199365,
	["128823.132831"] = 200327,
	["128911.132831"] = 207351,
	["128826.132831"] = 190503,
	["128821.132831"] = 200400,
	["128858.132831"] = 202302,
	["128825.132831"] = 196489,
	["128306.132831"] = 186396,
	["128860.132831"] = 210557,

	["128858.132851"] = 203018,
	["128821.132851"] = 200440,
	["128860.132851"] = 210590,
	["128306.132851"] = 186320,
	["128825.132851"] = 196355,
	["128937.132851"] = 199384,
	["128938.132851"] = 213116,
	["128911.132851"] = 207354,
	["128823.132851"] = 200302,
	["128826.132851"] = 190514,

	["128858.133025"] = 202384,
	["128821.133025"] = 200395,
	["128860.133025"] = 210570,
	["128306.133025"] = 189772,
	["128825.133025"] = 196434,
	["128938.133025"] = 213051,
	["128937.133025"] = 199364,
	["128911.133025"] = 207088,
	["128823.133025"] = 200326,
	["128826.133025"] = 190449,

	["128821.133058"] = 208762,
	["128858.133058"] = 202426,
	["128825.133058"] = 196416,
	["128306.133058"] = 189760,
	["128860.133058"] = 210575,
	["128823.133058"] = 200315,
	["128911.133058"] = 207118,
	["128826.133058"] = 190462,
	["128938.133058"] = 213180,
	["128937.133058"] = 199367,

	["128937.133121"] = 199364,
	["128938.133121"] = 213051,
	["128823.133121"] = 200326,
	["128911.133121"] = 207088,
	["128826.133121"] = 190449,
	["128821.133121"] = 200395,
	["128858.133121"] = 202384,
	["128825.133121"] = 196434,
	["128306.133121"] = 189772,
	["128860.133121"] = 210570,

	["128938.133132"] = 213136,
	["128937.133132"] = 199485,
	["128826.133132"] = 190567,
	["128823.133132"] = 200482,
	["128911.133132"] = 207348,
	["128825.133132"] = 196430,
	["128860.133132"] = 210631,
	["128306.133132"] = 189744,
	["128821.133132"] = 200415,
	["128858.133132"] = 202464,

	["128826.133143"] = 190457,
	["128911.133143"] = 207092,
	["128823.133143"] = 200316,
	["128938.133143"] = 213049,
	["128937.133143"] = 199366,
	["128860.133143"] = 210571,
	["128306.133143"] = 189768,
	["128825.133143"] = 196358,
	["128858.133143"] = 202386,
	["128821.133143"] = 200399,

	["128826.132296"] = 190462,
	["128911.132296"] = 207118,
	["128823.132296"] = 200315,
	["128938.132296"] = 213180,
	["128937.132296"] = 199367,
	["128860.132296"] = 210575,
	["128306.132296"] = 189760,
	["128825.132296"] = 196416,
	["128858.132296"] = 202426,
	["128821.132296"] = 208762,

	["128825.132297"] = 196429,
	["128306.132297"] = 189749,
	["128860.132297"] = 210637,
	["128821.132297"] = 200414,
	["128858.132297"] = 202466,
	["128826.132297"] = 190529,
	["128823.132297"] = 200298,
	["128911.132297"] = 207285,
	["128938.132297"] = 213133,
	["128937.132297"] = 199380,

	["128858.132311"] = 202386,
	["128821.132311"] = 200399,
	["128860.132311"] = 210571,
	["128306.132311"] = 189768,
	["128825.132311"] = 196358,
	["128938.132311"] = 213049,
	["128937.132311"] = 199366,
	["128911.132311"] = 207092,
	["128823.132311"] = 200316,
	["128826.132311"] = 190457,

	["128823.132322"] = 200482,
	["128911.132322"] = 207348,
	["128826.132322"] = 190567,
	["128937.132322"] = 199485,
	["128938.132322"] = 213136,
	["128821.132322"] = 200415,
	["128858.132322"] = 202464,
	["128825.132322"] = 196430,
	["128860.132322"] = 210631,
	["128306.132322"] = 189744,

	["128821.132782"] = 200402,
	["128858.132782"] = 202433,
	["128825.132782"] = 196418,
	["128860.132782"] = 210579,
	["128306.132782"] = 189757,
	["128937.132782"] = 199372,
	["128938.132782"] = 213062,
	["128823.132782"] = 200296,
	["128911.132782"] = 207206,
	["128826.132782"] = 190467,

	["128825.132793"] = 196422,
	["128306.132793"] = 189754,
	["128860.132793"] = 210593,
	["128821.132793"] = 200409,
	["128858.132793"] = 202445,
	["128826.132793"] = 190520,
	["128823.132793"] = 200294,
	["128911.132793"] = 207255,
	["128937.132793"] = 199377,
	["128938.132793"] = 213055,

	["128858.132805"] = 203018,
	["128821.132805"] = 200440,
	["128306.132805"] = 186320,
	["128860.132805"] = 210590,
	["128825.132805"] = 196355,
	["128911.132805"] = 207354,
	["128823.132805"] = 200302,
	["128826.132805"] = 190514,
	["128937.132805"] = 199384,
	["128938.132805"] = 213116,

	["128826.132816"] = 190462,
	["128911.132816"] = 207118,
	["128823.132816"] = 200315,
	["128937.132816"] = 199367,
	["128938.132816"] = 213180,
	["128860.132816"] = 210575,
	["128306.132816"] = 189760,
	["128825.132816"] = 196416,
	["128858.132816"] = 202426,
	["128821.132816"] = 208762,

	["128858.132990"] = 202433,
	["128821.132990"] = 200402,
	["128306.132990"] = 189757,
	["128860.132990"] = 210579,
	["128825.132990"] = 196418,
	["128911.132990"] = 207206,
	["128823.132990"] = 200296,
	["128826.132990"] = 190467,
	["128937.132990"] = 199372,
	["128938.132990"] = 213062,

	["128825.133001"] = 196430,
	["128306.133001"] = 189744,
	["128860.133001"] = 210631,
	["128821.133001"] = 200415,
	["128858.133001"] = 202464,
	["128938.133001"] = 213136,
	["128937.133001"] = 199485,
	["128826.133001"] = 190567,
	["128823.133001"] = 200482,
	["128911.133001"] = 207348,

	["128823.133013"] = 200316,
	["128911.133013"] = 207092,
	["128826.133013"] = 190457,
	["128937.133013"] = 199366,
	["128938.133013"] = 213049,
	["128821.133013"] = 200399,
	["128858.133013"] = 202386,
	["128825.133013"] = 196358,
	["128860.133013"] = 210571,
	["128306.133013"] = 189768,

	["128821.133036"] = 208762,
	["128858.133036"] = 202426,
	["128825.133036"] = 196416,
	["128860.133036"] = 210575,
	["128306.133036"] = 189760,
	["128937.133036"] = 199367,
	["128938.133036"] = 213180,
	["128823.133036"] = 200315,
	["128911.133036"] = 207118,
	["128826.133036"] = 190462,

	["128825.133047"] = 196489,
	["128306.133047"] = 186396,
	["128860.133047"] = 210557,
	["128821.133047"] = 200400,
	["128858.133047"] = 202302,
	["128937.133047"] = 199365,
	["128938.133047"] = 213047,
	["128826.133047"] = 190503,
	["128823.133047"] = 200327,
	["128911.133047"] = 207351,

	["128306.133076"] = 189772,
	["128860.133076"] = 210570,
	["128825.133076"] = 196434,
	["128858.133076"] = 202384,
	["128821.133076"] = 200395,
	["128826.133076"] = 190449,
	["128911.133076"] = 207088,
	["128823.133076"] = 200326,
	["128938.133076"] = 213051,
	["128937.133076"] = 199364,

	["128911.133087"] = 207351,
	["128823.133087"] = 200327,
	["128826.133087"] = 190503,
	["128938.133087"] = 213047,
	["128937.133087"] = 199365,
	["128858.133087"] = 202302,
	["128821.133087"] = 200400,
	["128860.133087"] = 210557,
	["128306.133087"] = 186396,
	["128825.133087"] = 196489,

	["128306.133099"] = 189754,
	["128860.133099"] = 210593,
	["128825.133099"] = 196422,
	["128858.133099"] = 202445,
	["128821.133099"] = 200409,
	["128826.133099"] = 190520,
	["128911.133099"] = 207255,
	["128823.133099"] = 200294,
	["128937.133099"] = 199377,
	["128938.133099"] = 213055,

	["128825.133110"] = 196429,
	["128306.133110"] = 189749,
	["128860.133110"] = 210637,
	["128821.133110"] = 200414,
	["128858.133110"] = 202466,
	["128826.133110"] = 190529,
	["128823.133110"] = 200298,
	["128911.133110"] = 207285,
	["128938.133110"] = 213133,
	["128937.133110"] = 199380,

	["128306.151012"] = 238050,
	["128860.151012"] = 238048,
	["128825.151012"] = 238064,
	["128858.151012"] = 238047,
	["128821.151012"] = 238049,
	["128937.151012"] = 238058,
	["128938.151012"] = 238057,
	["128826.151012"] = 238052,
	["128911.151012"] = 238071,
	["128823.151012"] = 238060,

	["128821.132338"] = 200395,
	["128820.132338"] = 194224,
	["128941.132338"] = 196211,
	["128908.132338"] = 200846,
	["128403.132338"] = 191419,
	["128289.132338"] = 188635,
	["120978.132338"] = 186941,
	["128943.132338"] = 211108,
	["128819.132338"] = 215381,

	["128289.132349"] = 203230,
	["128403.132349"] = 191592,
	["120978.132349"] = 186945,
	["128908.132349"] = 200853,
	["128941.132349"] = 196227,
	["128819.132349"] = 198292,
	["128943.132349"] = 211123,
	["128821.132349"] = 200402,
	["128820.132349"] = 210182,

	["128821.132828"] = 200402,
	["128820.132828"] = 210182,
	["128908.132828"] = 200853,
	["128289.132828"] = 203230,
	["120978.132828"] = 186945,
	["128403.132828"] = 191592,
	["128941.132828"] = 196227,
	["128943.132828"] = 211123,
	["128819.132828"] = 198292,

	["128820.132848"] = 194313,
	["128821.132848"] = 200409,
	["128943.132848"] = 211105,
	["128819.132848"] = 198299,
	["128941.132848"] = 196236,
	["128908.132848"] = 200856,
	["128403.132848"] = 191494,
	["128289.132848"] = 203225,
	["120978.132848"] = 186927,

	["128941.133022"] = 196211,
	["120978.133022"] = 186941,
	["128289.133022"] = 188635,
	["128403.133022"] = 191419,
	["128908.133022"] = 200846,
	["128819.133022"] = 215381,
	["128943.133022"] = 211108,
	["128821.133022"] = 200395,
	["128820.133022"] = 194224,

	["128943.133055"] = 211106,
	["128819.133055"] = 198247,
	["128941.133055"] = 196222,
	["128908.133055"] = 200849,
	["120978.133055"] = 184843,
	["128289.133055"] = 188683,
	["128403.133055"] = 191485,
	["128820.133055"] = 194312,
	["128821.133055"] = 208762,

	["128941.133118"] = 196432,
	["120978.133118"] = 185368,
	["128289.133118"] = 203227,
	["128403.133118"] = 191488,
	["128908.133118"] = 200860,
	["128819.133118"] = 198349,
	["128943.133118"] = 211119,
	["128821.133118"] = 200414,
	["128820.133118"] = 194314,

	["128820.133129"] = 194239,
	["128821.133129"] = 200415,
	["128943.133129"] = 211099,
	["128819.133129"] = 198238,
	["128941.133129"] = 196258,
	["128908.133129"] = 200861,
	["120978.133129"] = 186944,
	["128289.133129"] = 188639,
	["128403.133129"] = 208598,

	["128820.133140"] = 194312,
	["128821.133140"] = 208762,
	["128819.133140"] = 198247,
	["128943.133140"] = 211106,
	["128941.133140"] = 196222,
	["120978.133140"] = 184843,
	["128289.133140"] = 188683,
	["128403.133140"] = 191485,
	["128908.133140"] = 200849,

	["128821.132287"] = 208762,
	["128820.132287"] = 194312,
	["128289.132287"] = 188683,
	["128403.132287"] = 191485,
	["120978.132287"] = 184843,
	["128908.132287"] = 200849,
	["128941.132287"] = 196222,
	["128819.132287"] = 198247,
	["128943.132287"] = 211106,

	["128821.132288"] = 200414,
	["128820.132288"] = 194314,
	["128941.132288"] = 196432,
	["128908.132288"] = 200860,
	["128403.132288"] = 191488,
	["128289.132288"] = 203227,
	["120978.132288"] = 185368,
	["128943.132288"] = 211119,
	["128819.132288"] = 198349,

	["128821.132308"] = 200399,
	["128820.132308"] = 194234,
	["128941.132308"] = 196217,
	["128403.132308"] = 191442,
	["128289.132308"] = 216272,
	["120978.132308"] = 184759,
	["128908.132308"] = 216273,
	["128819.132308"] = 198236,
	["128943.132308"] = 211126,

	["128943.132319"] = 211099,
	["128819.132319"] = 198238,
	["128908.132319"] = 200861,
	["128289.132319"] = 188639,
	["120978.132319"] = 186944,
	["128403.132319"] = 208598,
	["128941.132319"] = 196258,
	["128820.132319"] = 194239,
	["128821.132319"] = 200415,

	["128289.132779"] = 203230,
	["128403.132779"] = 191592,
	["120978.132779"] = 186945,
	["128908.132779"] = 200853,
	["128941.132779"] = 196227,
	["128819.132779"] = 198292,
	["128943.132779"] = 211123,
	["128821.132779"] = 200402,
	["128820.132779"] = 210182,

	["128941.132790"] = 196236,
	["120978.132790"] = 186927,
	["128289.132790"] = 203225,
	["128403.132790"] = 191494,
	["128908.132790"] = 200856,
	["128819.132790"] = 198299,
	["128943.132790"] = 211105,
	["128821.132790"] = 200409,
	["128820.132790"] = 194313,

	["128941.132802"] = 196305,
	["128908.132802"] = 200859,
	["120978.132802"] = 184778,
	["128289.132802"] = 188644,
	["128403.132802"] = 191584,
	["128943.132802"] = 211131,
	["128819.132802"] = 198248,
	["128821.132802"] = 200440,
	["128820.132802"] = 194315,

	["128943.132813"] = 211106,
	["128819.132813"] = 198247,
	["128941.132813"] = 196222,
	["128908.132813"] = 200849,
	["120978.132813"] = 184843,
	["128289.132813"] = 188683,
	["128403.132813"] = 191485,
	["128820.132813"] = 194312,
	["128821.132813"] = 208762,

	["128941.132987"] = 196227,
	["128403.132987"] = 191592,
	["128289.132987"] = 203230,
	["120978.132987"] = 186945,
	["128908.132987"] = 200853,
	["128819.132987"] = 198292,
	["128943.132987"] = 211123,
	["128821.132987"] = 200402,
	["128820.132987"] = 210182,

	["128941.132998"] = 196258,
	["120978.132998"] = 186944,
	["128289.132998"] = 188639,
	["128403.132998"] = 208598,
	["128908.132998"] = 200861,
	["128819.132998"] = 198238,
	["128943.132998"] = 211099,
	["128821.132998"] = 200415,
	["128820.132998"] = 194239,

	["128821.133010"] = 200399,
	["128820.133010"] = 194234,
	["128941.133010"] = 196217,
	["128908.133010"] = 216273,
	["128403.133010"] = 191442,
	["128289.133010"] = 216272,
	["120978.133010"] = 184759,
	["128943.133010"] = 211126,
	["128819.133010"] = 198236,

	["128821.133033"] = 200400,
	["128820.133033"] = 194318,
	["128908.133033"] = 200857,
	["128289.133033"] = 188632,
	["128403.133033"] = 191565,
	["120978.133033"] = 186934,
	["128941.133033"] = 196301,
	["128943.133033"] = 211144,
	["128819.133033"] = 198296,

	["128820.133044"] = 194318,
	["128821.133044"] = 200400,
	["128819.133044"] = 198296,
	["128943.133044"] = 211144,
	["128289.133044"] = 188632,
	["128403.133044"] = 191565,
	["120978.133044"] = 186934,
	["128908.133044"] = 200857,
	["128941.133044"] = 196301,

	["128820.133073"] = 194224,
	["128821.133073"] = 200395,
	["128819.133073"] = 215381,
	["128943.133073"] = 211108,
	["128941.133073"] = 196211,
	["120978.133073"] = 186941,
	["128289.133073"] = 188635,
	["128403.133073"] = 191419,
	["128908.133073"] = 200846,

	["128819.133084"] = 198296,
	["128943.133084"] = 211144,
	["128289.133084"] = 188632,
	["128403.133084"] = 191565,
	["120978.133084"] = 186934,
	["128908.133084"] = 200857,
	["128941.133084"] = 196301,
	["128820.133084"] = 194318,
	["128821.133084"] = 200400,

	["128821.133096"] = 200409,
	["128820.133096"] = 194313,
	["128289.133096"] = 203225,
	["128403.133096"] = 191494,
	["120978.133096"] = 186927,
	["128908.133096"] = 200856,
	["128941.133096"] = 196236,
	["128819.133096"] = 198299,
	["128943.133096"] = 211105,

	["128821.133107"] = 200414,
	["128820.133107"] = 194314,
	["128289.133107"] = 203227,
	["120978.133107"] = 185368,
	["128403.133107"] = 191488,
	["128908.133107"] = 200860,
	["128941.133107"] = 196432,
	["128819.133107"] = 198349,
	["128943.133107"] = 211119,

	["128819.151009"] = 238070,
	["128943.151009"] = 238073,
	["128941.151009"] = 238074,
	["120978.151009"] = 238062,
	["128289.151009"] = 238077,
	["128403.151009"] = 238044,
	["128908.151009"] = 238076,
	["128820.151009"] = 238055,
	["128821.151009"] = 238049,

	["127857.132339"] = 187304,
	["128860.132339"] = 210570,
	["128306.132339"] = 189772,
	["128911.132339"] = 207088,
	["128935.132339"] = 191493,
	["128862.132339"] = 195315,
	["128937.132339"] = 199364,
	["128292.132339"] = 189080,

	["127857.132350"] = 187264,
	["128860.132350"] = 210579,
	["128306.132350"] = 189757,
	["128862.132350"] = 195323,
	["128935.132350"] = 191740,
	["128911.132350"] = 207206,
	["128937.132350"] = 199372,
	["128292.132350"] = 189164,

	["128306.132829"] = 189754,
	["128860.132829"] = 210593,
	["127857.132829"] = 187313,
	["128292.132829"] = 189144,
	["128937.132829"] = 199377,
	["128862.132829"] = 195345,
	["128935.132829"] = 191572,
	["128911.132829"] = 207255,

	["128937.132833"] = 199380,
	["128292.132833"] = 189147,
	["128862.132833"] = 195351,
	["128911.132833"] = 207285,
	["128935.132833"] = 191577,
	["127857.132833"] = 187276,
	["128860.132833"] = 210637,
	["128306.132833"] = 189749,

	["127857.132849"] = 187276,
	["128860.132849"] = 210637,
	["128306.132849"] = 189749,
	["128911.132849"] = 207285,
	["128935.132849"] = 191577,
	["128862.132849"] = 195351,
	["128937.132849"] = 199380,
	["128292.132849"] = 189147,

	["128862.132853"] = 195354,
	["128935.132853"] = 191569,
	["128911.132853"] = 207351,
	["128937.132853"] = 199365,
	["128292.132853"] = 189154,
	["127857.132853"] = 187301,
	["128860.132853"] = 210557,
	["128306.132853"] = 186396,

	["128306.133023"] = 189772,
	["128860.133023"] = 210570,
	["127857.133023"] = 187304,
	["128292.133023"] = 189080,
	["128937.133023"] = 199364,
	["128935.133023"] = 191493,
	["128911.133023"] = 207088,
	["128862.133023"] = 195315,

	["127857.133056"] = 187321,
	["128860.133056"] = 210575,
	["128306.133056"] = 189760,
	["128935.133056"] = 191504,
	["128911.133056"] = 207118,
	["128862.133056"] = 195322,
	["128937.133056"] = 199367,
	["128292.133056"] = 189086,

	["128292.133119"] = 189097,
	["128937.133119"] = 199485,
	["128935.133119"] = 191598,
	["128911.133119"] = 207348,
	["128862.133119"] = 195352,
	["128306.133119"] = 189744,
	["128860.133119"] = 210631,
	["127857.133119"] = 187287,

	["128292.133130"] = 189097,
	["128937.133130"] = 199485,
	["128862.133130"] = 195352,
	["128935.133130"] = 191598,
	["128911.133130"] = 207348,
	["128306.133130"] = 189744,
	["128860.133130"] = 210631,
	["127857.133130"] = 187287,

	["128306.133141"] = 186396,
	["128860.133141"] = 210557,
	["127857.133141"] = 187301,
	["128911.133141"] = 207351,
	["128935.133141"] = 191569,
	["128862.133141"] = 195354,
	["128292.133141"] = 189154,
	["128937.133141"] = 199365,

	["128306.132289"] = 189760,
	["128860.132289"] = 210575,
	["127857.132289"] = 187321,
	["128292.132289"] = 189086,
	["128937.132289"] = 199367,
	["128862.132289"] = 195322,
	["128935.132289"] = 191504,
	["128911.132289"] = 207118,

	["128862.132290"] = 195351,
	["128935.132290"] = 191577,
	["128911.132290"] = 207285,
	["128937.132290"] = 199380,
	["128292.132290"] = 189147,
	["127857.132290"] = 187276,
	["128860.132290"] = 210637,
	["128306.132290"] = 189749,

	["128292.132309"] = 189092,
	["128937.132309"] = 199366,
	["128935.132309"] = 191499,
	["128911.132309"] = 207092,
	["128862.132309"] = 195317,
	["128306.132309"] = 189768,
	["128860.132309"] = 210571,
	["127857.132309"] = 187258,

	["128862.132320"] = 195352,
	["128911.132320"] = 207348,
	["128935.132320"] = 191598,
	["128937.132320"] = 199485,
	["128292.132320"] = 189097,
	["127857.132320"] = 187287,
	["128860.132320"] = 210631,
	["128306.132320"] = 189744,

	["128937.132780"] = 199372,
	["128292.132780"] = 189164,
	["128862.132780"] = 195323,
	["128935.132780"] = 191740,
	["128911.132780"] = 207206,
	["127857.132780"] = 187264,
	["128860.132780"] = 210579,
	["128306.132780"] = 189757,

	["128292.132791"] = 189144,
	["128937.132791"] = 199377,
	["128862.132791"] = 195345,
	["128911.132791"] = 207255,
	["128935.132791"] = 191572,
	["128306.132791"] = 189754,
	["128860.132791"] = 210593,
	["127857.132791"] = 187313,

	["128937.132803"] = 199384,
	["128292.132803"] = 204875,
	["128935.132803"] = 191582,
	["128911.132803"] = 207354,
	["128862.132803"] = 214626,
	["127857.132803"] = 210716,
	["128860.132803"] = 210590,
	["128306.132803"] = 186320,

	["128937.132807"] = 199366,
	["128292.132807"] = 189092,
	["128862.132807"] = 195317,
	["128911.132807"] = 207092,
	["128935.132807"] = 191499,
	["127857.132807"] = 187258,
	["128860.132807"] = 210571,
	["128306.132807"] = 189768,

	["128306.132814"] = 189760,
	["128860.132814"] = 210575,
	["127857.132814"] = 187321,
	["128292.132814"] = 189086,
	["128937.132814"] = 199367,
	["128862.132814"] = 195322,
	["128911.132814"] = 207118,
	["128935.132814"] = 191504,

	["128937.132818"] = 199377,
	["128292.132818"] = 189144,
	["128935.132818"] = 191572,
	["128911.132818"] = 207255,
	["128862.132818"] = 195345,
	["127857.132818"] = 187313,
	["128860.132818"] = 210593,
	["128306.132818"] = 189754,

	["128862.132988"] = 195323,
	["128911.132988"] = 207206,
	["128935.132988"] = 191740,
	["128292.132988"] = 189164,
	["128937.132988"] = 199372,
	["128306.132988"] = 189757,
	["128860.132988"] = 210579,
	["127857.132988"] = 187264,

	["128306.132999"] = 189744,
	["128860.132999"] = 210631,
	["127857.132999"] = 187287,
	["128862.132999"] = 195352,
	["128935.132999"] = 191598,
	["128911.132999"] = 207348,
	["128292.132999"] = 189097,
	["128937.132999"] = 199485,

	["128862.133011"] = 195317,
	["128935.133011"] = 191499,
	["128911.133011"] = 207092,
	["128937.133011"] = 199366,
	["128292.133011"] = 189092,
	["127857.133011"] = 187258,
	["128860.133011"] = 210571,
	["128306.133011"] = 189768,

	["128306.133034"] = 186320,
	["128860.133034"] = 210590,
	["127857.133034"] = 210716,
	["128292.133034"] = 204875,
	["128937.133034"] = 199384,
	["128911.133034"] = 207354,
	["128935.133034"] = 191582,
	["128862.133034"] = 214626,

	["127857.133045"] = 187321,
	["128860.133045"] = 210575,
	["128306.133045"] = 189760,
	["128937.133045"] = 199367,
	["128292.133045"] = 189086,
	["128911.133045"] = 207118,
	["128935.133045"] = 191504,
	["128862.133045"] = 195322,

	["128862.133074"] = 195315,
	["128935.133074"] = 191493,
	["128911.133074"] = 207088,
	["128292.133074"] = 189080,
	["128937.133074"] = 199364,
	["128306.133074"] = 189772,
	["128860.133074"] = 210570,
	["127857.133074"] = 187304,

	["128935.133085"] = 191569,
	["128911.133085"] = 207351,
	["128862.133085"] = 195354,
	["128937.133085"] = 199365,
	["128292.133085"] = 189154,
	["127857.133085"] = 187301,
	["128860.133085"] = 210557,
	["128306.133085"] = 186396,

	["127857.133097"] = 187313,
	["128860.133097"] = 210593,
	["128306.133097"] = 189754,
	["128862.133097"] = 195345,
	["128935.133097"] = 191572,
	["128911.133097"] = 207255,
	["128937.133097"] = 199377,
	["128292.133097"] = 189144,

	["128911.133108"] = 207285,
	["128935.133108"] = 191577,
	["128862.133108"] = 195351,
	["128937.133108"] = 199380,
	["128292.133108"] = 189147,
	["127857.133108"] = 187276,
	["128860.133108"] = 210637,
	["128306.133108"] = 189749,

	["128306.151010"] = 238050,
	["128860.151010"] = 238048,
	["127857.151010"] = 238054,
	["128862.151010"] = 238056,
	["128935.151010"] = 238069,
	["128911.151010"] = 238071,
	["128292.151010"] = 238043,
	["128937.151010"] = 238058,

	["128832.132335"] = 207343,
	["127857.132335"] = 187304,
	["128858.132335"] = 202384,
	["128861.132335"] = 197038,
	["128820.132335"] = 194224,
	["128866.132335"] = 209229,
	["128862.132335"] = 195315,

	["128820.132346"] = 210182,
	["128861.132346"] = 197139,
	["127857.132346"] = 187264,
	["128858.132346"] = 202433,
	["128832.132346"] = 207375,
	["128862.132346"] = 195323,
	["128866.132346"] = 209226,

	["128862.132825"] = 195315,
	["128866.132825"] = 209229,
	["128820.132825"] = 194224,
	["128861.132825"] = 197038,
	["128858.132825"] = 202384,
	["127857.132825"] = 187304,
	["128832.132825"] = 207343,

	["128866.132845"] = 209217,
	["128862.132845"] = 195317,
	["128832.132845"] = 207347,
	["128858.132845"] = 202386,
	["127857.132845"] = 187258,
	["128861.132845"] = 197047,
	["128820.132845"] = 194234,

	["128862.133019"] = 195315,
	["128866.133019"] = 209229,
	["128820.133019"] = 194224,
	["128858.133019"] = 202384,
	["127857.133019"] = 187304,
	["128861.133019"] = 197038,
	["128832.133019"] = 207343,

	["128832.133052"] = 207352,
	["127857.133052"] = 187321,
	["128858.133052"] = 202426,
	["128861.133052"] = 197080,
	["128820.133052"] = 194312,
	["128866.133052"] = 209220,
	["128862.133052"] = 195322,

	["128866.133115"] = 209220,
	["128862.133115"] = 195322,
	["128832.133115"] = 207352,
	["128861.133115"] = 197080,
	["128858.133115"] = 202426,
	["127857.133115"] = 187321,
	["128820.133115"] = 194312,

	["128862.133126"] = 195352,
	["128866.133126"] = 209216,
	["128820.133126"] = 194239,
	["128832.133126"] = 212819,
	["128858.133126"] = 202464,
	["127857.133126"] = 187287,
	["128861.133126"] = 206910,

	["128820.133137"] = 210182,
	["128832.133137"] = 207375,
	["128861.133137"] = 197139,
	["127857.133137"] = 187264,
	["128858.133137"] = 202433,
	["128862.133137"] = 195323,
	["128866.133137"] = 209226,

	["128832.132281"] = 207352,
	["128861.132281"] = 197080,
	["127857.132281"] = 187321,
	["128858.132281"] = 202426,
	["128820.132281"] = 194312,
	["128866.132281"] = 209220,
	["128862.132281"] = 195322,

	["128866.132282"] = 209218,
	["128862.132282"] = 195351,
	["128861.132282"] = 197162,
	["127857.132282"] = 187276,
	["128858.132282"] = 202466,
	["128832.132282"] = 212817,
	["128820.132282"] = 194314,

	["128862.132305"] = 195317,
	["128866.132305"] = 209217,
	["128820.132305"] = 194234,
	["128861.132305"] = 197047,
	["128858.132305"] = 202386,
	["127857.132305"] = 187258,
	["128832.132305"] = 207347,

	["128820.132316"] = 194239,
	["128861.132316"] = 206910,
	["127857.132316"] = 187287,
	["128858.132316"] = 202464,
	["128832.132316"] = 212819,
	["128862.132316"] = 195352,
	["128866.132316"] = 209216,

	["128862.132776"] = 195323,
	["128866.132776"] = 209226,
	["128820.132776"] = 210182,
	["128861.132776"] = 197139,
	["128858.132776"] = 202433,
	["127857.132776"] = 187264,
	["128832.132776"] = 207375,

	["128820.132787"] = 194313,
	["128832.132787"] = 212816,
	["128861.132787"] = 197140,
	["127857.132787"] = 187313,
	["128858.132787"] = 202445,
	["128862.132787"] = 195345,
	["128866.132787"] = 209223,

	["128820.132799"] = 194315,
	["128832.132799"] = 212827,
	["127857.132799"] = 210716,
	["128858.132799"] = 203018,
	["128861.132799"] = 197138,
	["128862.132799"] = 214626,
	["128866.132799"] = 209225,

	["128832.132810"] = 207352,
	["127857.132810"] = 187321,
	["128858.132810"] = 202426,
	["128861.132810"] = 197080,
	["128820.132810"] = 194312,
	["128866.132810"] = 209220,
	["128862.132810"] = 195322,

	["128862.132984"] = 195323,
	["128866.132984"] = 209226,
	["128820.132984"] = 210182,
	["128832.132984"] = 207375,
	["128861.132984"] = 197139,
	["128858.132984"] = 202433,
	["127857.132984"] = 187264,

	["128866.132995"] = 209216,
	["128862.132995"] = 195352,
	["128832.132995"] = 212819,
	["128861.132995"] = 206910,
	["128858.132995"] = 202464,
	["127857.132995"] = 187287,
	["128820.132995"] = 194239,

	["128866.133007"] = 209217,
	["128862.133007"] = 195317,
	["128832.133007"] = 207347,
	["128858.133007"] = 202386,
	["127857.133007"] = 187258,
	["128861.133007"] = 197047,
	["128820.133007"] = 194234,

	["128820.133030"] = 194313,
	["128832.133030"] = 212816,
	["128861.133030"] = 197140,
	["127857.133030"] = 187313,
	["128858.133030"] = 202445,
	["128862.133030"] = 195345,
	["128866.133030"] = 209223,

	["128820.133041"] = 194318,
	["128861.133041"] = 197160,
	["127857.133041"] = 187301,
	["128858.133041"] = 202302,
	["128832.133041"] = 212821,
	["128862.133041"] = 195354,
	["128866.133041"] = 209224,

	["128820.133070"] = 194224,
	["128832.133070"] = 207343,
	["128861.133070"] = 197038,
	["127857.133070"] = 187304,
	["128858.133070"] = 202384,
	["128862.133070"] = 195315,
	["128866.133070"] = 209229,

	["128832.133081"] = 212821,
	["128861.133081"] = 197160,
	["127857.133081"] = 187301,
	["128858.133081"] = 202302,
	["128820.133081"] = 194318,
	["128866.133081"] = 209224,
	["128862.133081"] = 195354,

	["128862.133093"] = 195345,
	["128866.133093"] = 209223,
	["128820.133093"] = 194313,
	["128858.133093"] = 202445,
	["127857.133093"] = 187313,
	["128861.133093"] = 197140,
	["128832.133093"] = 212816,

	["128861.133104"] = 197162,
	["128858.133104"] = 202466,
	["127857.133104"] = 187276,
	["128832.133104"] = 212817,
	["128820.133104"] = 194314,
	["128866.133104"] = 209218,
	["128862.133104"] = 195351,

	["128861.151006"] = 197162,
	["128858.151006"] = 202466,
	["127857.151006"] = 187276,
	["128832.151006"] = 212817,
	["128820.151006"] = 194314,
	["128866.151006"] = 209218,
	["128862.151006"] = 195351,

	["128941.132337"] = 196211,
	["128943.132337"] = 211108,
	["128476.132337"] = 197231,
	["128832.132337"] = 207343,
	["127829.132337"] = 201454,

	["128832.132348"] = 207375,
	["127829.132348"] = 201457,
	["128476.132348"] = 197235,
	["128941.132348"] = 196227,
	["128943.132348"] = 211123,

	["128941.132827"] = 196222,
	["128943.132827"] = 211106,
	["128476.132827"] = 197234,
	["127829.132827"] = 201456,
	["128832.132827"] = 207352,

	["128476.132847"] = 197235,
	["127829.132847"] = 201457,
	["128832.132847"] = 207375,
	["128941.132847"] = 196227,
	["128943.132847"] = 211123,

	["128941.133021"] = 196211,
	["128943.133021"] = 211108,
	["128476.133021"] = 197231,
	["127829.133021"] = 201454,
	["128832.133021"] = 207343,

	["128476.133054"] = 197234,
	["127829.133054"] = 201456,
	["128832.133054"] = 207352,
	["128943.133054"] = 211106,
	["128941.133054"] = 196222,

	["128476.133117"] = 197369,
	["128832.133117"] = 212816,
	["127829.133117"] = 201458,
	["128941.133117"] = 196236,
	["128943.133117"] = 211105,

	["127829.133128"] = 201464,
	["128832.133128"] = 212819,
	["128476.133128"] = 197239,
	["128943.133128"] = 211099,
	["128941.133128"] = 196258,

	["127829.133139"] = 201460,
	["128832.133139"] = 212817,
	["128476.133139"] = 197386,
	["128941.133139"] = 196432,
	["128943.133139"] = 211119,

	["128832.132285"] = 207352,
	["127829.132285"] = 201456,
	["128476.132285"] = 197234,
	["128943.132285"] = 211106,
	["128941.132285"] = 196222,

	["128941.132286"] = 196432,
	["128943.132286"] = 211119,
	["127829.132286"] = 201460,
	["128832.132286"] = 212817,
	["128476.132286"] = 197386,

	["128476.132307"] = 197233,
	["128832.132307"] = 207347,
	["127829.132307"] = 201455,
	["128943.132307"] = 211126,
	["128941.132307"] = 196217,

	["128943.132318"] = 211099,
	["128941.132318"] = 196258,
	["128476.132318"] = 197239,
	["128832.132318"] = 212819,
	["127829.132318"] = 201464,

	["128476.132778"] = 197235,
	["127829.132778"] = 201457,
	["128832.132778"] = 207375,
	["128941.132778"] = 196227,
	["128943.132778"] = 211123,

	["127829.132789"] = 201458,
	["128832.132789"] = 212816,
	["128476.132789"] = 197369,
	["128943.132789"] = 211105,
	["128941.132789"] = 196236,

	["128941.132801"] = 196305,
	["128943.132801"] = 211131,
	["128476.132801"] = 197244,
	["128832.132801"] = 212827,
	["127829.132801"] = 201463,

	["128476.132812"] = 197234,
	["128832.132812"] = 207352,
	["127829.132812"] = 201456,
	["128943.132812"] = 211106,
	["128941.132812"] = 196222,

	["128832.132986"] = 207375,
	["127829.132986"] = 201457,
	["128476.132986"] = 197235,
	["128943.132986"] = 211123,
	["128941.132986"] = 196227,

	["128832.132997"] = 212819,
	["127829.132997"] = 201464,
	["128476.132997"] = 197239,
	["128941.132997"] = 196258,
	["128943.132997"] = 211099,

	["128943.133009"] = 211126,
	["128941.133009"] = 196217,
	["127829.133009"] = 201455,
	["128832.133009"] = 207347,
	["128476.133009"] = 197233,

	["128941.133032"] = 196258,
	["128943.133032"] = 211099,
	["128476.133032"] = 197239,
	["128832.133032"] = 212819,
	["127829.133032"] = 201464,

	["128832.133043"] = 212821,
	["127829.133043"] = 201459,
	["128476.133043"] = 197241,
	["128943.133043"] = 211144,
	["128941.133043"] = 196301,

	["128943.133072"] = 211108,
	["128941.133072"] = 196211,
	["128476.133072"] = 197231,
	["128832.133072"] = 207343,
	["127829.133072"] = 201454,

	["128476.133083"] = 197241,
	["127829.133083"] = 201459,
	["128832.133083"] = 212821,
	["128941.133083"] = 196301,
	["128943.133083"] = 211144,

	["128943.133095"] = 211105,
	["128941.133095"] = 196236,
	["128476.133095"] = 197369,
	["127829.133095"] = 201458,
	["128832.133095"] = 212816,

	["128832.133106"] = 212817,
	["127829.133106"] = 201460,
	["128476.133106"] = 197386,
	["128941.133106"] = 196432,
	["128943.133106"] = 211119,

	["128941.151008"] = 196432,
	["128943.151008"] = 211119,
	["128476.151008"] = 197386,
	["127829.151008"] = 201460,
	["128832.151008"] = 212817,

	["128910.132342"] = 209459,
	["128402.132342"] = 192450,
	["128868.132342"] = 197708,
	["127829.132342"] = 201454,
	["128476.132342"] = 197231,
	["128943.132342"] = 211108,
	["128827.132342"] = 194093,
	["128870.132342"] = 192310,
	["128942.132342"] = 199111,
	["128292.132342"] = 189080,
	["128403.132342"] = 191419,

	["128402.132353"] = 192457,
	["128910.132353"] = 216274,
	["128868.132353"] = 197716,
	["127829.132353"] = 201457,
	["128476.132353"] = 197235,
	["128827.132353"] = 193645,
	["128943.132353"] = 211123,
	["128942.132353"] = 199152,
	["128870.132353"] = 192326,
	["128292.132353"] = 189164,
	["128403.132353"] = 191592,

	["128476.132832"] = 197244,
	["127829.132832"] = 201463,
	["128868.132832"] = 216212,
	["128402.132832"] = 192538,
	["128910.132832"] = 209541,
	["128403.132832"] = 191584,
	["128870.132832"] = 192345,
	["128942.132832"] = 199214,
	["128292.132832"] = 204875,
	["128827.132832"] = 193647,
	["128943.132832"] = 211131,

	["128476.132852"] = 197231,
	["127829.132852"] = 201454,
	["128868.132852"] = 197708,
	["128910.132852"] = 209459,
	["128402.132852"] = 192450,
	["128403.132852"] = 191419,
	["128870.132852"] = 192310,
	["128942.132852"] = 199111,
	["128292.132852"] = 189080,
	["128943.132852"] = 211108,
	["128827.132852"] = 194093,

	["127829.133026"] = 201454,
	["128476.133026"] = 197231,
	["128402.133026"] = 192450,
	["128910.133026"] = 209459,
	["128868.133026"] = 197708,
	["128942.133026"] = 199111,
	["128870.133026"] = 192310,
	["128292.133026"] = 189080,
	["128403.133026"] = 191419,
	["128827.133026"] = 194093,
	["128943.133026"] = 211108,

	["128827.133059"] = 193644,
	["128943.133059"] = 211106,
	["128403.133059"] = 191485,
	["128870.133059"] = 192318,
	["128292.133059"] = 189086,
	["128942.133059"] = 199120,
	["128868.133059"] = 197715,
	["128402.133059"] = 192447,
	["128910.133059"] = 209472,
	["128476.133059"] = 197234,
	["127829.133059"] = 201456,

	["128827.133122"] = 193643,
	["128943.133122"] = 211126,
	["128403.133122"] = 191442,
	["128942.133122"] = 199112,
	["128870.133122"] = 192315,
	["128292.133122"] = 189092,
	["128868.133122"] = 197713,
	["128402.133122"] = 192453,
	["128910.133122"] = 209462,
	["128476.133122"] = 197233,
	["127829.133122"] = 201455,

	["128476.133133"] = 197239,
	["127829.133133"] = 201464,
	["128868.133133"] = 197762,
	["128402.133133"] = 192464,
	["128910.133133"] = 209494,
	["128403.133133"] = 208598,
	["128292.133133"] = 189097,
	["128870.133133"] = 192376,
	["128942.133133"] = 199163,
	["128827.133133"] = 194002,
	["128943.133133"] = 211099,

	["128943.133144"] = 211106,
	["128827.133144"] = 193644,
	["128403.133144"] = 191485,
	["128870.133144"] = 192318,
	["128942.133144"] = 199120,
	["128292.133144"] = 189086,
	["128868.133144"] = 197715,
	["128910.133144"] = 209472,
	["128402.133144"] = 192447,
	["128476.133144"] = 197234,
	["127829.133144"] = 201456,

	["128292.132298"] = 189086,
	["128870.132298"] = 192318,
	["128942.132298"] = 199120,
	["128403.132298"] = 191485,
	["128827.132298"] = 193644,
	["128943.132298"] = 211106,
	["127829.132298"] = 201456,
	["128476.132298"] = 197234,
	["128402.132298"] = 192447,
	["128910.132298"] = 209472,
	["128868.132298"] = 197715,

	["128403.132299"] = 191488,
	["128870.132299"] = 192349,
	["128942.132299"] = 199158,
	["128292.132299"] = 189147,
	["128827.132299"] = 194016,
	["128943.132299"] = 211119,
	["128476.132299"] = 197386,
	["127829.132299"] = 201460,
	["128868.132299"] = 197729,
	["128402.132299"] = 192542,
	["128910.132299"] = 248579,

	["127829.132312"] = 201455,
	["128476.132312"] = 197233,
	["128402.132312"] = 192453,
	["128910.132312"] = 209462,
	["128868.132312"] = 197713,
	["128942.132312"] = 199112,
	["128870.132312"] = 192315,
	["128292.132312"] = 189092,
	["128403.132312"] = 191442,
	["128827.132312"] = 193643,
	["128943.132312"] = 211126,

	["128292.132323"] = 189097,
	["128870.132323"] = 192376,
	["128942.132323"] = 199163,
	["128403.132323"] = 208598,
	["128943.132323"] = 211099,
	["128827.132323"] = 194002,
	["127829.132323"] = 201464,
	["128476.132323"] = 197239,
	["128910.132323"] = 209494,
	["128402.132323"] = 192464,
	["128868.132323"] = 197762,

	["128402.132783"] = 192457,
	["128910.132783"] = 216274,
	["128868.132783"] = 197716,
	["127829.132783"] = 201457,
	["128476.132783"] = 197235,
	["128827.132783"] = 193645,
	["128943.132783"] = 211123,
	["128942.132783"] = 199152,
	["128870.132783"] = 192326,
	["128292.132783"] = 189164,
	["128403.132783"] = 191592,

	["128910.132794"] = 209481,
	["128402.132794"] = 192460,
	["128868.132794"] = 197727,
	["127829.132794"] = 201458,
	["128476.132794"] = 197369,
	["128943.132794"] = 211105,
	["128827.132794"] = 194007,
	["128942.132794"] = 199153,
	["128870.132794"] = 192329,
	["128292.132794"] = 189144,
	["128403.132794"] = 191494,

	["128868.132806"] = 216212,
	["128402.132806"] = 192538,
	["128910.132806"] = 209541,
	["128476.132806"] = 197244,
	["127829.132806"] = 201463,
	["128827.132806"] = 193647,
	["128943.132806"] = 211131,
	["128403.132806"] = 191584,
	["128942.132806"] = 199214,
	["128870.132806"] = 192345,
	["128292.132806"] = 204875,

	["128868.132817"] = 197715,
	["128910.132817"] = 209472,
	["128402.132817"] = 192447,
	["128476.132817"] = 197234,
	["127829.132817"] = 201456,
	["128943.132817"] = 211106,
	["128827.132817"] = 193644,
	["128403.132817"] = 191485,
	["128870.132817"] = 192318,
	["128292.132817"] = 189086,
	["128942.132817"] = 199120,

	["128476.132991"] = 197235,
	["127829.132991"] = 201457,
	["128868.132991"] = 197716,
	["128910.132991"] = 216274,
	["128402.132991"] = 192457,
	["128403.132991"] = 191592,
	["128942.132991"] = 199152,
	["128870.132991"] = 192326,
	["128292.132991"] = 189164,
	["128943.132991"] = 211123,
	["128827.132991"] = 193645,

	["128403.133002"] = 208598,
	["128942.133002"] = 199163,
	["128870.133002"] = 192376,
	["128292.133002"] = 189097,
	["128943.133002"] = 211099,
	["128827.133002"] = 194002,
	["128476.133002"] = 197239,
	["127829.133002"] = 201464,
	["128868.133002"] = 197762,
	["128910.133002"] = 209494,
	["128402.133002"] = 192464,

	["128402.133014"] = 192453,
	["128910.133014"] = 209462,
	["128868.133014"] = 197713,
	["127829.133014"] = 201455,
	["128476.133014"] = 197233,
	["128827.133014"] = 193643,
	["128943.133014"] = 211126,
	["128870.133014"] = 192315,
	["128942.133014"] = 199112,
	["128292.133014"] = 189092,
	["128403.133014"] = 191442,

	["128910.133037"] = 216274,
	["128402.133037"] = 192457,
	["128868.133037"] = 197716,
	["127829.133037"] = 201457,
	["128476.133037"] = 197235,
	["128943.133037"] = 211123,
	["128827.133037"] = 193645,
	["128870.133037"] = 192326,
	["128292.133037"] = 189164,
	["128942.133037"] = 199152,
	["128403.133037"] = 191592,

	["127829.133048"] = 201459,
	["128476.133048"] = 197241,
	["128910.133048"] = 209483,
	["128402.133048"] = 192514,
	["128868.133048"] = 197711,
	["128292.133048"] = 189154,
	["128870.133048"] = 192323,
	["128942.133048"] = 199212,
	["128403.133048"] = 191565,
	["128943.133048"] = 211144,
	["128827.133048"] = 193642,

	["127829.133077"] = 201454,
	["128476.133077"] = 197231,
	["128402.133077"] = 192450,
	["128910.133077"] = 209459,
	["128868.133077"] = 197708,
	["128292.133077"] = 189080,
	["128870.133077"] = 192310,
	["128942.133077"] = 199111,
	["128403.133077"] = 191419,
	["128827.133077"] = 194093,
	["128943.133077"] = 211108,

	["128868.133088"] = 197711,
	["128402.133088"] = 192514,
	["128910.133088"] = 209483,
	["128476.133088"] = 197241,
	["127829.133088"] = 201459,
	["128827.133088"] = 193642,
	["128943.133088"] = 211144,
	["128403.133088"] = 191565,
	["128942.133088"] = 199212,
	["128870.133088"] = 192323,
	["128292.133088"] = 189154,

	["128476.133100"] = 197369,
	["127829.133100"] = 201458,
	["128868.133100"] = 197727,
	["128402.133100"] = 192460,
	["128910.133100"] = 209481,
	["128403.133100"] = 191494,
	["128870.133100"] = 192329,
	["128942.133100"] = 199153,
	["128292.133100"] = 189144,
	["128827.133100"] = 194007,
	["128943.133100"] = 211105,

	["128476.133111"] = 197386,
	["127829.133111"] = 201460,
	["128868.133111"] = 197729,
	["128402.133111"] = 192542,
	["128910.133111"] = 248579,
	["128403.133111"] = 191488,
	["128942.133111"] = 199158,
	["128870.133111"] = 192349,
	["128292.133111"] = 189147,
	["128827.133111"] = 194016,
	["128943.133111"] = 211119,

	["128827.151013"] = 194007,
	["128943.151013"] = 211105,
	["128403.151013"] = 191494,
	["128870.151013"] = 192329,
	["128292.151013"] = 189144,
	["128942.151013"] = 199153,
	["128868.151013"] = 197727,
	["128402.151013"] = 192460,
	["128910.151013"] = 209481,
	["128476.151013"] = 197369,
	["127829.151013"] = 201458,

	["128403.132336"] = 191419,
	["128289.132336"] = 188635,
	["128808.132336"] = 203566,
	["128870.132336"] = 192310,
	["128942.132336"] = 199111,
	["128872.132336"] = 216230,
	["128827.132336"] = 194093,
	["128826.132336"] = 190449,
	["128821.132336"] = 200395,
	["128860.132336"] = 210570,
	["128910.132336"] = 209459,
	["128402.132336"] = 192450,

	["128942.132347"] = 199152,
	["128870.132347"] = 192326,
	["128808.132347"] = 203638,
	["128289.132347"] = 203230,
	["128403.132347"] = 191592,
	["128826.132347"] = 190467,
	["128827.132347"] = 193645,
	["128872.132347"] = 202522,
	["128860.132347"] = 210579,
	["128821.132347"] = 200402,
	["128402.132347"] = 192457,
	["128910.132347"] = 216274,

	["128821.132826"] = 200399,
	["128860.132826"] = 210571,
	["128402.132826"] = 192453,
	["128910.132826"] = 209462,
	["128403.132826"] = 191442,
	["128289.132826"] = 216272,
	["128870.132826"] = 192315,
	["128942.132826"] = 199112,
	["128808.132826"] = 203577,
	["128827.132826"] = 193643,
	["128872.132826"] = 202507,
	["128826.132826"] = 190457,

	["128826.132846"] = 190462,
	["128872.132846"] = 202514,
	["128827.132846"] = 193644,
	["128808.132846"] = 203578,
	["128942.132846"] = 199120,
	["128870.132846"] = 192318,
	["128289.132846"] = 188683,
	["128403.132846"] = 191485,
	["128910.132846"] = 209472,
	["128402.132846"] = 192447,
	["128860.132846"] = 210575,
	["128821.132846"] = 208762,

	["128872.133020"] = 216230,
	["128827.133020"] = 194093,
	["128826.133020"] = 190449,
	["128289.133020"] = 188635,
	["128403.133020"] = 191419,
	["128808.133020"] = 203566,
	["128870.133020"] = 192310,
	["128942.133020"] = 199111,
	["128910.133020"] = 209459,
	["128402.133020"] = 192450,
	["128821.133020"] = 200395,
	["128860.133020"] = 210570,

	["128860.133053"] = 210575,
	["128821.133053"] = 208762,
	["128402.133053"] = 192447,
	["128910.133053"] = 209472,
	["128942.133053"] = 199120,
	["128870.133053"] = 192318,
	["128808.133053"] = 203578,
	["128289.133053"] = 188683,
	["128403.133053"] = 191485,
	["128826.133053"] = 190462,
	["128827.133053"] = 193644,
	["128872.133053"] = 202514,

	["128289.133116"] = 203230,
	["128403.133116"] = 191592,
	["128870.133116"] = 192326,
	["128942.133116"] = 199152,
	["128808.133116"] = 203638,
	["128827.133116"] = 193645,
	["128872.133116"] = 202522,
	["128826.133116"] = 190467,
	["128821.133116"] = 200402,
	["128860.133116"] = 210579,
	["128402.133116"] = 192457,
	["128910.133116"] = 216274,

	["128826.133127"] = 190567,
	["128827.133127"] = 194002,
	["128872.133127"] = 202907,
	["128942.133127"] = 199163,
	["128870.133127"] = 192376,
	["128808.133127"] = 203673,
	["128289.133127"] = 188639,
	["128403.133127"] = 208598,
	["128402.133127"] = 192464,
	["128910.133127"] = 209494,
	["128860.133127"] = 210631,
	["128821.133127"] = 200415,

	["128910.133138"] = 209481,
	["128402.133138"] = 192460,
	["128821.133138"] = 200409,
	["128860.133138"] = 210593,
	["128872.133138"] = 202524,
	["128827.133138"] = 194007,
	["128826.133138"] = 190520,
	["128289.133138"] = 203225,
	["128403.133138"] = 191494,
	["128808.133138"] = 203669,
	["128870.133138"] = 192329,
	["128942.133138"] = 199153,

	["128821.132283"] = 208762,
	["128860.132283"] = 210575,
	["128910.132283"] = 209472,
	["128402.132283"] = 192447,
	["128403.132283"] = 191485,
	["128289.132283"] = 188683,
	["128808.132283"] = 203578,
	["128870.132283"] = 192318,
	["128942.132283"] = 199120,
	["128872.132283"] = 202514,
	["128827.132283"] = 193644,
	["128826.132283"] = 190462,

	["128402.132284"] = 192542,
	["128910.132284"] = 248579,
	["128821.132284"] = 200414,
	["128860.132284"] = 210637,
	["128827.132284"] = 194016,
	["128872.132284"] = 202530,
	["128826.132284"] = 190529,
	["128289.132284"] = 203227,
	["128403.132284"] = 191488,
	["128870.132284"] = 192349,
	["128942.132284"] = 199158,
	["128808.132284"] = 203670,

	["128942.132306"] = 199112,
	["128870.132306"] = 192315,
	["128808.132306"] = 203577,
	["128403.132306"] = 191442,
	["128289.132306"] = 216272,
	["128826.132306"] = 190457,
	["128827.132306"] = 193643,
	["128872.132306"] = 202507,
	["128860.132306"] = 210571,
	["128821.132306"] = 200399,
	["128402.132306"] = 192453,
	["128910.132306"] = 209462,

	["128827.132317"] = 194002,
	["128872.132317"] = 202907,
	["128826.132317"] = 190567,
	["128403.132317"] = 208598,
	["128289.132317"] = 188639,
	["128870.132317"] = 192376,
	["128942.132317"] = 199163,
	["128808.132317"] = 203673,
	["128402.132317"] = 192464,
	["128910.132317"] = 209494,
	["128821.132317"] = 200415,
	["128860.132317"] = 210631,

	["128860.132777"] = 210579,
	["128821.132777"] = 200402,
	["128910.132777"] = 216274,
	["128402.132777"] = 192457,
	["128808.132777"] = 203638,
	["128942.132777"] = 199152,
	["128870.132777"] = 192326,
	["128403.132777"] = 191592,
	["128289.132777"] = 203230,
	["128826.132777"] = 190467,
	["128872.132777"] = 202522,
	["128827.132777"] = 193645,

	["128289.132788"] = 203225,
	["128403.132788"] = 191494,
	["128808.132788"] = 203669,
	["128870.132788"] = 192329,
	["128942.132788"] = 199153,
	["128872.132788"] = 202524,
	["128827.132788"] = 194007,
	["128826.132788"] = 190520,
	["128821.132788"] = 200409,
	["128860.132788"] = 210593,
	["128910.132788"] = 209481,
	["128402.132788"] = 192460,

	["128860.132800"] = 210590,
	["128821.132800"] = 200440,
	["128402.132800"] = 192538,
	["128910.132800"] = 209541,
	["128942.132800"] = 199214,
	["128870.132800"] = 192345,
	["128808.132800"] = 203749,
	["128403.132800"] = 191584,
	["128289.132800"] = 188644,
	["128826.132800"] = 190514,
	["128827.132800"] = 193647,
	["128872.132800"] = 202533,

	["128872.132811"] = 202514,
	["128827.132811"] = 193644,
	["128826.132811"] = 190462,
	["128289.132811"] = 188683,
	["128403.132811"] = 191485,
	["128808.132811"] = 203578,
	["128870.132811"] = 192318,
	["128942.132811"] = 199120,
	["128910.132811"] = 209472,
	["128402.132811"] = 192447,
	["128821.132811"] = 208762,
	["128860.132811"] = 210575,

	["128910.132985"] = 216274,
	["128402.132985"] = 192457,
	["128860.132985"] = 210579,
	["128821.132985"] = 200402,
	["128826.132985"] = 190467,
	["128872.132985"] = 202522,
	["128827.132985"] = 193645,
	["128808.132985"] = 203638,
	["128942.132985"] = 199152,
	["128870.132985"] = 192326,
	["128289.132985"] = 203230,
	["128403.132985"] = 191592,

	["128910.132996"] = 209494,
	["128402.132996"] = 192464,
	["128821.132996"] = 200415,
	["128860.132996"] = 210631,
	["128872.132996"] = 202907,
	["128827.132996"] = 194002,
	["128826.132996"] = 190567,
	["128403.132996"] = 208598,
	["128289.132996"] = 188639,
	["128808.132996"] = 203673,
	["128870.132996"] = 192376,
	["128942.132996"] = 199163,

	["128821.133008"] = 200399,
	["128860.133008"] = 210571,
	["128402.133008"] = 192453,
	["128910.133008"] = 209462,
	["128403.133008"] = 191442,
	["128289.133008"] = 216272,
	["128870.133008"] = 192315,
	["128942.133008"] = 199112,
	["128808.133008"] = 203577,
	["128827.133008"] = 193643,
	["128872.133008"] = 202507,
	["128826.133008"] = 190457,

	["128910.133031"] = 248579,
	["128402.133031"] = 192542,
	["128821.133031"] = 200414,
	["128860.133031"] = 210637,
	["128872.133031"] = 202530,
	["128827.133031"] = 194016,
	["128826.133031"] = 190529,
	["128289.133031"] = 203227,
	["128403.133031"] = 191488,
	["128808.133031"] = 203670,
	["128870.133031"] = 192349,
	["128942.133031"] = 199158,

	["128826.133042"] = 190503,
	["128872.133042"] = 202521,
	["128827.133042"] = 193642,
	["128808.133042"] = 224764,
	["128942.133042"] = 199212,
	["128870.133042"] = 192323,
	["128289.133042"] = 188632,
	["128403.133042"] = 191565,
	["128910.133042"] = 209483,
	["128402.133042"] = 192514,
	["128860.133042"] = 210557,
	["128821.133042"] = 200400,

	["128860.133071"] = 210570,
	["128821.133071"] = 200395,
	["128402.133071"] = 192450,
	["128910.133071"] = 209459,
	["128942.133071"] = 199111,
	["128870.133071"] = 192310,
	["128808.133071"] = 203566,
	["128289.133071"] = 188635,
	["128403.133071"] = 191419,
	["128826.133071"] = 190449,
	["128827.133071"] = 194093,
	["128872.133071"] = 216230,

	["128860.133082"] = 210557,
	["128821.133082"] = 200400,
	["128910.133082"] = 209483,
	["128402.133082"] = 192514,
	["128808.133082"] = 224764,
	["128942.133082"] = 199212,
	["128870.133082"] = 192323,
	["128289.133082"] = 188632,
	["128403.133082"] = 191565,
	["128826.133082"] = 190503,
	["128872.133082"] = 202521,
	["128827.133082"] = 193642,

	["128860.133094"] = 210593,
	["128821.133094"] = 200409,
	["128910.133094"] = 209481,
	["128402.133094"] = 192460,
	["128808.133094"] = 203669,
	["128942.133094"] = 199153,
	["128870.133094"] = 192329,
	["128289.133094"] = 203225,
	["128403.133094"] = 191494,
	["128826.133094"] = 190520,
	["128872.133094"] = 202524,
	["128827.133094"] = 194007,

	["128808.133105"] = 203670,
	["128942.133105"] = 199158,
	["128870.133105"] = 192349,
	["128403.133105"] = 191488,
	["128289.133105"] = 203227,
	["128826.133105"] = 190529,
	["128872.133105"] = 202530,
	["128827.133105"] = 194016,
	["128860.133105"] = 210637,
	["128821.133105"] = 200414,
	["128910.133105"] = 248579,
	["128402.133105"] = 192542,

	["128910.151007"] = 209481,
	["128402.151007"] = 192460,
	["128821.151007"] = 200409,
	["128860.151007"] = 210593,
	["128872.151007"] = 202524,
	["128827.151007"] = 194007,
	["128826.151007"] = 190520,
	["128403.151007"] = 191494,
	["128289.151007"] = 203225,
	["128808.151007"] = 203669,
	["128870.151007"] = 192329,
	["128942.151007"] = 199153,

	["128938.132340"] = 213051,
	["128289.132340"] = 188635,
	["128908.132340"] = 200846,
	["128870.132340"] = 192310,
	["128866.132340"] = 209229,
	["128808.132340"] = 203566,
	["128819.132340"] = 215381,
	["128872.132340"] = 216230,
	["128861.132340"] = 197038,
	["128832.132340"] = 207343,
	["128402.132340"] = 192450,
	["128910.132340"] = 209459,
	["128940.132340"] = 195243,

	["128872.132351"] = 202522,
	["128819.132351"] = 198292,
	["128808.132351"] = 203638,
	["128866.132351"] = 209226,
	["128870.132351"] = 192326,
	["128908.132351"] = 200853,
	["128938.132351"] = 213062,
	["128289.132351"] = 203230,
	["128940.132351"] = 195266,
	["128910.132351"] = 216274,
	["128402.132351"] = 192457,
	["128832.132351"] = 207375,
	["128861.132351"] = 197139,

	["128861.132830"] = 206910,
	["128832.132830"] = 212819,
	["128402.132830"] = 192464,
	["128910.132830"] = 209494,
	["128940.132830"] = 195267,
	["128938.132830"] = 213136,
	["128289.132830"] = 188639,
	["128908.132830"] = 200861,
	["128870.132830"] = 192376,
	["128866.132830"] = 209216,
	["128808.132830"] = 203673,
	["128819.132830"] = 198238,
	["128872.132830"] = 202907,

	["128866.132850"] = 209224,
	["128808.132850"] = 224764,
	["128870.132850"] = 192323,
	["128908.132850"] = 200857,
	["128289.132850"] = 188632,
	["128938.132850"] = 213047,
	["128872.132850"] = 202521,
	["128819.132850"] = 198296,
	["128832.132850"] = 212821,
	["128861.132850"] = 197160,
	["128910.132850"] = 209483,
	["128940.132850"] = 195244,
	["128402.132850"] = 192514,

	["128832.133024"] = 207343,
	["128861.133024"] = 197038,
	["128402.133024"] = 192450,
	["128940.133024"] = 195243,
	["128910.133024"] = 209459,
	["128870.133024"] = 192310,
	["128866.133024"] = 209229,
	["128808.133024"] = 203566,
	["128289.133024"] = 188635,
	["128938.133024"] = 213051,
	["128908.133024"] = 200846,
	["128819.133024"] = 215381,
	["128872.133024"] = 216230,

	["128819.133057"] = 198247,
	["128872.133057"] = 202514,
	["128870.133057"] = 192318,
	["128808.133057"] = 203578,
	["128866.133057"] = 209220,
	["128938.133057"] = 213180,
	["128289.133057"] = 188683,
	["128908.133057"] = 200849,
	["128402.133057"] = 192447,
	["128910.133057"] = 209472,
	["128940.133057"] = 218607,
	["128832.133057"] = 207352,
	["128861.133057"] = 197080,

	["128910.133120"] = 209541,
	["128940.133120"] = 195380,
	["128402.133120"] = 192538,
	["128861.133120"] = 197138,
	["128832.133120"] = 212827,
	["128872.133120"] = 202533,
	["128819.133120"] = 198248,
	["128908.133120"] = 200859,
	["128289.133120"] = 188644,
	["128938.133120"] = 213116,
	["128866.133120"] = 209225,
	["128808.133120"] = 203749,
	["128870.133120"] = 192345,

	["128819.133131"] = 198238,
	["128872.133131"] = 202907,
	["128870.133131"] = 192376,
	["128866.133131"] = 209216,
	["128808.133131"] = 203673,
	["128938.133131"] = 213136,
	["128289.133131"] = 188639,
	["128908.133131"] = 200861,
	["128402.133131"] = 192464,
	["128940.133131"] = 195267,
	["128910.133131"] = 209494,
	["128832.133131"] = 212819,
	["128861.133131"] = 206910,

	["128866.133142"] = 209229,
	["128808.133142"] = 203566,
	["128870.133142"] = 192310,
	["128908.133142"] = 200846,
	["128289.133142"] = 188635,
	["128938.133142"] = 213051,
	["128872.133142"] = 216230,
	["128819.133142"] = 215381,
	["128832.133142"] = 207343,
	["128861.133142"] = 197038,
	["128910.133142"] = 209459,
	["128940.133142"] = 195243,
	["128402.133142"] = 192450,

	["128866.132294"] = 209220,
	["128808.132294"] = 203578,
	["128870.132294"] = 192318,
	["128908.132294"] = 200849,
	["128289.132294"] = 188683,
	["128938.132294"] = 213180,
	["128872.132294"] = 202514,
	["128819.132294"] = 198247,
	["128832.132294"] = 207352,
	["128861.132294"] = 197080,
	["128910.132294"] = 209472,
	["128940.132294"] = 218607,
	["128402.132294"] = 192447,

	["128872.132295"] = 202530,
	["128819.132295"] = 198349,
	["128808.132295"] = 203670,
	["128866.132295"] = 209218,
	["128870.132295"] = 192349,
	["128908.132295"] = 200860,
	["128938.132295"] = 213133,
	["128289.132295"] = 203227,
	["128910.132295"] = 248579,
	["128940.132295"] = 195291,
	["128402.132295"] = 192542,
	["128832.132295"] = 212817,
	["128861.132295"] = 197162,

	["128861.132310"] = 197047,
	["128832.132310"] = 207347,
	["128402.132310"] = 192453,
	["128910.132310"] = 209462,
	["128940.132310"] = 195263,
	["128938.132310"] = 213049,
	["128289.132310"] = 216272,
	["128908.132310"] = 216273,
	["128870.132310"] = 192315,
	["128866.132310"] = 209217,
	["128808.132310"] = 203577,
	["128819.132310"] = 198236,
	["128872.132310"] = 202507,

	["128938.132321"] = 213136,
	["128289.132321"] = 188639,
	["128908.132321"] = 200861,
	["128870.132321"] = 192376,
	["128866.132321"] = 209216,
	["128808.132321"] = 203673,
	["128819.132321"] = 198238,
	["128872.132321"] = 202907,
	["128861.132321"] = 206910,
	["128832.132321"] = 212819,
	["128402.132321"] = 192464,
	["128940.132321"] = 195267,
	["128910.132321"] = 209494,

	["128938.132781"] = 213062,
	["128289.132781"] = 203230,
	["128908.132781"] = 200853,
	["128870.132781"] = 192326,
	["128866.132781"] = 209226,
	["128808.132781"] = 203638,
	["128819.132781"] = 198292,
	["128872.132781"] = 202522,
	["128861.132781"] = 197139,
	["128832.132781"] = 207375,
	["128402.132781"] = 192457,
	["128910.132781"] = 216274,
	["128940.132781"] = 195266,

	["128832.132792"] = 212816,
	["128861.132792"] = 197140,
	["128940.132792"] = 195269,
	["128910.132792"] = 209481,
	["128402.132792"] = 192460,
	["128808.132792"] = 203669,
	["128866.132792"] = 209223,
	["128870.132792"] = 192329,
	["128908.132792"] = 200856,
	["128289.132792"] = 203225,
	["128938.132792"] = 213055,
	["128872.132792"] = 202524,
	["128819.132792"] = 198299,

	["128870.132804"] = 192345,
	["128808.132804"] = 203749,
	["128866.132804"] = 209225,
	["128289.132804"] = 188644,
	["128938.132804"] = 213116,
	["128908.132804"] = 200859,
	["128819.132804"] = 198248,
	["128872.132804"] = 202533,
	["128832.132804"] = 212827,
	["128861.132804"] = 197138,
	["128402.132804"] = 192538,
	["128940.132804"] = 195380,
	["128910.132804"] = 209541,

	["128866.132815"] = 209220,
	["128808.132815"] = 203578,
	["128870.132815"] = 192318,
	["128908.132815"] = 200849,
	["128289.132815"] = 188683,
	["128938.132815"] = 213180,
	["128872.132815"] = 202514,
	["128819.132815"] = 198247,
	["128832.132815"] = 207352,
	["128861.132815"] = 197080,
	["128940.132815"] = 218607,
	["128910.132815"] = 209472,
	["128402.132815"] = 192447,

	["128819.132989"] = 198292,
	["128872.132989"] = 202522,
	["128870.132989"] = 192326,
	["128808.132989"] = 203638,
	["128866.132989"] = 209226,
	["128938.132989"] = 213062,
	["128289.132989"] = 203230,
	["128908.132989"] = 200853,
	["128402.132989"] = 192457,
	["128940.132989"] = 195266,
	["128910.132989"] = 216274,
	["128832.132989"] = 207375,
	["128861.132989"] = 197139,

	["128872.133000"] = 202907,
	["128819.133000"] = 198238,
	["128866.133000"] = 209216,
	["128808.133000"] = 203673,
	["128870.133000"] = 192376,
	["128908.133000"] = 200861,
	["128938.133000"] = 213136,
	["128289.133000"] = 188639,
	["128940.133000"] = 195267,
	["128910.133000"] = 209494,
	["128402.133000"] = 192464,
	["128832.133000"] = 212819,
	["128861.133000"] = 206910,

	["128872.133012"] = 202507,
	["128819.133012"] = 198236,
	["128866.133012"] = 209217,
	["128808.133012"] = 203577,
	["128870.133012"] = 192315,
	["128908.133012"] = 216273,
	["128938.133012"] = 213049,
	["128289.133012"] = 216272,
	["128940.133012"] = 195263,
	["128910.133012"] = 209462,
	["128402.133012"] = 192453,
	["128832.133012"] = 207347,
	["128861.133012"] = 197047,

	["128861.133035"] = 197047,
	["128832.133035"] = 207347,
	["128940.133035"] = 195263,
	["128910.133035"] = 209462,
	["128402.133035"] = 192453,
	["128908.133035"] = 216273,
	["128938.133035"] = 213049,
	["128289.133035"] = 216272,
	["128808.133035"] = 203577,
	["128866.133035"] = 209217,
	["128870.133035"] = 192315,
	["128872.133035"] = 202507,
	["128819.133035"] = 198236,

	["128402.133046"] = 192514,
	["128910.133046"] = 209483,
	["128940.133046"] = 195244,
	["128861.133046"] = 197160,
	["128832.133046"] = 212821,
	["128819.133046"] = 198296,
	["128872.133046"] = 202521,
	["128289.133046"] = 188632,
	["128938.133046"] = 213047,
	["128908.133046"] = 200857,
	["128870.133046"] = 192323,
	["128808.133046"] = 224764,
	["128866.133046"] = 209224,

	["128938.133075"] = 213051,
	["128289.133075"] = 188635,
	["128908.133075"] = 200846,
	["128870.133075"] = 192310,
	["128866.133075"] = 209229,
	["128808.133075"] = 203566,
	["128819.133075"] = 215381,
	["128872.133075"] = 216230,
	["128861.133075"] = 197038,
	["128832.133075"] = 207343,
	["128402.133075"] = 192450,
	["128910.133075"] = 209459,
	["128940.133075"] = 195243,

	["128832.133086"] = 212821,
	["128861.133086"] = 197160,
	["128402.133086"] = 192514,
	["128940.133086"] = 195244,
	["128910.133086"] = 209483,
	["128870.133086"] = 192323,
	["128808.133086"] = 224764,
	["128866.133086"] = 209224,
	["128289.133086"] = 188632,
	["128938.133086"] = 213047,
	["128908.133086"] = 200857,
	["128819.133086"] = 198296,
	["128872.133086"] = 202521,

	["128872.133098"] = 202524,
	["128819.133098"] = 198299,
	["128866.133098"] = 209223,
	["128808.133098"] = 203669,
	["128870.133098"] = 192329,
	["128908.133098"] = 200856,
	["128938.133098"] = 213055,
	["128289.133098"] = 203225,
	["128910.133098"] = 209481,
	["128940.133098"] = 195269,
	["128402.133098"] = 192460,
	["128832.133098"] = 212816,
	["128861.133098"] = 197140,

	["128819.133109"] = 198349,
	["128872.133109"] = 202530,
	["128870.133109"] = 192349,
	["128866.133109"] = 209218,
	["128808.133109"] = 203670,
	["128938.133109"] = 213133,
	["128289.133109"] = 203227,
	["128908.133109"] = 200860,
	["128402.133109"] = 192542,
	["128910.133109"] = 248579,
	["128940.133109"] = 195291,
	["128832.133109"] = 212817,
	["128861.133109"] = 197162,

	["128910.151011"] = 238075,
	["128940.151011"] = 238059,
	["128402.151011"] = 238042,
	["128861.151011"] = 238051,
	["128832.151011"] = 238046,
	["128872.151011"] = 238067,
	["128819.151011"] = 238070,
	["128908.151011"] = 238076,
	["128289.151011"] = 238077,
	["128938.151011"] = 238057,
	["128808.151011"] = 238053,
	["128866.151011"] = 238061,
	["128870.151011"] = 238066,

	["128825.152043"] = 196418,
	["128868.152043"] = 197716,
	["120978.152043"] = 186945,
	["128866.152043"] = 209226,
	["128823.152043"] = 200296,

	["128823.152044"] = 200326,
	["120978.152044"] = 186941,
	["128866.152044"] = 209229,
	["128868.152044"] = 197708,
	["128825.152044"] = 196434,

	["120978.152045"] = 186944,
	["128866.152045"] = 209216,
	["128823.152045"] = 200482,
	["128825.152045"] = 196430,
	["128868.152045"] = 197762,

	["120978.152046"] = 238062,
	["128866.152046"] = 238061,
	["128823.152046"] = 238060,
	["128825.152046"] = 238064,
	["128868.152046"] = 238063,

	["128825.152347"] = 196355,
	["128868.152347"] = 216212,
	["120978.152347"] = 184778,
	["128866.152347"] = 209225,
	["128823.152347"] = 200302,

	["128940.152058"] = 195263,
	["128861.152058"] = 197047,
	["128819.152058"] = 198236,
	["128935.152058"] = 191499,
	["128872.152058"] = 202507,
	["128826.152058"] = 190457,
	["128937.152058"] = 199366,
	["128938.152058"] = 213049,
	["128908.152058"] = 216273,
	["128808.152058"] = 203577,

	["128861.152059"] = 197140,
	["128940.152059"] = 195269,
	["128908.152059"] = 200856,
	["128938.152059"] = 213055,
	["128937.152059"] = 199377,
	["128808.152059"] = 203669,
	["128872.152059"] = 202524,
	["128819.152059"] = 198299,
	["128935.152059"] = 191572,
	["128826.152059"] = 190520,

	["128826.152060"] = 190449,
	["128935.152060"] = 191493,
	["128819.152060"] = 215381,
	["128872.152060"] = 216230,
	["128808.152060"] = 203566,
	["128937.152060"] = 199364,
	["128938.152060"] = 213051,
	["128908.152060"] = 200846,
	["128940.152060"] = 195243,
	["128861.152060"] = 197038,

	["128872.152061"] = 202522,
	["128819.152061"] = 198292,
	["128935.152061"] = 191740,
	["128826.152061"] = 190467,
	["128908.152061"] = 200853,
	["128937.152061"] = 199372,
	["128938.152061"] = 213062,
	["128808.152061"] = 203638,
	["128940.152061"] = 195266,
	["128861.152061"] = 197139,

	["128861.152348"] = 197160,
	["128940.152348"] = 195244,
	["128908.152348"] = 200857,
	["128937.152348"] = 199365,
	["128938.152348"] = 213047,
	["128808.152348"] = 224764,
	["128872.152348"] = 202521,
	["128819.152348"] = 198296,
	["128935.152348"] = 191569,
	["128826.152348"] = 190503,

	["128821.152050"] = 208762,
	["128858.152050"] = 202426,
	["128825.152050"] = 196416,
	["128306.152050"] = 189760,
	["128860.152050"] = 210575,
	["128823.152050"] = 200315,
	["128911.152050"] = 207118,
	["128826.152050"] = 190462,
	["128937.152050"] = 199367,
	["128938.152050"] = 213180,

	["128826.152051"] = 190520,
	["128823.152051"] = 200294,
	["128911.152051"] = 207255,
	["128937.152051"] = 199377,
	["128938.152051"] = 213055,
	["128825.152051"] = 196422,
	["128860.152051"] = 210593,
	["128306.152051"] = 189754,
	["128821.152051"] = 200409,
	["128858.152051"] = 202445,

	["128825.152052"] = 196358,
	["128306.152052"] = 189768,
	["128860.152052"] = 210571,
	["128821.152052"] = 200399,
	["128858.152052"] = 202386,
	["128826.152052"] = 190457,
	["128823.152052"] = 200316,
	["128911.152052"] = 207092,
	["128937.152052"] = 199366,
	["128938.152052"] = 213049,

	["128938.152053"] = 213116,
	["128937.152053"] = 199384,
	["128911.152053"] = 207354,
	["128823.152053"] = 200302,
	["128826.152053"] = 190514,
	["128858.152053"] = 203018,
	["128821.152053"] = 200440,
	["128306.152053"] = 186320,
	["128860.152053"] = 210590,
	["128825.152053"] = 196355,

	["128937.152291"] = 238058,
	["128938.152291"] = 238057,
	["128823.152291"] = 238060,
	["128911.152291"] = 238071,
	["128826.152291"] = 238052,
	["128821.152291"] = 238049,
	["128858.152291"] = 238047,
	["128825.152291"] = 238064,
	["128306.152291"] = 238050,
	["128860.152291"] = 238048,

	["128941.152035"] = 196258,
	["128908.152035"] = 200861,
	["120978.152035"] = 186944,
	["128289.152035"] = 188639,
	["128403.152035"] = 208598,
	["128943.152035"] = 211099,
	["128819.152035"] = 198238,
	["128821.152035"] = 200415,
	["128820.152035"] = 194239,

	["128819.152036"] = 198236,
	["128943.152036"] = 211126,
	["128289.152036"] = 216272,
	["128403.152036"] = 191442,
	["120978.152036"] = 184759,
	["128908.152036"] = 216273,
	["128941.152036"] = 196217,
	["128820.152036"] = 194234,
	["128821.152036"] = 200399,

	["128941.152037"] = 196236,
	["120978.152037"] = 186927,
	["128289.152037"] = 203225,
	["128403.152037"] = 191494,
	["128908.152037"] = 200856,
	["128819.152037"] = 198299,
	["128943.152037"] = 211105,
	["128821.152037"] = 200409,
	["128820.152037"] = 194313,

	["128821.152038"] = 200395,
	["128820.152038"] = 194224,
	["128941.152038"] = 196211,
	["128908.152038"] = 200846,
	["128403.152038"] = 191419,
	["128289.152038"] = 188635,
	["120978.152038"] = 186941,
	["128943.152038"] = 211108,
	["128819.152038"] = 215381,

	["128821.152294"] = 200400,
	["128820.152294"] = 194318,
	["128941.152294"] = 196301,
	["128403.152294"] = 191565,
	["128289.152294"] = 188632,
	["120978.152294"] = 186934,
	["128908.152294"] = 200857,
	["128819.152294"] = 198296,
	["128943.152294"] = 211144,

	["128937.152039"] = 199372,
	["128292.152039"] = 189164,
	["128862.152039"] = 195323,
	["128911.152039"] = 207206,
	["128935.152039"] = 191740,
	["127857.152039"] = 187264,
	["128860.152039"] = 210579,
	["128306.152039"] = 189757,

	["128306.152040"] = 189744,
	["128860.152040"] = 210631,
	["127857.152040"] = 187287,
	["128911.152040"] = 207348,
	["128935.152040"] = 191598,
	["128862.152040"] = 195352,
	["128292.152040"] = 189097,
	["128937.152040"] = 199485,

	["128306.152041"] = 189772,
	["128860.152041"] = 210570,
	["127857.152041"] = 187304,
	["128911.152041"] = 207088,
	["128935.152041"] = 191493,
	["128862.152041"] = 195315,
	["128292.152041"] = 189080,
	["128937.152041"] = 199364,

	["127857.152042"] = 187276,
	["128860.152042"] = 210637,
	["128306.152042"] = 189749,
	["128937.152042"] = 199380,
	["128292.152042"] = 189147,
	["128911.152042"] = 207285,
	["128935.152042"] = 191577,
	["128862.152042"] = 195351,

	["127857.152346"] = 187301,
	["128860.152346"] = 210557,
	["128306.152346"] = 186396,
	["128862.152346"] = 195354,
	["128911.152346"] = 207351,
	["128935.152346"] = 191569,
	["128937.152346"] = 199365,
	["128292.152346"] = 189154,

	["128832.152024"] = 207343,
	["128861.152024"] = 197038,
	["127857.152024"] = 187304,
	["128858.152024"] = 202384,
	["128820.152024"] = 194224,
	["128866.152024"] = 209229,
	["128862.152024"] = 195315,

	["128820.152025"] = 238055,
	["128832.152025"] = 238046,
	["127857.152025"] = 238054,
	["128858.152025"] = 238047,
	["128861.152025"] = 238051,
	["128862.152025"] = 238056,
	["128866.152025"] = 238061,

	["128862.152026"] = 195352,
	["128866.152026"] = 209216,
	["128820.152026"] = 194239,
	["128832.152026"] = 212819,
	["128858.152026"] = 202464,
	["127857.152026"] = 187287,
	["128861.152026"] = 206910,

	["128862.152027"] = 195317,
	["128866.152027"] = 209217,
	["128820.152027"] = 194234,
	["128861.152027"] = 197047,
	["128858.152027"] = 202386,
	["127857.152027"] = 187258,
	["128832.152027"] = 207347,

	["128820.152344"] = 194315,
	["127857.152344"] = 210716,
	["128858.152344"] = 203018,
	["128861.152344"] = 197138,
	["128832.152344"] = 212827,
	["128862.152344"] = 214626,
	["128866.152344"] = 209225,

	["127829.152031"] = 201460,
	["128832.152031"] = 212817,
	["128476.152031"] = 197386,
	["128943.152031"] = 211119,
	["128941.152031"] = 196432,

	["128943.152032"] = 211099,
	["128941.152032"] = 196258,
	["128476.152032"] = 197239,
	["128832.152032"] = 212819,
	["127829.152032"] = 201464,

	["128943.152033"] = 211105,
	["128941.152033"] = 196236,
	["128476.152033"] = 197369,
	["127829.152033"] = 201458,
	["128832.152033"] = 212816,

	["127829.152034"] = 201457,
	["128832.152034"] = 207375,
	["128476.152034"] = 197235,
	["128943.152034"] = 211123,
	["128941.152034"] = 196227,

	["128943.152345"] = 211099,
	["128941.152345"] = 196258,
	["128476.152345"] = 197239,
	["127829.152345"] = 201464,
	["128832.152345"] = 212819,

	["128476.152054"] = 197369,
	["127829.152054"] = 201458,
	["128868.152054"] = 197727,
	["128910.152054"] = 209481,
	["128402.152054"] = 192460,
	["128403.152054"] = 191494,
	["128870.152054"] = 192329,
	["128942.152054"] = 199153,
	["128292.152054"] = 189144,
	["128943.152054"] = 211105,
	["128827.152054"] = 194007,

	["127829.152055"] = 201456,
	["128476.152055"] = 197234,
	["128402.152055"] = 192447,
	["128910.152055"] = 209472,
	["128868.152055"] = 197715,
	["128292.152055"] = 189086,
	["128870.152055"] = 192318,
	["128942.152055"] = 199120,
	["128403.152055"] = 191485,
	["128827.152055"] = 193644,
	["128943.152055"] = 211106,

	["128827.152056"] = 194093,
	["128943.152056"] = 211108,
	["128403.152056"] = 191419,
	["128942.152056"] = 199111,
	["128870.152056"] = 192310,
	["128292.152056"] = 189080,
	["128868.152056"] = 197708,
	["128402.152056"] = 192450,
	["128910.152056"] = 209459,
	["128476.152056"] = 197231,
	["127829.152056"] = 201454,

	["128476.152057"] = 238068,
	["127829.152057"] = 238045,
	["128868.152057"] = 238063,
	["128910.152057"] = 238075,
	["128402.152057"] = 238042,
	["128403.152057"] = 238044,
	["128292.152057"] = 238043,
	["128870.152057"] = 238066,
	["128942.152057"] = 238072,
	["128943.152057"] = 238073,
	["128827.152057"] = 238065,

	["128827.152290"] = 193642,
	["128943.152290"] = 211144,
	["128870.152290"] = 192323,
	["128292.152290"] = 189154,
	["128942.152290"] = 199212,
	["128403.152290"] = 191565,
	["128402.152290"] = 192514,
	["128910.152290"] = 209483,
	["128868.152290"] = 197711,
	["127829.152290"] = 201459,
	["128476.152290"] = 197241,

	["128826.152028"] = 190567,
	["128872.152028"] = 202907,
	["128827.152028"] = 194002,
	["128808.152028"] = 203673,
	["128942.152028"] = 199163,
	["128870.152028"] = 192376,
	["128289.152028"] = 188639,
	["128403.152028"] = 208598,
	["128910.152028"] = 209494,
	["128402.152028"] = 192464,
	["128860.152028"] = 210631,
	["128821.152028"] = 200415,

	["128402.152029"] = 192457,
	["128910.152029"] = 216274,
	["128821.152029"] = 200402,
	["128860.152029"] = 210579,
	["128827.152029"] = 193645,
	["128872.152029"] = 202522,
	["128826.152029"] = 190467,
	["128403.152029"] = 191592,
	["128289.152029"] = 203230,
	["128870.152029"] = 192326,
	["128942.152029"] = 199152,
	["128808.152029"] = 203638,

	["128860.152030"] = 210557,
	["128821.152030"] = 200400,
	["128910.152030"] = 209483,
	["128402.152030"] = 192514,
	["128808.152030"] = 224764,
	["128942.152030"] = 199212,
	["128870.152030"] = 192323,
	["128289.152030"] = 188632,
	["128403.152030"] = 191565,
	["128826.152030"] = 190503,
	["128872.152030"] = 202521,
	["128827.152030"] = 193642,

	["128826.152092"] = 190529,
	["128872.152092"] = 202530,
	["128827.152092"] = 194016,
	["128808.152092"] = 203670,
	["128942.152092"] = 199158,
	["128870.152092"] = 192349,
	["128403.152092"] = 191488,
	["128289.152092"] = 203227,
	["128910.152092"] = 248579,
	["128402.152092"] = 192542,
	["128860.152092"] = 210637,
	["128821.152092"] = 200414,

	["128910.152295"] = 209472,
	["128402.152295"] = 192447,
	["128821.152295"] = 208762,
	["128860.152295"] = 210575,
	["128872.152295"] = 202514,
	["128827.152295"] = 193644,
	["128826.152295"] = 190462,
	["128289.152295"] = 188683,
	["128403.152295"] = 191485,
	["128808.152295"] = 203578,
	["128870.152295"] = 192318,
	["128942.152295"] = 199120,

	["128819.152047"] = 198236,
	["128872.152047"] = 202507,
	["128289.152047"] = 216272,
	["128938.152047"] = 213049,
	["128908.152047"] = 216273,
	["128870.152047"] = 192315,
	["128866.152047"] = 209217,
	["128808.152047"] = 203577,
	["128402.152047"] = 192453,
	["128940.152047"] = 195263,
	["128910.152047"] = 209462,
	["128861.152047"] = 197047,
	["128832.152047"] = 207347,

	["128872.152048"] = 238067,
	["128819.152048"] = 238070,
	["128908.152048"] = 238076,
	["128289.152048"] = 238077,
	["128938.152048"] = 238057,
	["128808.152048"] = 238053,
	["128866.152048"] = 238061,
	["128870.152048"] = 238066,
	["128940.152048"] = 238059,
	["128910.152048"] = 238075,
	["128402.152048"] = 238042,
	["128861.152048"] = 238051,
	["128832.152048"] = 238046,

	["128819.152049"] = 198247,
	["128872.152049"] = 202514,
	["128870.152049"] = 192318,
	["128866.152049"] = 209220,
	["128808.152049"] = 203578,
	["128938.152049"] = 213180,
	["128289.152049"] = 188683,
	["128908.152049"] = 200849,
	["128402.152049"] = 192447,
	["128910.152049"] = 209472,
	["128940.152049"] = 218607,
	["128832.152049"] = 207352,
	["128861.152049"] = 197080,

	["128819.152292"] = 198248,
	["128872.152292"] = 202533,
	["128870.152292"] = 192345,
	["128808.152292"] = 203749,
	["128866.152292"] = 209225,
	["128938.152292"] = 213116,
	["128289.152292"] = 188644,
	["128908.152292"] = 200859,
	["128402.152292"] = 192538,
	["128910.152292"] = 209541,
	["128940.152292"] = 195380,
	["128832.152292"] = 212827,
	["128861.152292"] = 197138,

	["128808.152293"] = 203670,
	["128866.152293"] = 209218,
	["128870.152293"] = 192349,
	["128908.152293"] = 200860,
	["128289.152293"] = 203227,
	["128938.152293"] = 213133,
	["128872.152293"] = 202530,
	["128819.152293"] = 198349,
	["128832.152293"] = 212817,
	["128861.152293"] = 197162,
	["128910.152293"] = 248579,
	["128940.152293"] = 195291,
	["128402.152293"] = 192542,

	["120978.152695"] = 184843,
	["128866.152695"] = 209220,
	["128823.152695"] = 200315,
	["128825.152695"] = 196416,
	["128868.152695"] = 197715,

	["128808.152715"] = 203638,
	["128938.152715"] = 213062,
	["128937.152715"] = 199372,
	["128908.152715"] = 200853,
	["128826.152715"] = 190467,
	["128935.152715"] = 191740,
	["128819.152715"] = 198292,
	["128872.152715"] = 202522,
	["128861.152715"] = 197139,
	["128940.152715"] = 195266,

	["128825.152697"] = 196422,
	["128306.152697"] = 189754,
	["128860.152697"] = 210593,
	["128821.152697"] = 200409,
	["128858.152697"] = 202445,
	["128938.152697"] = 213055,
	["128937.152697"] = 199377,
	["128826.152697"] = 190520,
	["128823.152697"] = 200294,
	["128911.152697"] = 207255,

	["128820.152693"] = 238055,
	["128821.152693"] = 238049,
	["128819.152693"] = 238070,
	["128943.152693"] = 238073,
	["128289.152693"] = 238077,
	["120978.152693"] = 238062,
	["128403.152693"] = 238044,
	["128908.152693"] = 238076,
	["128941.152693"] = 238074,

	["128935.152694"] = 191598,
	["128911.152694"] = 207348,
	["128862.152694"] = 195352,
	["128937.152694"] = 199485,
	["128292.152694"] = 189097,
	["127857.152694"] = 187287,
	["128860.152694"] = 210631,
	["128306.152694"] = 189744,

	["128862.152690"] = 195317,
	["128866.152690"] = 209217,
	["128820.152690"] = 194234,
	["128861.152690"] = 197047,
	["128858.152690"] = 202386,
	["127857.152690"] = 187258,
	["128832.152690"] = 207347,

	["127829.152692"] = 201458,
	["128832.152692"] = 212816,
	["128476.152692"] = 197369,
	["128941.152692"] = 196236,
	["128943.152692"] = 211105,

	["128827.153421"] = 193645,
	["128943.153421"] = 211123,
	["128292.153421"] = 189164,
	["128870.153421"] = 192326,
	["128942.153421"] = 199152,
	["128403.153421"] = 191592,
	["128402.153421"] = 192457,
	["128910.153421"] = 216274,
	["128868.153421"] = 197716,
	["127829.153421"] = 201457,
	["128476.153421"] = 197235,

	["128910.152691"] = 248579,
	["128402.152691"] = 192542,
	["128821.152691"] = 200414,
	["128860.152691"] = 210637,
	["128872.152691"] = 202530,
	["128827.152691"] = 194016,
	["128826.152691"] = 190529,
	["128403.152691"] = 191488,
	["128289.152691"] = 203227,
	["128808.152691"] = 203670,
	["128870.152691"] = 192349,
	["128942.152691"] = 199158,

	["128940.152696"] = 218607,
	["128910.152696"] = 209472,
	["128402.152696"] = 192447,
	["128832.152696"] = 207352,
	["128861.152696"] = 197080,
	["128872.152696"] = 202514,
	["128819.152696"] = 198247,
	["128866.152696"] = 209220,
	["128808.152696"] = 203578,
	["128870.152696"] = 192318,
	["128908.152696"] = 200849,
	["128938.152696"] = 213180,
	["128289.152696"] = 188683,

	["128868.151297"] = 197762,
	["128825.151297"] = 196430,
	["128823.151297"] = 200482,
	["120978.151297"] = 186944,
	["128866.151297"] = 209216,

	["128940.151295"] = 195269,
	["128861.151295"] = 197140,
	["128826.151295"] = 190520,
	["128872.151295"] = 202524,
	["128935.151295"] = 191572,
	["128819.151295"] = 198299,
	["128808.151295"] = 203669,
	["128908.151295"] = 200856,
	["128937.151295"] = 199377,
	["128938.151295"] = 213055,

	["128911.151288"] = 207088,
	["128823.151288"] = 200326,
	["128826.151288"] = 190449,
	["128937.151288"] = 199364,
	["128938.151288"] = 213051,
	["128858.151288"] = 202384,
	["128821.151288"] = 200395,
	["128860.151288"] = 210570,
	["128306.151288"] = 189772,
	["128825.151288"] = 196434,

	["128821.151290"] = 200402,
	["128820.151290"] = 210182,
	["128941.151290"] = 196227,
	["128908.151290"] = 200853,
	["120978.151290"] = 186945,
	["128289.151290"] = 203230,
	["128403.151290"] = 191592,
	["128943.151290"] = 211123,
	["128819.151290"] = 198292,

	["128935.151291"] = 191577,
	["128911.151291"] = 207285,
	["128862.151291"] = 195351,
	["128937.151291"] = 199380,
	["128292.151291"] = 189147,
	["127857.151291"] = 187276,
	["128860.151291"] = 210637,
	["128306.151291"] = 189749,

	["128820.151293"] = 194234,
	["127857.151293"] = 187258,
	["128858.151293"] = 202386,
	["128861.151293"] = 197047,
	["128832.151293"] = 207347,
	["128862.151293"] = 195317,
	["128866.151293"] = 209217,

	["128476.151289"] = 197241,
	["128832.151289"] = 212821,
	["127829.151289"] = 201459,
	["128941.151289"] = 196301,
	["128943.151289"] = 211144,

	["128403.151294"] = 191584,
	["128870.151294"] = 192345,
	["128942.151294"] = 199214,
	["128292.151294"] = 204875,
	["128827.151294"] = 193647,
	["128943.151294"] = 211131,
	["128476.151294"] = 197244,
	["127829.151294"] = 201463,
	["128868.151294"] = 216212,
	["128402.151294"] = 192538,
	["128910.151294"] = 209541,

	["128821.151296"] = 208762,
	["128860.151296"] = 210575,
	["128910.151296"] = 209472,
	["128402.151296"] = 192447,
	["128289.151296"] = 188683,
	["128403.151296"] = 191485,
	["128808.151296"] = 203578,
	["128870.151296"] = 192318,
	["128942.151296"] = 199120,
	["128872.151296"] = 202514,
	["128827.151296"] = 193644,
	["128826.151296"] = 190462,

	["128402.151292"] = 192460,
	["128940.151292"] = 195269,
	["128910.151292"] = 209481,
	["128832.151292"] = 212816,
	["128861.151292"] = 197140,
	["128819.151292"] = 198299,
	["128872.151292"] = 202524,
	["128870.151292"] = 192329,
	["128808.151292"] = 203669,
	["128866.151292"] = 209223,
	["128938.151292"] = 213055,
	["128289.151292"] = 203225,
	["128908.151292"] = 200856,

	["128866.150289"] = 209220,
	["120978.150289"] = 184843,
	["128823.150289"] = 200315,
	["128825.150289"] = 196416,
	["128868.150289"] = 197715,

	["128868.150290"] = 197762,
	["128825.150290"] = 196430,
	["128823.150290"] = 200482,
	["128866.150290"] = 209216,
	["120978.150290"] = 186944,

	["128823.150291"] = 200302,
	["120978.150291"] = 184778,
	["128866.150291"] = 209225,
	["128868.150291"] = 216212,
	["128825.150291"] = 196355,

	["120978.150313"] = 184843,
	["128866.150313"] = 209220,
	["128823.150313"] = 200315,
	["128825.150313"] = 196416,
	["128868.150313"] = 197715,

	["120978.150314"] = 186944,
	["128866.150314"] = 209216,
	["128823.150314"] = 200482,
	["128825.150314"] = 196430,
	["128868.150314"] = 197762,

	["128825.150315"] = 196355,
	["128868.150315"] = 216212,
	["120978.150315"] = 184778,
	["128866.150315"] = 209225,
	["128823.150315"] = 200302,

	["128823.150338"] = 200315,
	["120978.150338"] = 184843,
	["128866.150338"] = 209220,
	["128868.150338"] = 197715,
	["128825.150338"] = 196416,

	["128825.150339"] = 196430,
	["128868.150339"] = 197762,
	["128866.150339"] = 209216,
	["120978.150339"] = 186944,
	["128823.150339"] = 200482,

	["128823.150340"] = 200302,
	["128866.150340"] = 209225,
	["120978.150340"] = 184778,
	["128868.150340"] = 216212,
	["128825.150340"] = 196355,

	["128868.153461"] = 197715,
	["128825.153461"] = 196416,
	["128823.153461"] = 200315,
	["120978.153461"] = 184843,
	["128866.153461"] = 209220,

	["128866.153462"] = 209216,
	["120978.153462"] = 186944,
	["128823.153462"] = 200482,
	["128825.153462"] = 196430,
	["128868.153462"] = 197762,

	["128825.153463"] = 196355,
	["128868.153463"] = 216212,
	["128866.153463"] = 209225,
	["120978.153463"] = 184778,
	["128823.153463"] = 200302,

	["128861.150351"] = 197038,
	["128940.150351"] = 195243,
	["128808.150351"] = 203566,
	["128938.150351"] = 213051,
	["128937.150351"] = 199364,
	["128908.150351"] = 200846,
	["128826.150351"] = 190449,
	["128935.150351"] = 191493,
	["128819.150351"] = 215381,
	["128872.150351"] = 216230,

	["128861.150352"] = 197139,
	["128940.150352"] = 195266,
	["128808.150352"] = 203638,
	["128938.150352"] = 213062,
	["128937.150352"] = 199372,
	["128908.150352"] = 200853,
	["128826.150352"] = 190467,
	["128935.150352"] = 191740,
	["128819.150352"] = 198292,
	["128872.150352"] = 202522,

	["128826.150353"] = 190529,
	["128935.150353"] = 191577,
	["128819.150353"] = 198349,
	["128872.150353"] = 202530,
	["128808.150353"] = 203670,
	["128937.150353"] = 199380,
	["128938.150353"] = 213133,
	["128908.150353"] = 200860,
	["128940.150353"] = 195291,
	["128861.150353"] = 197162,

	["128861.150357"] = 197038,
	["128940.150357"] = 195243,
	["128938.150357"] = 213051,
	["128937.150357"] = 199364,
	["128908.150357"] = 200846,
	["128808.150357"] = 203566,
	["128819.150357"] = 215381,
	["128935.150357"] = 191493,
	["128872.150357"] = 216230,
	["128826.150357"] = 190449,

	["128808.150358"] = 203638,
	["128908.150358"] = 200853,
	["128938.150358"] = 213062,
	["128937.150358"] = 199372,
	["128826.150358"] = 190467,
	["128872.150358"] = 202522,
	["128935.150358"] = 191740,
	["128819.150358"] = 198292,
	["128861.150358"] = 197139,
	["128940.150358"] = 195266,

	["128808.150359"] = 203670,
	["128938.150359"] = 213133,
	["128937.150359"] = 199380,
	["128908.150359"] = 200860,
	["128826.150359"] = 190529,
	["128935.150359"] = 191577,
	["128819.150359"] = 198349,
	["128872.150359"] = 202530,
	["128861.150359"] = 197162,
	["128940.150359"] = 195291,

	["128940.150363"] = 195243,
	["128861.150363"] = 197038,
	["128826.150363"] = 190449,
	["128872.150363"] = 216230,
	["128935.150363"] = 191493,
	["128819.150363"] = 215381,
	["128808.150363"] = 203566,
	["128908.150363"] = 200846,
	["128937.150363"] = 199364,
	["128938.150363"] = 213051,

	["128940.150364"] = 195266,
	["128861.150364"] = 197139,
	["128819.150364"] = 198292,
	["128935.150364"] = 191740,
	["128872.150364"] = 202522,
	["128826.150364"] = 190467,
	["128937.150364"] = 199372,
	["128938.150364"] = 213062,
	["128908.150364"] = 200853,
	["128808.150364"] = 203638,

	["128861.150365"] = 197162,
	["128940.150365"] = 195291,
	["128908.150365"] = 200860,
	["128937.150365"] = 199380,
	["128938.150365"] = 213133,
	["128808.150365"] = 203670,
	["128872.150365"] = 202530,
	["128819.150365"] = 198349,
	["128935.150365"] = 191577,
	["128826.150365"] = 190529,

	["128808.153473"] = 203566,
	["128938.153473"] = 213051,
	["128937.153473"] = 199364,
	["128908.153473"] = 200846,
	["128826.153473"] = 190449,
	["128935.153473"] = 191493,
	["128819.153473"] = 215381,
	["128872.153473"] = 216230,
	["128861.153473"] = 197038,
	["128940.153473"] = 195243,

	["128940.153474"] = 195266,
	["128861.153474"] = 197139,
	["128826.153474"] = 190467,
	["128872.153474"] = 202522,
	["128935.153474"] = 191740,
	["128819.153474"] = 198292,
	["128808.153474"] = 203638,
	["128908.153474"] = 200853,
	["128937.153474"] = 199372,
	["128938.153474"] = 213062,

	["128940.153475"] = 195291,
	["128861.153475"] = 197162,
	["128826.153475"] = 190529,
	["128872.153475"] = 202530,
	["128935.153475"] = 191577,
	["128819.153475"] = 198349,
	["128808.153475"] = 203670,
	["128908.153475"] = 200860,
	["128938.153475"] = 213133,
	["128937.153475"] = 199380,

	["128826.150295"] = 190457,
	["128911.150295"] = 207092,
	["128823.150295"] = 200316,
	["128937.150295"] = 199366,
	["128938.150295"] = 213049,
	["128860.150295"] = 210571,
	["128306.150295"] = 189768,
	["128825.150295"] = 196358,
	["128858.150295"] = 202386,
	["128821.150295"] = 200399,

	["128938.150296"] = 213055,
	["128937.150296"] = 199377,
	["128826.150296"] = 190520,
	["128911.150296"] = 207255,
	["128823.150296"] = 200294,
	["128860.150296"] = 210593,
	["128306.150296"] = 189754,
	["128825.150296"] = 196422,
	["128858.150296"] = 202445,
	["128821.150296"] = 200409,

	["128826.150297"] = 190514,
	["128911.150297"] = 207354,
	["128823.150297"] = 200302,
	["128938.150297"] = 213116,
	["128937.150297"] = 199384,
	["128860.150297"] = 210590,
	["128306.150297"] = 186320,
	["128825.150297"] = 196355,
	["128858.150297"] = 203018,
	["128821.150297"] = 200440,

	["128938.150319"] = 213049,
	["128937.150319"] = 199366,
	["128826.150319"] = 190457,
	["128823.150319"] = 200316,
	["128911.150319"] = 207092,
	["128825.150319"] = 196358,
	["128860.150319"] = 210571,
	["128306.150319"] = 189768,
	["128821.150319"] = 200399,
	["128858.150319"] = 202386,

	["128858.150320"] = 202445,
	["128821.150320"] = 200409,
	["128860.150320"] = 210593,
	["128306.150320"] = 189754,
	["128825.150320"] = 196422,
	["128938.150320"] = 213055,
	["128937.150320"] = 199377,
	["128911.150320"] = 207255,
	["128823.150320"] = 200294,
	["128826.150320"] = 190520,

	["128306.150321"] = 186320,
	["128860.150321"] = 210590,
	["128825.150321"] = 196355,
	["128858.150321"] = 203018,
	["128821.150321"] = 200440,
	["128938.150321"] = 213116,
	["128937.150321"] = 199384,
	["128826.150321"] = 190514,
	["128911.150321"] = 207354,
	["128823.150321"] = 200302,

	["128825.150344"] = 196358,
	["128306.150344"] = 189768,
	["128860.150344"] = 210571,
	["128821.150344"] = 200399,
	["128858.150344"] = 202386,
	["128937.150344"] = 199366,
	["128938.150344"] = 213049,
	["128826.150344"] = 190457,
	["128823.150344"] = 200316,
	["128911.150344"] = 207092,

	["128858.150345"] = 202445,
	["128821.150345"] = 200409,
	["128860.150345"] = 210593,
	["128306.150345"] = 189754,
	["128825.150345"] = 196422,
	["128938.150345"] = 213055,
	["128937.150345"] = 199377,
	["128911.150345"] = 207255,
	["128823.150345"] = 200294,
	["128826.150345"] = 190520,

	["128821.150346"] = 200440,
	["128858.150346"] = 203018,
	["128825.150346"] = 196355,
	["128306.150346"] = 186320,
	["128860.150346"] = 210590,
	["128823.150346"] = 200302,
	["128911.150346"] = 207354,
	["128826.150346"] = 190514,
	["128938.150346"] = 213116,
	["128937.150346"] = 199384,

	["128938.153467"] = 213049,
	["128937.153467"] = 199366,
	["128826.153467"] = 190457,
	["128911.153467"] = 207092,
	["128823.153467"] = 200316,
	["128860.153467"] = 210571,
	["128306.153467"] = 189768,
	["128825.153467"] = 196358,
	["128858.153467"] = 202386,
	["128821.153467"] = 200399,

	["128938.153468"] = 213055,
	["128937.153468"] = 199377,
	["128826.153468"] = 190520,
	["128823.153468"] = 200294,
	["128911.153468"] = 207255,
	["128825.153468"] = 196422,
	["128860.153468"] = 210593,
	["128306.153468"] = 189754,
	["128821.153468"] = 200409,
	["128858.153468"] = 202445,

	["128826.153469"] = 190514,
	["128823.153469"] = 200302,
	["128911.153469"] = 207354,
	["128937.153469"] = 199384,
	["128938.153469"] = 213116,
	["128825.153469"] = 196355,
	["128860.153469"] = 210590,
	["128306.153469"] = 186320,
	["128821.153469"] = 200440,
	["128858.153469"] = 203018,

	["128820.150283"] = 194234,
	["128821.150283"] = 200399,
	["128819.150283"] = 198236,
	["128943.150283"] = 211126,
	["128941.150283"] = 196217,
	["128403.150283"] = 191442,
	["128289.150283"] = 216272,
	["120978.150283"] = 184759,
	["128908.150283"] = 216273,

	["128941.150284"] = 196236,
	["120978.150284"] = 186927,
	["128289.150284"] = 203225,
	["128403.150284"] = 191494,
	["128908.150284"] = 200856,
	["128819.150284"] = 198299,
	["128943.150284"] = 211105,
	["128821.150284"] = 200409,
	["128820.150284"] = 194313,

	["128820.150285"] = 194314,
	["128821.150285"] = 200414,
	["128943.150285"] = 211119,
	["128819.150285"] = 198349,
	["128941.150285"] = 196432,
	["128908.150285"] = 200860,
	["128403.150285"] = 191488,
	["128289.150285"] = 203227,
	["120978.150285"] = 185368,

	["128941.150307"] = 196217,
	["128908.150307"] = 216273,
	["128403.150307"] = 191442,
	["128289.150307"] = 216272,
	["120978.150307"] = 184759,
	["128943.150307"] = 211126,
	["128819.150307"] = 198236,
	["128821.150307"] = 200399,
	["128820.150307"] = 194234,

	["128943.150308"] = 211105,
	["128819.150308"] = 198299,
	["128908.150308"] = 200856,
	["128289.150308"] = 203225,
	["128403.150308"] = 191494,
	["120978.150308"] = 186927,
	["128941.150308"] = 196236,
	["128820.150308"] = 194313,
	["128821.150308"] = 200409,

	["128941.150309"] = 196432,
	["128908.150309"] = 200860,
	["120978.150309"] = 185368,
	["128289.150309"] = 203227,
	["128403.150309"] = 191488,
	["128943.150309"] = 211119,
	["128819.150309"] = 198349,
	["128821.150309"] = 200414,
	["128820.150309"] = 194314,

	["128821.150332"] = 200399,
	["128820.150332"] = 194234,
	["128941.150332"] = 196217,
	["128908.150332"] = 216273,
	["128403.150332"] = 191442,
	["128289.150332"] = 216272,
	["120978.150332"] = 184759,
	["128943.150332"] = 211126,
	["128819.150332"] = 198236,

	["128821.150333"] = 200409,
	["128820.150333"] = 194313,
	["128908.150333"] = 200856,
	["128289.150333"] = 203225,
	["128403.150333"] = 191494,
	["120978.150333"] = 186927,
	["128941.150333"] = 196236,
	["128943.150333"] = 211105,
	["128819.150333"] = 198299,

	["128820.150334"] = 194314,
	["128821.150334"] = 200414,
	["128943.150334"] = 211119,
	["128819.150334"] = 198349,
	["128941.150334"] = 196432,
	["128908.150334"] = 200860,
	["120978.150334"] = 185368,
	["128289.150334"] = 203227,
	["128403.150334"] = 191488,

	["128820.153455"] = 194234,
	["128821.153455"] = 200399,
	["128943.153455"] = 211126,
	["128819.153455"] = 198236,
	["128941.153455"] = 196217,
	["128908.153455"] = 216273,
	["120978.153455"] = 184759,
	["128289.153455"] = 216272,
	["128403.153455"] = 191442,

	["128820.153456"] = 194313,
	["128821.153456"] = 200409,
	["128943.153456"] = 211105,
	["128819.153456"] = 198299,
	["128908.153456"] = 200856,
	["128289.153456"] = 203225,
	["120978.153456"] = 186927,
	["128403.153456"] = 191494,
	["128941.153456"] = 196236,

	["128820.153457"] = 194314,
	["128821.153457"] = 200414,
	["128819.153457"] = 198349,
	["128943.153457"] = 211119,
	["128289.153457"] = 203227,
	["128403.153457"] = 191488,
	["120978.153457"] = 185368,
	["128908.153457"] = 200860,
	["128941.153457"] = 196432,

	["128292.150286"] = 189092,
	["128937.150286"] = 199366,
	["128911.150286"] = 207092,
	["128935.150286"] = 191499,
	["128862.150286"] = 195317,
	["128306.150286"] = 189768,
	["128860.150286"] = 210571,
	["127857.150286"] = 187258,

	["128935.150287"] = 191740,
	["128911.150287"] = 207206,
	["128862.150287"] = 195323,
	["128937.150287"] = 199372,
	["128292.150287"] = 189164,
	["127857.150287"] = 187264,
	["128860.150287"] = 210579,
	["128306.150287"] = 189757,

	["128937.150288"] = 199485,
	["128292.150288"] = 189097,
	["128862.150288"] = 195352,
	["128911.150288"] = 207348,
	["128935.150288"] = 191598,
	["127857.150288"] = 187287,
	["128860.150288"] = 210631,
	["128306.150288"] = 189744,

	["128911.150310"] = 207092,
	["128935.150310"] = 191499,
	["128862.150310"] = 195317,
	["128937.150310"] = 199366,
	["128292.150310"] = 189092,
	["127857.150310"] = 187258,
	["128860.150310"] = 210571,
	["128306.150310"] = 189768,

	["128935.150311"] = 191740,
	["128911.150311"] = 207206,
	["128862.150311"] = 195323,
	["128292.150311"] = 189164,
	["128937.150311"] = 199372,
	["128306.150311"] = 189757,
	["128860.150311"] = 210579,
	["127857.150311"] = 187264,

	["128937.150312"] = 199485,
	["128292.150312"] = 189097,
	["128862.150312"] = 195352,
	["128935.150312"] = 191598,
	["128911.150312"] = 207348,
	["127857.150312"] = 187287,
	["128860.150312"] = 210631,
	["128306.150312"] = 189744,

	["128937.150335"] = 199366,
	["128292.150335"] = 189092,
	["128862.150335"] = 195317,
	["128935.150335"] = 191499,
	["128911.150335"] = 207092,
	["127857.150335"] = 187258,
	["128860.150335"] = 210571,
	["128306.150335"] = 189768,

	["128292.150336"] = 189164,
	["128937.150336"] = 199372,
	["128911.150336"] = 207206,
	["128935.150336"] = 191740,
	["128862.150336"] = 195323,
	["128306.150336"] = 189757,
	["128860.150336"] = 210579,
	["127857.150336"] = 187264,

	["128306.150337"] = 189744,
	["128860.150337"] = 210631,
	["127857.150337"] = 187287,
	["128292.150337"] = 189097,
	["128937.150337"] = 199485,
	["128862.150337"] = 195352,
	["128911.150337"] = 207348,
	["128935.150337"] = 191598,

	["128937.153458"] = 199366,
	["128292.153458"] = 189092,
	["128862.153458"] = 195317,
	["128911.153458"] = 207092,
	["128935.153458"] = 191499,
	["127857.153458"] = 187258,
	["128860.153458"] = 210571,
	["128306.153458"] = 189768,

	["128292.153459"] = 189164,
	["128937.153459"] = 199372,
	["128862.153459"] = 195323,
	["128935.153459"] = 191740,
	["128911.153459"] = 207206,
	["128306.153459"] = 189757,
	["128860.153459"] = 210579,
	["127857.153459"] = 187264,

	["128292.153460"] = 189097,
	["128937.153460"] = 199485,
	["128862.153460"] = 195352,
	["128935.153460"] = 191598,
	["128911.153460"] = 207348,
	["128306.153460"] = 189744,
	["128860.153460"] = 210631,
	["127857.153460"] = 187287,

	["128862.150274"] = 195352,
	["128866.150274"] = 209216,
	["128820.150274"] = 194239,
	["128861.150274"] = 206910,
	["128858.150274"] = 202464,
	["127857.150274"] = 187287,
	["128832.150274"] = 212819,

	["128820.150275"] = 194312,
	["128861.150275"] = 197080,
	["127857.150275"] = 187321,
	["128858.150275"] = 202426,
	["128832.150275"] = 207352,
	["128862.150275"] = 195322,
	["128866.150275"] = 209220,

	["128862.150276"] = 195323,
	["128866.150276"] = 209226,
	["128820.150276"] = 210182,
	["128858.150276"] = 202433,
	["127857.150276"] = 187264,
	["128861.150276"] = 197139,
	["128832.150276"] = 207375,

	["128866.150298"] = 209216,
	["128862.150298"] = 195352,
	["127857.150298"] = 187287,
	["128858.150298"] = 202464,
	["128861.150298"] = 206910,
	["128832.150298"] = 212819,
	["128820.150298"] = 194239,

	["128832.150299"] = 207352,
	["128861.150299"] = 197080,
	["127857.150299"] = 187321,
	["128858.150299"] = 202426,
	["128820.150299"] = 194312,
	["128866.150299"] = 209220,
	["128862.150299"] = 195322,

	["128820.150300"] = 210182,
	["127857.150300"] = 187264,
	["128858.150300"] = 202433,
	["128861.150300"] = 197139,
	["128832.150300"] = 207375,
	["128862.150300"] = 195323,
	["128866.150300"] = 209226,

	["128862.150323"] = 195352,
	["128866.150323"] = 209216,
	["128820.150323"] = 194239,
	["128832.150323"] = 212819,
	["128858.150323"] = 202464,
	["127857.150323"] = 187287,
	["128861.150323"] = 206910,

	["128820.150324"] = 194312,
	["128861.150324"] = 197080,
	["127857.150324"] = 187321,
	["128858.150324"] = 202426,
	["128832.150324"] = 207352,
	["128862.150324"] = 195322,
	["128866.150324"] = 209220,

	["128866.150325"] = 209226,
	["128862.150325"] = 195323,
	["128861.150325"] = 197139,
	["127857.150325"] = 187264,
	["128858.150325"] = 202433,
	["128832.150325"] = 207375,
	["128820.150325"] = 210182,

	["128858.153446"] = 202464,
	["127857.153446"] = 187287,
	["128861.153446"] = 206910,
	["128832.153446"] = 212819,
	["128820.153446"] = 194239,
	["128866.153446"] = 209216,
	["128862.153446"] = 195352,

	["128862.153447"] = 195322,
	["128866.153447"] = 209220,
	["128820.153447"] = 194312,
	["128832.153447"] = 207352,
	["128858.153447"] = 202426,
	["127857.153447"] = 187321,
	["128861.153447"] = 197080,

	["128862.153448"] = 195323,
	["128866.153448"] = 209226,
	["128820.153448"] = 210182,
	["128858.153448"] = 202433,
	["127857.153448"] = 187264,
	["128861.153448"] = 197139,
	["128832.153448"] = 207375,

	["128941.150280"] = 196236,
	["128943.150280"] = 211105,
	["128832.150280"] = 212816,
	["127829.150280"] = 201458,
	["128476.150280"] = 197369,

	["128941.150281"] = 196258,
	["128943.150281"] = 211099,
	["128476.150281"] = 197239,
	["128832.150281"] = 212819,
	["127829.150281"] = 201464,

	["128476.150282"] = 197241,
	["128832.150282"] = 212821,
	["127829.150282"] = 201459,
	["128941.150282"] = 196301,
	["128943.150282"] = 211144,

	["128943.150304"] = 211105,
	["128941.150304"] = 196236,
	["127829.150304"] = 201458,
	["128832.150304"] = 212816,
	["128476.150304"] = 197369,

	["128476.150305"] = 197239,
	["127829.150305"] = 201464,
	["128832.150305"] = 212819,
	["128941.150305"] = 196258,
	["128943.150305"] = 211099,

	["128941.150306"] = 196301,
	["128943.150306"] = 211144,
	["128476.150306"] = 197241,
	["128832.150306"] = 212821,
	["127829.150306"] = 201459,

	["128476.150329"] = 197369,
	["127829.150329"] = 201458,
	["128832.150329"] = 212816,
	["128941.150329"] = 196236,
	["128943.150329"] = 211105,

	["128943.150330"] = 211099,
	["128941.150330"] = 196258,
	["127829.150330"] = 201464,
	["128832.150330"] = 212819,
	["128476.150330"] = 197239,

	["127829.150331"] = 201459,
	["128832.150331"] = 212821,
	["128476.150331"] = 197241,
	["128943.150331"] = 211144,
	["128941.150331"] = 196301,

	["128941.153452"] = 196236,
	["128943.153452"] = 211105,
	["128476.153452"] = 197369,
	["127829.153452"] = 201458,
	["128832.153452"] = 212816,

	["128943.153453"] = 211099,
	["128941.153453"] = 196258,
	["128476.153453"] = 197239,
	["128832.153453"] = 212819,
	["127829.153453"] = 201464,

	["128941.153454"] = 196301,
	["128943.153454"] = 211144,
	["128832.153454"] = 212821,
	["127829.153454"] = 201459,
	["128476.153454"] = 197241,

	["128943.150348"] = 211108,
	["128827.150348"] = 194093,
	["128403.150348"] = 191419,
	["128292.150348"] = 189080,
	["128870.150348"] = 192310,
	["128942.150348"] = 199111,
	["128868.150348"] = 197708,
	["128910.150348"] = 209459,
	["128402.150348"] = 192450,
	["128476.150348"] = 197231,
	["127829.150348"] = 201454,

	["128942.150349"] = 199152,
	["128870.150349"] = 192326,
	["128292.150349"] = 189164,
	["128403.150349"] = 191592,
	["128943.150349"] = 211123,
	["128827.150349"] = 193645,
	["127829.150349"] = 201457,
	["128476.150349"] = 197235,
	["128910.150349"] = 216274,
	["128402.150349"] = 192457,
	["128868.150349"] = 197716,

	["128403.150350"] = 191565,
	["128942.150350"] = 199212,
	["128870.150350"] = 192323,
	["128292.150350"] = 189154,
	["128827.150350"] = 193642,
	["128943.150350"] = 211144,
	["128476.150350"] = 197241,
	["127829.150350"] = 201459,
	["128868.150350"] = 197711,
	["128402.150350"] = 192514,
	["128910.150350"] = 209483,

	["128402.150354"] = 192450,
	["128910.150354"] = 209459,
	["128868.150354"] = 197708,
	["127829.150354"] = 201454,
	["128476.150354"] = 197231,
	["128827.150354"] = 194093,
	["128943.150354"] = 211108,
	["128870.150354"] = 192310,
	["128942.150354"] = 199111,
	["128292.150354"] = 189080,
	["128403.150354"] = 191419,

	["128870.150355"] = 192326,
	["128292.150355"] = 189164,
	["128942.150355"] = 199152,
	["128403.150355"] = 191592,
	["128943.150355"] = 211123,
	["128827.150355"] = 193645,
	["127829.150355"] = 201457,
	["128476.150355"] = 197235,
	["128910.150355"] = 216274,
	["128402.150355"] = 192457,
	["128868.150355"] = 197716,

	["128403.150356"] = 191565,
	["128292.150356"] = 189154,
	["128870.150356"] = 192323,
	["128942.150356"] = 199212,
	["128943.150356"] = 211144,
	["128827.150356"] = 193642,
	["128476.150356"] = 197241,
	["127829.150356"] = 201459,
	["128868.150356"] = 197711,
	["128910.150356"] = 209483,
	["128402.150356"] = 192514,

	["127829.150360"] = 201454,
	["128476.150360"] = 197231,
	["128910.150360"] = 209459,
	["128402.150360"] = 192450,
	["128868.150360"] = 197708,
	["128870.150360"] = 192310,
	["128942.150360"] = 199111,
	["128292.150360"] = 189080,
	["128403.150360"] = 191419,
	["128943.150360"] = 211108,
	["128827.150360"] = 194093,

	["127829.150361"] = 201457,
	["128476.150361"] = 197235,
	["128402.150361"] = 192457,
	["128910.150361"] = 216274,
	["128868.150361"] = 197716,
	["128292.150361"] = 189164,
	["128870.150361"] = 192326,
	["128942.150361"] = 199152,
	["128403.150361"] = 191592,
	["128827.150361"] = 193645,
	["128943.150361"] = 211123,

	["128868.150362"] = 197711,
	["128402.150362"] = 192514,
	["128910.150362"] = 209483,
	["128476.150362"] = 197241,
	["127829.150362"] = 201459,
	["128827.150362"] = 193642,
	["128943.150362"] = 211144,
	["128403.150362"] = 191565,
	["128292.150362"] = 189154,
	["128870.150362"] = 192323,
	["128942.150362"] = 199212,

	["128476.153470"] = 197231,
	["127829.153470"] = 201454,
	["128868.153470"] = 197708,
	["128402.153470"] = 192450,
	["128910.153470"] = 209459,
	["128403.153470"] = 191419,
	["128870.153470"] = 192310,
	["128292.153470"] = 189080,
	["128942.153470"] = 199111,
	["128827.153470"] = 194093,
	["128943.153470"] = 211108,

	["128868.153471"] = 197716,
	["128910.153471"] = 216274,
	["128402.153471"] = 192457,
	["128476.153471"] = 197235,
	["127829.153471"] = 201457,
	["128943.153471"] = 211123,
	["128827.153471"] = 193645,
	["128403.153471"] = 191592,
	["128870.153471"] = 192326,
	["128942.153471"] = 199152,
	["128292.153471"] = 189164,

	["128403.153472"] = 191565,
	["128292.153472"] = 189154,
	["128870.153472"] = 192323,
	["128942.153472"] = 199212,
	["128943.153472"] = 211144,
	["128827.153472"] = 193642,
	["128476.153472"] = 197241,
	["127829.153472"] = 201459,
	["128868.153472"] = 197711,
	["128910.153472"] = 209483,
	["128402.153472"] = 192514,

	["128827.150277"] = 194093,
	["128872.150277"] = 216230,
	["128826.150277"] = 190449,
	["128403.150277"] = 191419,
	["128289.150277"] = 188635,
	["128870.150277"] = 192310,
	["128942.150277"] = 199111,
	["128808.150277"] = 203566,
	["128402.150277"] = 192450,
	["128910.150277"] = 209459,
	["128821.150277"] = 200395,
	["128860.150277"] = 210570,

	["128910.150278"] = 209481,
	["128402.150278"] = 192460,
	["128821.150278"] = 200409,
	["128860.150278"] = 210593,
	["128872.150278"] = 202524,
	["128827.150278"] = 194007,
	["128826.150278"] = 190520,
	["128403.150278"] = 191494,
	["128289.150278"] = 203225,
	["128808.150278"] = 203669,
	["128870.150278"] = 192329,
	["128942.150278"] = 199153,

	["128860.150279"] = 210637,
	["128821.150279"] = 200414,
	["128910.150279"] = 248579,
	["128402.150279"] = 192542,
	["128808.150279"] = 203670,
	["128942.150279"] = 199158,
	["128870.150279"] = 192349,
	["128289.150279"] = 203227,
	["128403.150279"] = 191488,
	["128826.150279"] = 190529,
	["128872.150279"] = 202530,
	["128827.150279"] = 194016,

	["128402.150301"] = 192450,
	["128910.150301"] = 209459,
	["128821.150301"] = 200395,
	["128860.150301"] = 210570,
	["128827.150301"] = 194093,
	["128872.150301"] = 216230,
	["128826.150301"] = 190449,
	["128403.150301"] = 191419,
	["128289.150301"] = 188635,
	["128870.150301"] = 192310,
	["128942.150301"] = 199111,
	["128808.150301"] = 203566,

	["128860.150302"] = 210593,
	["128821.150302"] = 200409,
	["128402.150302"] = 192460,
	["128910.150302"] = 209481,
	["128942.150302"] = 199153,
	["128870.150302"] = 192329,
	["128808.150302"] = 203669,
	["128289.150302"] = 203225,
	["128403.150302"] = 191494,
	["128826.150302"] = 190520,
	["128827.150302"] = 194007,
	["128872.150302"] = 202524,

	["128821.150303"] = 200414,
	["128860.150303"] = 210637,
	["128402.150303"] = 192542,
	["128910.150303"] = 248579,
	["128289.150303"] = 203227,
	["128403.150303"] = 191488,
	["128870.150303"] = 192349,
	["128942.150303"] = 199158,
	["128808.150303"] = 203670,
	["128827.150303"] = 194016,
	["128872.150303"] = 202530,
	["128826.150303"] = 190529,

	["128402.150326"] = 192450,
	["128910.150326"] = 209459,
	["128821.150326"] = 200395,
	["128860.150326"] = 210570,
	["128827.150326"] = 194093,
	["128872.150326"] = 216230,
	["128826.150326"] = 190449,
	["128403.150326"] = 191419,
	["128289.150326"] = 188635,
	["128870.150326"] = 192310,
	["128942.150326"] = 199111,
	["128808.150326"] = 203566,

	["128826.150327"] = 190520,
	["128872.150327"] = 202524,
	["128827.150327"] = 194007,
	["128808.150327"] = 203669,
	["128942.150327"] = 199153,
	["128870.150327"] = 192329,
	["128403.150327"] = 191494,
	["128289.150327"] = 203225,
	["128910.150327"] = 209481,
	["128402.150327"] = 192460,
	["128860.150327"] = 210593,
	["128821.150327"] = 200409,

	["128289.150328"] = 203227,
	["128403.150328"] = 191488,
	["128808.150328"] = 203670,
	["128870.150328"] = 192349,
	["128942.150328"] = 199158,
	["128872.150328"] = 202530,
	["128827.150328"] = 194016,
	["128826.150328"] = 190529,
	["128821.150328"] = 200414,
	["128860.150328"] = 210637,
	["128910.150328"] = 248579,
	["128402.150328"] = 192542,

	["128402.153449"] = 192450,
	["128910.153449"] = 209459,
	["128860.153449"] = 210570,
	["128821.153449"] = 200395,
	["128826.153449"] = 190449,
	["128827.153449"] = 194093,
	["128872.153449"] = 216230,
	["128942.153449"] = 199111,
	["128870.153449"] = 192310,
	["128808.153449"] = 203566,
	["128403.153449"] = 191419,
	["128289.153449"] = 188635,

	["128826.153450"] = 190520,
	["128872.153450"] = 202524,
	["128827.153450"] = 194007,
	["128808.153450"] = 203669,
	["128942.153450"] = 199153,
	["128870.153450"] = 192329,
	["128289.153450"] = 203225,
	["128403.153450"] = 191494,
	["128910.153450"] = 209481,
	["128402.153450"] = 192460,
	["128860.153450"] = 210593,
	["128821.153450"] = 200409,

	["128872.153451"] = 202530,
	["128827.153451"] = 194016,
	["128826.153451"] = 190529,
	["128289.153451"] = 203227,
	["128403.153451"] = 191488,
	["128808.153451"] = 203670,
	["128870.153451"] = 192349,
	["128942.153451"] = 199158,
	["128910.153451"] = 248579,
	["128402.153451"] = 192542,
	["128821.153451"] = 200414,
	["128860.153451"] = 210637,

	["128910.150292"] = 209472,
	["128940.150292"] = 218607,
	["128402.150292"] = 192447,
	["128832.150292"] = 207352,
	["128861.150292"] = 197080,
	["128872.150292"] = 202514,
	["128819.150292"] = 198247,
	["128866.150292"] = 209220,
	["128808.150292"] = 203578,
	["128870.150292"] = 192318,
	["128908.150292"] = 200849,
	["128938.150292"] = 213180,
	["128289.150292"] = 188683,

	["128402.150293"] = 192542,
	["128940.150293"] = 195291,
	["128910.150293"] = 248579,
	["128861.150293"] = 197162,
	["128832.150293"] = 212817,
	["128819.150293"] = 198349,
	["128872.150293"] = 202530,
	["128289.150293"] = 203227,
	["128938.150293"] = 213133,
	["128908.150293"] = 200860,
	["128870.150293"] = 192349,
	["128866.150293"] = 209218,
	["128808.150293"] = 203670,

	["128938.150294"] = 213047,
	["128289.150294"] = 188632,
	["128908.150294"] = 200857,
	["128870.150294"] = 192323,
	["128866.150294"] = 209224,
	["128808.150294"] = 224764,
	["128819.150294"] = 198296,
	["128872.150294"] = 202521,
	["128861.150294"] = 197160,
	["128832.150294"] = 212821,
	["128402.150294"] = 192514,
	["128910.150294"] = 209483,
	["128940.150294"] = 195244,

	["128861.150316"] = 197080,
	["128832.150316"] = 207352,
	["128940.150316"] = 218607,
	["128910.150316"] = 209472,
	["128402.150316"] = 192447,
	["128908.150316"] = 200849,
	["128938.150316"] = 213180,
	["128289.150316"] = 188683,
	["128808.150316"] = 203578,
	["128866.150316"] = 209220,
	["128870.150316"] = 192318,
	["128872.150316"] = 202514,
	["128819.150316"] = 198247,

	["128808.150317"] = 203670,
	["128866.150317"] = 209218,
	["128870.150317"] = 192349,
	["128908.150317"] = 200860,
	["128289.150317"] = 203227,
	["128938.150317"] = 213133,
	["128872.150317"] = 202530,
	["128819.150317"] = 198349,
	["128832.150317"] = 212817,
	["128861.150317"] = 197162,
	["128940.150317"] = 195291,
	["128910.150317"] = 248579,
	["128402.150317"] = 192542,

	["128832.150318"] = 212821,
	["128861.150318"] = 197160,
	["128910.150318"] = 209483,
	["128940.150318"] = 195244,
	["128402.150318"] = 192514,
	["128808.150318"] = 224764,
	["128866.150318"] = 209224,
	["128870.150318"] = 192323,
	["128908.150318"] = 200857,
	["128289.150318"] = 188632,
	["128938.150318"] = 213047,
	["128872.150318"] = 202521,
	["128819.150318"] = 198296,

	["128910.150341"] = 209472,
	["128940.150341"] = 218607,
	["128402.150341"] = 192447,
	["128861.150341"] = 197080,
	["128832.150341"] = 207352,
	["128872.150341"] = 202514,
	["128819.150341"] = 198247,
	["128908.150341"] = 200849,
	["128289.150341"] = 188683,
	["128938.150341"] = 213180,
	["128808.150341"] = 203578,
	["128866.150341"] = 209220,
	["128870.150341"] = 192318,

	["128866.150342"] = 209218,
	["128808.150342"] = 203670,
	["128870.150342"] = 192349,
	["128908.150342"] = 200860,
	["128289.150342"] = 203227,
	["128938.150342"] = 213133,
	["128872.150342"] = 202530,
	["128819.150342"] = 198349,
	["128832.150342"] = 212817,
	["128861.150342"] = 197162,
	["128910.150342"] = 248579,
	["128940.150342"] = 195291,
	["128402.150342"] = 192542,

	["128870.150343"] = 192323,
	["128808.150343"] = 224764,
	["128866.150343"] = 209224,
	["128289.150343"] = 188632,
	["128938.150343"] = 213047,
	["128908.150343"] = 200857,
	["128819.150343"] = 198296,
	["128872.150343"] = 202521,
	["128832.150343"] = 212821,
	["128861.150343"] = 197160,
	["128402.150343"] = 192514,
	["128940.150343"] = 195244,
	["128910.150343"] = 209483,

	["128819.153464"] = 198247,
	["128872.153464"] = 202514,
	["128870.153464"] = 192318,
	["128866.153464"] = 209220,
	["128808.153464"] = 203578,
	["128938.153464"] = 213180,
	["128289.153464"] = 188683,
	["128908.153464"] = 200849,
	["128402.153464"] = 192447,
	["128910.153464"] = 209472,
	["128940.153464"] = 218607,
	["128832.153464"] = 207352,
	["128861.153464"] = 197080,

	["128908.153465"] = 200860,
	["128938.153465"] = 213133,
	["128289.153465"] = 203227,
	["128808.153465"] = 203670,
	["128866.153465"] = 209218,
	["128870.153465"] = 192349,
	["128872.153465"] = 202530,
	["128819.153465"] = 198349,
	["128861.153465"] = 197162,
	["128832.153465"] = 212817,
	["128940.153465"] = 195291,
	["128910.153465"] = 248579,
	["128402.153465"] = 192542,

	["128832.153466"] = 212821,
	["128861.153466"] = 197160,
	["128910.153466"] = 209483,
	["128940.153466"] = 195244,
	["128402.153466"] = 192514,
	["128808.153466"] = 224764,
	["128866.153466"] = 209224,
	["128870.153466"] = 192323,
	["128908.153466"] = 200857,
	["128289.153466"] = 188632,
	["128938.153466"] = 213047,
	["128872.153466"] = 202521,
	["128819.153466"] = 198296,

	["127857.156802"] = 187301,
	["128832.156802"] = 212821,
	["128820.156802"] = 194318,
	["128858.156802"] = 202302,
	["128861.156802"] = 197160,
	["128866.156802"] = 209224,
	["128862.156802"] = 195354,

	["127857.156803"] = 187276,
	["128832.156803"] = 212817,
	["128862.156803"] = 195351,
	["128858.156803"] = 202466,
	["128820.156803"] = 194314,
	["128861.156803"] = 197162,
	["128866.156803"] = 209218,

	["128942.156804"] = 199120,
	["128821.156804"] = 208762,
	["128860.156804"] = 210575,
	["128826.156804"] = 190462,
	["128808.156804"] = 203578,
	["128402.156804"] = 192447,
	["128870.156804"] = 192318,
	["128872.156804"] = 202514,
	["128403.156804"] = 191485,
	["128827.156804"] = 193644,
	["128910.156804"] = 209472,
	["128289.156804"] = 188683,

	["127829.156805"] = 201455,
	["128943.156805"] = 211126,
	["128476.156805"] = 197233,
	["128941.156805"] = 196217,
	["128832.156805"] = 207347,

	["128832.156810"] = 212816,
	["128941.156810"] = 196236,
	["128476.156810"] = 197369,
	["128943.156810"] = 211105,
	["127829.156810"] = 201458,

	["128941.156811"] = 196222,
	["128403.156811"] = 191485,
	["128819.156811"] = 198247,
	["120978.156811"] = 184843,
	["128943.156811"] = 211106,
	["128289.156811"] = 188683,
	["128821.156811"] = 208762,
	["128820.156811"] = 194312,
	["128908.156811"] = 200849,

	["128819.156812"] = 198238,
	["120978.156812"] = 186944,
	["128403.156812"] = 208598,
	["128941.156812"] = 196258,
	["128289.156812"] = 188639,
	["128943.156812"] = 211099,
	["128821.156812"] = 200415,
	["128908.156812"] = 200861,
	["128820.156812"] = 194239,

	["128292.156813"] = 189080,
	["128860.156813"] = 210570,
	["128935.156813"] = 191493,
	["128306.156813"] = 189772,
	["128862.156813"] = 195315,
	["128911.156813"] = 207088,
	["127857.156813"] = 187304,
	["128937.156813"] = 199364,

	["128935.156814"] = 191577,
	["128306.156814"] = 189749,
	["128860.156814"] = 210637,
	["128292.156814"] = 189147,
	["127857.156814"] = 187276,
	["128937.156814"] = 199380,
	["128911.156814"] = 207285,
	["128862.156814"] = 195351,

	["128823.156815"] = 200296,
	["128866.156815"] = 209226,
	["128825.156815"] = 196418,
	["120978.156815"] = 186945,
	["128868.156815"] = 197716,

	["120978.156816"] = 186941,
	["128868.156816"] = 197708,
	["128825.156816"] = 196434,
	["128866.156816"] = 209229,
	["128823.156816"] = 200326,

	["128819.156817"] = 198299,
	["128872.156817"] = 202524,
	["128832.156817"] = 212816,
	["128938.156817"] = 213055,
	["128870.156817"] = 192329,
	["128910.156817"] = 209481,
	["128289.156817"] = 203225,
	["128866.156817"] = 209223,
	["128402.156817"] = 192460,
	["128908.156817"] = 200856,
	["128940.156817"] = 195269,
	["128808.156817"] = 203669,
	["128861.156817"] = 197140,

	["128911.156818"] = 207206,
	["128938.156818"] = 213062,
	["128937.156818"] = 199372,
	["128825.156818"] = 196418,
	["128823.156818"] = 200296,
	["128821.156818"] = 200402,
	["128306.156818"] = 189757,
	["128858.156818"] = 202433,
	["128826.156818"] = 190467,
	["128860.156818"] = 210579,

	["128911.156819"] = 207354,
	["128937.156819"] = 199384,
	["128938.156819"] = 213116,
	["128823.156819"] = 200302,
	["128825.156819"] = 196355,
	["128306.156819"] = 186320,
	["128821.156819"] = 200440,
	["128858.156819"] = 203018,
	["128826.156819"] = 190514,
	["128860.156819"] = 210590,

	["128870.156820"] = 192323,
	["128868.156820"] = 197711,
	["128403.156820"] = 191565,
	["128827.156820"] = 193642,
	["128910.156820"] = 209483,
	["128476.156820"] = 197241,
	["128943.156820"] = 211144,
	["128942.156820"] = 199212,
	["127829.156820"] = 201459,
	["128402.156820"] = 192514,
	["128292.156820"] = 189154,

	["128402.156821"] = 192450,
	["128292.156821"] = 189080,
	["128942.156821"] = 199111,
	["127829.156821"] = 201454,
	["128476.156821"] = 197231,
	["128910.156821"] = 209459,
	["128943.156821"] = 211108,
	["128827.156821"] = 194093,
	["128403.156821"] = 191419,
	["128870.156821"] = 192310,
	["128868.156821"] = 197708,

	["128872.156822"] = 202522,
	["128819.156822"] = 198292,
	["128937.156822"] = 199372,
	["128938.156822"] = 213062,
	["128908.156822"] = 200853,
	["128940.156822"] = 195266,
	["128808.156822"] = 203638,
	["128861.156822"] = 197139,
	["128826.156822"] = 190467,
	["128935.156822"] = 191740,

	["128935.156823"] = 191598,
	["128908.156823"] = 200861,
	["128940.156823"] = 195267,
	["128808.156823"] = 203673,
	["128861.156823"] = 206910,
	["128826.156823"] = 190567,
	["128872.156823"] = 202907,
	["128819.156823"] = 198238,
	["128937.156823"] = 199485,
	["128938.156823"] = 213136,
}


-- RelicInspector.lua
local function invertTable(table)
	if type(table) ~= "table" then return end
	local invTable = {}
	for k, v in pairs(table) do
		invTable[v] = k 
	end
	return invTable
end

local RelicSpells = RelicInspector_SpellIDByRelic
local RelicTypeNames = RelicInspector_RelicTypes
local RelicSlotsByArtifact = RelicInspector_RelicSlots
local PowersToScrape = RelicInspector_PowersToScrape
local SpecByArtifact = RelicInspector_Artifacts
local ArtifactBySpec = invertTable(RelicInspector_Artifacts)

local MAX_LINE_LENGTH = 80
local TRAIT_DESC_COLOR = "|cffff78ff"
local RELIC_SPEC_DESC_COLOR = "|cffffd200"

-- 7.2 Hack for lack of item links
local t_threshold = 1.0
local itemRefLinkInfo = {'',0}
local xSetHyperlink = ItemRefTooltip.SetHyperlink
ItemRefTooltip.SetHyperlink = function(self, link, ...)
	itemRefLinkInfo[1] = link 
	itemRefLinkInfo[2] = GetTime()
	xSetHyperlink(self, link, ...)
end

local GameLinkInfo = {'',0}
local function gHack(self, unit, slot) 
	local link = GetInventoryItemLink(unit, slot)
	GameLinkInfo[1] = link 
	GameLinkInfo[2] = GetTime()
end
hooksecurefunc(GameTooltip,'SetInventoryItem', gHack)
--

local options, optionsFrame, db, charDB

local modifierPressed = 0

local itemLevelOptions = {
    [1] = "Relic",
    [2] = "Artifact",
}
local invItemLevelOptions = invertTable(itemLevelOptions)

local locItemLevelOptions = {
    [1] = INVTYPE_RELIC,
    [2] = ITEM_QUALITY6_DESC,
}

local hoverOptions = {
    [1] = "Never",
    [2] = "CTRL Key",
    [3] = "Always" 
}
local invHoverOptions = invertTable(hoverOptions)

local locHoverOptions = {
    [1] = NEVER,
    [2] = CTRL_KEY,
    [3] = ALWAYS
}

local linkOptions = {
    [1] = "Never",
    [2] = "Always" 
}
local invLinkOptions = invertTable(linkOptions)

local locLinkOptions = {
    [1] = NEVER,
    [2] = ALWAYS
}

local relicOffspecOptions = {
    [1] = "None",
    [2] = "All",
}
local invRelicOffspecOptions = invertTable(relicOffspecOptions)

local locRelicOffspecOptions = {
    [1] = NONE,
    [2] = ALL_SPECS,
}

local relicSpecOptions = {
    [1] = "None",
    [2] = "Specs",
    [3] = "SpecsAndQuantities",
    [4] = "SpecsAndTraits",
    [5] = "SpecsTraitDescription",
}
local invRelicSpecOptions = invertTable(relicSpecOptions)

local locRelicSpecOptions = {
    [1] = NONE,
    [2] = ALL_SPECS,
    [3] = ALL_SPECS .. " (with Quantities)",
    [4] = ALL_SPECS .. " & " .. ARTIFACTS_PERK_TAB,
    [5] = ALL_SPECS .. ", " .. ARTIFACTS_PERK_TAB .. ", & " .. DESCRIPTION
}

local defaults = {
	profile = {
		enabled = true,
		itemLevelDisplay = "Relic",
		hoverTraitNames = "Always",
		hoverTraitDesc = "CTRL Key",
		hoverNLC = "Always",
		linkTraitNames = "Always",
		linkTraitDesc = "Always",
		relicSpecs = "None",
		offspecsToShow = "None"
	}
}

local function SetupOptions()
	if options then return options end

	options = {
		name = "RelicInspector",
		type = "group",
		args = {
			general = {
				name = "Options",
				type = "group",
				args = {
					enabled = {
						name = "Enable",
						desc = "Enables / Disables RelicInspector",
						type = "toggle",
						width = "double",
						set = function(info,val) db.profile.enabled = val end,
						get = function(info) return db.profile.enabled end,
						order = 10
					},
					itemLevelChoice = {
						name = "Item Level To Display:",
						desc = "Whether to show relic item level or weapon gain",
						type = "select",
						width = "double",
						set = function(info,val) db.profile.itemLevelDisplay = itemLevelOptions[val] end,
						get = function(info) return invItemLevelOptions[db.profile.itemLevelDisplay] end,
						order = 15,
						values = locItemLevelOptions
					},
					itemTooltipHeader = {
						name = "Artifact Item Tooltips",
						type = "header",
						order = 20
					},
					itemTooltipTraitNames = {
						name = "Show Trait Names:",
						desc = "When to show trait names on artifact tooltips",
						type = "select",
						width = "single",
						set = function(info,val) db.profile.hoverTraitNames = hoverOptions[val] end,
						get = function(info) return invHoverOptions[db.profile.hoverTraitNames] end,
						order = 21,
						values = locHoverOptions
					},
					itemTooltipTraitDesc = {
						name = "Show Trait Descriptions:",
						desc = "When to show trait descriptions on artifact tooltips",
						type = "select",
						width = "single",
						set = function(info,val) db.profile.hoverTraitDesc = hoverOptions[val] end,
						get = function(info) return invHoverOptions[db.profile.hoverTraitDesc] end,
						order = 22,
						values = locHoverOptions
					},
					itemTooltipNetherlight = {
						name = "Show " .. SPLASH_LEGION_NEW_7_3_FEATURE1_TITLE .. " " .. ARTIFACTS_PERK_TAB .. ":",
						desc = "When to show Netherlight Crucible traits on artifact tooltips",
						type = "select",
						width = "single",
						set = function(info,val) db.profile.hoverNLC = linkOptions[val] end,
						get = function(info) return invLinkOptions[db.profile.hoverNLC] end,
						order = 23,
						values = locLinkOptions
					},
					linkTooltipHeader = {
						name = "Artifact Link Tooltips",
						type = "header",
						order = 30
					},
					linkTooltipTraitNames = {
						name = "Show Trait Names:",
						desc = "When to show trait names on link tooltips",
						type = "select",
						width = "single",
						set = function(info,val) db.profile.linkTraitNames = linkOptions[val] end,
						get = function(info) return invLinkOptions[db.profile.linkTraitNames] end,
						order = 31,
						values = locLinkOptions
					},
					linkTooltipTraitDesc = {
						name = "Show Trait Descriptions:",
						desc = "When to show trait descriptions on link tooltips",
						type = "select",
						width = "single",
						set = function(info,val) db.profile.linkTraitDesc = linkOptions[val] end,
						get = function(info) return invLinkOptions[db.profile.linkTraitDesc] end,
						order = 32,
						values = locLinkOptions
					},
					relicTooltipHeader = {
						name = "Relic Tooltips",
						type = "header",
						order = 40
					},
					relicTooltipOffspecs = {
						name = "Unequipped Artifact Traits to Show:",
						desc = "Which unequipped artifacts to show relic traits for",
						type = "select",
						width = "double",
						set = function(info,val) db.profile.offspecsToShow = relicOffspecOptions[val] end,
						get = function(info) return invRelicOffspecOptions[db.profile.offspecsToShow] end,
						order = 41,
						values = locRelicOffspecOptions
					},
					relicSpecs = {
						name = "Show Spec Requirements on Relics:",
						desc = "What spec information to show on relics",
						type = "select",
						width = "double",
						set = function(info,val) db.profile.relicSpecs = relicSpecOptions[val] end,
						get = function(info) return invRelicSpecOptions[db.profile.relicSpecs] end,
						order = 43,
						values = locRelicSpecOptions
					},
				}
			},
		}
	}

	return options
end

local function initialize()
	db = _G.LibStub("AceDB-3.0"):New("RelicInspectorDB", defaults, "Default")
	local config = _G.LibStub("AceConfig-3.0")
	local dialog = _G.LibStub("AceConfigDialog-3.0")
	local options = SetupOptions()

	config:RegisterOptionsTable("RelicInspector", options)
	optionsFrame = dialog:AddToBlizOptions("RelicInspector", RelicInspector_TITLE, nil, "general")

	-- Init the per-character DB also
	charDB = _G.LibStub("AceDB-3.0"):New("RelicInspectorCharDB")
end

local RISpellTooltip = CreateFrame('GameTooltip', 'RISpellTooltip', nil, 'GameTooltipTemplate')
local function GetDescriptionFromTooltip(powerID) 
	if not powerID then return nil end
	if not PowersToScrape[powerID] then return nil end

	RISpellTooltip:SetOwner(WorldFrame, 'ANCHOR_NONE')
	RISpellTooltip:SetArtifactPowerByID(powerID)

	local str = _G['RISpellTooltipTextLeft3']
	local text = str and str:GetText()
	return text
end

local function scrubRelicLink(link)
	if link == nil then return nil end
	local pieces = {strsplit(':', link)}
	pieces[10] = '' --remove Level
	pieces[11] = '' --remove Spec
	local str = pieces[1]
	for u=2,#pieces do
		str = str .. ':' .. pieces[u]
	end
	return str
end

local function updateArtifactCache()

	if nil == C_ArtifactRelicForgeUI or isPostLegion then
		return -- bail immediately, everything is diabled 
	end

	local artifactID,_,_,_,_,aLvl = C_ArtifactUI.GetArtifactInfo()

	if nil ~= artifactID then
		local weaponCache = {}
		if nil == charDB.char.artifactCache then
			charDB.char.artifactCache = {}
		elseif nil ~= charDB.char.artifactCache[artifactID] then
			weaponCache = charDB.char.artifactCache[artifactID]
		end

		local t = GetTime()
		weaponCache['timestamp'] = t
		weaponCache['level'] = aLvl

		local crucibled = weaponCache['crucibled'] or false
		
		for n=1,3 do
			local relicCache = {}
			local relicInfo = {C_ArtifactUI.GetRelicInfo(n)}
			if nil ~= relicInfo then
				relicInfo[4] = scrubRelicLink(relicInfo[4])
				relicCache['relic'] = relicInfo
			end

			if C_ArtifactRelicForgeUI.IsAtForge() then -- if we're not, we can't update NLC stuff
				local relicTalents = C_ArtifactRelicForgeUI.GetSocketedRelicTalents(n)

				--Cache the spellID for each "power"
				if nil ~= relicTalents then
					crucibled = true -- per-weapon check
					charDB.char.crucibleUsed = true -- per character check
					for p=1,#relicTalents do
						local pID = relicTalents[p].powerID
						local sID = C_ArtifactUI.GetPowerInfo(pID).spellID
						if nil ~= sID then
							relicTalents[p].spellID = sID
						end
					end
				end
				relicCache['traits'] = relicTalents
				weaponCache[n] = relicCache
			else 
				-- Still check relics but try not to nuke the NLC stuff if they haven't changed
				if nil ~= weaponCache[n] then
					if nil ~= weaponCache[n].relic then
						if nil ~= weaponCache[n].relic[4] then
							if nil ~= relicInfo[4] then
								if weaponCache[n].relic[4] == relicInfo[4] then
								else 
									weaponCache[n] = relicCache
								end
							end
						end
					end
				end
			end
		end
		weaponCache['crucibled'] = crucibled
		
		--store it in the per-character DB
		if nil == charDB.char.artifactCache then
			charDB.char.artifactCache = {}
		end
		charDB.char.artifactCache[artifactID] = weaponCache
	end
end

local function isItemRef(self)
	return (self:GetName() == "ItemRefTooltip")
end

local function isArtifactUsableByPlayerClass(artifactID)
	if artifactID == nil then return false end

	local specForArtifact = SpecByArtifact[artifactID]
	if specForArtifact == nil then return false end

	local _, _, classID = UnitClass("player")
	for a = 1,4 do 
		local aSpecID = GetSpecializationInfoForClassID(classID,a)
		if nil ~= aSpecID and aSpecID == specForArtifact then
			return true
		end
	end
	return false
end

local function DecorateArtifact(self)
	local _, link = self:GetItem()
	if type(link) == 'string' and db.profile.enabled == true then
		local _, itemID, _, relic1, relic2, relic3, _, _, _, _, _, upgradeID = strsplit(':', link)

		-- 7.2-introduced hack for lack of proper item links (still persists in 8.0)
		if nil == itemID or '' == itemID then 
			if isItemRef(self) and itemRefLinkInfo[1] ~= nil and itemRefLinkInfo[1] ~= '' then
				local tc = GetTime()
				local tdelta = tc-itemRefLinkInfo[2]
				local _, itemRefID, _, IRrelic1, IRrelic2, IRrelic3, _, _, _, _, _, IRupgradeID = strsplit(':', itemRefLinkInfo[1])
				if nil ~= itemRefID and '' ~= itemRefID then 
					if tdelta < t_threshold then
						link,itemID,relic1,relic2,relic3,upgradeID = itemRefLinkInfo[1],itemRefID,IRrelic1,IRrelic2,IRrelic3,IRupgradeID
					else
						self:AddLine(format('|cffff0000%s|r', "Double click link to reload and view relic info"), 1, 1, 1, true)
					end
				end
			elseif self:GetName() == "GameTooltip" and GameLinkInfo[1] ~= nil and GameLinkInfo[1] ~= '' then
				local tc = GetTime()
				local tdelta = tc-GameLinkInfo[2]
				local _, gID, _, grelic1, grelic2, grelic3, _, _, _, _, _, gupgradeID = strsplit(':', GameLinkInfo[1])
				if nil ~= gID and '' ~= gID then 
					if tdelta < t_threshold then
						link,itemID,relic1,relic2,relic3,upgradeID = GameLinkInfo[1],gID,grelic1,grelic2,grelic3,gupgradeID
					end
				end
			end
		end  

		if (upgradeID == '256' or upgradeID == '16777472') and nil ~= RelicSlotsByArtifact[tonumber(itemID)] then
			--It's a recognized artifact item
			local showTraitNames, showTraitDesc, showCrucibleTraits = false, false, false

			-- check if the user wants Crucible talents shown, then start eliminating reasons
			if invLinkOptions[db.profile.hoverNLC] == 2 then
				showCrucibleTraits = true
			end
			local artiCache = charDB.char.artifactCache
			if nil == artiCache then
				showCrucibleTraits = false
			end
			if isPostLegion then 
				showCrucibleTraits = false 
				showTraitNames = false
				showTraitDesc = false
			else
				if(isItemRef(self)) then
					-- Item Links
					showCrucibleTraits = false -- Never show Crucible for links
					
					if invLinkOptions[db.profile.linkTraitNames] == 2 then
						showTraitNames = true
					end
					if invLinkOptions[db.profile.linkTraitDesc] == 2 then
						showTraitDesc = true
					end
				else -- Game or Shopping Hover Tooltips
					if invHoverOptions[db.profile.hoverTraitNames] == 3 or
						(invHoverOptions[db.profile.hoverTraitNames] == 2 and modifierPressed ~= 0) then
						showTraitNames = true
					end
					if invHoverOptions[db.profile.hoverTraitDesc] == 3 or
						(invHoverOptions[db.profile.hoverTraitDesc] == 2 and modifierPressed ~= 0) then
						showTraitDesc = true
					end

					--Check what we're mousing over
					local owner = self:GetOwner()
					if nil ~= owner then
						local parent = owner:GetParent()
						if nil ~= parent then
							if parent:GetName() == nil then
								-- This should stop false appearances in ERT and others.
								showCrucibleTraits = false
							end
							if parent == InspectPaperDollItemsFrame or
							   parent == InspectArmory or
							   parent == TradeRecipientItem7 then 
								-- Exclude standard Inspect window and Shadows&Light Armory inspect and trade window by name
								showCrucibleTraits = false
							end
						else
							-- This shouldn't happen but who knows. Don't show in this case.
							showCrucibleTraits = false
						end
					end
				end

				if not isArtifactUsableByPlayerClass(tonumber(itemID)) then
					showCrucibleTraits = false
				end

				local _,_,_,nc = GetAchievementInfo(12072) -- is the Crucible unlocked?
				if not nc then
					showCrucibleTraits = false
				end

			end

			local relics = {relic1,relic2,relic3}
			local showNewNLCTraitMsg = false
			for i = 1,#relics do 
				if '' ~= relics[i] then
					local name, gemLink = GetItemGem(link,i)
					if type(gemLink) == 'string' then
						--Display the gem name, item level, and relic type
						local _, _, _, gemLevel = GetItemInfo(gemLink)
						local relicType = RelicTypeNames[RelicSlotsByArtifact[tonumber(itemID)][i]]
						if nil == relicType then relicType = "???" end
						
						local itemLevel = gemLevel
						local artifactLevelGain = C_ArtifactUI.GetItemLevelIncreaseProvidedByRelic(gemLink)
						if not isPostLegion and invItemLevelOptions[db.profile.itemLevelDisplay] == 2 then
							itemLevel = "+" .. artifactLevelGain
						end

						self:AddLine(' ',1,1,1,false)  -- Blank line as a spacer

						self:AddDoubleLine(format('|cffffd400(%s) %s|r', itemLevel or '???', gemLink or '???'), 
							format('|cff00ff00(%s)',relicType), 0, 1, 0, 0, 1, 0)

						if isPostLegion then
							-- Show the item level increase with the space that used to display traits
							self:AddLine(format(" " .. RELIC_TOOLTIP_ILVL_INCREASE, artifactLevelGain), 1, 1, 1, false)
						
						elseif showTraitNames or showTraitDesc then
							-- Let's add the Ranks and Trait names if we are supposed to
							local traitsToDisplay = {}

							-- Add the native trait 
							local spellLookupKey = itemID .. '.' .. relics[i]
							if nil ~= RelicSpells[spellLookupKey] then
								local nativeTrait = {}
								nativeTrait['spellID'] = RelicSpells[spellLookupKey]
								nativeTrait['powerID'] = 0 -- We don't really care what this is for now
								tinsert(traitsToDisplay,nativeTrait)
							end

							if showCrucibleTraits then
								local artiCacheWeapon = artiCache[tonumber(itemID)]
								if nil ~= artiCacheWeapon then
									local weaponArtifactLevel = artiCacheWeapon.level or 0
									local artiCacheRelic = artiCacheWeapon[i]
									if nil ~= artiCacheRelic then
										local traitCache = artiCacheRelic.traits
										if nil ~= traitCache then
											local traitsChosen = {}
											for p = 1,#traitCache do 
												if nil ~= traitCache[p] then
													if traitCache[p].isChosen then 
														traitsChosen[traitCache[p].requiredArtifactLevel] = true
														if traitCache[p].powerID == 1739 then -- 1739 is Netherlight Fortification (+5 Item levels). Show that first since it's special.
															tinsert(traitsToDisplay,1,traitCache[p])
														else
															tinsert(traitsToDisplay,traitCache[p])
														end
													else
														if nil == traitsChosen[traitCache[p].requiredArtifactLevel] then
															traitsChosen[traitCache[p].requiredArtifactLevel] = false
														end
													end
												end
											end
											for l,isChosen in pairs(traitsChosen) do 
												if not isChosen and l <= weaponArtifactLevel then
													-- Should have a new trait available!
													showNewNLCTraitMsg = true
												end

											end
										else
											--No cached traits, but is it bc we haven't unlocked any? Or bc we just changed a relic?
											if artiCacheWeapon.crucibled then
												--We've theoretically unlocked traits on this weapon before, so at least one should be available.
												--Prompt user to return to forge
												showNewNLCTraitMsg = true
											elseif charDB.char.crucibleUsed then
												showNewNLCTraitMsg = true
											end
										end
									elseif charDB.char.crucibleUsed then
										showNewNLCTraitMsg = true
									end
								else
									if charDB.char.crucibleUsed then
										showNewNLCTraitMsg = true
									end	
								end
							end

							for w = 1,#traitsToDisplay do
								local t = traitsToDisplay[w]
								--Add Trait Name
								if showTraitNames == true then
									if t.powerID == 1739 then -- 1739 is Netherlight Fortification
										self:AddLine(format(RELIC_TOOLTIP_ILVL_INCREASE, 5), 0, 1, 0, false)
									else  
										local traitName = GetSpellInfo(t.spellID)
										if nil ~= traitName then
											-- Still assuming 1 Rank per relic/trait. Will have to update this if relics ever start giving more than 1 rank
											self:AddLine(format(RELIC_TOOLTIP_RANK_INCREASE, 1, traitName), 1, 1, 1, false)
										end
									end
								end
								--Add Trait Description
								if showTraitDesc == true then
									if t.powerID ~= 1739 then -- +Item Levels is pretty self explanatory, doesn't need a desc
										local traitDesc = GetDescriptionFromTooltip(t.powerID) -- Check if it's one we should scrape first, do that
										if not traitDesc then
											traitDesc = GetSpellDescription(t.spellID)
										end
										if nil ~= traitDesc then
											traitDesc = string.gsub(traitDesc,string.char(10),"")
											traitDesc = string.gsub(traitDesc,string.char(13),string.char(13).."  ")
											traitDesc = string.gsub(traitDesc,"|r","|r"..TRAIT_DESC_COLOR)
											self:AddLine(format('%s  %s|r', TRAIT_DESC_COLOR, traitDesc), 1, 1, 1, (string.len(traitDesc) > MAX_LINE_LENGTH))
										end
									end
								end
							end
						end
					end	
				end
			end

			if not isPostLegion and showCrucibleTraits and showNewNLCTraitMsg then
				self:AddLine(' ',1,1,1,false)
				self:AddLine(format(ARTIFACT_RELIC_TALENT_AVAILABLE, 1, traitName), 1, 0, 0, false)
			end
		end	
	end
end

local function DecorateRelic(self)
	local _, link = self:GetItem()
	if type(link) == 'string' and db.profile.enabled == true then
		local _, itemID = strsplit(':', link)
		if nil == itemID or '' == itemID then return end  -- If there's no itemID we can't do anything

		local _, _, relicTypeKey = C_ArtifactUI.GetRelicInfoByItemID(tonumber(itemID))

		if nil == relicTypeKey then	return end -- If it's not a relic then we don't care

		local showOffspecs = false 
		if invRelicOffspecOptions[db.profile.offspecsToShow] > 1 then
			showOffspecs = true
		end

		if not isPostLegion and showOffspecs then
			local _, _, classID = UnitClass("player")
			local currentSpec = GetSpecializationInfo(GetSpecialization())

			local specTraitInfo = {}
			for a = 1,4 do -- Only Druids need 4, but should run them all in case
				local theSpecID = GetSpecializationInfoForClassID(classID,a)
				if nil ~= theSpecID then
					local anArtifactID = ArtifactBySpec[theSpecID]
					if nil ~= anArtifactID then
						local spellLookupKey = anArtifactID .. '.' .. itemID
						local traitSpellID = RelicSpells[spellLookupKey]

						if nil ~= traitSpellID then
							local specArtifactInfo = {theSpecID,anArtifactID,traitSpellID} 
							if theSpecID ~= currentSpec then 	-- Current spec is already shown by Blizzard UI (if you have that one)
								tinsert(specTraitInfo,specArtifactInfo)
							end
						end
					end
				end
			end

			if #specTraitInfo > 0 then 
				self:AddLine(' ',1,1,1,false) 
			end
			local showTraitNames, showTraitDesc = true, true  -- Change this if we want to give options for it
			for r = 1,#specTraitInfo do
				local tSpec, tArtifact, tSpellID = specTraitInfo[r][1], specTraitInfo[r][2], specTraitInfo[r][3]
				local _, specName = GetSpecializationInfoByID(tSpec)
				local _, artifactLink = GetItemInfo(tArtifact)

				if nil ~= specName and nil ~= artifactLink then
					self:AddLine(format('%s: %s', specName, artifactLink), 1, 1, 1, false)

					if showTraitNames == true then
						local traitName = GetSpellInfo(tSpellID)
						if nil ~= traitName then
							-- Assuming 1 Rank per relic right now. Will have to update this if relics start giving more than 1 rank
							self:AddLine(format(' ' .. RELIC_TOOLTIP_RANK_INCREASE, 1, traitName), 1, 1, 1, false)
						end
					end
					if showTraitDesc == true then
						local traitDesc = GetSpellDescription(tSpellID)
						if nil ~= traitDesc then
							traitDesc = string.gsub(traitDesc,string.char(10),"")
							traitDesc = string.gsub(traitDesc,string.char(13),"")
							traitDesc = string.gsub(traitDesc,"|r","|r"..TRAIT_DESC_COLOR)
							self:AddLine(format('%s  %s|r', TRAIT_DESC_COLOR, traitDesc), 1, 1, 1, true)
						end
					end
				end
			end
		end

		-- See if spec requirements are enabled for relics
		if invRelicSpecOptions[db.profile.relicSpecs] > 1 then
			self:AddLine(' ',1,1,1,false)
			-- First find the specs that use it, and how many of each
			local usableSpecs = {}
			for k, v in pairs(RelicSlotsByArtifact) do
				local aSpec = SpecByArtifact[k]
				local specRelicCount = 0
				for i = 1,3 do
					if(v[i] == relicTypeKey) then
						specRelicCount = specRelicCount + 1
					end
				end
				if specRelicCount > 0 then
					tinsert(usableSpecs,aSpec,specRelicCount)
				end
			end

			-- Make a table of required specs and sort that to keep class specs together
			local specKeys = {}
			for k in pairs(usableSpecs) do
				tinsert(specKeys,k)
			end
			table.sort(specKeys) 

			if not isPostLegion and invRelicSpecOptions[db.profile.relicSpecs] > 3 then
				for q = 1,#specKeys do
					local _, specName, _, _, _, classKey = GetSpecializationInfoByID(specKeys[q])
					local classColorSet = RAID_CLASS_COLORS[classKey]
					local classColor = classColorSet.colorStr
					local spellLookupKey = ArtifactBySpec[specKeys[q]] .. '.' .. itemID
					local traitSpellID = RelicSpells[spellLookupKey]
					local traitName = GetSpellInfo(traitSpellID)

					local quantity = ""
					if usableSpecs[specKeys[q]] > 1 then
						quantity = format(' (%d)',usableSpecs[specKeys[q]])
					end

					local specLine = format('|c%s%s%s:|r %s',classColor,specName,quantity,traitName or "???")
					self:AddLine(format(specLine), 1, 1, 1, false)
					if invRelicSpecOptions[db.profile.relicSpecs] > 4 then
						local traitDesc = GetSpellDescription(traitSpellID)
						if nil ~= traitDesc then
							traitDesc = string.gsub(traitDesc,string.char(10),"")
							traitDesc = string.gsub(traitDesc,string.char(13),"")
							traitDesc = string.gsub(traitDesc,"|r","|r"..RELIC_SPEC_DESC_COLOR)
							self:AddLine(format('%s  %s|r', RELIC_SPEC_DESC_COLOR, traitDesc), 1, 1, 1, (string.len(traitDesc) > MAX_LINE_LENGTH))
						end
					end
				end
			else
				-- Assemble the string of all specs (and quantities if applicable)
				local specsStr = ""
				for q = 1,#specKeys do
					local _, specName, _, _, _, classKey = GetSpecializationInfoByID(specKeys[q])
					local classColorSet = RAID_CLASS_COLORS[classKey]
					local classColor = classColorSet.colorStr
					local separator = ", "
					if q == #specKeys then separator = "" end
					local quantity = "" 
					if invRelicSpecOptions[db.profile.relicSpecs] >= 3 and usableSpecs[specKeys[q]] > 1 then
						quantity = format(' (%d)',usableSpecs[specKeys[q]])
					end
					local specString = format('|c%s%s%s|r%s',classColor,specName,quantity,separator)
					specsStr = specsStr .. specString
				end
				self:AddLine(format(ITEM_REQ_SPECIALIZATION,specsStr), 1, 1, 1, true)
			end
		end
	end
end

if not isPostLegion then
	-- don't need to check for modifiers in a post-trait world
	local m = CreateFrame('frame')
	m:HookScript("OnEvent", function(self, event, key, state)
		if event == "MODIFIER_STATE_CHANGED" and (key == "LCTRL" or key == "RCTRL") then
			modifierPressed = state
		end
	end)
	m:RegisterEvent("MODIFIER_STATE_CHANGED")
end

local f = CreateFrame('frame')
f:SetScript('OnEvent', function(self, event, arg1)
  if arg1 == "_ShiGuang" then
    self:UnregisterEvent('ADDON_LOADED')
    initialize()
  end
end)
f:RegisterEvent('ADDON_LOADED')

local af = CreateFrame('frame')
af:SetScript('OnEvent', function(self, event, arg1)
	updateArtifactCache()
end)
af:RegisterEvent('ARTIFACT_UPDATE')
if not isPostLegion then
	-- this event doesn't seem to ever fire in BfA
	af:RegisterEvent('ARTIFACT_RELIC_FORGE_UPDATE')
end

ItemRefTooltip:HookScript('OnTooltipSetItem', DecorateArtifact)
GameTooltip:HookScript('OnTooltipSetItem', DecorateArtifact)
ShoppingTooltip1:HookScript('OnTooltipSetItem', DecorateArtifact)
ShoppingTooltip2:HookScript('OnTooltipSetItem', DecorateArtifact)

GameTooltip:HookScript('OnTooltipSetItem', DecorateRelic)
ItemRefTooltip:HookScript('OnTooltipSetItem', DecorateRelic)
WorldMapTooltip.ItemTooltip.Tooltip:HookScript('OnTooltipSetItem', DecorateRelic)


